UpgradeList = LibStub("AceAddon-3.0"):NewAddon("UpgradeList", "AceConsole-3.0", "AceEvent-3.0", "AceHook-3.0")
local L = LibStub("AceLocale-3.0"):GetLocale("UpgradeList")

UPGRADELIST_VERSION = "0.5";

local LSM = LibStub("LibSharedMedia-3.0")


-- Register some media
LSM:Register("sound", "Dungeon Ready", [[Sound\Interface\levelup2.wav]])
LSM:Register("sound", "Level Up", [[Sound\Interface\LevelUp.wav]])
LSM:Register("sound", "Capture Flag", [[Sound\Interface\PVPFlagCapturedHordeMono.wav]])
LSM:Register("sound", "Horde Flag Taken", [[Sound\Interface\PVPFlagTakenHordeMono.wav]])
LSM:Register("sound", "Alliance Flag Taken", [[Sound\Interface\PVPFlagTakenMono.wav]])
LSM:Register("sound", "Ready?", [[Sound\Interface\ReadyCheck.wav]])
LSM:Register("sound", "Whip", [[Sound\Item\Weapons\Whip\BullWhipHit1.wav]])
LSM:Register("sound", "Puppy Bark", [[Sound\Emitters\Emitter_Dalaran_Petstore_Puppy_07.wav]])
LSM:Register("sound", "Squire Horn", [[Sound\Events\squire_horn_aa.wav]])
LSM:Register("sound", "Zelda-Heart Piece", [[Interface\Addons\UpgradeList\Sounds\LTTP_Get_HeartPiece.ogg]]) 
LSM:Register("sound", "Zelda-Item", [[Interface\Addons\UpgradeList\Sounds\LTTP_ItemFanfare_Stereo.ogg]]) 
LSM:Register("sound", "Zelda-Rupee", [[Interface\Addons\UpgradeList\Sounds\LTTP_Rupee1.ogg]]) 
LSM:Register("sound", "Zelda-Secret", [[Interface\Addons\UpgradeList\Sounds\LTTP_Secret.ogg]]) 


local displaychoices = {
	chatwindow = "Chat Window",
	scrollwindow = "Message Window",
}

local autodeletechoices = {
	[1] = "Assume acquired item is for Primary Spec list",
	[2] = "Assume acquired item is for Secondary Spec list",
	[3] = "Do nothing",
	[4] = "Ask me which spec the acquired item is for",
}

local onehandweaponchoices = {
	[1] = "Assume acquired weapon is for Main Hand list",
	[2] = "Assume acquired weapon is for Off Hand list",
	[3] = "Do nothing",
	[4] = "Ask me which list the acquired weapon is for",
}

local options = {
	name = "Upgrade List",
	handler = UpgradeList,
	type = 'group',
	args = {
		togglebutton = { 
			type = "execute",
			name = "Open Upgrade List",
			order = 1,
			desc = "This button will Open the Upgrade List addon.",
			func = "OpenUpgradeList",
		},
		lockframe = { --option is UpgradeListDBVar.profile.mainframe.lock
			type = "toggle",
			name = "Lock",
			desc = "Lock the Upgrade List frame.",
			order = 2,
			get = "MainFrameMovableGet",
			set = "MainFrameMovableSet",
		},
		minimapbutton = { --option is UpgradeListDBVar.profile.minimap.hide
			type = "toggle",
			name = "Hide Minimap Button",
			order = 3,
			get = "MinimapButtonGet",
			set = "MinimapButtonSet",
		},
		scale = { --option is UpgradeListDBVar.profile.mainframe.scale
			type = "range",
			name = "Scale",
			min = 0.01,
			max = 2,
			bigStep = 0.01,
			isPercent = true,
			get = "ScaleGet",
			set = "ScaleSet",
			order = 4,
			width = "full",
		},
		header = {
			name = "Detected Upgrade Options",
			type = "header",
			order = 5,
		},
		alertmessagepotential = { --option is UpgradeListDBVar.profile.messages.potential
			name = "Enable Messages",
			type = "toggle",
			desc = "Enable to allow Upgrade List to send you a message if an item on your list is detected.",
			order = 6,
			get = "AlertMessagePotentialGet",
			set = "AlertMessagePotentialSet",
		},
		alertmessagespotentialdropdown = { --option is UpgradeListDBVar.profile.messages.potentiallocation
			name = "Message Location:",
			type = "select",
			desc = "Select where you would like Upgrade List to display messages about detected upgrades.",
			values = displaychoices,
			get = "AlertMessagePotentialDropdownGet",
			set = "AlertMessagePotentialDropdownSet",
			style = "dropdown",
			order = 7,
			disabled = "DisableMessagePotentialDropdown",
		},
		alertsoundpotential = { --option is UpgradeListDBVar.profile.sound.potential
			name = "Enable Sound",
			type = "toggle",
			desc = "Enable to allow Upgrade List to play a sound if an item on your list is detected.",
			order = 8,
			get = "AlertSoundPotentialGet",
			set = "AlertSoundPotentialSet",
		},
		alertsoundpotentialdropdown = { --option is UpgradeListDBVar.profile.sound.potentialchoice
			name = "Sound:",
			type = "select",
			dialogControl = "LSM30_Sound",
			desc = "Select the sound you want to play when an item on your list is detected.",
			values = AceGUIWidgetLSMlists.sound,
			get = "AlertSoundPotentialDropdownGet",
			set = "AlertSoundPotentialDropdownSet",
			style = "dropdown",
			order = 9,
			disabled = "DisableSoundPotentialDropdown",
		},
		header2 = {
			name = "Acquired Upgrade Options",
			type = "header",
			order = 10,
		},
		alertmessageacquired = { --option is UpgradeListDBVar.profile.messages.acquired
			name = "Enable Messages",
			type = "toggle",
			desc = "Enable to allow Upgrade List to send you a message if an item on your list is acquired.",
			order = 11,
			get = "AlertMessageAcquiredGet",
			set = "AlertMessageAcquiredSet",
		},
		alertmessagesacquireddropdown = { --option is UpgradeListDBVar.profile.messages.acquiredlocation
			name = "Message Location:",
			type = "select",
			desc = "Select where you would like Upgrade List to display messages about acquired upgrades.",
			values = displaychoices,
			get = "AlertMessageAcquiredDropdownGet",
			set = "AlertMessageAcquiredDropdownSet",
			style = "dropdown",
			order = 12,
			disabled = "DisableMessageAcquiredDropdown",
		},
		alertsoundacquired = { --option is UpgradeListDBVar.profile.sound.acquired
			name = "Enable Sound",
			type = "toggle",
			desc = "Enable to allow Upgrade List to play a sound if an item on your list is acquired.",
			order = 13,
			get = "AlertSoundAcquiredGet",
			set = "AlertSoundAcquiredSet",
		},
		alertsoundacquireddropdown = { --option is UpgradeListDBVar.profile.sound.acquiredchoice
			name = "Sound:",
			type = "select",
			dialogControl = "LSM30_Sound",
			desc = "Select the sound you want to play when an item on your list is acquired.",
			values = AceGUIWidgetLSMlists.sound,
			get = "AlertSoundAcquiredDropdownGet",
			set = "AlertSoundAcquiredDropdownSet",
			style = "dropdown",
			order = 14,
			disabled = "DisableSoundAcquiredDropdown",
		},
		header3 = {
			name = "Auto-Delete Options",
			type = "header",
			order = 15,
		},
		autodelete = { --option is UpgradeListDBVar.profile.autodelete.enable
			name = "Enable Auto-Delete",
			type = "toggle",
			desc = "Enable to allow Upgrade List to auto-delete acquired items along with items of a lower priority (excluding items in the \"Other\" tab).",
			order = 16,
			get = "AutoDeleteGet",
			set = "AutoDeleteSet",
			width = "full",
		},
		autodeletemessage = { --option is UpgradeListDBVar.profile.autodelete.messages
			name = "Enable Messages",
			type = "toggle",
			desc = "Enable to allow Upgrade List to send you a message when it auto-deletes items from your list.",
			order = 17,
			get = "AutoDeleteMessageGet",
			set = "AutoDeleteMessageSet",
			disabled = "DisableAutoDeleteMessage",
		},
		autodeletemessagedropdown = { --option is UpgradeListDBVar.profile.autodelete.messagelocation
			name = "Message Location:",
			type = "select",
			desc = "Select where you would like Upgrade List to display messages about auto-deletion.",
			values = displaychoices,
			get = "AutoDeleteMessageDropdownGet",
			set = "AutoDeleteMessageDropdownSet",
			style = "dropdown",
			order = 18,
			disabled = "DisableAutoDeleteMessageDropdown",
		},
		ignorerings = {
			name = "Ignore Rings",
			type = "toggle",
			desc = "Check this option to make Upgrade List ignore Rings when auto-deleting.",
			order = 19,
			get = "IgnoreRingsGet",
			set = "IgnoreRingsSet",
			disabled = "DisableIgnoreRings",
		},
		ignoretrinkets = {
			name = "Ignore Trinkets",
			type = "toggle",
			desc = "Check this option to make Upgrade List ignore Trinkets when auto-deleting.",
			order = 20,
			get = "IgnoreTrinketsGet",
			set = "IgnoreTrinketsSet",
			disabled = "DisableIgnoreTrinkets",
		},
		autodeletedescription = {
			name = "When auto-deleting, if an item is on both the primary spec list and secondary spec list:",
			order = 21,
			type = "description",
			width = "double",
			fontSize = "medium",
		},
		autodeletechoicedropdown = { --option is UpgradeListDBVar.profile.autodelete.choice
			name = "Select action:",
			type = "select",
			desc = "Select how you would like Upgrade List to handle items in both spec lists.",
			values = autodeletechoices,
			get = "AutoDeleteChoiceDropdownGet",
			set = "AutoDeleteChoiceDropdownSet",
			style = "radio",
			order = 22,
			width = "double",
			disabled = "DisableAutoDeleteChoiceDropdown",
		},
		header4 = {
			name = "One-Handed Weapon Options",
			type = "header",
			order = 23,
		},
		onehandweapondescription = {
			name = "When you receive a 1-handed weapon, if it is on your Main Hand list and your Off Hand list:",
			order = 24,
			type = "description",
			width = "double",
			fontSize = "medium",
		},
		onehandweaponchoicedropdown = {
			name = "Select action:",
			type = "select",
			desc = "Select how you would like Upgrade List to handle 1-handed weapons in both main hand and off hand lists.",
			values = onehandweaponchoices,
			get = "OneHandWeaponChoiceDropdownGet",
			set = "OneHandWeaponChoiceDropdownSet",
			style = "radio",
			order = 25,
			width = "double",
		},
		header5 = {
			name = "Database Options",
			type = "header",
			order = 26,
		},
		deletebutton = { 
			type = "execute",
			name = "Delete ALL Data",
			order = 27,
			desc = "Delete ALL DATA in all tabs in both specs?",
			func = "ResetDatabase",
			confirm = true,
		},
	},
}

local defaults = { 
	char = {
		PrimarySpecList = {
			Head = {
				Row = { },
				Count = 1,
			},
			Neck = {
				Row = {	},
				Count = 1,
			},
			Shoulder = {
				Row = {	},
				Count = 1,
			},
			Back = {
				Row = {	},
				Count = 1,
			},
			Chest = {
				Row = {	},
				Count = 1,
			},
			Wrist = {
				Row = {	},
				Count = 1,
			},
			Hand = {
				Row = {	},
				Count = 1,
			},
			Waist = {
				Row = {	},
				Count = 1,
			},
			Leg = {
				Row = {	},
				Count = 1,
			},
			Foot = {
				Row = {	},
				Count = 1,
			},
			Ring = {
				Row = {	},
				Count = 1,
			},
			Trinket = {
				Row = {	},
				Count = 1,
			},
			Main = {
				Row = {	},
				Count = 1,
			},
			Off = {
				Row = {	},
				Count = 1,
			},
			Ranged = {
				Row = {	},
				Count = 1,
			},
			Other = {
				Row = {	},
				Count = 1,
			},
		},
		SecondarySpecList = {
			Head = {
				Row = {	},
				Count = 1,
			},
			Neck = {
				Row = {	},
				Count = 1,
			},
			Shoulder = {
				Row = {	},
				Count = 1,
			},
			Back = {
				Row = {	},
				Count = 1,
			},
			Chest = {
				Row = {	},
				Count = 1,
			},
			Wrist = {
				Row = {	},
				Count = 1,
			},
			Hand = {
				Row = {	},
				Count = 1,
			},
			Waist = {
				Row = {	},
				Count = 1,
			},
			Leg = {
				Row = {	},
				Count = 1,
			},
			Foot = {
				Row = {	},
				Count = 1,
			},
			Ring = {
				Row = {	},
				Count = 1,
			},
			Trinket = {
				Row = {	},
				Count = 1,
			},
			Main = {
				Row = {	},
				Count = 1,
			},
			Off = {
				Row = {	},
				Count = 1,
			},
			Ranged = {
				Row = {	},
				Count = 1,
			},
			Other = {
				Row = {	},
				Count = 1,
			},
		},
		SavedOptions = {
			PrimaryCheck = nil,
			SecondaryCheck = nil,
			SelectedInstance = nil,
			SelectedBoss = nil,
			SelectedDifficulty = nil,
			tableUL = nil,
		},
	},
	profile = {
		ignoreflags = {
			rings = false,
			trinkets = false,
		},
		minimap = {
			hide = false,
		},
		mainframe = {
			lock = false,
			scale = 1.0,
			showoptions = true,
		},
		messages = {
			potential = true,
			potentiallocation = "scrollwindow",
			acquired = true,
			acquiredlocation = "scrollwindow",
			scrollwindow = nil,
		},
		sound = {
			potential = true,
			potentialchoice = "None",
			acquired = true,
			acquiredchoice = "None",
		},
		autodelete = {
			enable = true,
			messages = true,
			messagelocation = "chatwindow",
			choice = 1,
		},
		onehandweapon = {
			choice = 1,
		},
		tabcreate = {
			Tab_1 = nil,
			Tab_2 = nil,
			Tab_3 = nil,
			Tab_4 = nil,
			Tab_5 = nil,
			Tab_6 = nil,
			Tab_7 = nil,
			Tab_8 = nil,
			Tab_9 = nil,
			Tab_10 = nil,
			Tab_11 = nil,
			Tab_12 = nil,
			Tab_13 = nil,
			Tab_14 = nil,
			Tab_15 = nil,
			Tab_16 = nil,
		},
	},
}

UpgradeListLDB = LibStub("LibDataBroker-1.1"):NewDataObject("UpgradeList", {
	type = "launcher",
	label = "Upgrade List",
	icon = "Interface\\Icons\\Achievement_BG_returnXflags_def_WSG",
})


function UpgradeListLDB.OnClick(self, button)
	if (button == "LeftButton") then
		UpgradeList:OpenUpgradeList()
	else
		InterfaceOptionsFrame_OpenToCategory(UpgradeList.optionsFrame)
	end
end

local icon = LibStub("LibDBIcon-1.0")

function UpgradeList:OnInitialize()
	UpgradeListDBVar = LibStub("AceDB-3.0"):New("UpgradeListDB", defaults, "Default")
	LibStub("AceConfig-3.0"):RegisterOptionsTable("UpgradeList", options)
	self.optionsFrame = LibStub("AceConfigDialog-3.0"):AddToBlizOptions("UpgradeList", "Upgrade List")
	LibStub("AceConfig-3.0"):RegisterOptionsTable("UpgradeList-Profiles", LibStub("AceDBOptions-3.0"):GetOptionsTable(UpgradeListDBVar))
	self.profilesFrame = LibStub("AceConfigDialog-3.0"):AddToBlizOptions("UpgradeList-Profiles", "Profiles", "Upgrade List")
	icon:Register("UpgradeListLDB", UpgradeListLDB, UpgradeListDBVar.profile.minimap)
	self:RegisterChatCommand("upgradelist", "ChatCommand")
	self:RegisterChatCommand("ul", "ChatCommand")
end

local waitTable = {};
local waitFrame = nil;

function UpgradeList_wait(delay, func, ...)
  if(type(delay)~="number" or type(func)~="function") then
    return false;
  end
  if(waitFrame == nil) then
    waitFrame = CreateFrame("Frame","WaitFrame", UIParent);
    waitFrame:SetScript("onUpdate",function (self,elapse)
      local count = #waitTable;
      local i = 1;
      while(i<=count) do
        local waitRecord = tremove(waitTable,i);
        local d = tremove(waitRecord,1);
        local f = tremove(waitRecord,1);
        local p = tremove(waitRecord,1);
        if(d>elapse) then
          tinsert(waitTable,i,{d-elapse,f,p});
          i = i + 1;
        else
          count = count - 1;
          f(unpack(p));
        end
      end
    end);
  end
  tinsert(waitTable,{delay,func,{...}});
  return true;
end

function UpgradeList:ChatCommand(input)
	if not input or input:trim() == "" then
		InterfaceOptionsFrame_OpenToCategory(self.optionsFrame)
	else
		LibStub("AceConfigCmd-3.0").HandleCommand(UpgradeList, "ul", "upgradelist", input)
	end
end

function UpgradeList:MainFrameMovableGet(info)
	return UpgradeListDBVar.profile.mainframe.lock;
end

function UpgradeList:MainFrameMovableSet(info, value)
	UpgradeListDBVar.profile.mainframe.lock = not UpgradeListDBVar.profile.mainframe.lock;
	if UpgradeListDBVar.profile.mainframe.lock then
		UpgradeListMainFrame:SetMovable(false);
		UpgradeListMainFrame:EnableMouse(false);
	else
		UpgradeListMainFrame:SetMovable(true);
		UpgradeListMainFrame:EnableMouse(true);
	end
end

function UpgradeList:MinimapButtonGet(info)
	return UpgradeListDBVar.profile.minimap.hide;
end

function UpgradeList:MinimapButtonSet(info, value)
	UpgradeListDBVar.profile.minimap.hide = not UpgradeListDBVar.profile.minimap.hide;
	if UpgradeListDBVar.profile.minimap.hide then
		icon:Hide("UpgradeListLDB");
	else
		icon:Show("UpgradeListLDB");
	end
end

function UpgradeList:ScaleGet(info)
	return UpgradeListDBVar.profile.mainframe.scale;
end

function UpgradeList:ScaleSet(info, value)
	UpgradeListMainFrame:SetScale(value);
	UpgradeListDBVar.profile.mainframe.scale = value;
end

function UpgradeList:AlertMessagePotentialGet(info)
	return UpgradeListDBVar.profile.messages.potential;
end

function UpgradeList:AlertMessagePotentialSet(info, value)
	UpgradeListDBVar.profile.messages.potential = not UpgradeListDBVar.profile.messages.potential
end

function UpgradeList:AlertMessagePotentialDropdownGet(info)
	return UpgradeListDBVar.profile.messages.potentiallocation;
end

function UpgradeList:AlertMessagePotentialDropdownSet(info, value)
	UpgradeListDBVar.profile.messages.potentiallocation = value;
end

function UpgradeList:DisableMessagePotentialDropdown()
	if UpgradeListDBVar.profile.messages.potential then
		return false
	else
		return true
	end
end

function UpgradeList:AlertSoundPotentialGet(info)
	return UpgradeListDBVar.profile.sound.potential;
end

function UpgradeList:AlertSoundPotentialSet(info, value)
	UpgradeListDBVar.profile.sound.potential = not UpgradeListDBVar.profile.sound.potential
end

function UpgradeList:AlertSoundPotentialDropdownGet(info)
	return UpgradeListDBVar.profile.sound.potentialchoice;
end

function UpgradeList:AlertSoundPotentialDropdownSet(info, value)
	UpgradeListDBVar.profile.sound.potentialchoice = value;
end

function UpgradeList:DisableSoundPotentialDropdown()
	if UpgradeListDBVar.profile.sound.potential then
		return false
	else
		return true
	end
end

function UpgradeList:AlertMessageAcquiredGet(info)
	return UpgradeListDBVar.profile.messages.acquired;
end

function UpgradeList:AlertMessageAcquiredSet(info, value)
	UpgradeListDBVar.profile.messages.acquired = not UpgradeListDBVar.profile.messages.acquired
end

function UpgradeList:AlertMessageAcquiredDropdownGet(info)
	return UpgradeListDBVar.profile.messages.acquiredlocation;
end

function UpgradeList:AlertMessageAcquiredDropdownSet(info, value)
	UpgradeListDBVar.profile.messages.acquiredlocation = value;
end

function UpgradeList:DisableMessageAcquiredDropdown()
	if UpgradeListDBVar.profile.messages.acquired then
		return false
	else
		return true
	end
end

function UpgradeList:AlertSoundAcquiredGet(info)
	return UpgradeListDBVar.profile.sound.acquired;
end

function UpgradeList:AlertSoundAcquiredSet(info, value)
	UpgradeListDBVar.profile.sound.acquired = not UpgradeListDBVar.profile.sound.acquired
end

function UpgradeList:AlertSoundAcquiredDropdownGet(info)
	return UpgradeListDBVar.profile.sound.acquiredchoice;
end

function UpgradeList:AlertSoundAcquiredDropdownSet(info, value)
	UpgradeListDBVar.profile.sound.acquiredchoice = value;
end

function UpgradeList:DisableSoundAcquiredDropdown()
	if UpgradeListDBVar.profile.sound.acquired then
		return false
	else
		return true
	end
end

function UpgradeList:AutoDeleteGet(info)
	return UpgradeListDBVar.profile.autodelete.enable;
end

function UpgradeList:AutoDeleteSet(info, value)
	UpgradeListDBVar.profile.autodelete.enable = not UpgradeListDBVar.profile.autodelete.enable
end

function UpgradeList:AutoDeleteMessageGet(info)
	return UpgradeListDBVar.profile.autodelete.messages;
end

function UpgradeList:AutoDeleteMessageSet(info, value)
	UpgradeListDBVar.profile.autodelete.messages = not UpgradeListDBVar.profile.autodelete.messages
end

function UpgradeList:DisableAutoDeleteMessage()
	if UpgradeListDBVar.profile.autodelete.enable then
		return false
	else
		return true
	end
end

function UpgradeList:AutoDeleteMessageDropdownGet(info)
	return UpgradeListDBVar.profile.autodelete.messagelocation;
end

function UpgradeList:AutoDeleteMessageDropdownSet(info, value)
	UpgradeListDBVar.profile.autodelete.messagelocation = value;
end

function UpgradeList:DisableAutoDeleteMessageDropdown()
	if UpgradeListDBVar.profile.autodelete.enable and UpgradeListDBVar.profile.autodelete.messages then
		return false
	else
		return true
	end
end

function UpgradeList:IgnoreRingsGet(info)
	return UpgradeListDBVar.profile.ignoreflags.rings;
end

function UpgradeList:IgnoreRingsSet(info, value)
	UpgradeListDBVar.profile.ignoreflags.rings = not UpgradeListDBVar.profile.ignoreflags.rings;
end

function UpgradeList:DisableIgnoreRings()
	if UpgradeListDBVar.profile.autodelete.enable then
		return false
	else
		return true
	end
end

function UpgradeList:IgnoreTrinketsGet(info)
	return UpgradeListDBVar.profile.ignoreflags.trinkets;
end

function UpgradeList:IgnoreTrinketsSet(info, value)
	UpgradeListDBVar.profile.ignoreflags.trinkets = not UpgradeListDBVar.profile.ignoreflags.trinkets;
end

function UpgradeList:DisableIgnoreTrinkets()
	if UpgradeListDBVar.profile.autodelete.enable then
		return false
	else
		return true
	end
end

function UpgradeList:AutoDeleteChoiceDropdownGet(info)
	return UpgradeListDBVar.profile.autodelete.choice;
end

function UpgradeList:AutoDeleteChoiceDropdownSet(info, value)
	UpgradeListDBVar.profile.autodelete.choice = value;
end

function UpgradeList:DisableAutoDeleteChoiceDropdown()
	if UpgradeListDBVar.profile.autodelete.enable then
		return false
	else
		return true
	end
end

function UpgradeList:OneHandWeaponChoiceDropdownGet(info)
	return UpgradeListDBVar.profile.onehandweapon.choice;
end

function UpgradeList:OneHandWeaponChoiceDropdownSet(info, value)
	UpgradeListDBVar.profile.onehandweapon.choice = value;
end

function UpgradeList:ResetDatabase()
	UpgradeListDBVar.char.PrimarySpecList = defaults.char.PrimarySpecList
	UpgradeListDBVar.char.SecondarySpecList = defaults.char.SecondarySpecList
end

function UpgradeList:RefreshWindow(name, difficulty, instanceflag)
	local InstanceHighlightColor = {
		["r"] = 0.0,
		["g"] = 0.0,
		["b"] = 0.0,
		["a"] = 1.0,
	};
	if UpgradeListDBVar.char.SavedOptions.PrimaryCheck:GetChecked() then --If the primary checkbox is checked
		if PanelTemplates_GetSelectedTab(UpgradeListMainFrame) == 1 then
			UpgradeListDBVar.char.SavedOptions.tableUL:SetData(UpgradeListDBVar.char.PrimarySpecList.Head.Row, true);
--			if instanceflag == true then
--				local count = 1;
--				while UpgradeListDBVar.char.PrimarySpecList.Head.Row[count] ~= nil do
--					if UpgradeListDBVar.char.PrimarySpecList.Head.Row[count][5] == name and UpgradeListDBVar.char.PrimarySpecList.Head.Row[count][4] == difficulty then
--						--Highlight the particular row
--						--UpgradeListDBVar.char.SavedOptions.tableUL:
--					end
--					count = count + 1;
--				end
--			end
		elseif PanelTemplates_GetSelectedTab(UpgradeListMainFrame) == 2 then
			UpgradeListDBVar.char.SavedOptions.tableUL:SetData(UpgradeListDBVar.char.PrimarySpecList.Neck.Row, true);
		elseif PanelTemplates_GetSelectedTab(UpgradeListMainFrame) == 3 then
			UpgradeListDBVar.char.SavedOptions.tableUL:SetData(UpgradeListDBVar.char.PrimarySpecList.Shoulder.Row, true);
		elseif PanelTemplates_GetSelectedTab(UpgradeListMainFrame) == 4 then
			UpgradeListDBVar.char.SavedOptions.tableUL:SetData(UpgradeListDBVar.char.PrimarySpecList.Back.Row, true);
		elseif PanelTemplates_GetSelectedTab(UpgradeListMainFrame) == 5 then
			UpgradeListDBVar.char.SavedOptions.tableUL:SetData(UpgradeListDBVar.char.PrimarySpecList.Chest.Row, true);
		elseif PanelTemplates_GetSelectedTab(UpgradeListMainFrame) == 6 then
			UpgradeListDBVar.char.SavedOptions.tableUL:SetData(UpgradeListDBVar.char.PrimarySpecList.Wrist.Row, true);
		elseif PanelTemplates_GetSelectedTab(UpgradeListMainFrame) == 7 then
			UpgradeListDBVar.char.SavedOptions.tableUL:SetData(UpgradeListDBVar.char.PrimarySpecList.Hand.Row, true);
		elseif PanelTemplates_GetSelectedTab(UpgradeListMainFrame) == 8 then
			UpgradeListDBVar.char.SavedOptions.tableUL:SetData(UpgradeListDBVar.char.PrimarySpecList.Waist.Row, true);
		elseif PanelTemplates_GetSelectedTab(UpgradeListMainFrame) == 9 then
			UpgradeListDBVar.char.SavedOptions.tableUL:SetData(UpgradeListDBVar.char.PrimarySpecList.Leg.Row, true);
		elseif PanelTemplates_GetSelectedTab(UpgradeListMainFrame) == 10 then
			UpgradeListDBVar.char.SavedOptions.tableUL:SetData(UpgradeListDBVar.char.PrimarySpecList.Foot.Row, true);
		elseif PanelTemplates_GetSelectedTab(UpgradeListMainFrame) == 11 then
			UpgradeListDBVar.char.SavedOptions.tableUL:SetData(UpgradeListDBVar.char.PrimarySpecList.Ring.Row, true);
		elseif PanelTemplates_GetSelectedTab(UpgradeListMainFrame) == 12 then
			UpgradeListDBVar.char.SavedOptions.tableUL:SetData(UpgradeListDBVar.char.PrimarySpecList.Trinket.Row, true);
		elseif PanelTemplates_GetSelectedTab(UpgradeListMainFrame) == 13 then
			UpgradeListDBVar.char.SavedOptions.tableUL:SetData(UpgradeListDBVar.char.PrimarySpecList.Main.Row, true);
		elseif PanelTemplates_GetSelectedTab(UpgradeListMainFrame) == 14 then
			UpgradeListDBVar.char.SavedOptions.tableUL:SetData(UpgradeListDBVar.char.PrimarySpecList.Off.Row, true);
		elseif PanelTemplates_GetSelectedTab(UpgradeListMainFrame) == 15 then
			UpgradeListDBVar.char.SavedOptions.tableUL:SetData(UpgradeListDBVar.char.PrimarySpecList.Ranged.Row, true);
		elseif PanelTemplates_GetSelectedTab(UpgradeListMainFrame) == 16 then
			UpgradeListDBVar.char.SavedOptions.tableUL:SetData(UpgradeListDBVar.char.PrimarySpecList.Other.Row, true);
		end
	else --The secondary checkbox is checked
		if PanelTemplates_GetSelectedTab(UpgradeListMainFrame) == 1 then
			UpgradeListDBVar.char.SavedOptions.tableUL:SetData(UpgradeListDBVar.char.SecondarySpecList.Head.Row, true);
		elseif PanelTemplates_GetSelectedTab(UpgradeListMainFrame) == 2 then
			UpgradeListDBVar.char.SavedOptions.tableUL:SetData(UpgradeListDBVar.char.SecondarySpecList.Neck.Row, true);
		elseif PanelTemplates_GetSelectedTab(UpgradeListMainFrame) == 3 then
			UpgradeListDBVar.char.SavedOptions.tableUL:SetData(UpgradeListDBVar.char.SecondarySpecList.Shoulder.Row, true);
		elseif PanelTemplates_GetSelectedTab(UpgradeListMainFrame) == 4 then
			UpgradeListDBVar.char.SavedOptions.tableUL:SetData(UpgradeListDBVar.char.SecondarySpecList.Back.Row, true);
		elseif PanelTemplates_GetSelectedTab(UpgradeListMainFrame) == 5 then
			UpgradeListDBVar.char.SavedOptions.tableUL:SetData(UpgradeListDBVar.char.SecondarySpecList.Chest.Row, true);
		elseif PanelTemplates_GetSelectedTab(UpgradeListMainFrame) == 6 then
			UpgradeListDBVar.char.SavedOptions.tableUL:SetData(UpgradeListDBVar.char.SecondarySpecList.Wrist.Row, true);
		elseif PanelTemplates_GetSelectedTab(UpgradeListMainFrame) == 7 then
			UpgradeListDBVar.char.SavedOptions.tableUL:SetData(UpgradeListDBVar.char.SecondarySpecList.Hand.Row, true);
		elseif PanelTemplates_GetSelectedTab(UpgradeListMainFrame) == 8 then
			UpgradeListDBVar.char.SavedOptions.tableUL:SetData(UpgradeListDBVar.char.SecondarySpecList.Waist.Row, true);
		elseif PanelTemplates_GetSelectedTab(UpgradeListMainFrame) == 9 then
			UpgradeListDBVar.char.SavedOptions.tableUL:SetData(UpgradeListDBVar.char.SecondarySpecList.Leg.Row, true);
		elseif PanelTemplates_GetSelectedTab(UpgradeListMainFrame) == 10 then
			UpgradeListDBVar.char.SavedOptions.tableUL:SetData(UpgradeListDBVar.char.SecondarySpecList.Foot.Row, true);
		elseif PanelTemplates_GetSelectedTab(UpgradeListMainFrame) == 11 then
			UpgradeListDBVar.char.SavedOptions.tableUL:SetData(UpgradeListDBVar.char.SecondarySpecList.Ring.Row, true);
		elseif PanelTemplates_GetSelectedTab(UpgradeListMainFrame) == 12 then
			UpgradeListDBVar.char.SavedOptions.tableUL:SetData(UpgradeListDBVar.char.SecondarySpecList.Trinket.Row, true);
		elseif PanelTemplates_GetSelectedTab(UpgradeListMainFrame) == 13 then
			UpgradeListDBVar.char.SavedOptions.tableUL:SetData(UpgradeListDBVar.char.SecondarySpecList.Main.Row, true);
		elseif PanelTemplates_GetSelectedTab(UpgradeListMainFrame) == 14 then
			UpgradeListDBVar.char.SavedOptions.tableUL:SetData(UpgradeListDBVar.char.SecondarySpecList.Off.Row, true);
		elseif PanelTemplates_GetSelectedTab(UpgradeListMainFrame) == 15 then
			UpgradeListDBVar.char.SavedOptions.tableUL:SetData(UpgradeListDBVar.char.SecondarySpecList.Ranged.Row, true);
		elseif PanelTemplates_GetSelectedTab(UpgradeListMainFrame) == 16 then
			UpgradeListDBVar.char.SavedOptions.tableUL:SetData(UpgradeListDBVar.char.SecondarySpecList.Other.Row, true);
		end
	end
	PanelTemplates_TabResize(UpgradeListDBVar.profile.tabcreate.Tab_1, 0, 93, 94);
	PanelTemplates_TabResize(UpgradeListDBVar.profile.tabcreate.Tab_2, 0, 93, 94);
	PanelTemplates_TabResize(UpgradeListDBVar.profile.tabcreate.Tab_3, 0, 93, 94);
	PanelTemplates_TabResize(UpgradeListDBVar.profile.tabcreate.Tab_4, 0, 93, 94);
	PanelTemplates_TabResize(UpgradeListDBVar.profile.tabcreate.Tab_5, 0, 93, 94);
	PanelTemplates_TabResize(UpgradeListDBVar.profile.tabcreate.Tab_6, 0, 93, 94);
	PanelTemplates_TabResize(UpgradeListDBVar.profile.tabcreate.Tab_7, 0, 93, 94);
	PanelTemplates_TabResize(UpgradeListDBVar.profile.tabcreate.Tab_8, 0, 93, 94);
	PanelTemplates_TabResize(UpgradeListDBVar.profile.tabcreate.Tab_9, 0, 93, 94);
	PanelTemplates_TabResize(UpgradeListDBVar.profile.tabcreate.Tab_10, 0, 93, 94);
	PanelTemplates_TabResize(UpgradeListDBVar.profile.tabcreate.Tab_11, 0, 93, 94);
	PanelTemplates_TabResize(UpgradeListDBVar.profile.tabcreate.Tab_12, 0, 93, 94);
	PanelTemplates_TabResize(UpgradeListDBVar.profile.tabcreate.Tab_13, 0, 102, 90);
	PanelTemplates_TabResize(UpgradeListDBVar.profile.tabcreate.Tab_14, 0, 94, 94);
	PanelTemplates_TabResize(UpgradeListDBVar.profile.tabcreate.Tab_15, 0, 94, 94);
	PanelTemplates_TabResize(UpgradeListDBVar.profile.tabcreate.Tab_16, 0, 94, 94);
	
	--statusbarfont:SetTextColor(1, 1, 1);
	--statusbarfont:SetText("UpgradeList v " .. UPGRADELIST_VERSION);
end

function UpgradeList:OpenUpgradeList(self)
	UpgradeListMainFrame:Show()
	if UpgradeListDBVar.profile.mainframe.showoptions == false then
		OptionsFrame:Hide()
	end
	InterfaceOptionsFrame:Hide()
	GameMenuButtonContinue:Click()
	UpgradeList:RefreshWindow()
end

local function EnterItemIntoDatabase(ItemEntryBox, PrimarySpecRadioButton, SecondarySpecRadioButton, UpgradeListMainFrame, priorityfield, statusbarfont, NoteEntryBox, itemName, itemLink, itemRarity, itemLevel, itemMinLevel, itemType, itemSubType, itemStackCount, itemEquipLoc, itemTexture, itemSellPrice, itemID)
	local priorityfieldnum = tonumber(priorityfield:GetText());
	if priorityfieldnum ~= nil then
		priorityfieldnum = math.floor(priorityfieldnum);
	end
	if itemEquipLoc == "INVTYPE_HEAD" then --Head Item
		if priorityfieldnum == nil and priorityfield:GetText() ~= "" then
			statusbarfont:SetTextColor(1, 0, 0);
			statusbarfont:SetText("Priority field must be a number.");
			priorityfield:HighlightText();
		elseif UpgradeListDBVar.char.SavedOptions.SelectedInstance == nil then
			statusbarfont:SetTextColor(1, 0, 0);
			statusbarfont:SetText("You must select an item location.");
			ItemEntryBox:ClearFocus();
			NoteEntryBox:ClearFocus();
			priorityfield:ClearFocus();
		elseif PrimarySpecRadioButton:GetChecked() then --Adding to Primary Spec List
			if priorityfield:GetText() == "" or priorityfieldnum > UpgradeListDBVar.char.PrimarySpecList.Head.Count then --Priority # entered was blank or bigger than the list of items
				UpgradeListDBVar.char.PrimarySpecList.Head.Row[UpgradeListDBVar.char.PrimarySpecList.Head.Count] = { UpgradeListDBVar.char.PrimarySpecList.Head.Count, itemLevel, itemLink, UpgradeListDBVar.char.SavedOptions.SelectedDifficulty, UpgradeListDBVar.char.SavedOptions.SelectedInstance, UpgradeListDBVar.char.SavedOptions.SelectedBoss, NoteEntryBox:GetText(), itemID };
			elseif priorityfieldnum <= UpgradeListDBVar.char.PrimarySpecList.Head.Count and priorityfieldnum > 0 then --If the priority number is equal to or less than the list length and not zero
				table.insert(UpgradeListDBVar.char.PrimarySpecList.Head.Row, priorityfieldnum, { priorityfieldnum, itemLevel, itemLink, UpgradeListDBVar.char.SavedOptions.SelectedDifficulty, UpgradeListDBVar.char.SavedOptions.SelectedInstance, UpgradeListDBVar.char.SavedOptions.SelectedBoss, NoteEntryBox:GetText(), itemID });
				for i = UpgradeListDBVar.char.PrimarySpecList.Head.Count, priorityfieldnum, -1 do
					UpgradeListDBVar.char.PrimarySpecList.Head.Row[i][1] = i;
				end
			end
			UpgradeListDBVar.char.PrimarySpecList.Head.Count = UpgradeListDBVar.char.PrimarySpecList.Head.Count + 1;
			statusbarfont:SetTextColor(0, 1, 0);
			statusbarfont:SetText("Successfully added " .. itemLink .. " to your Primary Spec's Head tab.");
			if (PanelTemplates_GetSelectedTab(UpgradeListMainFrame) == 1) and (UpgradeListDBVar.char.SavedOptions.PrimaryCheck:GetChecked() == 1) then --If you're viewing the tab you're adding to
				UpgradeList:RefreshWindow()
			end
			UpgradeListDBVar.char.SavedOptions.SelectedInstance = nil;
			UpgradeListDBVar.char.SavedOptions.SelectedBoss = nil;
			UpgradeListDBVar.char.SavedOptions.SelectedDifficulty = nil;
			ItemEntryBox:SetText("");
			ItemEntryBox:ClearFocus();
			NoteEntryBox:SetText("");
			NoteEntryBox:ClearFocus();
			priorityfield:SetText("");
			priorityfield:ClearFocus();
			UIDropDownMenu_SetText(DropDown_Button, "Location:");
		else --Adding to Secondary Spec List
			if priorityfield:GetText() == "" or priorityfieldnum > UpgradeListDBVar.char.SecondarySpecList.Head.Count then --Priority # entered was blank or bigger than the list of items
				UpgradeListDBVar.char.SecondarySpecList.Head.Row[UpgradeListDBVar.char.SecondarySpecList.Head.Count] = { UpgradeListDBVar.char.SecondarySpecList.Head.Count, itemLevel, itemLink, UpgradeListDBVar.char.SavedOptions.SelectedDifficulty, UpgradeListDBVar.char.SavedOptions.SelectedInstance, UpgradeListDBVar.char.SavedOptions.SelectedBoss, NoteEntryBox:GetText(), itemID };
			elseif priorityfieldnum <= UpgradeListDBVar.char.SecondarySpecList.Head.Count and priorityfieldnum > 0 then --If the priority number is equal to or less than the list length and not zero
				table.insert(UpgradeListDBVar.char.SecondarySpecList.Head.Row, priorityfieldnum, { priorityfieldnum, itemLevel, itemLink, UpgradeListDBVar.char.SavedOptions.SelectedDifficulty, UpgradeListDBVar.char.SavedOptions.SelectedInstance, UpgradeListDBVar.char.SavedOptions.SelectedBoss, NoteEntryBox:GetText(), itemID });
				for i = UpgradeListDBVar.char.SecondarySpecList.Head.Count, priorityfieldnum, -1 do
					UpgradeListDBVar.char.SecondarySpecList.Head.Row[i][1] = i;
				end
			end
			UpgradeListDBVar.char.SecondarySpecList.Head.Count = UpgradeListDBVar.char.SecondarySpecList.Head.Count + 1;
			statusbarfont:SetTextColor(0, 1, 0);
			statusbarfont:SetText("Successfully added " .. itemLink .. " to your Secondary Spec's Head tab.");
			if (PanelTemplates_GetSelectedTab(UpgradeListMainFrame) == 1) and (UpgradeListDBVar.char.SavedOptions.SecondaryCheck:GetChecked() == 1) then --If you're viewing the tab you're adding to
				UpgradeList:RefreshWindow()
			end
			UpgradeListDBVar.char.SavedOptions.SelectedInstance = nil;
			UpgradeListDBVar.char.SavedOptions.SelectedBoss = nil;
			UpgradeListDBVar.char.SavedOptions.SelectedDifficulty = nil;
			ItemEntryBox:SetText("");
			ItemEntryBox:ClearFocus();
			NoteEntryBox:SetText("");
			NoteEntryBox:ClearFocus();
			priorityfield:SetText("");
			priorityfield:ClearFocus();
			UIDropDownMenu_SetText(DropDown_Button, "Location:");
		end
	elseif itemEquipLoc == "INVTYPE_NECK" then --Neck Item
		if priorityfieldnum == nil and priorityfield:GetText() ~= "" then
			statusbarfont:SetTextColor(1, 0, 0);
			statusbarfont:SetText("Priority field must be a number.");
			priorityfield:HighlightText();
		elseif UpgradeListDBVar.char.SavedOptions.SelectedInstance == nil then
			statusbarfont:SetTextColor(1, 0, 0);
			statusbarfont:SetText("You must select an item location.");
			ItemEntryBox:ClearFocus();
			NoteEntryBox:ClearFocus();
			priorityfield:ClearFocus();
		elseif PrimarySpecRadioButton:GetChecked() then --Adding to Primary Spec List
			if priorityfield:GetText() == "" or priorityfieldnum > UpgradeListDBVar.char.PrimarySpecList.Neck.Count then --Priority # entered was blank or bigger than the list of items
				UpgradeListDBVar.char.PrimarySpecList.Neck.Row[UpgradeListDBVar.char.PrimarySpecList.Neck.Count] = { UpgradeListDBVar.char.PrimarySpecList.Neck.Count, itemLevel, itemLink, UpgradeListDBVar.char.SavedOptions.SelectedDifficulty, UpgradeListDBVar.char.SavedOptions.SelectedInstance, UpgradeListDBVar.char.SavedOptions.SelectedBoss, NoteEntryBox:GetText(), itemID };
			elseif priorityfieldnum <= UpgradeListDBVar.char.PrimarySpecList.Neck.Count and priorityfieldnum > 0 then --If the priority number is equal to or less than the list length and not zero
				table.insert(UpgradeListDBVar.char.PrimarySpecList.Neck.Row, priorityfieldnum, { priorityfieldnum, itemLevel, itemLink, UpgradeListDBVar.char.SavedOptions.SelectedDifficulty, UpgradeListDBVar.char.SavedOptions.SelectedInstance, UpgradeListDBVar.char.SavedOptions.SelectedBoss, NoteEntryBox:GetText(), itemID });
				for i = UpgradeListDBVar.char.PrimarySpecList.Neck.Count, priorityfieldnum, -1 do
					UpgradeListDBVar.char.PrimarySpecList.Neck.Row[i][1] = i;
				end
			end
			UpgradeListDBVar.char.PrimarySpecList.Neck.Count = UpgradeListDBVar.char.PrimarySpecList.Neck.Count + 1;
			statusbarfont:SetTextColor(0, 1, 0);
			statusbarfont:SetText("Successfully added " .. itemLink .. " to your Primary Spec's Neck tab.");
			if (PanelTemplates_GetSelectedTab(UpgradeListMainFrame) == 2) and (UpgradeListDBVar.char.SavedOptions.PrimaryCheck:GetChecked() == 1) then --If you're viewing the tab you're adding to
				UpgradeList:RefreshWindow()
			end
			UpgradeListDBVar.char.SavedOptions.SelectedInstance = nil;
			UpgradeListDBVar.char.SavedOptions.SelectedBoss = nil;
			UpgradeListDBVar.char.SavedOptions.SelectedDifficulty = nil;
			ItemEntryBox:SetText("");
			ItemEntryBox:ClearFocus();
			NoteEntryBox:SetText("");
			NoteEntryBox:ClearFocus();
			priorityfield:SetText("");
			priorityfield:ClearFocus();
			UIDropDownMenu_SetText(DropDown_Button, "Location:");
		else --Adding to Secondary Spec List
			if priorityfield:GetText() == "" or priorityfieldnum > UpgradeListDBVar.char.SecondarySpecList.Neck.Count then --Priority # entered was blank or bigger than the list of items
				UpgradeListDBVar.char.SecondarySpecList.Neck.Row[UpgradeListDBVar.char.SecondarySpecList.Neck.Count] = { UpgradeListDBVar.char.SecondarySpecList.Neck.Count, itemLevel, itemLink, UpgradeListDBVar.char.SavedOptions.SelectedDifficulty, UpgradeListDBVar.char.SavedOptions.SelectedInstance, UpgradeListDBVar.char.SavedOptions.SelectedBoss, NoteEntryBox:GetText(), itemID };
			elseif priorityfieldnum <= UpgradeListDBVar.char.SecondarySpecList.Neck.Count and priorityfieldnum > 0 then --If the priority number is equal to or less than the list length and not zero
				table.insert(UpgradeListDBVar.char.SecondarySpecList.Neck.Row, priorityfieldnum, { priorityfieldnum, itemLevel, itemLink, UpgradeListDBVar.char.SavedOptions.SelectedDifficulty, UpgradeListDBVar.char.SavedOptions.SelectedInstance, UpgradeListDBVar.char.SavedOptions.SelectedBoss, NoteEntryBox:GetText(), itemID });
				for i = UpgradeListDBVar.char.SecondarySpecList.Neck.Count, priorityfieldnum, -1 do
					UpgradeListDBVar.char.SecondarySpecList.Neck.Row[i][1] = i;
				end
			end
			UpgradeListDBVar.char.SecondarySpecList.Neck.Count = UpgradeListDBVar.char.SecondarySpecList.Neck.Count + 1;
			statusbarfont:SetTextColor(0, 1, 0);
			statusbarfont:SetText("Successfully added " .. itemLink .. " to your Secondary Spec's Neck tab.");
			if (PanelTemplates_GetSelectedTab(UpgradeListMainFrame) == 2) and (UpgradeListDBVar.char.SavedOptions.SecondaryCheck:GetChecked() == 1) then --If you're viewing the tab you're adding to
				UpgradeList:RefreshWindow()
			end
			UpgradeListDBVar.char.SavedOptions.SelectedInstance = nil;
			UpgradeListDBVar.char.SavedOptions.SelectedBoss = nil;
			UpgradeListDBVar.char.SavedOptions.SelectedDifficulty = nil;
			ItemEntryBox:SetText("");
			ItemEntryBox:ClearFocus();
			NoteEntryBox:SetText("");
			NoteEntryBox:ClearFocus();
			priorityfield:SetText("");
			priorityfield:ClearFocus();
			UIDropDownMenu_SetText(DropDown_Button, "Location:");
		end
	elseif itemEquipLoc == "INVTYPE_SHOULDER" then --Shoulder Item
		if priorityfieldnum == nil and priorityfield:GetText() ~= "" then
			statusbarfont:SetTextColor(1, 0, 0);
			statusbarfont:SetText("Priority field must be a number.");
			priorityfield:HighlightText();
		elseif UpgradeListDBVar.char.SavedOptions.SelectedInstance == nil then
			statusbarfont:SetTextColor(1, 0, 0);
			statusbarfont:SetText("You must select an item location.");
			ItemEntryBox:ClearFocus();
			NoteEntryBox:ClearFocus();
			priorityfield:ClearFocus();
		elseif PrimarySpecRadioButton:GetChecked() then --Adding to Primary Spec List
			if priorityfield:GetText() == "" or priorityfieldnum > UpgradeListDBVar.char.PrimarySpecList.Shoulder.Count then --Priority # entered was blank or bigger than the list of items
				UpgradeListDBVar.char.PrimarySpecList.Shoulder.Row[UpgradeListDBVar.char.PrimarySpecList.Shoulder.Count] = { UpgradeListDBVar.char.PrimarySpecList.Shoulder.Count, itemLevel, itemLink, UpgradeListDBVar.char.SavedOptions.SelectedDifficulty, UpgradeListDBVar.char.SavedOptions.SelectedInstance, UpgradeListDBVar.char.SavedOptions.SelectedBoss, NoteEntryBox:GetText(), itemID };
			elseif priorityfieldnum <= UpgradeListDBVar.char.PrimarySpecList.Shoulder.Count and priorityfieldnum > 0 then --If the priority number is equal to or less than the list length and not zero
				table.insert(UpgradeListDBVar.char.PrimarySpecList.Shoulder.Row, priorityfieldnum, { priorityfieldnum, itemLevel, itemLink, UpgradeListDBVar.char.SavedOptions.SelectedDifficulty, UpgradeListDBVar.char.SavedOptions.SelectedInstance, UpgradeListDBVar.char.SavedOptions.SelectedBoss, NoteEntryBox:GetText(), itemID });
				for i = UpgradeListDBVar.char.PrimarySpecList.Shoulder.Count, priorityfieldnum, -1 do
					UpgradeListDBVar.char.PrimarySpecList.Shoulder.Row[i][1] = i;
				end
			end
			UpgradeListDBVar.char.PrimarySpecList.Shoulder.Count = UpgradeListDBVar.char.PrimarySpecList.Shoulder.Count + 1;
			statusbarfont:SetTextColor(0, 1, 0);
			statusbarfont:SetText("Successfully added " .. itemLink .. " to your Primary Spec's Shoulder tab.");
			if (PanelTemplates_GetSelectedTab(UpgradeListMainFrame) == 3) and (UpgradeListDBVar.char.SavedOptions.PrimaryCheck:GetChecked() == 1) then --If you're viewing the tab you're adding to
				UpgradeList:RefreshWindow()
			end
			UpgradeListDBVar.char.SavedOptions.SelectedInstance = nil;
			UpgradeListDBVar.char.SavedOptions.SelectedBoss = nil;
			UpgradeListDBVar.char.SavedOptions.SelectedDifficulty = nil;
			ItemEntryBox:SetText("");
			ItemEntryBox:ClearFocus();
			NoteEntryBox:SetText("");
			NoteEntryBox:ClearFocus();
			priorityfield:SetText("");
			priorityfield:ClearFocus();
			UIDropDownMenu_SetText(DropDown_Button, "Location:");
		else --Adding to Secondary Spec List
			if priorityfield:GetText() == "" or priorityfieldnum > UpgradeListDBVar.char.SecondarySpecList.Shoulder.Count then --Priority # entered was blank or bigger than the list of items
				UpgradeListDBVar.char.SecondarySpecList.Shoulder.Row[UpgradeListDBVar.char.SecondarySpecList.Shoulder.Count] = { UpgradeListDBVar.char.SecondarySpecList.Shoulder.Count, itemLevel, itemLink, UpgradeListDBVar.char.SavedOptions.SelectedDifficulty, UpgradeListDBVar.char.SavedOptions.SelectedInstance, UpgradeListDBVar.char.SavedOptions.SelectedBoss, NoteEntryBox:GetText(), itemID };
			elseif priorityfieldnum <= UpgradeListDBVar.char.SecondarySpecList.Shoulder.Count and priorityfieldnum > 0 then --If the priority number is equal to or less than the list length and not zero
				table.insert(UpgradeListDBVar.char.SecondarySpecList.Shoulder.Row, priorityfieldnum, { priorityfieldnum, itemLevel, itemLink, UpgradeListDBVar.char.SavedOptions.SelectedDifficulty, UpgradeListDBVar.char.SavedOptions.SelectedInstance, UpgradeListDBVar.char.SavedOptions.SelectedBoss, NoteEntryBox:GetText(), itemID });
				for i = UpgradeListDBVar.char.SecondarySpecList.Shoulder.Count, priorityfieldnum, -1 do
					UpgradeListDBVar.char.SecondarySpecList.Shoulder.Row[i][1] = i;
				end
			end
			UpgradeListDBVar.char.SecondarySpecList.Shoulder.Count = UpgradeListDBVar.char.SecondarySpecList.Shoulder.Count + 1;
			statusbarfont:SetTextColor(0, 1, 0);
			statusbarfont:SetText("Successfully added " .. itemLink .. " to your Secondary Spec's Shoulder tab.");
			if (PanelTemplates_GetSelectedTab(UpgradeListMainFrame) == 3) and (UpgradeListDBVar.char.SavedOptions.SecondaryCheck:GetChecked() == 1) then --If you're viewing the tab you're adding to
				UpgradeList:RefreshWindow()
			end
			UpgradeListDBVar.char.SavedOptions.SelectedInstance = nil;
			UpgradeListDBVar.char.SavedOptions.SelectedBoss = nil;
			UpgradeListDBVar.char.SavedOptions.SelectedDifficulty = nil;
			ItemEntryBox:SetText("");
			ItemEntryBox:ClearFocus();
			NoteEntryBox:SetText("");
			NoteEntryBox:ClearFocus();
			priorityfield:SetText("");
			priorityfield:ClearFocus();
			UIDropDownMenu_SetText(DropDown_Button, "Location:");
		end
	elseif itemEquipLoc == "INVTYPE_CLOAK" then --Back Item
		if priorityfieldnum == nil and priorityfield:GetText() ~= "" then
			statusbarfont:SetTextColor(1, 0, 0);
			statusbarfont:SetText("Priority field must be a number.");
			priorityfield:HighlightText();
		elseif UpgradeListDBVar.char.SavedOptions.SelectedInstance == nil then
			statusbarfont:SetTextColor(1, 0, 0);
			statusbarfont:SetText("You must select an item location.");
			ItemEntryBox:ClearFocus();
			NoteEntryBox:ClearFocus();
			priorityfield:ClearFocus();
		elseif PrimarySpecRadioButton:GetChecked() then --Adding to Primary Spec List
			if priorityfield:GetText() == "" or priorityfieldnum > UpgradeListDBVar.char.PrimarySpecList.Back.Count then --Priority # entered was blank or bigger than the list of items
				UpgradeListDBVar.char.PrimarySpecList.Back.Row[UpgradeListDBVar.char.PrimarySpecList.Back.Count] = { UpgradeListDBVar.char.PrimarySpecList.Back.Count, itemLevel, itemLink, UpgradeListDBVar.char.SavedOptions.SelectedDifficulty, UpgradeListDBVar.char.SavedOptions.SelectedInstance, UpgradeListDBVar.char.SavedOptions.SelectedBoss, NoteEntryBox:GetText(), itemID };
			elseif priorityfieldnum <= UpgradeListDBVar.char.PrimarySpecList.Back.Count and priorityfieldnum > 0 then --If the priority number is equal to or less than the list length and not zero
				table.insert(UpgradeListDBVar.char.PrimarySpecList.Back.Row, priorityfieldnum, { priorityfieldnum, itemLevel, itemLink, UpgradeListDBVar.char.SavedOptions.SelectedDifficulty, UpgradeListDBVar.char.SavedOptions.SelectedInstance, UpgradeListDBVar.char.SavedOptions.SelectedBoss, NoteEntryBox:GetText(), itemID });
				for i = UpgradeListDBVar.char.PrimarySpecList.Back.Count, priorityfieldnum, -1 do
					UpgradeListDBVar.char.PrimarySpecList.Back.Row[i][1] = i;
				end
			end
			UpgradeListDBVar.char.PrimarySpecList.Back.Count = UpgradeListDBVar.char.PrimarySpecList.Back.Count + 1;
			statusbarfont:SetTextColor(0, 1, 0);
			statusbarfont:SetText("Successfully added " .. itemLink .. " to your Primary Spec's Back tab.");
			if (PanelTemplates_GetSelectedTab(UpgradeListMainFrame) == 4) and (UpgradeListDBVar.char.SavedOptions.PrimaryCheck:GetChecked() == 1) then --If you're viewing the tab you're adding to
				UpgradeList:RefreshWindow()
			end
			UpgradeListDBVar.char.SavedOptions.SelectedInstance = nil;
			UpgradeListDBVar.char.SavedOptions.SelectedBoss = nil;
			UpgradeListDBVar.char.SavedOptions.SelectedDifficulty = nil;
			ItemEntryBox:SetText("");
			ItemEntryBox:ClearFocus();
			NoteEntryBox:SetText("");
			NoteEntryBox:ClearFocus();
			priorityfield:SetText("");
			priorityfield:ClearFocus();
			UIDropDownMenu_SetText(DropDown_Button, "Location:");
		else --Adding to Secondary Spec List
			if priorityfield:GetText() == "" or priorityfieldnum > UpgradeListDBVar.char.SecondarySpecList.Back.Count then --Priority # entered was blank or bigger than the list of items
				UpgradeListDBVar.char.SecondarySpecList.Back.Row[UpgradeListDBVar.char.SecondarySpecList.Back.Count] = { UpgradeListDBVar.char.SecondarySpecList.Back.Count, itemLevel, itemLink, UpgradeListDBVar.char.SavedOptions.SelectedDifficulty, UpgradeListDBVar.char.SavedOptions.SelectedInstance, UpgradeListDBVar.char.SavedOptions.SelectedBoss, NoteEntryBox:GetText(), itemID };
			elseif priorityfieldnum <= UpgradeListDBVar.char.SecondarySpecList.Back.Count and priorityfieldnum > 0 then --If the priority number is equal to or less than the list length and not zero
				table.insert(UpgradeListDBVar.char.SecondarySpecList.Back.Row, priorityfieldnum, { priorityfieldnum, itemLevel, itemLink, UpgradeListDBVar.char.SavedOptions.SelectedDifficulty, UpgradeListDBVar.char.SavedOptions.SelectedInstance, UpgradeListDBVar.char.SavedOptions.SelectedBoss, NoteEntryBox:GetText(), itemID });
				for i = UpgradeListDBVar.char.SecondarySpecList.Back.Count, priorityfieldnum, -1 do
					UpgradeListDBVar.char.SecondarySpecList.Back.Row[i][1] = i;
				end
			end
			UpgradeListDBVar.char.SecondarySpecList.Back.Count = UpgradeListDBVar.char.SecondarySpecList.Back.Count + 1;
			statusbarfont:SetTextColor(0, 1, 0);
			statusbarfont:SetText("Successfully added " .. itemLink .. " to your Secondary Spec's Back tab.");
			if (PanelTemplates_GetSelectedTab(UpgradeListMainFrame) == 4) and (UpgradeListDBVar.char.SavedOptions.SecondaryCheck:GetChecked() == 1) then --If you're viewing the tab you're adding to
				UpgradeList:RefreshWindow()
			end
			UpgradeListDBVar.char.SavedOptions.SelectedInstance = nil;
			UpgradeListDBVar.char.SavedOptions.SelectedBoss = nil;
			UpgradeListDBVar.char.SavedOptions.SelectedDifficulty = nil;
			ItemEntryBox:SetText("");
			ItemEntryBox:ClearFocus();
			NoteEntryBox:SetText("");
			NoteEntryBox:ClearFocus();
			priorityfield:SetText("");
			priorityfield:ClearFocus();
			UIDropDownMenu_SetText(DropDown_Button, "Location:");
		end
	elseif itemEquipLoc == "INVTYPE_CHEST" or itemEquipLoc == "INVTYPE_ROBE" then --Chest Item
		if priorityfieldnum == nil and priorityfield:GetText() ~= "" then
			statusbarfont:SetTextColor(1, 0, 0);
			statusbarfont:SetText("Priority field must be a number.");
			priorityfield:HighlightText();
		elseif UpgradeListDBVar.char.SavedOptions.SelectedInstance == nil then
			statusbarfont:SetTextColor(1, 0, 0);
			statusbarfont:SetText("You must select an item location.");
			ItemEntryBox:ClearFocus();
			NoteEntryBox:ClearFocus();
			priorityfield:ClearFocus();
		elseif PrimarySpecRadioButton:GetChecked() then --Adding to Primary Spec List
			if priorityfield:GetText() == "" or priorityfieldnum > UpgradeListDBVar.char.PrimarySpecList.Chest.Count then --Priority # entered was blank or bigger than the list of items
				UpgradeListDBVar.char.PrimarySpecList.Chest.Row[UpgradeListDBVar.char.PrimarySpecList.Chest.Count] = { UpgradeListDBVar.char.PrimarySpecList.Chest.Count, itemLevel, itemLink, UpgradeListDBVar.char.SavedOptions.SelectedDifficulty, UpgradeListDBVar.char.SavedOptions.SelectedInstance, UpgradeListDBVar.char.SavedOptions.SelectedBoss, NoteEntryBox:GetText(), itemID };
			elseif priorityfieldnum <= UpgradeListDBVar.char.PrimarySpecList.Chest.Count and priorityfieldnum > 0 then --If the priority number is equal to or less than the list length and not zero
				table.insert(UpgradeListDBVar.char.PrimarySpecList.Chest.Row, priorityfieldnum, { priorityfieldnum, itemLevel, itemLink, UpgradeListDBVar.char.SavedOptions.SelectedDifficulty, UpgradeListDBVar.char.SavedOptions.SelectedInstance, UpgradeListDBVar.char.SavedOptions.SelectedBoss, NoteEntryBox:GetText(), itemID });
				for i = UpgradeListDBVar.char.PrimarySpecList.Chest.Count, priorityfieldnum, -1 do
					UpgradeListDBVar.char.PrimarySpecList.Chest.Row[i][1] = i;
				end
			end
			UpgradeListDBVar.char.PrimarySpecList.Chest.Count = UpgradeListDBVar.char.PrimarySpecList.Chest.Count + 1;
			statusbarfont:SetTextColor(0, 1, 0);
			statusbarfont:SetText("Successfully added " .. itemLink .. " to your Primary Spec's Chest tab.");
			if (PanelTemplates_GetSelectedTab(UpgradeListMainFrame) == 5) and (UpgradeListDBVar.char.SavedOptions.PrimaryCheck:GetChecked() == 1) then --If you're viewing the tab you're adding to
				UpgradeList:RefreshWindow()
			end
			UpgradeListDBVar.char.SavedOptions.SelectedInstance = nil;
			UpgradeListDBVar.char.SavedOptions.SelectedBoss = nil;
			UpgradeListDBVar.char.SavedOptions.SelectedDifficulty = nil;
			ItemEntryBox:SetText("");
			ItemEntryBox:ClearFocus();
			NoteEntryBox:SetText("");
			NoteEntryBox:ClearFocus();
			priorityfield:SetText("");
			priorityfield:ClearFocus();
			UIDropDownMenu_SetText(DropDown_Button, "Location:");
		else --Adding to Secondary Spec List
			if priorityfield:GetText() == "" or priorityfieldnum > UpgradeListDBVar.char.SecondarySpecList.Chest.Count then --Priority # entered was blank or bigger than the list of items
				UpgradeListDBVar.char.SecondarySpecList.Chest.Row[UpgradeListDBVar.char.SecondarySpecList.Chest.Count] = { UpgradeListDBVar.char.SecondarySpecList.Chest.Count, itemLevel, itemLink, UpgradeListDBVar.char.SavedOptions.SelectedDifficulty, UpgradeListDBVar.char.SavedOptions.SelectedInstance, UpgradeListDBVar.char.SavedOptions.SelectedBoss, NoteEntryBox:GetText(), itemID };
			elseif priorityfieldnum <= UpgradeListDBVar.char.SecondarySpecList.Chest.Count and priorityfieldnum > 0 then --If the priority number is equal to or less than the list length and not zero
				table.insert(UpgradeListDBVar.char.SecondarySpecList.Chest.Row, priorityfieldnum, { priorityfieldnum, itemLevel, itemLink, UpgradeListDBVar.char.SavedOptions.SelectedDifficulty, UpgradeListDBVar.char.SavedOptions.SelectedInstance, UpgradeListDBVar.char.SavedOptions.SelectedBoss, NoteEntryBox:GetText(), itemID });
				for i = UpgradeListDBVar.char.SecondarySpecList.Chest.Count, priorityfieldnum, -1 do
					UpgradeListDBVar.char.SecondarySpecList.Chest.Row[i][1] = i;
				end
			end
			UpgradeListDBVar.char.SecondarySpecList.Chest.Count = UpgradeListDBVar.char.SecondarySpecList.Chest.Count + 1;
			statusbarfont:SetTextColor(0, 1, 0);
			statusbarfont:SetText("Successfully added " .. itemLink .. " to your Secondary Spec's Chest tab.");
			if (PanelTemplates_GetSelectedTab(UpgradeListMainFrame) == 5) and (UpgradeListDBVar.char.SavedOptions.SecondaryCheck:GetChecked() == 1) then --If you're viewing the tab you're adding to
				UpgradeList:RefreshWindow()
			end
			UpgradeListDBVar.char.SavedOptions.SelectedInstance = nil;
			UpgradeListDBVar.char.SavedOptions.SelectedBoss = nil;
			UpgradeListDBVar.char.SavedOptions.SelectedDifficulty = nil;
			ItemEntryBox:SetText("");
			ItemEntryBox:ClearFocus();
			NoteEntryBox:SetText("");
			NoteEntryBox:ClearFocus();
			priorityfield:SetText("");
			priorityfield:ClearFocus();
			UIDropDownMenu_SetText(DropDown_Button, "Location:");
		end
	elseif itemEquipLoc == "INVTYPE_WRIST" then --Wrist Item
		if priorityfieldnum == nil and priorityfield:GetText() ~= "" then
			statusbarfont:SetTextColor(1, 0, 0);
			statusbarfont:SetText("Priority field must be a number.");
			priorityfield:HighlightText();
		elseif UpgradeListDBVar.char.SavedOptions.SelectedInstance == nil then
			statusbarfont:SetTextColor(1, 0, 0);
			statusbarfont:SetText("You must select an item location.");
			ItemEntryBox:ClearFocus();
			NoteEntryBox:ClearFocus();
			priorityfield:ClearFocus();
		elseif PrimarySpecRadioButton:GetChecked() then --Adding to Primary Spec List
			if priorityfield:GetText() == "" or priorityfieldnum > UpgradeListDBVar.char.PrimarySpecList.Wrist.Count then --Priority # entered was blank or bigger than the list of items
				UpgradeListDBVar.char.PrimarySpecList.Wrist.Row[UpgradeListDBVar.char.PrimarySpecList.Wrist.Count] = { UpgradeListDBVar.char.PrimarySpecList.Wrist.Count, itemLevel, itemLink, UpgradeListDBVar.char.SavedOptions.SelectedDifficulty, UpgradeListDBVar.char.SavedOptions.SelectedInstance, UpgradeListDBVar.char.SavedOptions.SelectedBoss, NoteEntryBox:GetText(), itemID };
			elseif priorityfieldnum <= UpgradeListDBVar.char.PrimarySpecList.Wrist.Count and priorityfieldnum > 0 then --If the priority number is equal to or less than the list length and not zero
				table.insert(UpgradeListDBVar.char.PrimarySpecList.Wrist.Row, priorityfieldnum, { priorityfieldnum, itemLevel, itemLink, UpgradeListDBVar.char.SavedOptions.SelectedDifficulty, UpgradeListDBVar.char.SavedOptions.SelectedInstance, UpgradeListDBVar.char.SavedOptions.SelectedBoss, NoteEntryBox:GetText(), itemID });
				for i = UpgradeListDBVar.char.PrimarySpecList.Wrist.Count, priorityfieldnum, -1 do
					UpgradeListDBVar.char.PrimarySpecList.Wrist.Row[i][1] = i;
				end
			end
			UpgradeListDBVar.char.PrimarySpecList.Wrist.Count = UpgradeListDBVar.char.PrimarySpecList.Wrist.Count + 1;
			statusbarfont:SetTextColor(0, 1, 0);
			statusbarfont:SetText("Successfully added " .. itemLink .. " to your Primary Spec's Wrist tab.");
			if (PanelTemplates_GetSelectedTab(UpgradeListMainFrame) == 6) and (UpgradeListDBVar.char.SavedOptions.PrimaryCheck:GetChecked() == 1) then --If you're viewing the tab you're adding to
				UpgradeList:RefreshWindow()
			end
			UpgradeListDBVar.char.SavedOptions.SelectedInstance = nil;
			UpgradeListDBVar.char.SavedOptions.SelectedBoss = nil;
			UpgradeListDBVar.char.SavedOptions.SelectedDifficulty = nil;
			ItemEntryBox:SetText("");
			ItemEntryBox:ClearFocus();
			NoteEntryBox:SetText("");
			NoteEntryBox:ClearFocus();
			priorityfield:SetText("");
			priorityfield:ClearFocus();
			UIDropDownMenu_SetText(DropDown_Button, "Location:");
		else --Adding to Secondary Spec List
			if priorityfield:GetText() == "" or priorityfieldnum > UpgradeListDBVar.char.SecondarySpecList.Wrist.Count then --Priority # entered was blank or bigger than the list of items
				UpgradeListDBVar.char.SecondarySpecList.Wrist.Row[UpgradeListDBVar.char.SecondarySpecList.Wrist.Count] = { UpgradeListDBVar.char.SecondarySpecList.Wrist.Count, itemLevel, itemLink, UpgradeListDBVar.char.SavedOptions.SelectedDifficulty, UpgradeListDBVar.char.SavedOptions.SelectedInstance, UpgradeListDBVar.char.SavedOptions.SelectedBoss, NoteEntryBox:GetText(), itemID };
			elseif priorityfieldnum <= UpgradeListDBVar.char.SecondarySpecList.Wrist.Count and priorityfieldnum > 0 then --If the priority number is equal to or less than the list length and not zero
				table.insert(UpgradeListDBVar.char.SecondarySpecList.Wrist.Row, priorityfieldnum, { priorityfieldnum, itemLevel, itemLink, UpgradeListDBVar.char.SavedOptions.SelectedDifficulty, UpgradeListDBVar.char.SavedOptions.SelectedInstance, UpgradeListDBVar.char.SavedOptions.SelectedBoss, NoteEntryBox:GetText(), itemID });
				for i = UpgradeListDBVar.char.SecondarySpecList.Wrist.Count, priorityfieldnum, -1 do
					UpgradeListDBVar.char.SecondarySpecList.Wrist.Row[i][1] = i;
				end
			end
			UpgradeListDBVar.char.SecondarySpecList.Wrist.Count = UpgradeListDBVar.char.SecondarySpecList.Wrist.Count + 1;
			statusbarfont:SetTextColor(0, 1, 0);
			statusbarfont:SetText("Successfully added " .. itemLink .. " to your Secondary Spec's Wrist tab.");
			if (PanelTemplates_GetSelectedTab(UpgradeListMainFrame) == 6) and (UpgradeListDBVar.char.SavedOptions.SecondaryCheck:GetChecked() == 1) then --If you're viewing the tab you're adding to
				UpgradeList:RefreshWindow()
			end
			UpgradeListDBVar.char.SavedOptions.SelectedInstance = nil;
			UpgradeListDBVar.char.SavedOptions.SelectedBoss = nil;
			UpgradeListDBVar.char.SavedOptions.SelectedDifficulty = nil;
			ItemEntryBox:SetText("");
			ItemEntryBox:ClearFocus();
			NoteEntryBox:SetText("");
			NoteEntryBox:ClearFocus();
			priorityfield:SetText("");
			priorityfield:ClearFocus();
			UIDropDownMenu_SetText(DropDown_Button, "Location:");
		end
	elseif itemEquipLoc == "INVTYPE_HAND" then --Hand Item
		if priorityfieldnum == nil and priorityfield:GetText() ~= "" then
			statusbarfont:SetTextColor(1, 0, 0);
			statusbarfont:SetText("Priority field must be a number.");
			priorityfield:HighlightText();
		elseif UpgradeListDBVar.char.SavedOptions.SelectedInstance == nil then
			statusbarfont:SetTextColor(1, 0, 0);
			statusbarfont:SetText("You must select an item location.");
			ItemEntryBox:ClearFocus();
			NoteEntryBox:ClearFocus();
			priorityfield:ClearFocus();
		elseif PrimarySpecRadioButton:GetChecked() then --Adding to Primary Spec List
			if priorityfield:GetText() == "" or priorityfieldnum > UpgradeListDBVar.char.PrimarySpecList.Hand.Count then --Priority # entered was blank or bigger than the list of items
				UpgradeListDBVar.char.PrimarySpecList.Hand.Row[UpgradeListDBVar.char.PrimarySpecList.Hand.Count] = { UpgradeListDBVar.char.PrimarySpecList.Hand.Count, itemLevel, itemLink, UpgradeListDBVar.char.SavedOptions.SelectedDifficulty, UpgradeListDBVar.char.SavedOptions.SelectedInstance, UpgradeListDBVar.char.SavedOptions.SelectedBoss, NoteEntryBox:GetText(), itemID };
			elseif priorityfieldnum <= UpgradeListDBVar.char.PrimarySpecList.Hand.Count and priorityfieldnum > 0 then --If the priority number is equal to or less than the list length and not zero
				table.insert(UpgradeListDBVar.char.PrimarySpecList.Hand.Row, priorityfieldnum, { priorityfieldnum, itemLevel, itemLink, UpgradeListDBVar.char.SavedOptions.SelectedDifficulty, UpgradeListDBVar.char.SavedOptions.SelectedInstance, UpgradeListDBVar.char.SavedOptions.SelectedBoss, NoteEntryBox:GetText(), itemID });
				for i = UpgradeListDBVar.char.PrimarySpecList.Hand.Count, priorityfieldnum, -1 do
					UpgradeListDBVar.char.PrimarySpecList.Hand.Row[i][1] = i;
				end
			end
			UpgradeListDBVar.char.PrimarySpecList.Hand.Count = UpgradeListDBVar.char.PrimarySpecList.Hand.Count + 1;
			statusbarfont:SetTextColor(0, 1, 0);
			statusbarfont:SetText("Successfully added " .. itemLink .. " to your Primary Spec's Hand tab.");
			if (PanelTemplates_GetSelectedTab(UpgradeListMainFrame) == 7) and (UpgradeListDBVar.char.SavedOptions.PrimaryCheck:GetChecked() == 1) then --If you're viewing the tab you're adding to
				UpgradeList:RefreshWindow()
			end
			UpgradeListDBVar.char.SavedOptions.SelectedInstance = nil;
			UpgradeListDBVar.char.SavedOptions.SelectedBoss = nil;
			UpgradeListDBVar.char.SavedOptions.SelectedDifficulty = nil;
			ItemEntryBox:SetText("");
			ItemEntryBox:ClearFocus();
			NoteEntryBox:SetText("");
			NoteEntryBox:ClearFocus();
			priorityfield:SetText("");
			priorityfield:ClearFocus();
			UIDropDownMenu_SetText(DropDown_Button, "Location:");
		else --Adding to Secondary Spec List
			if priorityfield:GetText() == "" or priorityfieldnum > UpgradeListDBVar.char.SecondarySpecList.Hand.Count then --Priority # entered was blank or bigger than the list of items
				UpgradeListDBVar.char.SecondarySpecList.Hand.Row[UpgradeListDBVar.char.SecondarySpecList.Hand.Count] = { UpgradeListDBVar.char.SecondarySpecList.Hand.Count, itemLevel, itemLink, UpgradeListDBVar.char.SavedOptions.SelectedDifficulty, UpgradeListDBVar.char.SavedOptions.SelectedInstance, UpgradeListDBVar.char.SavedOptions.SelectedBoss, NoteEntryBox:GetText(), itemID };
			elseif priorityfieldnum <= UpgradeListDBVar.char.SecondarySpecList.Hand.Count and priorityfieldnum > 0 then --If the priority number is equal to or less than the list length and not zero
				table.insert(UpgradeListDBVar.char.SecondarySpecList.Hand.Row, priorityfieldnum, { priorityfieldnum, itemLevel, itemLink, UpgradeListDBVar.char.SavedOptions.SelectedDifficulty, UpgradeListDBVar.char.SavedOptions.SelectedInstance, UpgradeListDBVar.char.SavedOptions.SelectedBoss, NoteEntryBox:GetText(), itemID });
				for i = UpgradeListDBVar.char.SecondarySpecList.Hand.Count, priorityfieldnum, -1 do
					UpgradeListDBVar.char.SecondarySpecList.Hand.Row[i][1] = i;
				end
			end
			UpgradeListDBVar.char.SecondarySpecList.Hand.Count = UpgradeListDBVar.char.SecondarySpecList.Hand.Count + 1;
			statusbarfont:SetTextColor(0, 1, 0);
			statusbarfont:SetText("Successfully added " .. itemLink .. " to your Secondary Spec's Hand tab.");
			if (PanelTemplates_GetSelectedTab(UpgradeListMainFrame) == 7) and (UpgradeListDBVar.char.SavedOptions.SecondaryCheck:GetChecked() == 1) then --If you're viewing the tab you're adding to
				UpgradeList:RefreshWindow()
			end
			UpgradeListDBVar.char.SavedOptions.SelectedInstance = nil;
			UpgradeListDBVar.char.SavedOptions.SelectedBoss = nil;
			UpgradeListDBVar.char.SavedOptions.SelectedDifficulty = nil;
			ItemEntryBox:SetText("");
			ItemEntryBox:ClearFocus();
			NoteEntryBox:SetText("");
			NoteEntryBox:ClearFocus();
			priorityfield:SetText("");
			priorityfield:ClearFocus();
			UIDropDownMenu_SetText(DropDown_Button, "Location:");
		end
	elseif itemEquipLoc == "INVTYPE_WAIST" then --Waist Item
		if priorityfieldnum == nil and priorityfield:GetText() ~= "" then
			statusbarfont:SetTextColor(1, 0, 0);
			statusbarfont:SetText("Priority field must be a number.");
			priorityfield:HighlightText();
		elseif UpgradeListDBVar.char.SavedOptions.SelectedInstance == nil then
			statusbarfont:SetTextColor(1, 0, 0);
			statusbarfont:SetText("You must select an item location.");
			ItemEntryBox:ClearFocus();
			NoteEntryBox:ClearFocus();
			priorityfield:ClearFocus();
		elseif PrimarySpecRadioButton:GetChecked() then --Adding to Primary Spec List
			if priorityfield:GetText() == "" or priorityfieldnum > UpgradeListDBVar.char.PrimarySpecList.Waist.Count then --Priority # entered was blank or bigger than the list of items
				UpgradeListDBVar.char.PrimarySpecList.Waist.Row[UpgradeListDBVar.char.PrimarySpecList.Waist.Count] = { UpgradeListDBVar.char.PrimarySpecList.Waist.Count, itemLevel, itemLink, UpgradeListDBVar.char.SavedOptions.SelectedDifficulty, UpgradeListDBVar.char.SavedOptions.SelectedInstance, UpgradeListDBVar.char.SavedOptions.SelectedBoss, NoteEntryBox:GetText(), itemID };
			elseif priorityfieldnum <= UpgradeListDBVar.char.PrimarySpecList.Waist.Count and priorityfieldnum > 0 then --If the priority number is equal to or less than the list length and not zero
				table.insert(UpgradeListDBVar.char.PrimarySpecList.Waist.Row, priorityfieldnum, { priorityfieldnum, itemLevel, itemLink, UpgradeListDBVar.char.SavedOptions.SelectedDifficulty, UpgradeListDBVar.char.SavedOptions.SelectedInstance, UpgradeListDBVar.char.SavedOptions.SelectedBoss, NoteEntryBox:GetText(), itemID });
				for i = UpgradeListDBVar.char.PrimarySpecList.Waist.Count, priorityfieldnum, -1 do
					UpgradeListDBVar.char.PrimarySpecList.Waist.Row[i][1] = i;
				end
			end
			UpgradeListDBVar.char.PrimarySpecList.Waist.Count = UpgradeListDBVar.char.PrimarySpecList.Waist.Count + 1;
			statusbarfont:SetTextColor(0, 1, 0);
			statusbarfont:SetText("Successfully added " .. itemLink .. " to your Primary Spec's Waist tab.");
			if (PanelTemplates_GetSelectedTab(UpgradeListMainFrame) == 8) and (UpgradeListDBVar.char.SavedOptions.PrimaryCheck:GetChecked() == 1) then --If you're viewing the tab you're adding to
				UpgradeList:RefreshWindow()
			end
			UpgradeListDBVar.char.SavedOptions.SelectedInstance = nil;
			UpgradeListDBVar.char.SavedOptions.SelectedBoss = nil;
			UpgradeListDBVar.char.SavedOptions.SelectedDifficulty = nil;
			ItemEntryBox:SetText("");
			ItemEntryBox:ClearFocus();
			NoteEntryBox:SetText("");
			NoteEntryBox:ClearFocus();
			priorityfield:SetText("");
			priorityfield:ClearFocus();
			UIDropDownMenu_SetText(DropDown_Button, "Location:");
		else --Adding to Secondary Spec List
			if priorityfield:GetText() == "" or priorityfieldnum > UpgradeListDBVar.char.SecondarySpecList.Waist.Count then --Priority # entered was blank or bigger than the list of items
				UpgradeListDBVar.char.SecondarySpecList.Waist.Row[UpgradeListDBVar.char.SecondarySpecList.Waist.Count] = { UpgradeListDBVar.char.SecondarySpecList.Waist.Count, itemLevel, itemLink, UpgradeListDBVar.char.SavedOptions.SelectedDifficulty, UpgradeListDBVar.char.SavedOptions.SelectedInstance, UpgradeListDBVar.char.SavedOptions.SelectedBoss, NoteEntryBox:GetText(), itemID };
			elseif priorityfieldnum <= UpgradeListDBVar.char.SecondarySpecList.Waist.Count and priorityfieldnum > 0 then --If the priority number is equal to or less than the list length and not zero
				table.insert(UpgradeListDBVar.char.SecondarySpecList.Waist.Row, priorityfieldnum, { priorityfieldnum, itemLevel, itemLink, UpgradeListDBVar.char.SavedOptions.SelectedDifficulty, UpgradeListDBVar.char.SavedOptions.SelectedInstance, UpgradeListDBVar.char.SavedOptions.SelectedBoss, NoteEntryBox:GetText(), itemID });
				for i = UpgradeListDBVar.char.SecondarySpecList.Waist.Count, priorityfieldnum, -1 do
					UpgradeListDBVar.char.SecondarySpecList.Waist.Row[i][1] = i;
				end
			end
			UpgradeListDBVar.char.SecondarySpecList.Waist.Count = UpgradeListDBVar.char.SecondarySpecList.Waist.Count + 1;
			statusbarfont:SetTextColor(0, 1, 0);
			statusbarfont:SetText("Successfully added " .. itemLink .. " to your Secondary Spec's Waist tab.");
			if (PanelTemplates_GetSelectedTab(UpgradeListMainFrame) == 8) and (UpgradeListDBVar.char.SavedOptions.SecondaryCheck:GetChecked() == 1) then --If you're viewing the tab you're adding to
				UpgradeList:RefreshWindow()
			end
			UpgradeListDBVar.char.SavedOptions.SelectedInstance = nil;
			UpgradeListDBVar.char.SavedOptions.SelectedBoss = nil;
			UpgradeListDBVar.char.SavedOptions.SelectedDifficulty = nil;
			ItemEntryBox:SetText("");
			ItemEntryBox:ClearFocus();
			NoteEntryBox:SetText("");
			NoteEntryBox:ClearFocus();
			priorityfield:SetText("");
			priorityfield:ClearFocus();
			UIDropDownMenu_SetText(DropDown_Button, "Location:");
		end
	elseif itemEquipLoc == "INVTYPE_LEGS" then --Leg Item
		if priorityfieldnum == nil and priorityfield:GetText() ~= "" then
			statusbarfont:SetTextColor(1, 0, 0);
			statusbarfont:SetText("Priority field must be a number.");
			priorityfield:HighlightText();
		elseif UpgradeListDBVar.char.SavedOptions.SelectedInstance == nil then
			statusbarfont:SetTextColor(1, 0, 0);
			statusbarfont:SetText("You must select an item location.");
			ItemEntryBox:ClearFocus();
			NoteEntryBox:ClearFocus();
			priorityfield:ClearFocus();
		elseif PrimarySpecRadioButton:GetChecked() then --Adding to Primary Spec List
			if priorityfield:GetText() == "" or priorityfieldnum > UpgradeListDBVar.char.PrimarySpecList.Leg.Count then --Priority # entered was blank or bigger than the list of items
				UpgradeListDBVar.char.PrimarySpecList.Leg.Row[UpgradeListDBVar.char.PrimarySpecList.Leg.Count] = { UpgradeListDBVar.char.PrimarySpecList.Leg.Count, itemLevel, itemLink, UpgradeListDBVar.char.SavedOptions.SelectedDifficulty, UpgradeListDBVar.char.SavedOptions.SelectedInstance, UpgradeListDBVar.char.SavedOptions.SelectedBoss, NoteEntryBox:GetText(), itemID };
			elseif priorityfieldnum <= UpgradeListDBVar.char.PrimarySpecList.Leg.Count and priorityfieldnum > 0 then --If the priority number is equal to or less than the list length and not zero
				table.insert(UpgradeListDBVar.char.PrimarySpecList.Leg.Row, priorityfieldnum, { priorityfieldnum, itemLevel, itemLink, UpgradeListDBVar.char.SavedOptions.SelectedDifficulty, UpgradeListDBVar.char.SavedOptions.SelectedInstance, UpgradeListDBVar.char.SavedOptions.SelectedBoss, NoteEntryBox:GetText(), itemID });
				for i = UpgradeListDBVar.char.PrimarySpecList.Leg.Count, priorityfieldnum, -1 do
					UpgradeListDBVar.char.PrimarySpecList.Leg.Row[i][1] = i;
				end
			end
			UpgradeListDBVar.char.PrimarySpecList.Leg.Count = UpgradeListDBVar.char.PrimarySpecList.Leg.Count + 1;
			statusbarfont:SetTextColor(0, 1, 0);
			statusbarfont:SetText("Successfully added " .. itemLink .. " to your Primary Spec's Leg tab.");
			if (PanelTemplates_GetSelectedTab(UpgradeListMainFrame) == 9) and (UpgradeListDBVar.char.SavedOptions.PrimaryCheck:GetChecked() == 1) then --If you're viewing the tab you're adding to
				UpgradeList:RefreshWindow()
			end
			UpgradeListDBVar.char.SavedOptions.SelectedInstance = nil;
			UpgradeListDBVar.char.SavedOptions.SelectedBoss = nil;
			UpgradeListDBVar.char.SavedOptions.SelectedDifficulty = nil;
			ItemEntryBox:SetText("");
			ItemEntryBox:ClearFocus();
			NoteEntryBox:SetText("");
			NoteEntryBox:ClearFocus();
			priorityfield:SetText("");
			priorityfield:ClearFocus();
			UIDropDownMenu_SetText(DropDown_Button, "Location:");
		else --Adding to Secondary Spec List
			if priorityfield:GetText() == "" or priorityfieldnum > UpgradeListDBVar.char.SecondarySpecList.Leg.Count then --Priority # entered was blank or bigger than the list of items
				UpgradeListDBVar.char.SecondarySpecList.Leg.Row[UpgradeListDBVar.char.SecondarySpecList.Leg.Count] = { UpgradeListDBVar.char.SecondarySpecList.Leg.Count, itemLevel, itemLink, UpgradeListDBVar.char.SavedOptions.SelectedDifficulty, UpgradeListDBVar.char.SavedOptions.SelectedInstance, UpgradeListDBVar.char.SavedOptions.SelectedBoss, NoteEntryBox:GetText(), itemID };
			elseif priorityfieldnum <= UpgradeListDBVar.char.SecondarySpecList.Leg.Count and priorityfieldnum > 0 then --If the priority number is equal to or less than the list length and not zero
				table.insert(UpgradeListDBVar.char.SecondarySpecList.Leg.Row, priorityfieldnum, { priorityfieldnum, itemLevel, itemLink, UpgradeListDBVar.char.SavedOptions.SelectedDifficulty, UpgradeListDBVar.char.SavedOptions.SelectedInstance, UpgradeListDBVar.char.SavedOptions.SelectedBoss, NoteEntryBox:GetText(), itemID });
				for i = UpgradeListDBVar.char.SecondarySpecList.Leg.Count, priorityfieldnum, -1 do
					UpgradeListDBVar.char.SecondarySpecList.Leg.Row[i][1] = i;
				end
			end
			UpgradeListDBVar.char.SecondarySpecList.Leg.Count = UpgradeListDBVar.char.SecondarySpecList.Leg.Count + 1;
			statusbarfont:SetTextColor(0, 1, 0);
			statusbarfont:SetText("Successfully added " .. itemLink .. " to your Secondary Spec's Leg tab.");
			if (PanelTemplates_GetSelectedTab(UpgradeListMainFrame) == 9) and (UpgradeListDBVar.char.SavedOptions.SecondaryCheck:GetChecked() == 1) then --If you're viewing the tab you're adding to
				UpgradeList:RefreshWindow()
			end
			UpgradeListDBVar.char.SavedOptions.SelectedInstance = nil;
			UpgradeListDBVar.char.SavedOptions.SelectedBoss = nil;
			UpgradeListDBVar.char.SavedOptions.SelectedDifficulty = nil;
			ItemEntryBox:SetText("");
			ItemEntryBox:ClearFocus();
			NoteEntryBox:SetText("");
			NoteEntryBox:ClearFocus();
			priorityfield:SetText("");
			priorityfield:ClearFocus();
			UIDropDownMenu_SetText(DropDown_Button, "Location:");
		end
	elseif itemEquipLoc == "INVTYPE_FEET" then --Foot Item
		if priorityfieldnum == nil and priorityfield:GetText() ~= "" then
			statusbarfont:SetTextColor(1, 0, 0);
			statusbarfont:SetText("Priority field must be a number.");
			priorityfield:HighlightText();
		elseif UpgradeListDBVar.char.SavedOptions.SelectedInstance == nil then
			statusbarfont:SetTextColor(1, 0, 0);
			statusbarfont:SetText("You must select an item location.");
			ItemEntryBox:ClearFocus();
			NoteEntryBox:ClearFocus();
			priorityfield:ClearFocus();
		elseif PrimarySpecRadioButton:GetChecked() then --Adding to Primary Spec List
			if priorityfield:GetText() == "" or priorityfieldnum > UpgradeListDBVar.char.PrimarySpecList.Foot.Count then --Priority # entered was blank or bigger than the list of items
				UpgradeListDBVar.char.PrimarySpecList.Foot.Row[UpgradeListDBVar.char.PrimarySpecList.Foot.Count] = { UpgradeListDBVar.char.PrimarySpecList.Foot.Count, itemLevel, itemLink, UpgradeListDBVar.char.SavedOptions.SelectedDifficulty, UpgradeListDBVar.char.SavedOptions.SelectedInstance, UpgradeListDBVar.char.SavedOptions.SelectedBoss, NoteEntryBox:GetText(), itemID };
			elseif priorityfieldnum <= UpgradeListDBVar.char.PrimarySpecList.Foot.Count and priorityfieldnum > 0 then --If the priority number is equal to or less than the list length and not zero
				table.insert(UpgradeListDBVar.char.PrimarySpecList.Foot.Row, priorityfieldnum, { priorityfieldnum, itemLevel, itemLink, UpgradeListDBVar.char.SavedOptions.SelectedDifficulty, UpgradeListDBVar.char.SavedOptions.SelectedInstance, UpgradeListDBVar.char.SavedOptions.SelectedBoss, NoteEntryBox:GetText(), itemID });
				for i = UpgradeListDBVar.char.PrimarySpecList.Foot.Count, priorityfieldnum, -1 do
					UpgradeListDBVar.char.PrimarySpecList.Foot.Row[i][1] = i;
				end
			end
			UpgradeListDBVar.char.PrimarySpecList.Foot.Count = UpgradeListDBVar.char.PrimarySpecList.Foot.Count + 1;
			statusbarfont:SetTextColor(0, 1, 0);
			statusbarfont:SetText("Successfully added " .. itemLink .. " to your Primary Spec's Foot tab.");
			if (PanelTemplates_GetSelectedTab(UpgradeListMainFrame) == 10) and (UpgradeListDBVar.char.SavedOptions.PrimaryCheck:GetChecked() == 1) then --If you're viewing the tab you're adding to
				UpgradeList:RefreshWindow()
			end
			UpgradeListDBVar.char.SavedOptions.SelectedInstance = nil;
			UpgradeListDBVar.char.SavedOptions.SelectedBoss = nil;
			UpgradeListDBVar.char.SavedOptions.SelectedDifficulty = nil;
			ItemEntryBox:SetText("");
			ItemEntryBox:ClearFocus();
			NoteEntryBox:SetText("");
			NoteEntryBox:ClearFocus();
			priorityfield:SetText("");
			priorityfield:ClearFocus();
			UIDropDownMenu_SetText(DropDown_Button, "Location:");
		else --Adding to Secondary Spec List
			if priorityfield:GetText() == "" or priorityfieldnum > UpgradeListDBVar.char.SecondarySpecList.Foot.Count then --Priority # entered was blank or bigger than the list of items
				UpgradeListDBVar.char.SecondarySpecList.Foot.Row[UpgradeListDBVar.char.SecondarySpecList.Foot.Count] = { UpgradeListDBVar.char.SecondarySpecList.Foot.Count, itemLevel, itemLink, UpgradeListDBVar.char.SavedOptions.SelectedDifficulty, UpgradeListDBVar.char.SavedOptions.SelectedInstance, UpgradeListDBVar.char.SavedOptions.SelectedBoss, NoteEntryBox:GetText(), itemID };
			elseif priorityfieldnum <= UpgradeListDBVar.char.SecondarySpecList.Foot.Count and priorityfieldnum > 0 then --If the priority number is equal to or less than the list length and not zero
				table.insert(UpgradeListDBVar.char.SecondarySpecList.Foot.Row, priorityfieldnum, { priorityfieldnum, itemLevel, itemLink, UpgradeListDBVar.char.SavedOptions.SelectedDifficulty, UpgradeListDBVar.char.SavedOptions.SelectedInstance, UpgradeListDBVar.char.SavedOptions.SelectedBoss, NoteEntryBox:GetText(), itemID });
				for i = UpgradeListDBVar.char.SecondarySpecList.Foot.Count, priorityfieldnum, -1 do
					UpgradeListDBVar.char.SecondarySpecList.Foot.Row[i][1] = i;
				end
			end
			UpgradeListDBVar.char.SecondarySpecList.Foot.Count = UpgradeListDBVar.char.SecondarySpecList.Foot.Count + 1;
			statusbarfont:SetTextColor(0, 1, 0);
			statusbarfont:SetText("Successfully added " .. itemLink .. " to your Secondary Spec's Foot tab.");
			if (PanelTemplates_GetSelectedTab(UpgradeListMainFrame) == 10) and (UpgradeListDBVar.char.SavedOptions.SecondaryCheck:GetChecked() == 1) then --If you're viewing the tab you're adding to
				UpgradeList:RefreshWindow()
			end
			UpgradeListDBVar.char.SavedOptions.SelectedInstance = nil;
			UpgradeListDBVar.char.SavedOptions.SelectedBoss = nil;
			UpgradeListDBVar.char.SavedOptions.SelectedDifficulty = nil;
			ItemEntryBox:SetText("");
			ItemEntryBox:ClearFocus();
			NoteEntryBox:SetText("");
			NoteEntryBox:ClearFocus();
			priorityfield:SetText("");
			priorityfield:ClearFocus();
			UIDropDownMenu_SetText(DropDown_Button, "Location:");
		end
	elseif itemEquipLoc == "INVTYPE_FINGER" then --Rings
		if priorityfieldnum == nil and priorityfield:GetText() ~= "" then
			statusbarfont:SetTextColor(1, 0, 0);
			statusbarfont:SetText("Priority field must be a number.");
			priorityfield:HighlightText();
		elseif UpgradeListDBVar.char.SavedOptions.SelectedInstance == nil then
			statusbarfont:SetTextColor(1, 0, 0);
			statusbarfont:SetText("You must select an item location.");
			ItemEntryBox:ClearFocus();
			NoteEntryBox:ClearFocus();
			priorityfield:ClearFocus();
		elseif PrimarySpecRadioButton:GetChecked() then --Adding to Primary Spec List
			if priorityfield:GetText() == "" or priorityfieldnum > UpgradeListDBVar.char.PrimarySpecList.Ring.Count then --Priority # entered was blank or bigger than the list of items
				UpgradeListDBVar.char.PrimarySpecList.Ring.Row[UpgradeListDBVar.char.PrimarySpecList.Ring.Count] = { UpgradeListDBVar.char.PrimarySpecList.Ring.Count, itemLevel, itemLink, UpgradeListDBVar.char.SavedOptions.SelectedDifficulty, UpgradeListDBVar.char.SavedOptions.SelectedInstance, UpgradeListDBVar.char.SavedOptions.SelectedBoss, NoteEntryBox:GetText(), itemID };
			elseif priorityfieldnum <= UpgradeListDBVar.char.PrimarySpecList.Ring.Count and priorityfieldnum > 0 then --If the priority number is equal to or less than the list length and not zero
				table.insert(UpgradeListDBVar.char.PrimarySpecList.Ring.Row, priorityfieldnum, { priorityfieldnum, itemLevel, itemLink, UpgradeListDBVar.char.SavedOptions.SelectedDifficulty, UpgradeListDBVar.char.SavedOptions.SelectedInstance, UpgradeListDBVar.char.SavedOptions.SelectedBoss, NoteEntryBox:GetText(), itemID });
				for i = UpgradeListDBVar.char.PrimarySpecList.Ring.Count, priorityfieldnum, -1 do
					UpgradeListDBVar.char.PrimarySpecList.Ring.Row[i][1] = i;
				end
			end
			UpgradeListDBVar.char.PrimarySpecList.Ring.Count = UpgradeListDBVar.char.PrimarySpecList.Ring.Count + 1;
			statusbarfont:SetTextColor(0, 1, 0);
			statusbarfont:SetText("Successfully added " .. itemLink .. " to your Primary Spec's Ring tab.");
			if (PanelTemplates_GetSelectedTab(UpgradeListMainFrame) == 11) and (UpgradeListDBVar.char.SavedOptions.PrimaryCheck:GetChecked() == 1) then --If you're viewing the tab you're adding to
				UpgradeList:RefreshWindow()
			end
			UpgradeListDBVar.char.SavedOptions.SelectedInstance = nil;
			UpgradeListDBVar.char.SavedOptions.SelectedBoss = nil;
			UpgradeListDBVar.char.SavedOptions.SelectedDifficulty = nil;
			ItemEntryBox:SetText("");
			ItemEntryBox:ClearFocus();
			NoteEntryBox:SetText("");
			NoteEntryBox:ClearFocus();
			priorityfield:SetText("");
			priorityfield:ClearFocus();
			UIDropDownMenu_SetText(DropDown_Button, "Location:");
		else --Adding to Secondary Spec List
			if priorityfield:GetText() == "" or priorityfieldnum > UpgradeListDBVar.char.SecondarySpecList.Ring.Count then --Priority # entered was blank or bigger than the list of items
				UpgradeListDBVar.char.SecondarySpecList.Ring.Row[UpgradeListDBVar.char.SecondarySpecList.Ring.Count] = { UpgradeListDBVar.char.SecondarySpecList.Ring.Count, itemLevel, itemLink, UpgradeListDBVar.char.SavedOptions.SelectedDifficulty, UpgradeListDBVar.char.SavedOptions.SelectedInstance, UpgradeListDBVar.char.SavedOptions.SelectedBoss, NoteEntryBox:GetText(), itemID };
			elseif priorityfieldnum <= UpgradeListDBVar.char.SecondarySpecList.Ring.Count and priorityfieldnum > 0 then --If the priority number is equal to or less than the list length and not zero
				table.insert(UpgradeListDBVar.char.SecondarySpecList.Ring.Row, priorityfieldnum, { priorityfieldnum, itemLevel, itemLink, UpgradeListDBVar.char.SavedOptions.SelectedDifficulty, UpgradeListDBVar.char.SavedOptions.SelectedInstance, UpgradeListDBVar.char.SavedOptions.SelectedBoss, NoteEntryBox:GetText(), itemID });
				for i = UpgradeListDBVar.char.SecondarySpecList.Ring.Count, priorityfieldnum, -1 do
					UpgradeListDBVar.char.SecondarySpecList.Ring.Row[i][1] = i;
				end
			end
			UpgradeListDBVar.char.SecondarySpecList.Ring.Count = UpgradeListDBVar.char.SecondarySpecList.Ring.Count + 1;
			statusbarfont:SetTextColor(0, 1, 0);
			statusbarfont:SetText("Successfully added " .. itemLink .. " to your Secondary Spec's Ring tab.");
			if (PanelTemplates_GetSelectedTab(UpgradeListMainFrame) == 11) and (UpgradeListDBVar.char.SavedOptions.SecondaryCheck:GetChecked() == 1) then --If you're viewing the tab you're adding to
				UpgradeList:RefreshWindow()
			end
			UpgradeListDBVar.char.SavedOptions.SelectedInstance = nil;
			UpgradeListDBVar.char.SavedOptions.SelectedBoss = nil;
			UpgradeListDBVar.char.SavedOptions.SelectedDifficulty = nil;
			ItemEntryBox:SetText("");
			ItemEntryBox:ClearFocus();
			NoteEntryBox:SetText("");
			NoteEntryBox:ClearFocus();
			priorityfield:SetText("");
			priorityfield:ClearFocus();
			UIDropDownMenu_SetText(DropDown_Button, "Location:");
		end
	elseif itemEquipLoc == "INVTYPE_TRINKET" then --Trinkets
		if priorityfieldnum == nil and priorityfield:GetText() ~= "" then
			statusbarfont:SetTextColor(1, 0, 0);
			statusbarfont:SetText("Priority field must be a number.");
			priorityfield:HighlightText();
		elseif UpgradeListDBVar.char.SavedOptions.SelectedInstance == nil then
			statusbarfont:SetTextColor(1, 0, 0);
			statusbarfont:SetText("You must select an item location.");
			ItemEntryBox:ClearFocus();
			NoteEntryBox:ClearFocus();
			priorityfield:ClearFocus();
		elseif PrimarySpecRadioButton:GetChecked() then --Adding to Primary Spec List
			if priorityfield:GetText() == "" or priorityfieldnum > UpgradeListDBVar.char.PrimarySpecList.Trinket.Count then --Priority # entered was blank or bigger than the list of items
				UpgradeListDBVar.char.PrimarySpecList.Trinket.Row[UpgradeListDBVar.char.PrimarySpecList.Trinket.Count] = { UpgradeListDBVar.char.PrimarySpecList.Trinket.Count, itemLevel, itemLink, UpgradeListDBVar.char.SavedOptions.SelectedDifficulty, UpgradeListDBVar.char.SavedOptions.SelectedInstance, UpgradeListDBVar.char.SavedOptions.SelectedBoss, NoteEntryBox:GetText(), itemID };
			elseif priorityfieldnum <= UpgradeListDBVar.char.PrimarySpecList.Trinket.Count and priorityfieldnum > 0 then --If the priority number is equal to or less than the list length and not zero
				table.insert(UpgradeListDBVar.char.PrimarySpecList.Trinket.Row, priorityfieldnum, { priorityfieldnum, itemLevel, itemLink, UpgradeListDBVar.char.SavedOptions.SelectedDifficulty, UpgradeListDBVar.char.SavedOptions.SelectedInstance, UpgradeListDBVar.char.SavedOptions.SelectedBoss, NoteEntryBox:GetText(), itemID });
				for i = UpgradeListDBVar.char.PrimarySpecList.Trinket.Count, priorityfieldnum, -1 do
					UpgradeListDBVar.char.PrimarySpecList.Trinket.Row[i][1] = i;
				end
			end
			UpgradeListDBVar.char.PrimarySpecList.Trinket.Count = UpgradeListDBVar.char.PrimarySpecList.Trinket.Count + 1;
			statusbarfont:SetTextColor(0, 1, 0);
			statusbarfont:SetText("Successfully added " .. itemLink .. " to your Primary Spec's Trinket tab.");
			if (PanelTemplates_GetSelectedTab(UpgradeListMainFrame) == 12) and (UpgradeListDBVar.char.SavedOptions.PrimaryCheck:GetChecked() == 1) then --If you're viewing the tab you're adding to
				UpgradeList:RefreshWindow()
			end
			UpgradeListDBVar.char.SavedOptions.SelectedInstance = nil;
			UpgradeListDBVar.char.SavedOptions.SelectedBoss = nil;
			UpgradeListDBVar.char.SavedOptions.SelectedDifficulty = nil;
			ItemEntryBox:SetText("");
			ItemEntryBox:ClearFocus();
			NoteEntryBox:SetText("");
			NoteEntryBox:ClearFocus();
			priorityfield:SetText("");
			priorityfield:ClearFocus();
			UIDropDownMenu_SetText(DropDown_Button, "Location:");
		else --Adding to Secondary Spec List
			if priorityfield:GetText() == "" or priorityfieldnum > UpgradeListDBVar.char.SecondarySpecList.Trinket.Count then --Priority # entered was blank or bigger than the list of items
				UpgradeListDBVar.char.SecondarySpecList.Trinket.Row[UpgradeListDBVar.char.SecondarySpecList.Trinket.Count] = { UpgradeListDBVar.char.SecondarySpecList.Trinket.Count, itemLevel, itemLink, UpgradeListDBVar.char.SavedOptions.SelectedDifficulty, UpgradeListDBVar.char.SavedOptions.SelectedInstance, UpgradeListDBVar.char.SavedOptions.SelectedBoss, NoteEntryBox:GetText(), itemID };
			elseif priorityfieldnum <= UpgradeListDBVar.char.SecondarySpecList.Trinket.Count and priorityfieldnum > 0 then --If the priority number is equal to or less than the list length and not zero
				table.insert(UpgradeListDBVar.char.SecondarySpecList.Trinket.Row, priorityfieldnum, { priorityfieldnum, itemLevel, itemLink, UpgradeListDBVar.char.SavedOptions.SelectedDifficulty, UpgradeListDBVar.char.SavedOptions.SelectedInstance, UpgradeListDBVar.char.SavedOptions.SelectedBoss, NoteEntryBox:GetText(), itemID });
				for i = UpgradeListDBVar.char.SecondarySpecList.Trinket.Count, priorityfieldnum, -1 do
					UpgradeListDBVar.char.SecondarySpecList.Trinket.Row[i][1] = i;
				end
			end
			UpgradeListDBVar.char.SecondarySpecList.Trinket.Count = UpgradeListDBVar.char.SecondarySpecList.Trinket.Count + 1;
			statusbarfont:SetTextColor(0, 1, 0);
			statusbarfont:SetText("Successfully added " .. itemLink .. " to your Secondary Spec's Trinket tab.");
			if (PanelTemplates_GetSelectedTab(UpgradeListMainFrame) == 12) and (UpgradeListDBVar.char.SavedOptions.SecondaryCheck:GetChecked() == 1) then --If you're viewing the tab you're adding to
				UpgradeList:RefreshWindow()
			end
			UpgradeListDBVar.char.SavedOptions.SelectedInstance = nil;
			UpgradeListDBVar.char.SavedOptions.SelectedBoss = nil;
			UpgradeListDBVar.char.SavedOptions.SelectedDifficulty = nil;
			ItemEntryBox:SetText("");
			ItemEntryBox:ClearFocus();
			NoteEntryBox:SetText("");
			NoteEntryBox:ClearFocus();
			priorityfield:SetText("");
			priorityfield:ClearFocus();
			UIDropDownMenu_SetText(DropDown_Button, "Location:");
		end
	elseif itemEquipLoc == "INVTYPE_WEAPONMAINHAND" or itemEquipLoc == "INVTYPE_2HWEAPON" then --Main Hand Item
		if priorityfieldnum == nil and priorityfield:GetText() ~= "" then
			statusbarfont:SetTextColor(1, 0, 0);
			statusbarfont:SetText("Priority field must be a number.");
			priorityfield:HighlightText();
		elseif UpgradeListDBVar.char.SavedOptions.SelectedInstance == nil then
			statusbarfont:SetTextColor(1, 0, 0);
			statusbarfont:SetText("You must select an item location.");
			ItemEntryBox:ClearFocus();
			NoteEntryBox:ClearFocus();
			priorityfield:ClearFocus();
		elseif PrimarySpecRadioButton:GetChecked() then --Adding to Primary Spec List
			if priorityfield:GetText() == "" or priorityfieldnum > UpgradeListDBVar.char.PrimarySpecList.Main.Count then --Priority # entered was blank or bigger than the list of items
				UpgradeListDBVar.char.PrimarySpecList.Main.Row[UpgradeListDBVar.char.PrimarySpecList.Main.Count] = { UpgradeListDBVar.char.PrimarySpecList.Main.Count, itemLevel, itemLink, UpgradeListDBVar.char.SavedOptions.SelectedDifficulty, UpgradeListDBVar.char.SavedOptions.SelectedInstance, UpgradeListDBVar.char.SavedOptions.SelectedBoss, NoteEntryBox:GetText(), itemID };
			elseif priorityfieldnum <= UpgradeListDBVar.char.PrimarySpecList.Main.Count and priorityfieldnum > 0 then --If the priority number is equal to or less than the list length and not zero
				table.insert(UpgradeListDBVar.char.PrimarySpecList.Main.Row, priorityfieldnum, { priorityfieldnum, itemLevel, itemLink, UpgradeListDBVar.char.SavedOptions.SelectedDifficulty, UpgradeListDBVar.char.SavedOptions.SelectedInstance, UpgradeListDBVar.char.SavedOptions.SelectedBoss, NoteEntryBox:GetText(), itemID });
				for i = UpgradeListDBVar.char.PrimarySpecList.Main.Count, priorityfieldnum, -1 do
					UpgradeListDBVar.char.PrimarySpecList.Main.Row[i][1] = i;
				end
			end
			UpgradeListDBVar.char.PrimarySpecList.Main.Count = UpgradeListDBVar.char.PrimarySpecList.Main.Count + 1;
			statusbarfont:SetTextColor(0, 1, 0);
			statusbarfont:SetText("Successfully added " .. itemLink .. " to your Primary Spec's Main tab.");
			if (PanelTemplates_GetSelectedTab(UpgradeListMainFrame) == 13) and (UpgradeListDBVar.char.SavedOptions.PrimaryCheck:GetChecked() == 1) then --If you're viewing the tab you're adding to
				UpgradeList:RefreshWindow()
			end
			UpgradeListDBVar.char.SavedOptions.SelectedInstance = nil;
			UpgradeListDBVar.char.SavedOptions.SelectedBoss = nil;
			UpgradeListDBVar.char.SavedOptions.SelectedDifficulty = nil;
			ItemEntryBox:SetText("");
			ItemEntryBox:ClearFocus();
			NoteEntryBox:SetText("");
			NoteEntryBox:ClearFocus();
			priorityfield:SetText("");
			priorityfield:ClearFocus();
			UIDropDownMenu_SetText(DropDown_Button, "Location:");
		else --Adding to Secondary Spec List
			if priorityfield:GetText() == "" or priorityfieldnum > UpgradeListDBVar.char.SecondarySpecList.Main.Count then --Priority # entered was blank or bigger than the list of items
				UpgradeListDBVar.char.SecondarySpecList.Main.Row[UpgradeListDBVar.char.SecondarySpecList.Main.Count] = { UpgradeListDBVar.char.SecondarySpecList.Main.Count, itemLevel, itemLink, UpgradeListDBVar.char.SavedOptions.SelectedDifficulty, UpgradeListDBVar.char.SavedOptions.SelectedInstance, UpgradeListDBVar.char.SavedOptions.SelectedBoss, NoteEntryBox:GetText(), itemID };
			elseif priorityfieldnum <= UpgradeListDBVar.char.SecondarySpecList.Main.Count and priorityfieldnum > 0 then --If the priority number is equal to or less than the list length and not zero
				table.insert(UpgradeListDBVar.char.SecondarySpecList.Main.Row, priorityfieldnum, { priorityfieldnum, itemLevel, itemLink, UpgradeListDBVar.char.SavedOptions.SelectedDifficulty, UpgradeListDBVar.char.SavedOptions.SelectedInstance, UpgradeListDBVar.char.SavedOptions.SelectedBoss, NoteEntryBox:GetText(), itemID });
				for i = UpgradeListDBVar.char.SecondarySpecList.Main.Count, priorityfieldnum, -1 do
					UpgradeListDBVar.char.SecondarySpecList.Main.Row[i][1] = i;
				end
			end
			UpgradeListDBVar.char.SecondarySpecList.Main.Count = UpgradeListDBVar.char.SecondarySpecList.Main.Count + 1;
			statusbarfont:SetTextColor(0, 1, 0);
			statusbarfont:SetText("Successfully added " .. itemLink .. " to your Secondary Spec's Main tab.");
			if (PanelTemplates_GetSelectedTab(UpgradeListMainFrame) == 13) and (UpgradeListDBVar.char.SavedOptions.SecondaryCheck:GetChecked() == 1) then --If you're viewing the tab you're adding to
				UpgradeList:RefreshWindow()
			end
			UpgradeListDBVar.char.SavedOptions.SelectedInstance = nil;
			UpgradeListDBVar.char.SavedOptions.SelectedBoss = nil;
			UpgradeListDBVar.char.SavedOptions.SelectedDifficulty = nil;
			ItemEntryBox:SetText("");
			ItemEntryBox:ClearFocus();
			NoteEntryBox:SetText("");
			NoteEntryBox:ClearFocus();
			priorityfield:SetText("");
			priorityfield:ClearFocus();
			UIDropDownMenu_SetText(DropDown_Button, "Location:");
		end
	elseif itemEquipLoc == "INVTYPE_WEAPONOFFHAND" or itemEquipLoc == "INVTYPE_SHIELD" or itemEquipLoc == "INVTYPE_HOLDABLE" then --Off Hand Item
		if priorityfieldnum == nil and priorityfield:GetText() ~= "" then
			statusbarfont:SetTextColor(1, 0, 0);
			statusbarfont:SetText("Priority field must be a number.");
			priorityfield:HighlightText();
		elseif UpgradeListDBVar.char.SavedOptions.SelectedInstance == nil then
			statusbarfont:SetTextColor(1, 0, 0);
			statusbarfont:SetText("You must select an item location.");
			ItemEntryBox:ClearFocus();
			NoteEntryBox:ClearFocus();
			priorityfield:ClearFocus();
		elseif PrimarySpecRadioButton:GetChecked() then --Adding to Primary Spec List
			if priorityfield:GetText() == "" or priorityfieldnum > UpgradeListDBVar.char.PrimarySpecList.Off.Count then --Priority # entered was blank or bigger than the list of items
				UpgradeListDBVar.char.PrimarySpecList.Off.Row[UpgradeListDBVar.char.PrimarySpecList.Off.Count] = { UpgradeListDBVar.char.PrimarySpecList.Off.Count, itemLevel, itemLink, UpgradeListDBVar.char.SavedOptions.SelectedDifficulty, UpgradeListDBVar.char.SavedOptions.SelectedInstance, UpgradeListDBVar.char.SavedOptions.SelectedBoss, NoteEntryBox:GetText(), itemID };
			elseif priorityfieldnum <= UpgradeListDBVar.char.PrimarySpecList.Off.Count and priorityfieldnum > 0 then --If the priority number is equal to or less than the list length and not zero
				table.insert(UpgradeListDBVar.char.PrimarySpecList.Off.Row, priorityfieldnum, { priorityfieldnum, itemLevel, itemLink, UpgradeListDBVar.char.SavedOptions.SelectedDifficulty, UpgradeListDBVar.char.SavedOptions.SelectedInstance, UpgradeListDBVar.char.SavedOptions.SelectedBoss, NoteEntryBox:GetText(), itemID });
				for i = UpgradeListDBVar.char.PrimarySpecList.Off.Count, priorityfieldnum, -1 do
					UpgradeListDBVar.char.PrimarySpecList.Off.Row[i][1] = i;
				end
			end
			UpgradeListDBVar.char.PrimarySpecList.Off.Count = UpgradeListDBVar.char.PrimarySpecList.Off.Count + 1;
			statusbarfont:SetTextColor(0, 1, 0);
			statusbarfont:SetText("Successfully added " .. itemLink .. " to your Primary Spec's Off tab.");
			if (PanelTemplates_GetSelectedTab(UpgradeListMainFrame) == 14) and (UpgradeListDBVar.char.SavedOptions.PrimaryCheck:GetChecked() == 1) then --If you're viewing the tab you're adding to
				UpgradeList:RefreshWindow()
			end
			UpgradeListDBVar.char.SavedOptions.SelectedInstance = nil;
			UpgradeListDBVar.char.SavedOptions.SelectedBoss = nil;
			UpgradeListDBVar.char.SavedOptions.SelectedDifficulty = nil;
			ItemEntryBox:SetText("");
			ItemEntryBox:ClearFocus();
			NoteEntryBox:SetText("");
			NoteEntryBox:ClearFocus();
			priorityfield:SetText("");
			priorityfield:ClearFocus();
			UIDropDownMenu_SetText(DropDown_Button, "Location:");
		else --Adding to Secondary Spec List
			if priorityfield:GetText() == "" or priorityfieldnum > UpgradeListDBVar.char.SecondarySpecList.Off.Count then --Priority # entered was blank or bigger than the list of items
				UpgradeListDBVar.char.SecondarySpecList.Off.Row[UpgradeListDBVar.char.SecondarySpecList.Off.Count] = { UpgradeListDBVar.char.SecondarySpecList.Off.Count, itemLevel, itemLink, UpgradeListDBVar.char.SavedOptions.SelectedDifficulty, UpgradeListDBVar.char.SavedOptions.SelectedInstance, UpgradeListDBVar.char.SavedOptions.SelectedBoss, NoteEntryBox:GetText(), itemID };
			elseif priorityfieldnum <= UpgradeListDBVar.char.SecondarySpecList.Off.Count and priorityfieldnum > 0 then --If the priority number is equal to or less than the list length and not zero
				table.insert(UpgradeListDBVar.char.SecondarySpecList.Off.Row, priorityfieldnum, { priorityfieldnum, itemLevel, itemLink, UpgradeListDBVar.char.SavedOptions.SelectedDifficulty, UpgradeListDBVar.char.SavedOptions.SelectedInstance, UpgradeListDBVar.char.SavedOptions.SelectedBoss, NoteEntryBox:GetText(), itemID });
				for i = UpgradeListDBVar.char.SecondarySpecList.Off.Count, priorityfieldnum, -1 do
					UpgradeListDBVar.char.SecondarySpecList.Off.Row[i][1] = i;
				end
			end
			UpgradeListDBVar.char.SecondarySpecList.Off.Count = UpgradeListDBVar.char.SecondarySpecList.Off.Count + 1;
			statusbarfont:SetTextColor(0, 1, 0);
			statusbarfont:SetText("Successfully added " .. itemLink .. " to your Secondary Spec's Off tab.");
			if (PanelTemplates_GetSelectedTab(UpgradeListMainFrame) == 14) and (UpgradeListDBVar.char.SavedOptions.SecondaryCheck:GetChecked() == 1) then --If you're viewing the tab you're adding to
				UpgradeList:RefreshWindow()
			end
			UpgradeListDBVar.char.SavedOptions.SelectedInstance = nil;
			UpgradeListDBVar.char.SavedOptions.SelectedBoss = nil;
			UpgradeListDBVar.char.SavedOptions.SelectedDifficulty = nil;
			ItemEntryBox:SetText("");
			ItemEntryBox:ClearFocus();
			NoteEntryBox:SetText("");
			NoteEntryBox:ClearFocus();
			priorityfield:SetText("");
			priorityfield:ClearFocus();
			UIDropDownMenu_SetText(DropDown_Button, "Location:");
		end
	elseif itemEquipLoc == "INVTYPE_RANGED" or itemEquipLoc == "INVTYPE_THROWN" or itemEquipLoc == "INVTYPE_RANGEDRIGHT" or itemEquipLoc == "INVTYPE_RELIC" then --Ranged Slot Item
		if priorityfieldnum == nil and priorityfield:GetText() ~= "" then
			statusbarfont:SetTextColor(1, 0, 0);
			statusbarfont:SetText("Priority field must be a number.");
			priorityfield:HighlightText();
		elseif UpgradeListDBVar.char.SavedOptions.SelectedInstance == nil then
			statusbarfont:SetTextColor(1, 0, 0);
			statusbarfont:SetText("You must select an item location.");
			ItemEntryBox:ClearFocus();
			NoteEntryBox:ClearFocus();
			priorityfield:ClearFocus();
		elseif PrimarySpecRadioButton:GetChecked() then --Adding to Primary Spec List
			if priorityfield:GetText() == "" or priorityfieldnum > UpgradeListDBVar.char.PrimarySpecList.Ranged.Count then --Priority # entered was blank or bigger than the list of items
				UpgradeListDBVar.char.PrimarySpecList.Ranged.Row[UpgradeListDBVar.char.PrimarySpecList.Ranged.Count] = { UpgradeListDBVar.char.PrimarySpecList.Ranged.Count, itemLevel, itemLink, UpgradeListDBVar.char.SavedOptions.SelectedDifficulty, UpgradeListDBVar.char.SavedOptions.SelectedInstance, UpgradeListDBVar.char.SavedOptions.SelectedBoss, NoteEntryBox:GetText(), itemID };
			elseif priorityfieldnum <= UpgradeListDBVar.char.PrimarySpecList.Ranged.Count and priorityfieldnum > 0 then --If the priority number is equal to or less than the list length and not zero
				table.insert(UpgradeListDBVar.char.PrimarySpecList.Ranged.Row, priorityfieldnum, { priorityfieldnum, itemLevel, itemLink, UpgradeListDBVar.char.SavedOptions.SelectedDifficulty, UpgradeListDBVar.char.SavedOptions.SelectedInstance, UpgradeListDBVar.char.SavedOptions.SelectedBoss, NoteEntryBox:GetText(), itemID });
				for i = UpgradeListDBVar.char.PrimarySpecList.Ranged.Count, priorityfieldnum, -1 do
					UpgradeListDBVar.char.PrimarySpecList.Ranged.Row[i][1] = i;
				end
			end
			UpgradeListDBVar.char.PrimarySpecList.Ranged.Count = UpgradeListDBVar.char.PrimarySpecList.Ranged.Count + 1;
			statusbarfont:SetTextColor(0, 1, 0);
			statusbarfont:SetText("Successfully added " .. itemLink .. " to your Primary Spec's Ranged tab.");
			if (PanelTemplates_GetSelectedTab(UpgradeListMainFrame) == 15) and (UpgradeListDBVar.char.SavedOptions.PrimaryCheck:GetChecked() == 1) then --If you're viewing the tab you're adding to
				UpgradeList:RefreshWindow()
			end
			UpgradeListDBVar.char.SavedOptions.SelectedInstance = nil;
			UpgradeListDBVar.char.SavedOptions.SelectedBoss = nil;
			UpgradeListDBVar.char.SavedOptions.SelectedDifficulty = nil;
			ItemEntryBox:SetText("");
			ItemEntryBox:ClearFocus();
			NoteEntryBox:SetText("");
			NoteEntryBox:ClearFocus();
			priorityfield:SetText("");
			priorityfield:ClearFocus();
			UIDropDownMenu_SetText(DropDown_Button, "Location:");
		else --Adding to Secondary Spec List
			if priorityfield:GetText() == "" or priorityfieldnum > UpgradeListDBVar.char.SecondarySpecList.Ranged.Count then --Priority # entered was blank or bigger than the list of items
				UpgradeListDBVar.char.SecondarySpecList.Ranged.Row[UpgradeListDBVar.char.SecondarySpecList.Ranged.Count] = { UpgradeListDBVar.char.SecondarySpecList.Ranged.Count, itemLevel, itemLink, UpgradeListDBVar.char.SavedOptions.SelectedDifficulty, UpgradeListDBVar.char.SavedOptions.SelectedInstance, UpgradeListDBVar.char.SavedOptions.SelectedBoss, NoteEntryBox:GetText(), itemID };
			elseif priorityfieldnum <= UpgradeListDBVar.char.SecondarySpecList.Ranged.Count and priorityfieldnum > 0 then --If the priority number is equal to or less than the list length and not zero
				table.insert(UpgradeListDBVar.char.SecondarySpecList.Ranged.Row, priorityfieldnum, { priorityfieldnum, itemLevel, itemLink, UpgradeListDBVar.char.SavedOptions.SelectedDifficulty, UpgradeListDBVar.char.SavedOptions.SelectedInstance, UpgradeListDBVar.char.SavedOptions.SelectedBoss, NoteEntryBox:GetText(), itemID });
				for i = UpgradeListDBVar.char.SecondarySpecList.Ranged.Count, priorityfieldnum, -1 do
					UpgradeListDBVar.char.SecondarySpecList.Ranged.Row[i][1] = i;
				end
			end
			UpgradeListDBVar.char.SecondarySpecList.Ranged.Count = UpgradeListDBVar.char.SecondarySpecList.Ranged.Count + 1;
			statusbarfont:SetTextColor(0, 1, 0);
			statusbarfont:SetText("Successfully added " .. itemLink .. " to your Secondary Spec's Ranged tab.");
			if (PanelTemplates_GetSelectedTab(UpgradeListMainFrame) == 15) and (UpgradeListDBVar.char.SavedOptions.SecondaryCheck:GetChecked() == 1) then --If you're viewing the tab you're adding to
				UpgradeList:RefreshWindow()
			end
			UpgradeListDBVar.char.SavedOptions.SelectedInstance = nil;
			UpgradeListDBVar.char.SavedOptions.SelectedBoss = nil;
			UpgradeListDBVar.char.SavedOptions.SelectedDifficulty = nil;
			ItemEntryBox:SetText("");
			ItemEntryBox:ClearFocus();
			NoteEntryBox:SetText("");
			NoteEntryBox:ClearFocus();
			priorityfield:SetText("");
			priorityfield:ClearFocus();
			UIDropDownMenu_SetText(DropDown_Button, "Location:");
		end
	elseif itemEquipLoc == "INVTYPE_WEAPON" then --Main Hand OR Off Hand Item
		if priorityfieldnum == nil and priorityfield:GetText() ~= "" then
			statusbarfont:SetTextColor(1, 0, 0);
			statusbarfont:SetText("Priority field must be a number.");
			priorityfield:HighlightText();
		elseif UpgradeListDBVar.char.SavedOptions.SelectedInstance == nil then
			statusbarfont:SetTextColor(1, 0, 0);
			statusbarfont:SetText("You must select an item location.");
			ItemEntryBox:ClearFocus();
			NoteEntryBox:ClearFocus();
			priorityfield:ClearFocus();
		else
			WeaponInput:Show(); --After checking that priority field is a number and an item location is selected, show the WeaponInput frame.
			UpgradeListMainFrame:EnableMouse(false)
			CloseButton:EnableMouse(false)
			ToggleButton:EnableMouse(false)
			UpgradeListDBVar.char.SavedOptions.PrimaryCheck:EnableMouse(false)
			UpgradeListDBVar.char.SavedOptions.SecondaryCheck:EnableMouse(false)
			OptionsFrame:EnableMouse(false)
			ItemEntryBox:EnableMouse(false)
			DropDown_Button:EnableMouse(false)
			NoteEntryBox:EnableMouse(false)
			PrimarySpecRadioButton:EnableMouse(false)
			SecondarySpecRadioButton:EnableMouse(false)
			priorityfield:EnableMouse(false)
			AddButton:EnableMouse(false)
			tofield:EnableMouse(false)
			fromfield:EnableMouse(false)
			MoveButton:EnableMouse(false)
			DeleteButton:EnableMouse(false)
			deletefield:EnableMouse(false)
		end
	else --Adding to Other tab.
		if priorityfieldnum == nil and priorityfield:GetText() ~= "" then
			statusbarfont:SetTextColor(1, 0, 0);
			statusbarfont:SetText("Priority field must be a number.");
			priorityfield:HighlightText();
		elseif UpgradeListDBVar.char.SavedOptions.SelectedInstance == nil then
			statusbarfont:SetTextColor(1, 0, 0);
			statusbarfont:SetText("You must select an item location.");
			ItemEntryBox:ClearFocus();
			NoteEntryBox:ClearFocus();
			priorityfield:ClearFocus();
		elseif PrimarySpecRadioButton:GetChecked() then --Adding to Primary Spec List
			if priorityfield:GetText() == "" or priorityfieldnum > UpgradeListDBVar.char.PrimarySpecList.Other.Count then --Priority # entered was blank or bigger than the list of items
				UpgradeListDBVar.char.PrimarySpecList.Other.Row[UpgradeListDBVar.char.PrimarySpecList.Other.Count] = { UpgradeListDBVar.char.PrimarySpecList.Other.Count, itemLevel, itemLink, UpgradeListDBVar.char.SavedOptions.SelectedDifficulty, UpgradeListDBVar.char.SavedOptions.SelectedInstance, UpgradeListDBVar.char.SavedOptions.SelectedBoss, NoteEntryBox:GetText(), itemID };
			elseif priorityfieldnum <= UpgradeListDBVar.char.PrimarySpecList.Other.Count and priorityfieldnum > 0 then --If the priority number is equal to or less than the list length and not zero
				table.insert(UpgradeListDBVar.char.PrimarySpecList.Other.Row, priorityfieldnum, { priorityfieldnum, itemLevel, itemLink, UpgradeListDBVar.char.SavedOptions.SelectedDifficulty, UpgradeListDBVar.char.SavedOptions.SelectedInstance, UpgradeListDBVar.char.SavedOptions.SelectedBoss, NoteEntryBox:GetText(), itemID });
				for i = UpgradeListDBVar.char.PrimarySpecList.Other.Count, priorityfieldnum, -1 do
					UpgradeListDBVar.char.PrimarySpecList.Other.Row[i][1] = i;
				end
			end
			UpgradeListDBVar.char.PrimarySpecList.Other.Count = UpgradeListDBVar.char.PrimarySpecList.Other.Count + 1;
			statusbarfont:SetTextColor(0, 1, 0);
			statusbarfont:SetText("Successfully added " .. itemLink .. " to your Primary Spec's Other tab.");
			if (PanelTemplates_GetSelectedTab(UpgradeListMainFrame) == 16) and (UpgradeListDBVar.char.SavedOptions.PrimaryCheck:GetChecked() == 1) then --If you're viewing the tab you're adding to
				UpgradeList:RefreshWindow()
			end
			UpgradeListDBVar.char.SavedOptions.SelectedInstance = nil;
			UpgradeListDBVar.char.SavedOptions.SelectedBoss = nil;
			UpgradeListDBVar.char.SavedOptions.SelectedDifficulty = nil;
			ItemEntryBox:SetText("");
			ItemEntryBox:ClearFocus();
			NoteEntryBox:SetText("");
			NoteEntryBox:ClearFocus();
			priorityfield:SetText("");
			priorityfield:ClearFocus();
			UIDropDownMenu_SetText(DropDown_Button, "Location:");
		else --Adding to Secondary Spec List
			if priorityfield:GetText() == "" or priorityfieldnum > UpgradeListDBVar.char.SecondarySpecList.Other.Count then --Priority # entered was blank or bigger than the list of items
				UpgradeListDBVar.char.SecondarySpecList.Other.Row[UpgradeListDBVar.char.SecondarySpecList.Other.Count] = { UpgradeListDBVar.char.SecondarySpecList.Other.Count, itemLevel, itemLink, UpgradeListDBVar.char.SavedOptions.SelectedDifficulty, UpgradeListDBVar.char.SavedOptions.SelectedInstance, UpgradeListDBVar.char.SavedOptions.SelectedBoss, NoteEntryBox:GetText(), itemID };
			elseif priorityfieldnum <= UpgradeListDBVar.char.SecondarySpecList.Other.Count and priorityfieldnum > 0 then --If the priority number is equal to or less than the list length and not zero
				table.insert(UpgradeListDBVar.char.SecondarySpecList.Other.Row, priorityfieldnum, { priorityfieldnum, itemLevel, itemLink, UpgradeListDBVar.char.SavedOptions.SelectedDifficulty, UpgradeListDBVar.char.SavedOptions.SelectedInstance, UpgradeListDBVar.char.SavedOptions.SelectedBoss, NoteEntryBox:GetText(), itemID });
				for i = UpgradeListDBVar.char.SecondarySpecList.Other.Count, priorityfieldnum, -1 do
					UpgradeListDBVar.char.SecondarySpecList.Other.Row[i][1] = i;
				end
			end
			UpgradeListDBVar.char.SecondarySpecList.Other.Count = UpgradeListDBVar.char.SecondarySpecList.Other.Count + 1;
			statusbarfont:SetTextColor(0, 1, 0);
			statusbarfont:SetText("Successfully added " .. itemLink .. " to your Secondary Spec's Other tab.");
			if (PanelTemplates_GetSelectedTab(UpgradeListMainFrame) == 16) and (UpgradeListDBVar.char.SavedOptions.SecondaryCheck:GetChecked() == 1) then --If you're viewing the tab you're adding to
				UpgradeList:RefreshWindow()
			end
			UpgradeListDBVar.char.SavedOptions.SelectedInstance = nil;
			UpgradeListDBVar.char.SavedOptions.SelectedBoss = nil;
			UpgradeListDBVar.char.SavedOptions.SelectedDifficulty = nil;
			ItemEntryBox:SetText("");
			ItemEntryBox:ClearFocus();
			NoteEntryBox:SetText("");
			NoteEntryBox:ClearFocus();
			priorityfield:SetText("");
			priorityfield:ClearFocus();
			UIDropDownMenu_SetText(DropDown_Button, "Location:");
		end
	end
end

local function AddItem(ItemEntryBox, PrimarySpecRadioButton, SecondarySpecRadioButton, UpgradeListMainFrame, priorityfield, statusbarfont, NoteEntryBox)
	local itemName, itemLink, itemRarity, itemLevel, itemMinLevel, itemType, itemSubType, itemStackCount, itemEquipLoc, itemTexture, itemSellPrice = GetItemInfo(ItemEntryBox:GetText());
	if itemEquipLoc ~= nil then
		local _, _, Color, Ltype, ID = string.find(itemLink, "|?c?f?f?(%x*)|?H?([^:]*):?(%d+):?(%d*):?(%d*):?(%d*):?(%d*):?(%d*):?(%-?%d*):?(%-?%d*):?(%d*):?(%d*)|?h?%[?([^%[%]]*)%]?|?h?|?r?");
	end
	if itemEquipLoc == "" or itemEquipLoc == "INVTYPE_BAG" or itemEquipLoc == "INVTYPE_TABARD" or itemEqupLoc == "BODY" then --Non-equipable items
		EnterItemIntoDatabase(ItemEntryBox, PrimarySpecRadioButton, SecondarySpecRadioButton, UpgradeListMainFrame, priorityfield, statusbarfont, NoteEntryBox, itemName, itemLink, itemRarity, itemLevel, itemMinLevel, itemType, itemSubType, itemStackCount, itemEquipLoc, itemTexture, itemSellPrice, ID)
	elseif itemEquipLoc == nil then
		statusbarfont:SetTextColor(1, 0, 0);
		statusbarfont:SetText("Invalid item.");
		ItemEntryBox:HighlightText();
	else
		local localizedClass, englishClass = UnitClass("player");
		if englishClass == "DEATHKNIGHT" then
			if (itemSubType ~= "Cloth") and (itemSubType ~= "Leather") and (itemSubType ~= "Mail") and (itemSubType ~= "Plate") and (itemSubType ~= "Relic") and (itemSubType ~= "One-Handed Maces") and (itemSubType ~= "Two-Handed Maces") and (itemSubType ~= "Polearms") and (itemSubType ~= "One-Handed Swords") and (itemSubType ~= "Two-Handed Swords") and (itemSubType ~= "One-Handed Axes") and (itemSubType ~= "Two-Handed Axes") and (itemSubType ~= "Miscellaneous") then
				--The player CANNOT equip the item.
				statusbarfont:SetTextColor(1, 0, 0);
				statusbarfont:SetText("Your character cannot equip " .. itemLink);
				ItemEntryBox:HighlightText();
			else
				--The player CAN equip the item.
				EnterItemIntoDatabase(ItemEntryBox, PrimarySpecRadioButton, SecondarySpecRadioButton, UpgradeListMainFrame, priorityfield, statusbarfont, NoteEntryBox, itemName, itemLink, itemRarity, itemLevel, itemMinLevel, itemType, itemSubType, itemStackCount, itemEquipLoc, itemTexture, itemSellPrice, ID)
			end
		elseif englishClass == "DRUID" then
			if (itemSubType ~= "Cloth") and (itemSubType ~= "Leather") and (itemSubType ~= "Relic") and (itemSubType ~= "Daggers") and (itemSubType ~= "Fist Weapons") and (itemSubType ~= "One-Handed Maces") and (itemSubType ~= "Polearms") and (itemSubType ~= "Staves") and (itemSubType ~= "Two-Handed Maces") and (itemSubType ~= "Miscellaneous") then
				--The player CANNOT equip the item.
				statusbarfont:SetTextColor(1, 0, 0);
				statusbarfont:SetText("Your character cannot equip " .. itemLink);
				ItemEntryBox:HighlightText();
			else
				--The player CAN equip the item.
				EnterItemIntoDatabase(ItemEntryBox, PrimarySpecRadioButton, SecondarySpecRadioButton, UpgradeListMainFrame, priorityfield, statusbarfont, NoteEntryBox, itemName, itemLink, itemRarity, itemLevel, itemMinLevel, itemType, itemSubType, itemStackCount, itemEquipLoc, itemTexture, itemSellPrice, ID)
			end
		elseif englishClass == "HUNTER" then
			if (itemSubType ~= "Cloth") and (itemSubType ~= "Leather") and (itemSubType ~= "Mail") and (itemSubType ~= "Guns") and (itemSubType ~= "Bows") and (itemSubType ~= "Crossbows") and (itemSubType ~= "Thrown") and (itemSubType ~= "Fist Weapons") and (itemSubType ~= "One-Handed Axes") and (itemSubType ~= "One-Handed Swords") and (itemSubType ~= "Polearms") and (itemSubType ~= "Staves") and (itemSubType ~= "Two-Handed Axes") and (itemSubType ~= "Two-Handed Swords") and (itemSubType ~= "Miscellaneous") then
				--The player CANNOT equip the item.
				statusbarfont:SetTextColor(1, 0, 0);
				statusbarfont:SetText("Your character cannot equip " .. itemLink);
				ItemEntryBox:HighlightText();
			else
				--The player CAN equip the item.
				EnterItemIntoDatabase(ItemEntryBox, PrimarySpecRadioButton, SecondarySpecRadioButton, UpgradeListMainFrame, priorityfield, statusbarfont, NoteEntryBox, itemName, itemLink, itemRarity, itemLevel, itemMinLevel, itemType, itemSubType, itemStackCount, itemEquipLoc, itemTexture, itemSellPrice, ID)
			end
		elseif englishClass == "MAGE" then
			if (itemSubType ~= "Cloth") and (itemSubType ~= "Staves") and (itemSubType ~= "Wands") and (itemSubType ~= "Daggers") and (itemSubType ~= "One-Handed Swords") and (itemSubType ~= "Miscellaneous") then
				--The player CANNOT equip the item.
				statusbarfont:SetTextColor(1, 0, 0);
				statusbarfont:SetText("Your character cannot equip " .. itemLink);
				ItemEntryBox:HighlightText();
			else
				--The player CAN equip the item.
				EnterItemIntoDatabase(ItemEntryBox, PrimarySpecRadioButton, SecondarySpecRadioButton, UpgradeListMainFrame, priorityfield, statusbarfont, NoteEntryBox, itemName, itemLink, itemRarity, itemLevel, itemMinLevel, itemType, itemSubType, itemStackCount, itemEquipLoc, itemTexture, itemSellPrice, ID)
			end
		elseif englishClass == "PALADIN" then
			if (itemSubType ~= "Cloth") and (itemSubType ~= "Leather") and (itemSubType ~= "Mail") and (itemSubType ~= "Plate") and (itemSubType ~= "Shields") and (itemSubType ~= "Relic") and (itemSubType ~= "One-Handed Maces") and (itemSubType ~= "Two-Handed Maces") and (itemSubType ~= "Polearms") and (itemSubType ~= "One-Handed Swords") and (itemSubType ~= "Two-Handed Swords") and (itemSubType ~= "One-Handed Axes") and (itemSubType ~= "Two-Handed Axes") and (itemSubType ~= "Miscellaneous") then
				--The player CANNOT equip the item.
				statusbarfont:SetTextColor(1, 0, 0);
				statusbarfont:SetText("Your character cannot equip " .. itemLink);
				ItemEntryBox:HighlightText();
			else
				--The player CAN equip the item.
				EnterItemIntoDatabase(ItemEntryBox, PrimarySpecRadioButton, SecondarySpecRadioButton, UpgradeListMainFrame, priorityfield, statusbarfont, NoteEntryBox, itemName, itemLink, itemRarity, itemLevel, itemMinLevel, itemType, itemSubType, itemStackCount, itemEquipLoc, itemTexture, itemSellPrice, ID)
			end
		elseif englishClass == "PRIEST" then
			if (itemSubType ~= "Cloth") and (itemSubType ~= "Staves") and (itemSubType ~= "Wands") and (itemSubType ~= "Daggers") and (itemSubType ~= "One-Handed Maces") and (itemSubType ~= "Miscellaneous") then
				--The player CANNOT equip the item.
				statusbarfont:SetTextColor(1, 0, 0);
				statusbarfont:SetText("Your character cannot equip " .. itemLink);
				ItemEntryBox:HighlightText();
			else
				--The player CAN equip the item.
				EnterItemIntoDatabase(ItemEntryBox, PrimarySpecRadioButton, SecondarySpecRadioButton, UpgradeListMainFrame, priorityfield, statusbarfont, NoteEntryBox, itemName, itemLink, itemRarity, itemLevel, itemMinLevel, itemType, itemSubType, itemStackCount, itemEquipLoc, itemTexture, itemSellPrice, ID)
			end
		elseif englishClass == "ROGUE" then
			if (itemSubType ~= "Cloth") and (itemSubType ~= "Leather") and (itemSubType ~= "Daggers") and (itemSubType ~= "Fist Weapons") and (itemSubType ~= "One-Handed Maces") and (itemSubType ~= "One-Handed Axes") and (itemSubType ~= "One-Handed Swords") and (itemSubType ~= "Bows") and (itemSubType ~= "Crossbows") and (itemSubType ~= "Thrown") and (itemSubType ~= "Guns") and (itemSubType ~= "Miscellaneous") then
				--The player CANNOT equip the item.
				statusbarfont:SetTextColor(1, 0, 0);
				statusbarfont:SetText("Your character cannot equip " .. itemLink);
				ItemEntryBox:HighlightText();
			else
				--The player CAN equip the item.
				EnterItemIntoDatabase(ItemEntryBox, PrimarySpecRadioButton, SecondarySpecRadioButton, UpgradeListMainFrame, priorityfield, statusbarfont, NoteEntryBox, itemName, itemLink, itemRarity, itemLevel, itemMinLevel, itemType, itemSubType, itemStackCount, itemEquipLoc, itemTexture, itemSellPrice, ID)
			end
		elseif englishClass == "SHAMAN" then
			if (itemSubType ~= "Cloth") and (itemSubType ~= "Leather") and (itemSubType ~= "Mail") and (itemSubType ~= "Shields") and (itemSubType ~= "Daggers") and (itemSubType ~= "Fist Weapons") and (itemSubType ~= "One-Handed Maces") and (itemSubType ~= "One-Handed Axes") and (itemSubType ~= "Relic") and (itemSubType ~= "Staves") and (itemSubType ~= "Two-Handed Maces") and (itemSubType ~= "Two-Handed Axes") and (itemSubType ~= "Miscellaneous") then
				--The player CANNOT equip the item.
				statusbarfont:SetTextColor(1, 0, 0);
				statusbarfont:SetText("Your character cannot equip " .. itemLink);
				ItemEntryBox:HighlightText();
			else
				--The player CAN equip the item.
				EnterItemIntoDatabase(ItemEntryBox, PrimarySpecRadioButton, SecondarySpecRadioButton, UpgradeListMainFrame, priorityfield, statusbarfont, NoteEntryBox, itemName, itemLink, itemRarity, itemLevel, itemMinLevel, itemType, itemSubType, itemStackCount, itemEquipLoc, itemTexture, itemSellPrice, ID)
			end
		elseif englishClass == "WARLOCK" then
			if (itemSubType ~= "Cloth") and (itemSubType ~= "Staves") and (itemSubType ~= "Wands") and (itemSubType ~= "Daggers") and (itemSubType ~= "One-Handed Swords") and (itemSubType ~= "Miscellaneous") then
				--The player CANNOT equip the item.
				statusbarfont:SetTextColor(1, 0, 0);
				statusbarfont:SetText("Your character cannot equip " .. itemLink);
				ItemEntryBox:HighlightText();
			else
				--The player CAN equip the item.
				EnterItemIntoDatabase(ItemEntryBox, PrimarySpecRadioButton, SecondarySpecRadioButton, UpgradeListMainFrame, priorityfield, statusbarfont, NoteEntryBox, itemName, itemLink, itemRarity, itemLevel, itemMinLevel, itemType, itemSubType, itemStackCount, itemEquipLoc, itemTexture, itemSellPrice, ID)
			end
		elseif englishClass == "WARRIOR" then
			if (itemSubType ~= "Cloth") and (itemSubType ~= "Leather") and (itemSubType ~= "Mail") and (itemSubType ~= "Plate") and (itemSubType ~= "Shields") and (itemSubType ~= "Bows") and (itemSubType ~= "Crossbows") and (itemSubType ~= "Fist Weapons") and (itemSubType ~= "Guns") and (itemSubType ~= "One-Handed Axes") and (itemSubType ~= "One-Handed Maces") and (itemSubType ~= "One-Handed Swords") and (itemSubType ~= "Polearms") and (itemSubType ~= "Staves") and (itemSubType ~= "Two-Handed Axes") and (itemSubType ~= "Two-Handed Maces") and (itemSubType ~= "Two-Handed Swords") and (itemSubType ~= "Miscellaneous") then
				--The player CANNOT equip the equipable item
				statusbarfont:SetTextColor(1, 0, 0);
				statusbarfont:SetText("Your character cannot equip " .. itemLink);
				ItemEntryBox:HighlightText();
			else 
				--Player can equip the item
				EnterItemIntoDatabase(ItemEntryBox, PrimarySpecRadioButton, SecondarySpecRadioButton, UpgradeListMainFrame, priorityfield, statusbarfont, NoteEntryBox, itemName, itemLink, itemRarity, itemLevel, itemMinLevel, itemType, itemSubType, itemStackCount, itemEquipLoc, itemTexture, itemSellPrice, ID)
			end
		else
			statusbarfont:SetTextColor(1, 0, 0);
			statusbarfont:SetText("ERROR: Unable to determine your class.");
		end
	end
end

local function DeleteItem(deletefield, UpgradeListMainFrame, statusbarfont)
	local deletefieldnum = tonumber(deletefield:GetText());
	if deletefieldnum ~= nil then
		deletefieldnum = math.floor(deletefieldnum);
	end
	if deletefieldnum == nil and deletefield:GetText() ~= "" then
		statusbarfont:SetTextColor(1, 0, 0);
		statusbarfont:SetText("Delete field must be a number.");
		deletefield:HighlightText();
	elseif deletefieldnum == nil then
		statusbarfont:SetTextColor(1, 0, 0);
		statusbarfont:SetText("Nothing entered in delete field.");
		deletefield:HighlightText();
	elseif PanelTemplates_GetSelectedTab(UpgradeListMainFrame) == 1 then --If the head tab is selected
		if UpgradeListDBVar.char.SavedOptions.PrimaryCheck:GetChecked() == 1 then --If the primary spec checkbox is checked
			if deletefieldnum >= UpgradeListDBVar.char.PrimarySpecList.Head.Count or deletefieldnum == 0 then
				statusbarfont:SetTextColor(1, 0, 0);
				statusbarfont:SetText("Delete field does not match an item in your Primary Spec's Head list.");
				deletefield:HighlightText();
			elseif deletefieldnum ~= UpgradeListDBVar.char.PrimarySpecList.Head.Count - 1 and deletefieldnum > 0 then --If deleted item is NOT the last one in the list
				table.remove(UpgradeListDBVar.char.PrimarySpecList.Head.Row, deletefieldnum);
				UpgradeListDBVar.char.PrimarySpecList.Head.Count = UpgradeListDBVar.char.PrimarySpecList.Head.Count - 1;
				statusbarfont:SetTextColor(0, 1, 0);
				statusbarfont:SetText("Successfully deleted item " .. deletefieldnum .. " from your Primary Spec's Head list.");
				for i = UpgradeListDBVar.char.PrimarySpecList.Head.Row[deletefieldnum][1], UpgradeListDBVar.char.PrimarySpecList.Head.Count, 1 do
					UpgradeListDBVar.char.PrimarySpecList.Head.Row[i - 1][1] = i - 1;
				end
				deletefield:SetText("");
				deletefield:ClearFocus();
				UpgradeList:RefreshWindow()
			elseif deletefieldnum > 0 then --Deleting the last item in the list
				table.remove(UpgradeListDBVar.char.PrimarySpecList.Head.Row, deletefieldnum);
				UpgradeListDBVar.char.PrimarySpecList.Head.Count = UpgradeListDBVar.char.PrimarySpecList.Head.Count - 1;
				statusbarfont:SetTextColor(0, 1, 0);
				statusbarfont:SetText("Successfully deleted item " .. deletefieldnum .. " from your Primary Spec's Head list.");
				deletefield:SetText("");
				deletefield:ClearFocus();
				UpgradeList:RefreshWindow()
			else
				statusbarfont:SetTextColor(1, 0, 0);
				statusbarfont:SetText(deletefieldnum .. " is not a valid number for deletion.");
				deletefield:HighlightText();
			end
		else --The secondary spec checkbox is checked
			if deletefieldnum >= UpgradeListDBVar.char.SecondarySpecList.Head.Count or deletefieldnum == 0 then
				statusbarfont:SetTextColor(1, 0, 0);
				statusbarfont:SetText("Delete field does not match an item in your Secondary Spec's Head list.");
				deletefield:HighlightText();
			elseif deletefieldnum ~= UpgradeListDBVar.char.SecondarySpecList.Head.Count - 1 then --If the deletefieldnum is equal to the last displayed item in the list, it breaks the array
				table.remove(UpgradeListDBVar.char.SecondarySpecList.Head.Row, deletefieldnum);
				UpgradeListDBVar.char.SecondarySpecList.Head.Count = UpgradeListDBVar.char.SecondarySpecList.Head.Count - 1;
				statusbarfont:SetTextColor(0, 1, 0);
				statusbarfont:SetText("Successfully deleted item " .. deletefieldnum .. " from your Secondary Spec's Head list.");
				for i = UpgradeListDBVar.char.SecondarySpecList.Head.Row[deletefieldnum][1], UpgradeListDBVar.char.SecondarySpecList.Head.Count, 1 do
					UpgradeListDBVar.char.SecondarySpecList.Head.Row[i - 1][1] = i - 1;
				end
				deletefield:SetText("");
				deletefield:ClearFocus();
				UpgradeList:RefreshWindow()
			else --Deleting the last item in the list
				table.remove(UpgradeListDBVar.char.SecondarySpecList.Head.Row, deletefieldnum);
				UpgradeListDBVar.char.SecondarySpecList.Head.Count = UpgradeListDBVar.char.SecondarySpecList.Head.Count - 1;
				statusbarfont:SetTextColor(0, 1, 0);
				statusbarfont:SetText("Successfully deleted item " .. deletefieldnum .. " from your Secondary Spec's Head list.");
				deletefield:SetText("");
				deletefield:ClearFocus();
				UpgradeList:RefreshWindow()
			end
		end
	elseif PanelTemplates_GetSelectedTab(UpgradeListMainFrame) == 2 then --If the neck tab is selected
		if UpgradeListDBVar.char.SavedOptions.PrimaryCheck:GetChecked() == 1 then --If the primary spec checkbox is checked
			if deletefieldnum >= UpgradeListDBVar.char.PrimarySpecList.Neck.Count or deletefieldnum == 0 then
				statusbarfont:SetTextColor(1, 0, 0);
				statusbarfont:SetText("Delete field does not match an item in your Primary Spec's Neck list.");
				deletefield:HighlightText();
			elseif deletefieldnum ~= UpgradeListDBVar.char.PrimarySpecList.Neck.Count - 1 then --If the deletefieldnum is equal to the last displayed item in the list, it breaks the array
				table.remove(UpgradeListDBVar.char.PrimarySpecList.Neck.Row, deletefieldnum);
				UpgradeListDBVar.char.PrimarySpecList.Neck.Count = UpgradeListDBVar.char.PrimarySpecList.Neck.Count - 1;
				statusbarfont:SetTextColor(0, 1, 0);
				statusbarfont:SetText("Successfully deleted item " .. deletefieldnum .. " from your Primary Spec's Neck list.");
				for i = UpgradeListDBVar.char.PrimarySpecList.Neck.Row[deletefieldnum][1], UpgradeListDBVar.char.PrimarySpecList.Neck.Count, 1 do
					UpgradeListDBVar.char.PrimarySpecList.Neck.Row[i - 1][1] = i - 1;
				end
				deletefield:SetText("");
				deletefield:ClearFocus();
				UpgradeList:RefreshWindow()
			else --Deleting the last item in the list
				table.remove(UpgradeListDBVar.char.PrimarySpecList.Neck.Row, deletefieldnum);
				UpgradeListDBVar.char.PrimarySpecList.Neck.Count = UpgradeListDBVar.char.PrimarySpecList.Neck.Count - 1;
				statusbarfont:SetTextColor(0, 1, 0);
				statusbarfont:SetText("Successfully deleted item " .. deletefieldnum .. " from your Primary Spec's Neck list.");
				deletefield:SetText("");
				deletefield:ClearFocus();
				UpgradeList:RefreshWindow()
			end
		else --The secondary spec checkbox is checked
			if deletefieldnum >= UpgradeListDBVar.char.SecondarySpecList.Neck.Count or deletefieldnum == 0 then
				statusbarfont:SetTextColor(1, 0, 0);
				statusbarfont:SetText("Delete field does not match an item in your Secondary Spec's Neck list.");
				deletefield:HighlightText();
			elseif deletefieldnum ~= UpgradeListDBVar.char.SecondarySpecList.Neck.Count - 1 then --If the deletefieldnum is equal to the last displayed item in the list, it breaks the array
				table.remove(UpgradeListDBVar.char.SecondarySpecList.Neck.Row, deletefieldnum);
				UpgradeListDBVar.char.SecondarySpecList.Neck.Count = UpgradeListDBVar.char.SecondarySpecList.Neck.Count - 1;
				statusbarfont:SetTextColor(0, 1, 0);
				statusbarfont:SetText("Successfully deleted item " .. deletefieldnum .. " from your Secondary Spec's Neck list.");
				for i = UpgradeListDBVar.char.SecondarySpecList.Neck.Row[deletefieldnum][1], UpgradeListDBVar.char.SecondarySpecList.Neck.Count, 1 do
					UpgradeListDBVar.char.SecondarySpecList.Neck.Row[i - 1][1] = i - 1;
				end
				deletefield:SetText("");
				deletefield:ClearFocus();
				UpgradeList:RefreshWindow()
			else --Deleting the last item in the list
				table.remove(UpgradeListDBVar.char.SecondarySpecList.Neck.Row, deletefieldnum);
				UpgradeListDBVar.char.SecondarySpecList.Neck.Count = UpgradeListDBVar.char.SecondarySpecList.Neck.Count - 1;
				statusbarfont:SetTextColor(0, 1, 0);
				statusbarfont:SetText("Successfully deleted item " .. deletefieldnum .. " from your Secondary Spec's Neck list.");
				deletefield:SetText("");
				deletefield:ClearFocus();
				UpgradeList:RefreshWindow()
			end
		end
	elseif PanelTemplates_GetSelectedTab(UpgradeListMainFrame) == 3 then --If the Shoulder tab is selected
		if UpgradeListDBVar.char.SavedOptions.PrimaryCheck:GetChecked() == 1 then --If the primary spec checkbox is checked
			if deletefieldnum >= UpgradeListDBVar.char.PrimarySpecList.Shoulder.Count or deletefieldnum == 0 then
				statusbarfont:SetTextColor(1, 0, 0);
				statusbarfont:SetText("Delete field does not match an item in your Primary Spec's Shoulder list.");
				deletefield:HighlightText();
			elseif deletefieldnum ~= UpgradeListDBVar.char.PrimarySpecList.Shoulder.Count - 1 then --If the deletefieldnum is equal to the last displayed item in the list, it breaks the array
				table.remove(UpgradeListDBVar.char.PrimarySpecList.Shoulder.Row, deletefieldnum);
				UpgradeListDBVar.char.PrimarySpecList.Shoulder.Count = UpgradeListDBVar.char.PrimarySpecList.Shoulder.Count - 1;
				statusbarfont:SetTextColor(0, 1, 0);
				statusbarfont:SetText("Successfully deleted item " .. deletefieldnum .. " from your Primary Spec's Shoulder list.");
				for i = UpgradeListDBVar.char.PrimarySpecList.Shoulder.Row[deletefieldnum][1], UpgradeListDBVar.char.PrimarySpecList.Shoulder.Count, 1 do
					UpgradeListDBVar.char.PrimarySpecList.Shoulder.Row[i - 1][1] = i - 1;
				end
				deletefield:SetText("");
				deletefield:ClearFocus();
				UpgradeList:RefreshWindow()
			else --Deleting the last item in the list
				table.remove(UpgradeListDBVar.char.PrimarySpecList.Shoulder.Row, deletefieldnum);
				UpgradeListDBVar.char.PrimarySpecList.Shoulder.Count = UpgradeListDBVar.char.PrimarySpecList.Shoulder.Count - 1;
				statusbarfont:SetTextColor(0, 1, 0);
				statusbarfont:SetText("Successfully deleted item " .. deletefieldnum .. " from your Primary Spec's Shoulder list.");
				deletefield:SetText("");
				deletefield:ClearFocus();
				UpgradeList:RefreshWindow()
			end
		else --The secondary spec checkbox is checked
			if deletefieldnum >= UpgradeListDBVar.char.SecondarySpecList.Shoulder.Count or deletefieldnum == 0 then
				statusbarfont:SetTextColor(1, 0, 0);
				statusbarfont:SetText("Delete field does not match an item in your Secondary Spec's Shoulder list.");
				deletefield:HighlightText();
			elseif deletefieldnum ~= UpgradeListDBVar.char.SecondarySpecList.Shoulder.Count - 1 then --If the deletefieldnum is equal to the last displayed item in the list, it breaks the array
				table.remove(UpgradeListDBVar.char.SecondarySpecList.Shoulder.Row, deletefieldnum);
				UpgradeListDBVar.char.SecondarySpecList.Shoulder.Count = UpgradeListDBVar.char.SecondarySpecList.Shoulder.Count - 1;
				statusbarfont:SetTextColor(0, 1, 0);
				statusbarfont:SetText("Successfully deleted item " .. deletefieldnum .. " from your Secondary Spec's Shoulder list.");
				for i = UpgradeListDBVar.char.SecondarySpecList.Shoulder.Row[deletefieldnum][1], UpgradeListDBVar.char.SecondarySpecList.Shoulder.Count, 1 do
					UpgradeListDBVar.char.SecondarySpecList.Shoulder.Row[i - 1][1] = i - 1;
				end
				deletefield:SetText("");
				deletefield:ClearFocus();
				UpgradeList:RefreshWindow()
			else --Deleting the last item in the list
				table.remove(UpgradeListDBVar.char.SecondarySpecList.Shoulder.Row, deletefieldnum);
				UpgradeListDBVar.char.SecondarySpecList.Shoulder.Count = UpgradeListDBVar.char.SecondarySpecList.Shoulder.Count - 1;
				statusbarfont:SetTextColor(0, 1, 0);
				statusbarfont:SetText("Successfully deleted item " .. deletefieldnum .. " from your Secondary Spec's Shoulder list.");
				deletefield:SetText("");
				deletefield:ClearFocus();
				UpgradeList:RefreshWindow()
			end
		end
	elseif PanelTemplates_GetSelectedTab(UpgradeListMainFrame) == 4 then --If the Back tab is selected
		if UpgradeListDBVar.char.SavedOptions.PrimaryCheck:GetChecked() == 1 then --If the primary spec checkbox is checked
			if deletefieldnum >= UpgradeListDBVar.char.PrimarySpecList.Back.Count or deletefieldnum == 0 then
				statusbarfont:SetTextColor(1, 0, 0);
				statusbarfont:SetText("Delete field does not match an item in your Primary Spec's Back list.");
				deletefield:HighlightText();
			elseif deletefieldnum ~= UpgradeListDBVar.char.PrimarySpecList.Back.Count - 1 then --If the deletefieldnum is equal to the last displayed item in the list, it breaks the array
				table.remove(UpgradeListDBVar.char.PrimarySpecList.Back.Row, deletefieldnum);
				UpgradeListDBVar.char.PrimarySpecList.Back.Count = UpgradeListDBVar.char.PrimarySpecList.Back.Count - 1;
				statusbarfont:SetTextColor(0, 1, 0);
				statusbarfont:SetText("Successfully deleted item " .. deletefieldnum .. " from your Primary Spec's Back list.");
				for i = UpgradeListDBVar.char.PrimarySpecList.Back.Row[deletefieldnum][1], UpgradeListDBVar.char.PrimarySpecList.Back.Count, 1 do
					UpgradeListDBVar.char.PrimarySpecList.Back.Row[i - 1][1] = i - 1;
				end
				deletefield:SetText("");
				deletefield:ClearFocus();
				UpgradeList:RefreshWindow()
			else --Deleting the last item in the list
				table.remove(UpgradeListDBVar.char.PrimarySpecList.Back.Row, deletefieldnum);
				UpgradeListDBVar.char.PrimarySpecList.Back.Count = UpgradeListDBVar.char.PrimarySpecList.Back.Count - 1;
				statusbarfont:SetTextColor(0, 1, 0);
				statusbarfont:SetText("Successfully deleted item " .. deletefieldnum .. " from your Primary Spec's Back list.");
				deletefield:SetText("");
				deletefield:ClearFocus();
				UpgradeList:RefreshWindow()
			end
		else --The secondary spec checkbox is checked
			if deletefieldnum >= UpgradeListDBVar.char.SecondarySpecList.Back.Count or deletefieldnum == 0 then
				statusbarfont:SetTextColor(1, 0, 0);
				statusbarfont:SetText("Delete field does not match an item in your Secondary Spec's Back list.");
				deletefield:HighlightText();
			elseif deletefieldnum ~= UpgradeListDBVar.char.SecondarySpecList.Back.Count - 1 then --If the deletefieldnum is equal to the last displayed item in the list, it breaks the array
				table.remove(UpgradeListDBVar.char.SecondarySpecList.Back.Row, deletefieldnum);
				UpgradeListDBVar.char.SecondarySpecList.Back.Count = UpgradeListDBVar.char.SecondarySpecList.Back.Count - 1;
				statusbarfont:SetTextColor(0, 1, 0);
				statusbarfont:SetText("Successfully deleted item " .. deletefieldnum .. " from your Secondary Spec's Back list.");
				for i = UpgradeListDBVar.char.SecondarySpecList.Back.Row[deletefieldnum][1], UpgradeListDBVar.char.SecondarySpecList.Back.Count, 1 do
					UpgradeListDBVar.char.SecondarySpecList.Back.Row[i - 1][1] = i - 1;
				end
				deletefield:SetText("");
				deletefield:ClearFocus();
				UpgradeList:RefreshWindow()
			else --Deleting the last item in the list
				table.remove(UpgradeListDBVar.char.SecondarySpecList.Back.Row, deletefieldnum);
				UpgradeListDBVar.char.SecondarySpecList.Back.Count = UpgradeListDBVar.char.SecondarySpecList.Back.Count - 1;
				statusbarfont:SetTextColor(0, 1, 0);
				statusbarfont:SetText("Successfully deleted item " .. deletefieldnum .. " from your Secondary Spec's Back list.");
				deletefield:SetText("");
				deletefield:ClearFocus();
				UpgradeList:RefreshWindow()
			end
		end
	elseif PanelTemplates_GetSelectedTab(UpgradeListMainFrame) == 5 then --If the Chest tab is selected
		if UpgradeListDBVar.char.SavedOptions.PrimaryCheck:GetChecked() == 1 then --If the primary spec checkbox is checked
			if deletefieldnum >= UpgradeListDBVar.char.PrimarySpecList.Chest.Count or deletefieldnum == 0 then
				statusbarfont:SetTextColor(1, 0, 0);
				statusbarfont:SetText("Delete field does not match an item in your Primary Spec's Chest list.");
				deletefield:HighlightText();
			elseif deletefieldnum ~= UpgradeListDBVar.char.PrimarySpecList.Chest.Count - 1 then --If the deletefieldnum is equal to the last displayed item in the list, it breaks the array
				table.remove(UpgradeListDBVar.char.PrimarySpecList.Chest.Row, deletefieldnum);
				UpgradeListDBVar.char.PrimarySpecList.Chest.Count = UpgradeListDBVar.char.PrimarySpecList.Chest.Count - 1;
				statusbarfont:SetTextColor(0, 1, 0);
				statusbarfont:SetText("Successfully deleted item " .. deletefieldnum .. " from your Primary Spec's Chest list.");
				for i = UpgradeListDBVar.char.PrimarySpecList.Chest.Row[deletefieldnum][1], UpgradeListDBVar.char.PrimarySpecList.Chest.Count, 1 do
					UpgradeListDBVar.char.PrimarySpecList.Chest.Row[i - 1][1] = i - 1;
				end
				deletefield:SetText("");
				deletefield:ClearFocus();
				UpgradeList:RefreshWindow()
			else --Deleting the last item in the list
				table.remove(UpgradeListDBVar.char.PrimarySpecList.Chest.Row, deletefieldnum);
				UpgradeListDBVar.char.PrimarySpecList.Chest.Count = UpgradeListDBVar.char.PrimarySpecList.Chest.Count - 1;
				statusbarfont:SetTextColor(0, 1, 0);
				statusbarfont:SetText("Successfully deleted item " .. deletefieldnum .. " from your Primary Spec's Chest list.");
				deletefield:SetText("");
				deletefield:ClearFocus();
				UpgradeList:RefreshWindow()
			end
		else --The secondary spec checkbox is checked
			if deletefieldnum >= UpgradeListDBVar.char.SecondarySpecList.Chest.Count or deletefieldnum == 0 then
				statusbarfont:SetTextColor(1, 0, 0);
				statusbarfont:SetText("Delete field does not match an item in your Secondary Spec's Chest list.");
				deletefield:HighlightText();
			elseif deletefieldnum ~= UpgradeListDBVar.char.SecondarySpecList.Chest.Count - 1 then --If the deletefieldnum is equal to the last displayed item in the list, it breaks the array
				table.remove(UpgradeListDBVar.char.SecondarySpecList.Chest.Row, deletefieldnum);
				UpgradeListDBVar.char.SecondarySpecList.Chest.Count = UpgradeListDBVar.char.SecondarySpecList.Chest.Count - 1;
				statusbarfont:SetTextColor(0, 1, 0);
				statusbarfont:SetText("Successfully deleted item " .. deletefieldnum .. " from your Secondary Spec's Chest list.");
				for i = UpgradeListDBVar.char.SecondarySpecList.Chest.Row[deletefieldnum][1], UpgradeListDBVar.char.SecondarySpecList.Chest.Count, 1 do
					UpgradeListDBVar.char.SecondarySpecList.Chest.Row[i - 1][1] = i - 1;
				end
				deletefield:SetText("");
				deletefield:ClearFocus();
				UpgradeList:RefreshWindow()
			else --Deleting the last item in the list
				table.remove(UpgradeListDBVar.char.SecondarySpecList.Chest.Row, deletefieldnum);
				UpgradeListDBVar.char.SecondarySpecList.Chest.Count = UpgradeListDBVar.char.SecondarySpecList.Chest.Count - 1;
				statusbarfont:SetTextColor(0, 1, 0);
				statusbarfont:SetText("Successfully deleted item " .. deletefieldnum .. " from your Secondary Spec's Chest list.");
				deletefield:SetText("");
				deletefield:ClearFocus();
				UpgradeList:RefreshWindow()
			end
		end
	elseif PanelTemplates_GetSelectedTab(UpgradeListMainFrame) == 6 then --If the Wrist tab is selected
		if UpgradeListDBVar.char.SavedOptions.PrimaryCheck:GetChecked() == 1 then --If the primary spec checkbox is checked
			if deletefieldnum >= UpgradeListDBVar.char.PrimarySpecList.Wrist.Count or deletefieldnum == 0 then
				statusbarfont:SetTextColor(1, 0, 0);
				statusbarfont:SetText("Delete field does not match an item in your Primary Spec's Wrist list.");
				deletefield:HighlightText();
			elseif deletefieldnum ~= UpgradeListDBVar.char.PrimarySpecList.Wrist.Count - 1 then --If the deletefieldnum is equal to the last displayed item in the list, it breaks the array
				table.remove(UpgradeListDBVar.char.PrimarySpecList.Wrist.Row, deletefieldnum);
				UpgradeListDBVar.char.PrimarySpecList.Wrist.Count = UpgradeListDBVar.char.PrimarySpecList.Wrist.Count - 1;
				statusbarfont:SetTextColor(0, 1, 0);
				statusbarfont:SetText("Successfully deleted item " .. deletefieldnum .. " from your Primary Spec's Wrist list.");
				for i = UpgradeListDBVar.char.PrimarySpecList.Wrist.Row[deletefieldnum][1], UpgradeListDBVar.char.PrimarySpecList.Wrist.Count, 1 do
					UpgradeListDBVar.char.PrimarySpecList.Wrist.Row[i - 1][1] = i - 1;
				end
				deletefield:SetText("");
				deletefield:ClearFocus();
				UpgradeList:RefreshWindow()
			else --Deleting the last item in the list
				table.remove(UpgradeListDBVar.char.PrimarySpecList.Wrist.Row, deletefieldnum);
				UpgradeListDBVar.char.PrimarySpecList.Wrist.Count = UpgradeListDBVar.char.PrimarySpecList.Wrist.Count - 1;
				statusbarfont:SetTextColor(0, 1, 0);
				statusbarfont:SetText("Successfully deleted item " .. deletefieldnum .. " from your Primary Spec's Wrist list.");
				deletefield:SetText("");
				deletefield:ClearFocus();
				UpgradeList:RefreshWindow()
			end
		else --The secondary spec checkbox is checked
			if deletefieldnum >= UpgradeListDBVar.char.SecondarySpecList.Wrist.Count or deletefieldnum == 0 then
				statusbarfont:SetTextColor(1, 0, 0);
				statusbarfont:SetText("Delete field does not match an item in your Secondary Spec's Wrist list.");
				deletefield:HighlightText();
			elseif deletefieldnum ~= UpgradeListDBVar.char.SecondarySpecList.Wrist.Count - 1 then --If the deletefieldnum is equal to the last displayed item in the list, it breaks the array
				table.remove(UpgradeListDBVar.char.SecondarySpecList.Wrist.Row, deletefieldnum);
				UpgradeListDBVar.char.SecondarySpecList.Wrist.Count = UpgradeListDBVar.char.SecondarySpecList.Wrist.Count - 1;
				statusbarfont:SetTextColor(0, 1, 0);
				statusbarfont:SetText("Successfully deleted item " .. deletefieldnum .. " from your Secondary Spec's Wrist list.");
				for i = UpgradeListDBVar.char.SecondarySpecList.Wrist.Row[deletefieldnum][1], UpgradeListDBVar.char.SecondarySpecList.Wrist.Count, 1 do
					UpgradeListDBVar.char.SecondarySpecList.Wrist.Row[i - 1][1] = i - 1;
				end
				deletefield:SetText("");
				deletefield:ClearFocus();
				UpgradeList:RefreshWindow()
			else --Deleting the last item in the list
				table.remove(UpgradeListDBVar.char.SecondarySpecList.Wrist.Row, deletefieldnum);
				UpgradeListDBVar.char.SecondarySpecList.Wrist.Count = UpgradeListDBVar.char.SecondarySpecList.Wrist.Count - 1;
				statusbarfont:SetTextColor(0, 1, 0);
				statusbarfont:SetText("Successfully deleted item " .. deletefieldnum .. " from your Secondary Spec's Wrist list.");
				deletefield:SetText("");
				deletefield:ClearFocus();
				UpgradeList:RefreshWindow()
			end
		end
	elseif PanelTemplates_GetSelectedTab(UpgradeListMainFrame) == 7 then --If the Hand tab is selected
		if UpgradeListDBVar.char.SavedOptions.PrimaryCheck:GetChecked() == 1 then --If the primary spec checkbox is checked
			if deletefieldnum >= UpgradeListDBVar.char.PrimarySpecList.Hand.Count or deletefieldnum == 0 then
				statusbarfont:SetTextColor(1, 0, 0);
				statusbarfont:SetText("Delete field does not match an item in your Primary Spec's Hand list.");
				deletefield:HighlightText();
			elseif deletefieldnum ~= UpgradeListDBVar.char.PrimarySpecList.Hand.Count - 1 then --If the deletefieldnum is equal to the last displayed item in the list, it breaks the array
				table.remove(UpgradeListDBVar.char.PrimarySpecList.Hand.Row, deletefieldnum);
				UpgradeListDBVar.char.PrimarySpecList.Hand.Count = UpgradeListDBVar.char.PrimarySpecList.Hand.Count - 1;
				statusbarfont:SetTextColor(0, 1, 0);
				statusbarfont:SetText("Successfully deleted item " .. deletefieldnum .. " from your Primary Spec's Hand list.");
				for i = UpgradeListDBVar.char.PrimarySpecList.Hand.Row[deletefieldnum][1], UpgradeListDBVar.char.PrimarySpecList.Hand.Count, 1 do
					UpgradeListDBVar.char.PrimarySpecList.Hand.Row[i - 1][1] = i - 1;
				end
				deletefield:SetText("");
				deletefield:ClearFocus();
				UpgradeList:RefreshWindow()
			else --Deleting the last item in the list
				table.remove(UpgradeListDBVar.char.PrimarySpecList.Hand.Row, deletefieldnum);
				UpgradeListDBVar.char.PrimarySpecList.Hand.Count = UpgradeListDBVar.char.PrimarySpecList.Hand.Count - 1;
				statusbarfont:SetTextColor(0, 1, 0);
				statusbarfont:SetText("Successfully deleted item " .. deletefieldnum .. " from your Primary Spec's Hand list.");
				deletefield:SetText("");
				deletefield:ClearFocus();
				UpgradeList:RefreshWindow()
			end
		else --The secondary spec checkbox is checked
			if deletefieldnum >= UpgradeListDBVar.char.SecondarySpecList.Hand.Count or deletefieldnum == 0 then
				statusbarfont:SetTextColor(1, 0, 0);
				statusbarfont:SetText("Delete field does not match an item in your Secondary Spec's Hand list.");
				deletefield:HighlightText();
			elseif deletefieldnum ~= UpgradeListDBVar.char.SecondarySpecList.Hand.Count - 1 then --If the deletefieldnum is equal to the last displayed item in the list, it breaks the array
				table.remove(UpgradeListDBVar.char.SecondarySpecList.Hand.Row, deletefieldnum);
				UpgradeListDBVar.char.SecondarySpecList.Hand.Count = UpgradeListDBVar.char.SecondarySpecList.Hand.Count - 1;
				statusbarfont:SetTextColor(0, 1, 0);
				statusbarfont:SetText("Successfully deleted item " .. deletefieldnum .. " from your Secondary Spec's Hand list.");
				for i = UpgradeListDBVar.char.SecondarySpecList.Hand.Row[deletefieldnum][1], UpgradeListDBVar.char.SecondarySpecList.Hand.Count, 1 do
					UpgradeListDBVar.char.SecondarySpecList.Hand.Row[i - 1][1] = i - 1;
				end
				deletefield:SetText("");
				deletefield:ClearFocus();
				UpgradeList:RefreshWindow()
			else --Deleting the last item in the list
				table.remove(UpgradeListDBVar.char.SecondarySpecList.Hand.Row, deletefieldnum);
				UpgradeListDBVar.char.SecondarySpecList.Hand.Count = UpgradeListDBVar.char.SecondarySpecList.Hand.Count - 1;
				statusbarfont:SetTextColor(0, 1, 0);
				statusbarfont:SetText("Successfully deleted item " .. deletefieldnum .. " from your Secondary Spec's Hand list.");
				deletefield:SetText("");
				deletefield:ClearFocus();
				UpgradeList:RefreshWindow()
			end
		end
	elseif PanelTemplates_GetSelectedTab(UpgradeListMainFrame) == 8 then --If the Waist tab is selected
		if UpgradeListDBVar.char.SavedOptions.PrimaryCheck:GetChecked() == 1 then --If the primary spec checkbox is checked
			if deletefieldnum >= UpgradeListDBVar.char.PrimarySpecList.Waist.Count or deletefieldnum == 0 then
				statusbarfont:SetTextColor(1, 0, 0);
				statusbarfont:SetText("Delete field does not match an item in your Primary Spec's Waist list.");
				deletefield:HighlightText();
			elseif deletefieldnum ~= UpgradeListDBVar.char.PrimarySpecList.Waist.Count - 1 then --If the deletefieldnum is equal to the last displayed item in the list, it breaks the array
				table.remove(UpgradeListDBVar.char.PrimarySpecList.Waist.Row, deletefieldnum);
				UpgradeListDBVar.char.PrimarySpecList.Waist.Count = UpgradeListDBVar.char.PrimarySpecList.Waist.Count - 1;
				statusbarfont:SetTextColor(0, 1, 0);
				statusbarfont:SetText("Successfully deleted item " .. deletefieldnum .. " from your Primary Spec's Waist list.");
				for i = UpgradeListDBVar.char.PrimarySpecList.Waist.Row[deletefieldnum][1], UpgradeListDBVar.char.PrimarySpecList.Waist.Count, 1 do
					UpgradeListDBVar.char.PrimarySpecList.Waist.Row[i - 1][1] = i - 1;
				end
				deletefield:SetText("");
				deletefield:ClearFocus();
				UpgradeList:RefreshWindow()
			else --Deleting the last item in the list
				table.remove(UpgradeListDBVar.char.PrimarySpecList.Waist.Row, deletefieldnum);
				UpgradeListDBVar.char.PrimarySpecList.Waist.Count = UpgradeListDBVar.char.PrimarySpecList.Waist.Count - 1;
				statusbarfont:SetTextColor(0, 1, 0);
				statusbarfont:SetText("Successfully deleted item " .. deletefieldnum .. " from your Primary Spec's Waist list.");
				deletefield:SetText("");
				deletefield:ClearFocus();
				UpgradeList:RefreshWindow()
			end
		else --The secondary spec checkbox is checked
			if deletefieldnum >= UpgradeListDBVar.char.SecondarySpecList.Waist.Count or deletefieldnum == 0 then
				statusbarfont:SetTextColor(1, 0, 0);
				statusbarfont:SetText("Delete field does not match an item in your Secondary Spec's Waist list.");
				deletefield:HighlightText();
			elseif deletefieldnum ~= UpgradeListDBVar.char.SecondarySpecList.Waist.Count - 1 then --If the deletefieldnum is equal to the last displayed item in the list, it breaks the array
				table.remove(UpgradeListDBVar.char.SecondarySpecList.Waist.Row, deletefieldnum);
				UpgradeListDBVar.char.SecondarySpecList.Waist.Count = UpgradeListDBVar.char.SecondarySpecList.Waist.Count - 1;
				statusbarfont:SetTextColor(0, 1, 0);
				statusbarfont:SetText("Successfully deleted item " .. deletefieldnum .. " from your Secondary Spec's Waist list.");
				for i = UpgradeListDBVar.char.SecondarySpecList.Waist.Row[deletefieldnum][1], UpgradeListDBVar.char.SecondarySpecList.Waist.Count, 1 do
					UpgradeListDBVar.char.SecondarySpecList.Waist.Row[i - 1][1] = i - 1;
				end
				deletefield:SetText("");
				deletefield:ClearFocus();
				UpgradeList:RefreshWindow()
			else --Deleting the last item in the list
				table.remove(UpgradeListDBVar.char.SecondarySpecList.Waist.Row, deletefieldnum);
				UpgradeListDBVar.char.SecondarySpecList.Waist.Count = UpgradeListDBVar.char.SecondarySpecList.Waist.Count - 1;
				statusbarfont:SetTextColor(0, 1, 0);
				statusbarfont:SetText("Successfully deleted item " .. deletefieldnum .. " from your Secondary Spec's Waist list.");
				deletefield:SetText("");
				deletefield:ClearFocus();
				UpgradeList:RefreshWindow()
			end
		end
	elseif PanelTemplates_GetSelectedTab(UpgradeListMainFrame) == 9 then --If the Leg tab is selected
		if UpgradeListDBVar.char.SavedOptions.PrimaryCheck:GetChecked() == 1 then --If the primary spec checkbox is checked
			if deletefieldnum >= UpgradeListDBVar.char.PrimarySpecList.Leg.Count or deletefieldnum == 0 then
				statusbarfont:SetTextColor(1, 0, 0);
				statusbarfont:SetText("Delete field does not match an item in your Primary Spec's Leg list.");
				deletefield:HighlightText();
			elseif deletefieldnum ~= UpgradeListDBVar.char.PrimarySpecList.Leg.Count - 1 then --If the deletefieldnum is equal to the last displayed item in the list, it breaks the array
				table.remove(UpgradeListDBVar.char.PrimarySpecList.Leg.Row, deletefieldnum);
				UpgradeListDBVar.char.PrimarySpecList.Leg.Count = UpgradeListDBVar.char.PrimarySpecList.Leg.Count - 1;
				statusbarfont:SetTextColor(0, 1, 0);
				statusbarfont:SetText("Successfully deleted item " .. deletefieldnum .. " from your Primary Spec's Leg list.");
				for i = UpgradeListDBVar.char.PrimarySpecList.Leg.Row[deletefieldnum][1], UpgradeListDBVar.char.PrimarySpecList.Leg.Count, 1 do
					UpgradeListDBVar.char.PrimarySpecList.Leg.Row[i - 1][1] = i - 1;
				end
				deletefield:SetText("");
				deletefield:ClearFocus();
				UpgradeList:RefreshWindow()
			else --Deleting the last item in the list
				table.remove(UpgradeListDBVar.char.PrimarySpecList.Leg.Row, deletefieldnum);
				UpgradeListDBVar.char.PrimarySpecList.Leg.Count = UpgradeListDBVar.char.PrimarySpecList.Leg.Count - 1;
				statusbarfont:SetTextColor(0, 1, 0);
				statusbarfont:SetText("Successfully deleted item " .. deletefieldnum .. " from your Primary Spec's Leg list.");
				deletefield:SetText("");
				deletefield:ClearFocus();
				UpgradeList:RefreshWindow()
			end
		else --The secondary spec checkbox is checked
			if deletefieldnum >= UpgradeListDBVar.char.SecondarySpecList.Leg.Count or deletefieldnum == 0 then
				statusbarfont:SetTextColor(1, 0, 0);
				statusbarfont:SetText("Delete field does not match an item in your Secondary Spec's Leg list.");
				deletefield:HighlightText();
			elseif deletefieldnum ~= UpgradeListDBVar.char.SecondarySpecList.Leg.Count - 1 then --If the deletefieldnum is equal to the last displayed item in the list, it breaks the array
				table.remove(UpgradeListDBVar.char.SecondarySpecList.Leg.Row, deletefieldnum);
				UpgradeListDBVar.char.SecondarySpecList.Leg.Count = UpgradeListDBVar.char.SecondarySpecList.Leg.Count - 1;
				statusbarfont:SetTextColor(0, 1, 0);
				statusbarfont:SetText("Successfully deleted item " .. deletefieldnum .. " from your Secondary Spec's Leg list.");
				for i = UpgradeListDBVar.char.SecondarySpecList.Leg.Row[deletefieldnum][1], UpgradeListDBVar.char.SecondarySpecList.Leg.Count, 1 do
					UpgradeListDBVar.char.SecondarySpecList.Leg.Row[i - 1][1] = i - 1;
				end
				deletefield:SetText("");
				deletefield:ClearFocus();
				UpgradeList:RefreshWindow()
			else --Deleting the last item in the list
				table.remove(UpgradeListDBVar.char.SecondarySpecList.Leg.Row, deletefieldnum);
				UpgradeListDBVar.char.SecondarySpecList.Leg.Count = UpgradeListDBVar.char.SecondarySpecList.Leg.Count - 1;
				statusbarfont:SetTextColor(0, 1, 0);
				statusbarfont:SetText("Successfully deleted item " .. deletefieldnum .. " from your Secondary Spec's Leg list.");
				deletefield:SetText("");
				deletefield:ClearFocus();
				UpgradeList:RefreshWindow()
			end
		end
	elseif PanelTemplates_GetSelectedTab(UpgradeListMainFrame) == 10 then --If the Foot tab is selected
		if UpgradeListDBVar.char.SavedOptions.PrimaryCheck:GetChecked() == 1 then --If the primary spec checkbox is checked
			if deletefieldnum >= UpgradeListDBVar.char.PrimarySpecList.Foot.Count or deletefieldnum == 0 then
				statusbarfont:SetTextColor(1, 0, 0);
				statusbarfont:SetText("Delete field does not match an item in your Primary Spec's Foot list.");
				deletefield:HighlightText();
			elseif deletefieldnum ~= UpgradeListDBVar.char.PrimarySpecList.Foot.Count - 1 then --If the deletefieldnum is equal to the last displayed item in the list, it breaks the array
				table.remove(UpgradeListDBVar.char.PrimarySpecList.Foot.Row, deletefieldnum);
				UpgradeListDBVar.char.PrimarySpecList.Foot.Count = UpgradeListDBVar.char.PrimarySpecList.Foot.Count - 1;
				statusbarfont:SetTextColor(0, 1, 0);
				statusbarfont:SetText("Successfully deleted item " .. deletefieldnum .. " from your Primary Spec's Foot list.");
				for i = UpgradeListDBVar.char.PrimarySpecList.Foot.Row[deletefieldnum][1], UpgradeListDBVar.char.PrimarySpecList.Foot.Count, 1 do
					UpgradeListDBVar.char.PrimarySpecList.Foot.Row[i - 1][1] = i - 1;
				end
				deletefield:SetText("");
				deletefield:ClearFocus();
				UpgradeList:RefreshWindow()
			else --Deleting the last item in the list
				table.remove(UpgradeListDBVar.char.PrimarySpecList.Foot.Row, deletefieldnum);
				UpgradeListDBVar.char.PrimarySpecList.Foot.Count = UpgradeListDBVar.char.PrimarySpecList.Foot.Count - 1;
				statusbarfont:SetTextColor(0, 1, 0);
				statusbarfont:SetText("Successfully deleted item " .. deletefieldnum .. " from your Primary Spec's Foot list.");
				deletefield:SetText("");
				deletefield:ClearFocus();
				UpgradeList:RefreshWindow()
			end
		else --The secondary spec checkbox is checked
			if deletefieldnum >= UpgradeListDBVar.char.SecondarySpecList.Foot.Count or deletefieldnum == 0 then
				statusbarfont:SetTextColor(1, 0, 0);
				statusbarfont:SetText("Delete field does not match an item in your Secondary Spec's Foot list.");
				deletefield:HighlightText();
			elseif deletefieldnum ~= UpgradeListDBVar.char.SecondarySpecList.Foot.Count - 1 then --If the deletefieldnum is equal to the last displayed item in the list, it breaks the array
				table.remove(UpgradeListDBVar.char.SecondarySpecList.Foot.Row, deletefieldnum);
				UpgradeListDBVar.char.SecondarySpecList.Foot.Count = UpgradeListDBVar.char.SecondarySpecList.Foot.Count - 1;
				statusbarfont:SetTextColor(0, 1, 0);
				statusbarfont:SetText("Successfully deleted item " .. deletefieldnum .. " from your Secondary Spec's Foot list.");
				for i = UpgradeListDBVar.char.SecondarySpecList.Foot.Row[deletefieldnum][1], UpgradeListDBVar.char.SecondarySpecList.Foot.Count, 1 do
					UpgradeListDBVar.char.SecondarySpecList.Foot.Row[i - 1][1] = i - 1;
				end
				deletefield:SetText("");
				deletefield:ClearFocus();
				UpgradeList:RefreshWindow()
			else --Deleting the last item in the list
				table.remove(UpgradeListDBVar.char.SecondarySpecList.Foot.Row, deletefieldnum);
				UpgradeListDBVar.char.SecondarySpecList.Foot.Count = UpgradeListDBVar.char.SecondarySpecList.Foot.Count - 1;
				statusbarfont:SetTextColor(0, 1, 0);
				statusbarfont:SetText("Successfully deleted item " .. deletefieldnum .. " from your Secondary Spec's Foot list.");
				deletefield:SetText("");
				deletefield:ClearFocus();
				UpgradeList:RefreshWindow()
			end
		end
	elseif PanelTemplates_GetSelectedTab(UpgradeListMainFrame) == 11 then --If the Ring tab is selected
		if UpgradeListDBVar.char.SavedOptions.PrimaryCheck:GetChecked() == 1 then --If the primary spec checkbox is checked
			if deletefieldnum >= UpgradeListDBVar.char.PrimarySpecList.Ring.Count or deletefieldnum == 0 then
				statusbarfont:SetTextColor(1, 0, 0);
				statusbarfont:SetText("Delete field does not match an item in your Primary Spec's Ring list.");
				deletefield:HighlightText();
			elseif deletefieldnum ~= UpgradeListDBVar.char.PrimarySpecList.Ring.Count - 1 then --If the deletefieldnum is equal to the last displayed item in the list, it breaks the array
				table.remove(UpgradeListDBVar.char.PrimarySpecList.Ring.Row, deletefieldnum);
				UpgradeListDBVar.char.PrimarySpecList.Ring.Count = UpgradeListDBVar.char.PrimarySpecList.Ring.Count - 1;
				statusbarfont:SetTextColor(0, 1, 0);
				statusbarfont:SetText("Successfully deleted item " .. deletefieldnum .. " from your Primary Spec's Ring list.");
				for i = UpgradeListDBVar.char.PrimarySpecList.Ring.Row[deletefieldnum][1], UpgradeListDBVar.char.PrimarySpecList.Ring.Count, 1 do
					UpgradeListDBVar.char.PrimarySpecList.Ring.Row[i - 1][1] = i - 1;
				end
				deletefield:SetText("");
				deletefield:ClearFocus();
				UpgradeList:RefreshWindow()
			else --Deleting the last item in the list
				table.remove(UpgradeListDBVar.char.PrimarySpecList.Ring.Row, deletefieldnum);
				UpgradeListDBVar.char.PrimarySpecList.Ring.Count = UpgradeListDBVar.char.PrimarySpecList.Ring.Count - 1;
				statusbarfont:SetTextColor(0, 1, 0);
				statusbarfont:SetText("Successfully deleted item " .. deletefieldnum .. " from your Primary Spec's Ring list.");
				deletefield:SetText("");
				deletefield:ClearFocus();
				UpgradeList:RefreshWindow()
			end
		else --The secondary spec checkbox is checked
			if deletefieldnum >= UpgradeListDBVar.char.SecondarySpecList.Ring.Count or deletefieldnum == 0 then
				statusbarfont:SetTextColor(1, 0, 0);
				statusbarfont:SetText("Delete field does not match an item in your Secondary Spec's Ring list.");
				deletefield:HighlightText();
			elseif deletefieldnum ~= UpgradeListDBVar.char.SecondarySpecList.Ring.Count - 1 then --If the deletefieldnum is equal to the last displayed item in the list, it breaks the array
				table.remove(UpgradeListDBVar.char.SecondarySpecList.Ring.Row, deletefieldnum);
				UpgradeListDBVar.char.SecondarySpecList.Ring.Count = UpgradeListDBVar.char.SecondarySpecList.Ring.Count - 1;
				statusbarfont:SetTextColor(0, 1, 0);
				statusbarfont:SetText("Successfully deleted item " .. deletefieldnum .. " from your Secondary Spec's Ring list.");
				for i = UpgradeListDBVar.char.SecondarySpecList.Ring.Row[deletefieldnum][1], UpgradeListDBVar.char.SecondarySpecList.Ring.Count, 1 do
					UpgradeListDBVar.char.SecondarySpecList.Ring.Row[i - 1][1] = i - 1;
				end
				deletefield:SetText("");
				deletefield:ClearFocus();
				UpgradeList:RefreshWindow()
			else --Deleting the last item in the list
				table.remove(UpgradeListDBVar.char.SecondarySpecList.Ring.Row, deletefieldnum);
				UpgradeListDBVar.char.SecondarySpecList.Ring.Count = UpgradeListDBVar.char.SecondarySpecList.Ring.Count - 1;
				statusbarfont:SetTextColor(0, 1, 0);
				statusbarfont:SetText("Successfully deleted item " .. deletefieldnum .. " from your Secondary Spec's Ring list.");
				deletefield:SetText("");
				deletefield:ClearFocus();
				UpgradeList:RefreshWindow()
			end
		end
	elseif PanelTemplates_GetSelectedTab(UpgradeListMainFrame) == 12 then --If the Trinket tab is selected
		if UpgradeListDBVar.char.SavedOptions.PrimaryCheck:GetChecked() == 1 then --If the primary spec checkbox is checked
			if deletefieldnum >= UpgradeListDBVar.char.PrimarySpecList.Trinket.Count or deletefieldnum == 0 then
				statusbarfont:SetTextColor(1, 0, 0);
				statusbarfont:SetText("Delete field does not match an item in your Primary Spec's Trinket list.");
				deletefield:HighlightText();
			elseif deletefieldnum ~= UpgradeListDBVar.char.PrimarySpecList.Trinket.Count - 1 then --If the deletefieldnum is equal to the last displayed item in the list, it breaks the array
				table.remove(UpgradeListDBVar.char.PrimarySpecList.Trinket.Row, deletefieldnum);
				UpgradeListDBVar.char.PrimarySpecList.Trinket.Count = UpgradeListDBVar.char.PrimarySpecList.Trinket.Count - 1;
				statusbarfont:SetTextColor(0, 1, 0);
				statusbarfont:SetText("Successfully deleted item " .. deletefieldnum .. " from your Primary Spec's Trinket list.");
				for i = UpgradeListDBVar.char.PrimarySpecList.Trinket.Row[deletefieldnum][1], UpgradeListDBVar.char.PrimarySpecList.Trinket.Count, 1 do
					UpgradeListDBVar.char.PrimarySpecList.Trinket.Row[i - 1][1] = i - 1;
				end
				deletefield:SetText("");
				deletefield:ClearFocus();
				UpgradeList:RefreshWindow()
			else --Deleting the last item in the list
				table.remove(UpgradeListDBVar.char.PrimarySpecList.Trinket.Row, deletefieldnum);
				UpgradeListDBVar.char.PrimarySpecList.Trinket.Count = UpgradeListDBVar.char.PrimarySpecList.Trinket.Count - 1;
				statusbarfont:SetTextColor(0, 1, 0);
				statusbarfont:SetText("Successfully deleted item " .. deletefieldnum .. " from your Primary Spec's Trinket list.");
				deletefield:SetText("");
				deletefield:ClearFocus();
				UpgradeList:RefreshWindow()
			end
		else --The secondary spec checkbox is checked
			if deletefieldnum >= UpgradeListDBVar.char.SecondarySpecList.Trinket.Count or deletefieldnum == 0 then
				statusbarfont:SetTextColor(1, 0, 0);
				statusbarfont:SetText("Delete field does not match an item in your Secondary Spec's Trinket list.");
				deletefield:HighlightText();
			elseif deletefieldnum ~= UpgradeListDBVar.char.SecondarySpecList.Trinket.Count - 1 then --If the deletefieldnum is equal to the last displayed item in the list, it breaks the array
				table.remove(UpgradeListDBVar.char.SecondarySpecList.Trinket.Row, deletefieldnum);
				UpgradeListDBVar.char.SecondarySpecList.Trinket.Count = UpgradeListDBVar.char.SecondarySpecList.Trinket.Count - 1;
				statusbarfont:SetTextColor(0, 1, 0);
				statusbarfont:SetText("Successfully deleted item " .. deletefieldnum .. " from your Secondary Spec's Trinket list.");
				for i = UpgradeListDBVar.char.SecondarySpecList.Trinket.Row[deletefieldnum][1], UpgradeListDBVar.char.SecondarySpecList.Trinket.Count, 1 do
					UpgradeListDBVar.char.SecondarySpecList.Trinket.Row[i - 1][1] = i - 1;
				end
				deletefield:SetText("");
				deletefield:ClearFocus();
				UpgradeList:RefreshWindow()
			else --Deleting the last item in the list
				table.remove(UpgradeListDBVar.char.SecondarySpecList.Trinket.Row, deletefieldnum);
				UpgradeListDBVar.char.SecondarySpecList.Trinket.Count = UpgradeListDBVar.char.SecondarySpecList.Trinket.Count - 1;
				statusbarfont:SetTextColor(0, 1, 0);
				statusbarfont:SetText("Successfully deleted item " .. deletefieldnum .. " from your Secondary Spec's Trinket list.");
				deletefield:SetText("");
				deletefield:ClearFocus();
				UpgradeList:RefreshWindow()
			end
		end
	elseif PanelTemplates_GetSelectedTab(UpgradeListMainFrame) == 13 then --If the Main tab is selected
		if UpgradeListDBVar.char.SavedOptions.PrimaryCheck:GetChecked() == 1 then --If the primary spec checkbox is checked
			if deletefieldnum >= UpgradeListDBVar.char.PrimarySpecList.Main.Count or deletefieldnum == 0 then
				statusbarfont:SetTextColor(1, 0, 0);
				statusbarfont:SetText("Delete field does not match an item in your Primary Spec's Main list.");
				deletefield:HighlightText();
			elseif deletefieldnum ~= UpgradeListDBVar.char.PrimarySpecList.Main.Count - 1 then --If the deletefieldnum is equal to the last displayed item in the list, it breaks the array
				table.remove(UpgradeListDBVar.char.PrimarySpecList.Main.Row, deletefieldnum);
				UpgradeListDBVar.char.PrimarySpecList.Main.Count = UpgradeListDBVar.char.PrimarySpecList.Main.Count - 1;
				statusbarfont:SetTextColor(0, 1, 0);
				statusbarfont:SetText("Successfully deleted item " .. deletefieldnum .. " from your Primary Spec's Main Hand list.");
				for i = UpgradeListDBVar.char.PrimarySpecList.Main.Row[deletefieldnum][1], UpgradeListDBVar.char.PrimarySpecList.Main.Count, 1 do
					UpgradeListDBVar.char.PrimarySpecList.Main.Row[i - 1][1] = i - 1;
				end
				deletefield:SetText("");
				deletefield:ClearFocus();
				UpgradeList:RefreshWindow()
			else --Deleting the last item in the list
				table.remove(UpgradeListDBVar.char.PrimarySpecList.Main.Row, deletefieldnum);
				UpgradeListDBVar.char.PrimarySpecList.Main.Count = UpgradeListDBVar.char.PrimarySpecList.Main.Count - 1;
				statusbarfont:SetTextColor(0, 1, 0);
				statusbarfont:SetText("Successfully deleted item " .. deletefieldnum .. " from your Primary Spec's Main Hand list.");
				deletefield:SetText("");
				deletefield:ClearFocus();
				UpgradeList:RefreshWindow()
			end
		else --The secondary spec checkbox is checked
			if deletefieldnum >= UpgradeListDBVar.char.SecondarySpecList.Main.Count or deletefieldnum == 0 then
				statusbarfont:SetTextColor(1, 0, 0);
				statusbarfont:SetText("Delete field does not match an item in your Secondary Spec's Main list.");
				deletefield:HighlightText();
			elseif deletefieldnum ~= UpgradeListDBVar.char.SecondarySpecList.Main.Count - 1 then --If the deletefieldnum is equal to the last displayed item in the list, it breaks the array
				table.remove(UpgradeListDBVar.char.SecondarySpecList.Main.Row, deletefieldnum);
				UpgradeListDBVar.char.SecondarySpecList.Main.Count = UpgradeListDBVar.char.SecondarySpecList.Main.Count - 1;
				statusbarfont:SetTextColor(0, 1, 0);
				statusbarfont:SetText("Successfully deleted item " .. deletefieldnum .. " from your Secondary Spec's Main Hand list.");
				for i = UpgradeListDBVar.char.SecondarySpecList.Main.Row[deletefieldnum][1], UpgradeListDBVar.char.SecondarySpecList.Main.Count, 1 do
					UpgradeListDBVar.char.SecondarySpecList.Main.Row[i - 1][1] = i - 1;
				end
				deletefield:SetText("");
				deletefield:ClearFocus();
				UpgradeList:RefreshWindow()
			else --Deleting the last item in the list
				table.remove(UpgradeListDBVar.char.SecondarySpecList.Main.Row, deletefieldnum);
				UpgradeListDBVar.char.SecondarySpecList.Main.Count = UpgradeListDBVar.char.SecondarySpecList.Main.Count - 1;
				statusbarfont:SetTextColor(0, 1, 0);
				statusbarfont:SetText("Successfully deleted item " .. deletefieldnum .. " from your Secondary Spec's Main Hand list.");
				deletefield:SetText("");
				deletefield:ClearFocus();
				UpgradeList:RefreshWindow()
			end
		end
	elseif PanelTemplates_GetSelectedTab(UpgradeListMainFrame) == 14 then --If the Off tab is selected
		if UpgradeListDBVar.char.SavedOptions.PrimaryCheck:GetChecked() == 1 then --If the primary spec checkbox is checked
			if deletefieldnum >= UpgradeListDBVar.char.PrimarySpecList.Off.Count or deletefieldnum == 0 then
				statusbarfont:SetTextColor(1, 0, 0);
				statusbarfont:SetText("Delete field does not match an item in your Primary Spec's Off list.");
				deletefield:HighlightText();
			elseif deletefieldnum ~= UpgradeListDBVar.char.PrimarySpecList.Off.Count - 1 then --If the deletefieldnum is equal to the last displayed item in the list, it breaks the array
				table.remove(UpgradeListDBVar.char.PrimarySpecList.Off.Row, deletefieldnum);
				UpgradeListDBVar.char.PrimarySpecList.Off.Count = UpgradeListDBVar.char.PrimarySpecList.Off.Count - 1;
				statusbarfont:SetTextColor(0, 1, 0);
				statusbarfont:SetText("Successfully deleted item " .. deletefieldnum .. " from your Primary Spec's Off Hand list.");
				for i = UpgradeListDBVar.char.PrimarySpecList.Off.Row[deletefieldnum][1], UpgradeListDBVar.char.PrimarySpecList.Off.Count, 1 do
					UpgradeListDBVar.char.PrimarySpecList.Off.Row[i - 1][1] = i - 1;
				end
				deletefield:SetText("");
				deletefield:ClearFocus();
				UpgradeList:RefreshWindow()
			else --Deleting the last item in the list
				table.remove(UpgradeListDBVar.char.PrimarySpecList.Off.Row, deletefieldnum);
				UpgradeListDBVar.char.PrimarySpecList.Off.Count = UpgradeListDBVar.char.PrimarySpecList.Off.Count - 1;
				statusbarfont:SetTextColor(0, 1, 0);
				statusbarfont:SetText("Successfully deleted item " .. deletefieldnum .. " from your Primary Spec's Off Hand list.");
				deletefield:SetText("");
				deletefield:ClearFocus();
				UpgradeList:RefreshWindow()
			end
		else --The secondary spec checkbox is checked
			if deletefieldnum >= UpgradeListDBVar.char.SecondarySpecList.Off.Count or deletefieldnum == 0 then
				statusbarfont:SetTextColor(1, 0, 0);
				statusbarfont:SetText("Delete field does not match an item in your Secondary Spec's Off list.");
				deletefield:HighlightText();
			elseif deletefieldnum ~= UpgradeListDBVar.char.SecondarySpecList.Off.Count - 1 then --If the deletefieldnum is equal to the last displayed item in the list, it breaks the array
				table.remove(UpgradeListDBVar.char.SecondarySpecList.Off.Row, deletefieldnum);
				UpgradeListDBVar.char.SecondarySpecList.Off.Count = UpgradeListDBVar.char.SecondarySpecList.Off.Count - 1;
				statusbarfont:SetTextColor(0, 1, 0);
				statusbarfont:SetText("Successfully deleted item " .. deletefieldnum .. " from your Secondary Spec's Off Hand list.");
				for i = UpgradeListDBVar.char.SecondarySpecList.Off.Row[deletefieldnum][1], UpgradeListDBVar.char.SecondarySpecList.Off.Count, 1 do
					UpgradeListDBVar.char.SecondarySpecList.Off.Row[i - 1][1] = i - 1;
				end
				deletefield:SetText("");
				deletefield:ClearFocus();
				UpgradeList:RefreshWindow()
			else --Deleting the last item in the list
				table.remove(UpgradeListDBVar.char.SecondarySpecList.Off.Row, deletefieldnum);
				UpgradeListDBVar.char.SecondarySpecList.Off.Count = UpgradeListDBVar.char.SecondarySpecList.Off.Count - 1;
				statusbarfont:SetTextColor(0, 1, 0);
				statusbarfont:SetText("Successfully deleted item " .. deletefieldnum .. " from your Secondary Spec's Off Hand list.");
				deletefield:SetText("");
				deletefield:ClearFocus();
				UpgradeList:RefreshWindow()
			end
		end
	elseif PanelTemplates_GetSelectedTab(UpgradeListMainFrame) == 15 then --If the Ranged tab is selected
		if UpgradeListDBVar.char.SavedOptions.PrimaryCheck:GetChecked() == 1 then --If the primary spec checkbox is checked
			if deletefieldnum >= UpgradeListDBVar.char.PrimarySpecList.Ranged.Count or deletefieldnum == 0 then
				statusbarfont:SetTextColor(1, 0, 0);
				statusbarfont:SetText("Delete field does not match an item in your Primary Spec's Ranged list.");
				deletefield:HighlightText();
			elseif deletefieldnum ~= UpgradeListDBVar.char.PrimarySpecList.Ranged.Count - 1 then --If the deletefieldnum is equal to the last displayed item in the list, it breaks the array
				table.remove(UpgradeListDBVar.char.PrimarySpecList.Ranged.Row, deletefieldnum);
				UpgradeListDBVar.char.PrimarySpecList.Ranged.Count = UpgradeListDBVar.char.PrimarySpecList.Ranged.Count - 1;
				statusbarfont:SetTextColor(0, 1, 0);
				statusbarfont:SetText("Successfully deleted item " .. deletefieldnum .. " from your Primary Spec's Ranged list.");
				for i = UpgradeListDBVar.char.PrimarySpecList.Ranged.Row[deletefieldnum][1], UpgradeListDBVar.char.PrimarySpecList.Ranged.Count, 1 do
					UpgradeListDBVar.char.PrimarySpecList.Ranged.Row[i - 1][1] = i - 1;
				end
				deletefield:SetText("");
				deletefield:ClearFocus();
				UpgradeList:RefreshWindow()
			else --Deleting the last item in the list
				table.remove(UpgradeListDBVar.char.PrimarySpecList.Ranged.Row, deletefieldnum);
				UpgradeListDBVar.char.PrimarySpecList.Ranged.Count = UpgradeListDBVar.char.PrimarySpecList.Ranged.Count - 1;
				statusbarfont:SetTextColor(0, 1, 0);
				statusbarfont:SetText("Successfully deleted item " .. deletefieldnum .. " from your Primary Spec's Ranged list.");
				deletefield:SetText("");
				deletefield:ClearFocus();
				UpgradeList:RefreshWindow()
			end
		else --The secondary spec checkbox is checked
			if deletefieldnum >= UpgradeListDBVar.char.SecondarySpecList.Ranged.Count or deletefieldnum == 0 then
				statusbarfont:SetTextColor(1, 0, 0);
				statusbarfont:SetText("Delete field does not match an item in your Secondary Spec's Ranged list.");
				deletefield:HighlightText();
			elseif deletefieldnum ~= UpgradeListDBVar.char.SecondarySpecList.Ranged.Count - 1 then --If the deletefieldnum is equal to the last displayed item in the list, it breaks the array
				table.remove(UpgradeListDBVar.char.SecondarySpecList.Ranged.Row, deletefieldnum);
				UpgradeListDBVar.char.SecondarySpecList.Ranged.Count = UpgradeListDBVar.char.SecondarySpecList.Ranged.Count - 1;
				statusbarfont:SetTextColor(0, 1, 0);
				statusbarfont:SetText("Successfully deleted item " .. deletefieldnum .. " from your Secondary Spec's Ranged list.");
				for i = UpgradeListDBVar.char.SecondarySpecList.Ranged.Row[deletefieldnum][1], UpgradeListDBVar.char.SecondarySpecList.Ranged.Count, 1 do
					UpgradeListDBVar.char.SecondarySpecList.Ranged.Row[i - 1][1] = i - 1;
				end
				deletefield:SetText("");
				deletefield:ClearFocus();
				UpgradeList:RefreshWindow()
			else --Deleting the last item in the list
				table.remove(UpgradeListDBVar.char.SecondarySpecList.Ranged.Row, deletefieldnum);
				UpgradeListDBVar.char.SecondarySpecList.Ranged.Count = UpgradeListDBVar.char.SecondarySpecList.Ranged.Count - 1;
				statusbarfont:SetTextColor(0, 1, 0);
				statusbarfont:SetText("Successfully deleted item " .. deletefieldnum .. " from your Secondary Spec's Ranged list.");
				deletefield:SetText("");
				deletefield:ClearFocus();
				UpgradeList:RefreshWindow()
			end
		end
	elseif PanelTemplates_GetSelectedTab(UpgradeListMainFrame) == 16 then --If the Other tab is selected
		if UpgradeListDBVar.char.SavedOptions.PrimaryCheck:GetChecked() == 1 then --If the primary spec checkbox is checked
			if deletefieldnum >= UpgradeListDBVar.char.PrimarySpecList.Other.Count or deletefieldnum == 0 then
				statusbarfont:SetTextColor(1, 0, 0);
				statusbarfont:SetText("Delete field does not match an item in your Primary Spec's Other list.");
				deletefield:HighlightText();
			elseif deletefieldnum ~= UpgradeListDBVar.char.PrimarySpecList.Other.Count - 1 then --If the deletefieldnum is equal to the last displayed item in the list, it breaks the array
				table.remove(UpgradeListDBVar.char.PrimarySpecList.Other.Row, deletefieldnum);
				UpgradeListDBVar.char.PrimarySpecList.Other.Count = UpgradeListDBVar.char.PrimarySpecList.Other.Count - 1;
				statusbarfont:SetTextColor(0, 1, 0);
				statusbarfont:SetText("Successfully deleted item " .. deletefieldnum .. " from your Primary Spec's Other list.");
				for i = UpgradeListDBVar.char.PrimarySpecList.Other.Row[deletefieldnum][1], UpgradeListDBVar.char.PrimarySpecList.Other.Count, 1 do
					UpgradeListDBVar.char.PrimarySpecList.Other.Row[i - 1][1] = i - 1;
				end
				deletefield:SetText("");
				deletefield:ClearFocus();
				UpgradeList:RefreshWindow()
			else --Deleting the last item in the list
				table.remove(UpgradeListDBVar.char.PrimarySpecList.Other.Row, deletefieldnum);
				UpgradeListDBVar.char.PrimarySpecList.Other.Count = UpgradeListDBVar.char.PrimarySpecList.Other.Count - 1;
				statusbarfont:SetTextColor(0, 1, 0);
				statusbarfont:SetText("Successfully deleted item " .. deletefieldnum .. " from your Primary Spec's Other list.");
				deletefield:SetText("");
				deletefield:ClearFocus();
				UpgradeList:RefreshWindow()
			end
		else --The secondary spec checkbox is checked
			if deletefieldnum >= UpgradeListDBVar.char.SecondarySpecList.Other.Count or deletefieldnum == 0 then
				statusbarfont:SetTextColor(1, 0, 0);
				statusbarfont:SetText("Delete field does not match an item in your Secondary Spec's Other list.");
				deletefield:HighlightText();
			elseif deletefieldnum ~= UpgradeListDBVar.char.SecondarySpecList.Other.Count - 1 then --If the deletefieldnum is equal to the last displayed item in the list, it breaks the array
				table.remove(UpgradeListDBVar.char.SecondarySpecList.Other.Row, deletefieldnum);
				UpgradeListDBVar.char.SecondarySpecList.Other.Count = UpgradeListDBVar.char.SecondarySpecList.Other.Count - 1;
				statusbarfont:SetTextColor(0, 1, 0);
				statusbarfont:SetText("Successfully deleted item " .. deletefieldnum .. " from your Secondary Spec's Other list.");
				for i = UpgradeListDBVar.char.SecondarySpecList.Other.Row[deletefieldnum][1], UpgradeListDBVar.char.SecondarySpecList.Other.Count, 1 do
					UpgradeListDBVar.char.SecondarySpecList.Other.Row[i - 1][1] = i - 1;
				end
				deletefield:SetText("");
				deletefield:ClearFocus();
				UpgradeList:RefreshWindow()
			else --Deleting the last item in the list
				table.remove(UpgradeListDBVar.char.SecondarySpecList.Other.Row, deletefieldnum);
				UpgradeListDBVar.char.SecondarySpecList.Other.Count = UpgradeListDBVar.char.SecondarySpecList.Other.Count - 1;
				statusbarfont:SetTextColor(0, 1, 0);
				statusbarfont:SetText("Successfully deleted item " .. deletefieldnum .. " from your Secondary Spec's Other list.");
				deletefield:SetText("");
				deletefield:ClearFocus();
				UpgradeList:RefreshWindow()
			end
		end
	else
		statusbarfont:SetTextColor(1, 0, 0);
		statusbarfont:SetText(deletefield:GetText() .. " is not a valid number for the delete number.");
	end
end

local function MoveItem(fromfield, tofield, UpgradeListMainFrame)
	local fromfieldnum = tonumber(fromfield:GetText());
	local tofieldnum = tonumber(tofield:GetText());
	if fromfieldnum ~= nil and tofieldnum ~= nil then
		fromfieldnum = math.floor(fromfieldnum);
		tofieldnum = math.floor(tofieldnum);
	end
	if fromfieldnum == nil and fromfield:GetText() ~= "" then
		statusbarfont:SetTextColor(1, 0, 0);
		statusbarfont:SetText("From field must be a number.");
		fromfield:HighlightText();
	elseif tofieldnum == nil and tofield:GetText() ~= "" then
		statusbarfont:SetTextColor(1, 0, 0);
		statusbarfont:SetText("To field must be a number.");
		tofield:HighlightText();
	elseif fromfieldnum == nil then
		statusbarfont:SetTextColor(1, 0, 0);
		statusbarfont:SetText("Nothing entered in from field.");
		fromfield:HighlightText();
	elseif tofieldnum == nil then
		statusbarfont:SetTextColor(1, 0, 0);
		statusbarfont:SetText("Nothing entered in to field.");
		tofield:HighlightText();
	elseif PanelTemplates_GetSelectedTab(UpgradeListMainFrame) == 1 then --If the head tab is selected
		if UpgradeListDBVar.char.SavedOptions.PrimaryCheck:GetChecked() == 1 then --If the primary spec checkbox is checked
			if fromfieldnum >= UpgradeListDBVar.char.PrimarySpecList.Head.Count or fromfieldnum == 0 then
				statusbarfont:SetTextColor(1, 0, 0);
				statusbarfont:SetText("From field does not match an item in your Primary Spec's Head list.");
				fromfield:HighlightText();
			elseif tofieldnum >= UpgradeListDBVar.char.PrimarySpecList.Head.Count or tofieldnum == 0 then
				statusbarfont:SetTextColor(1, 0, 0);
				statusbarfont:SetText("To field does not match an item in your Primary Spec's Head list.");
				tofield:HighlightText();
			elseif tofieldnum == fromfieldnum then
				statusbarfont:SetTextColor(1, 0, 0);
				statusbarfont:SetText("From Field and To Field match, cannot move any items.");
				tofield:HighlightText();
			else
				if fromfieldnum > tofieldnum then
					table.insert(UpgradeListDBVar.char.PrimarySpecList.Head.Row, tofieldnum, UpgradeListDBVar.char.PrimarySpecList.Head.Row[fromfieldnum]);
					table.remove(UpgradeListDBVar.char.PrimarySpecList.Head.Row, fromfieldnum + 1);
					for i = 1, #UpgradeListDBVar.char.PrimarySpecList.Head.Row, 1 do
						UpgradeListDBVar.char.PrimarySpecList.Head.Row[i][1] = i;
					end
				else
					table.insert(UpgradeListDBVar.char.PrimarySpecList.Head.Row, tofieldnum + 1, UpgradeListDBVar.char.PrimarySpecList.Head.Row[fromfieldnum]);
					table.remove(UpgradeListDBVar.char.PrimarySpecList.Head.Row, fromfieldnum);
					for i = 1, #UpgradeListDBVar.char.PrimarySpecList.Head.Row, 1 do
						UpgradeListDBVar.char.PrimarySpecList.Head.Row[i][1] = i;
					end
				end
				statusbarfont:SetTextColor(0, 1, 0);
				statusbarfont:SetText("Successfully moved row " .. fromfieldnum .. " to row " .. tofieldnum .. " in your Primary Spec's Head list.");
				fromfield:SetText("");
				fromfield:ClearFocus();
				tofield:SetText("");
				tofield:ClearFocus();
				UpgradeList:RefreshWindow()
			end
		else --If the Secondary spec checkbox is checked
			if fromfieldnum >= UpgradeListDBVar.char.SecondarySpecList.Head.Count or fromfieldnum == 0 then
				statusbarfont:SetTextColor(1, 0, 0);
				statusbarfont:SetText("From field does not match an item in your Secondary Spec's Head list.");
				fromfield:HighlightText();
			elseif tofieldnum >= UpgradeListDBVar.char.SecondarySpecList.Head.Count or tofieldnum == 0 then
				statusbarfont:SetTextColor(1, 0, 0);
				statusbarfont:SetText("To field does not match an item in your Secondary Spec's Head list.");
				tofield:HighlightText();
			elseif tofieldnum == fromfieldnum then
				statusbarfont:SetTextColor(1, 0, 0);
				statusbarfont:SetText("From Field and To Field match, cannot move any items.");
				tofield:HighlightText();
			else
				if fromfieldnum > tofieldnum then
					table.insert(UpgradeListDBVar.char.SecondarySpecList.Head.Row, tofieldnum, UpgradeListDBVar.char.SecondarySpecList.Head.Row[fromfieldnum]);
					table.remove(UpgradeListDBVar.char.SecondarySpecList.Head.Row, fromfieldnum + 1);
					for i = 1, #UpgradeListDBVar.char.SecondarySpecList.Head.Row, 1 do
						UpgradeListDBVar.char.SecondarySpecList.Head.Row[i][1] = i;
					end
				else
					table.insert(UpgradeListDBVar.char.SecondarySpecList.Head.Row, tofieldnum + 1, UpgradeListDBVar.char.SecondarySpecList.Head.Row[fromfieldnum]);
					table.remove(UpgradeListDBVar.char.SecondarySpecList.Head.Row, fromfieldnum);
					for i = 1, #UpgradeListDBVar.char.SecondarySpecList.Head.Row, 1 do
						UpgradeListDBVar.char.SecondarySpecList.Head.Row[i][1] = i;
					end
				end
				statusbarfont:SetTextColor(0, 1, 0);
				statusbarfont:SetText("Successfully moved row " .. fromfieldnum .. " to row " .. tofieldnum .. " in your Secondary Spec's Head list.");
				fromfield:SetText("");
				fromfield:ClearFocus();
				tofield:SetText("");
				tofield:ClearFocus();
				UpgradeList:RefreshWindow()
			end
		end
	elseif PanelTemplates_GetSelectedTab(UpgradeListMainFrame) == 2 then --If the Neck tab is selected
		if UpgradeListDBVar.char.SavedOptions.PrimaryCheck:GetChecked() == 1 then --If the primary spec checkbox is checked
			if fromfieldnum >= UpgradeListDBVar.char.PrimarySpecList.Neck.Count or fromfieldnum == 0 then
				statusbarfont:SetTextColor(1, 0, 0);
				statusbarfont:SetText("From field does not match an item in your Primary Spec's Neck list.");
				fromfield:HighlightText();
			elseif tofieldnum >= UpgradeListDBVar.char.PrimarySpecList.Neck.Count or tofieldnum == 0 then
				statusbarfont:SetTextColor(1, 0, 0);
				statusbarfont:SetText("To field does not match an item in your Primary Spec's Neck list.");
				tofield:HighlightText();
			elseif tofieldnum == fromfieldnum then
				statusbarfont:SetTextColor(1, 0, 0);
				statusbarfont:SetText("From Field and To Field match, cannot move any items.");
				tofield:HighlightText();
			else
				if fromfieldnum > tofieldnum then
					table.insert(UpgradeListDBVar.char.PrimarySpecList.Neck.Row, tofieldnum, UpgradeListDBVar.char.PrimarySpecList.Neck.Row[fromfieldnum]);
					table.remove(UpgradeListDBVar.char.PrimarySpecList.Neck.Row, fromfieldnum + 1);
					for i = 1, #UpgradeListDBVar.char.PrimarySpecList.Neck.Row, 1 do
						UpgradeListDBVar.char.PrimarySpecList.Neck.Row[i][1] = i;
					end
				else
					table.insert(UpgradeListDBVar.char.PrimarySpecList.Neck.Row, tofieldnum + 1, UpgradeListDBVar.char.PrimarySpecList.Neck.Row[fromfieldnum]);
					table.remove(UpgradeListDBVar.char.PrimarySpecList.Neck.Row, fromfieldnum);
					for i = 1, #UpgradeListDBVar.char.PrimarySpecList.Neck.Row, 1 do
						UpgradeListDBVar.char.PrimarySpecList.Neck.Row[i][1] = i;
					end
				end
				statusbarfont:SetTextColor(0, 1, 0);
				statusbarfont:SetText("Successfully moved row " .. fromfieldnum .. " to row " .. tofieldnum .. " in your Primary Spec's Neck list.");
				fromfield:SetText("");
				fromfield:ClearFocus();
				tofield:SetText("");
				tofield:ClearFocus();
				UpgradeList:RefreshWindow()
			end
		else --If the Secondary spec checkbox is checked
			if fromfieldnum >= UpgradeListDBVar.char.SecondarySpecList.Neck.Count or fromfieldnum == 0 then
				statusbarfont:SetTextColor(1, 0, 0);
				statusbarfont:SetText("From field does not match an item in your Secondary Spec's Neck list.");
				fromfield:HighlightText();
			elseif tofieldnum >= UpgradeListDBVar.char.SecondarySpecList.Neck.Count or tofieldnum == 0 then
				statusbarfont:SetTextColor(1, 0, 0);
				statusbarfont:SetText("To field does not match an item in your Secondary Spec's Neck list.");
				tofield:HighlightText();
			elseif tofieldnum == fromfieldnum then
				statusbarfont:SetTextColor(1, 0, 0);
				statusbarfont:SetText("From Field and To Field match, cannot move any items.");
				tofield:HighlightText();
			else
				if fromfieldnum > tofieldnum then
					table.insert(UpgradeListDBVar.char.SecondarySpecList.Neck.Row, tofieldnum, UpgradeListDBVar.char.SecondarySpecList.Neck.Row[fromfieldnum]);
					table.remove(UpgradeListDBVar.char.SecondarySpecList.Neck.Row, fromfieldnum + 1);
					for i = 1, #UpgradeListDBVar.char.SecondarySpecList.Neck.Row, 1 do
						UpgradeListDBVar.char.SecondarySpecList.Neck.Row[i][1] = i;
					end
				else
					table.insert(UpgradeListDBVar.char.SecondarySpecList.Neck.Row, tofieldnum + 1, UpgradeListDBVar.char.SecondarySpecList.Neck.Row[fromfieldnum]);
					table.remove(UpgradeListDBVar.char.SecondarySpecList.Neck.Row, fromfieldnum);
					for i = 1, #UpgradeListDBVar.char.SecondarySpecList.Neck.Row, 1 do
						UpgradeListDBVar.char.SecondarySpecList.Neck.Row[i][1] = i;
					end
				end
				statusbarfont:SetTextColor(0, 1, 0);
				statusbarfont:SetText("Successfully moved row " .. fromfieldnum .. " to row " .. tofieldnum .. " in your Secondary Spec's Neck list.");
				fromfield:SetText("");
				fromfield:ClearFocus();
				tofield:SetText("");
				tofield:ClearFocus();
				UpgradeList:RefreshWindow()
			end
		end
		elseif PanelTemplates_GetSelectedTab(UpgradeListMainFrame) == 3 then --If the Shoulder tab is selected
		if UpgradeListDBVar.char.SavedOptions.PrimaryCheck:GetChecked() == 1 then --If the primary spec checkbox is checked
			if fromfieldnum >= UpgradeListDBVar.char.PrimarySpecList.Shoulder.Count or fromfieldnum == 0 then
				statusbarfont:SetTextColor(1, 0, 0);
				statusbarfont:SetText("From field does not match an item in your Primary Spec's Shoulder list.");
				fromfield:HighlightText();
			elseif tofieldnum >= UpgradeListDBVar.char.PrimarySpecList.Shoulder.Count or tofieldnum == 0 then
				statusbarfont:SetTextColor(1, 0, 0);
				statusbarfont:SetText("To field does not match an item in your Primary Spec's Shoulder list.");
				tofield:HighlightText();
			elseif tofieldnum == fromfieldnum then
				statusbarfont:SetTextColor(1, 0, 0);
				statusbarfont:SetText("From Field and To Field match, cannot move any items.");
				tofield:HighlightText();
			else
				if fromfieldnum > tofieldnum then
					table.insert(UpgradeListDBVar.char.PrimarySpecList.Shoulder.Row, tofieldnum, UpgradeListDBVar.char.PrimarySpecList.Shoulder.Row[fromfieldnum]);
					table.remove(UpgradeListDBVar.char.PrimarySpecList.Shoulder.Row, fromfieldnum + 1);
					for i = 1, #UpgradeListDBVar.char.PrimarySpecList.Shoulder.Row, 1 do
						UpgradeListDBVar.char.PrimarySpecList.Shoulder.Row[i][1] = i;
					end
				else
					table.insert(UpgradeListDBVar.char.PrimarySpecList.Shoulder.Row, tofieldnum + 1, UpgradeListDBVar.char.PrimarySpecList.Shoulder.Row[fromfieldnum]);
					table.remove(UpgradeListDBVar.char.PrimarySpecList.Shoulder.Row, fromfieldnum);
					for i = 1, #UpgradeListDBVar.char.PrimarySpecList.Shoulder.Row, 1 do
						UpgradeListDBVar.char.PrimarySpecList.Shoulder.Row[i][1] = i;
					end
				end
				statusbarfont:SetTextColor(0, 1, 0);
				statusbarfont:SetText("Successfully moved row " .. fromfieldnum .. " to row " .. tofieldnum .. " in your Primary Spec's Shoulder list.");
				fromfield:SetText("");
				fromfield:ClearFocus();
				tofield:SetText("");
				tofield:ClearFocus();
				UpgradeList:RefreshWindow()
			end
		else --If the Secondary spec checkbox is checked
			if fromfieldnum >= UpgradeListDBVar.char.SecondarySpecList.Shoulder.Count or fromfieldnum == 0 then
				statusbarfont:SetTextColor(1, 0, 0);
				statusbarfont:SetText("From field does not match an item in your Secondary Spec's Shoulder list.");
				fromfield:HighlightText();
			elseif tofieldnum >= UpgradeListDBVar.char.SecondarySpecList.Shoulder.Count or tofieldnum == 0 then
				statusbarfont:SetTextColor(1, 0, 0);
				statusbarfont:SetText("To field does not match an item in your Secondary Spec's Shoulder list.");
				tofield:HighlightText();
			elseif tofieldnum == fromfieldnum then
				statusbarfont:SetTextColor(1, 0, 0);
				statusbarfont:SetText("From Field and To Field match, cannot move any items.");
				tofield:HighlightText();
			else
				if fromfieldnum > tofieldnum then
					table.insert(UpgradeListDBVar.char.SecondarySpecList.Shoulder.Row, tofieldnum, UpgradeListDBVar.char.SecondarySpecList.Shoulder.Row[fromfieldnum]);
					table.remove(UpgradeListDBVar.char.SecondarySpecList.Shoulder.Row, fromfieldnum + 1);
					for i = 1, #UpgradeListDBVar.char.SecondarySpecList.Shoulder.Row, 1 do
						UpgradeListDBVar.char.SecondarySpecList.Shoulder.Row[i][1] = i;
					end
				else
					table.insert(UpgradeListDBVar.char.SecondarySpecList.Shoulder.Row, tofieldnum + 1, UpgradeListDBVar.char.SecondarySpecList.Shoulder.Row[fromfieldnum]);
					table.remove(UpgradeListDBVar.char.SecondarySpecList.Shoulder.Row, fromfieldnum);
					for i = 1, #UpgradeListDBVar.char.SecondarySpecList.Shoulder.Row, 1 do
						UpgradeListDBVar.char.SecondarySpecList.Shoulder.Row[i][1] = i;
					end
				end
				statusbarfont:SetTextColor(0, 1, 0);
				statusbarfont:SetText("Successfully moved row " .. fromfieldnum .. " to row " .. tofieldnum .. " in your Secondary Spec's Shoulder list.");
				fromfield:SetText("");
				fromfield:ClearFocus();
				tofield:SetText("");
				tofield:ClearFocus();
				UpgradeList:RefreshWindow()
			end
		end
	elseif PanelTemplates_GetSelectedTab(UpgradeListMainFrame) == 4 then --If the Back tab is selected
		if UpgradeListDBVar.char.SavedOptions.PrimaryCheck:GetChecked() == 1 then --If the primary spec checkbox is checked
			if fromfieldnum >= UpgradeListDBVar.char.PrimarySpecList.Back.Count or fromfieldnum == 0 then
				statusbarfont:SetTextColor(1, 0, 0);
				statusbarfont:SetText("From field does not match an item in your Primary Spec's Back list.");
				fromfield:HighlightText();
			elseif tofieldnum >= UpgradeListDBVar.char.PrimarySpecList.Back.Count or tofieldnum == 0 then
				statusbarfont:SetTextColor(1, 0, 0);
				statusbarfont:SetText("To field does not match an item in your Primary Spec's Back list.");
				tofield:HighlightText();
			elseif tofieldnum == fromfieldnum then
				statusbarfont:SetTextColor(1, 0, 0);
				statusbarfont:SetText("From Field and To Field match, cannot move any items.");
				tofield:HighlightText();
			else
				if fromfieldnum > tofieldnum then
					table.insert(UpgradeListDBVar.char.PrimarySpecList.Back.Row, tofieldnum, UpgradeListDBVar.char.PrimarySpecList.Back.Row[fromfieldnum]);
					table.remove(UpgradeListDBVar.char.PrimarySpecList.Back.Row, fromfieldnum + 1);
					for i = 1, #UpgradeListDBVar.char.PrimarySpecList.Back.Row, 1 do
						UpgradeListDBVar.char.PrimarySpecList.Back.Row[i][1] = i;
					end
				else
					table.insert(UpgradeListDBVar.char.PrimarySpecList.Back.Row, tofieldnum + 1, UpgradeListDBVar.char.PrimarySpecList.Back.Row[fromfieldnum]);
					table.remove(UpgradeListDBVar.char.PrimarySpecList.Back.Row, fromfieldnum);
					for i = 1, #UpgradeListDBVar.char.PrimarySpecList.Back.Row, 1 do
						UpgradeListDBVar.char.PrimarySpecList.Back.Row[i][1] = i;
					end
				end
				statusbarfont:SetTextColor(0, 1, 0);
				statusbarfont:SetText("Successfully moved row " .. fromfieldnum .. " to row " .. tofieldnum .. " in your Primary Spec's Back list.");
				fromfield:SetText("");
				fromfield:ClearFocus();
				tofield:SetText("");
				tofield:ClearFocus();
				UpgradeList:RefreshWindow()
			end
		else --If the Secondary spec checkbox is checked
			if fromfieldnum >= UpgradeListDBVar.char.SecondarySpecList.Back.Count or fromfieldnum == 0 then
				statusbarfont:SetTextColor(1, 0, 0);
				statusbarfont:SetText("From field does not match an item in your Secondary Spec's Back list.");
				fromfield:HighlightText();
			elseif tofieldnum >= UpgradeListDBVar.char.SecondarySpecList.Back.Count or tofieldnum == 0 then
				statusbarfont:SetTextColor(1, 0, 0);
				statusbarfont:SetText("To field does not match an item in your Secondary Spec's Back list.");
				tofield:HighlightText();
			elseif tofieldnum == fromfieldnum then
				statusbarfont:SetTextColor(1, 0, 0);
				statusbarfont:SetText("From Field and To Field match, cannot move any items.");
				tofield:HighlightText();
			else
				if fromfieldnum > tofieldnum then
					table.insert(UpgradeListDBVar.char.SecondarySpecList.Back.Row, tofieldnum, UpgradeListDBVar.char.SecondarySpecList.Back.Row[fromfieldnum]);
					table.remove(UpgradeListDBVar.char.SecondarySpecList.Back.Row, fromfieldnum + 1);
					for i = 1, #UpgradeListDBVar.char.SecondarySpecList.Back.Row, 1 do
						UpgradeListDBVar.char.SecondarySpecList.Back.Row[i][1] = i;
					end
				else
					table.insert(UpgradeListDBVar.char.SecondarySpecList.Back.Row, tofieldnum + 1, UpgradeListDBVar.char.SecondarySpecList.Back.Row[fromfieldnum]);
					table.remove(UpgradeListDBVar.char.SecondarySpecList.Back.Row, fromfieldnum);
					for i = 1, #UpgradeListDBVar.char.SecondarySpecList.Back.Row, 1 do
						UpgradeListDBVar.char.SecondarySpecList.Back.Row[i][1] = i;
					end
				end
				statusbarfont:SetTextColor(0, 1, 0);
				statusbarfont:SetText("Successfully moved row " .. fromfieldnum .. " to row " .. tofieldnum .. " in your Secondary Spec's Back list.");
				fromfield:SetText("");
				fromfield:ClearFocus();
				tofield:SetText("");
				tofield:ClearFocus();
				UpgradeList:RefreshWindow()
			end
		end
		elseif PanelTemplates_GetSelectedTab(UpgradeListMainFrame) == 5 then --If the Chest tab is selected
		if UpgradeListDBVar.char.SavedOptions.PrimaryCheck:GetChecked() == 1 then --If the primary spec checkbox is checked
			if fromfieldnum >= UpgradeListDBVar.char.PrimarySpecList.Chest.Count or fromfieldnum == 0 then
				statusbarfont:SetTextColor(1, 0, 0);
				statusbarfont:SetText("From field does not match an item in your Primary Spec's Chest list.");
				fromfield:HighlightText();
			elseif tofieldnum >= UpgradeListDBVar.char.PrimarySpecList.Chest.Count or tofieldnum == 0 then
				statusbarfont:SetTextColor(1, 0, 0);
				statusbarfont:SetText("To field does not match an item in your Primary Spec's Chest list.");
				tofield:HighlightText();
			elseif tofieldnum == fromfieldnum then
				statusbarfont:SetTextColor(1, 0, 0);
				statusbarfont:SetText("From Field and To Field match, cannot move any items.");
				tofield:HighlightText();
			else
				if fromfieldnum > tofieldnum then
					table.insert(UpgradeListDBVar.char.PrimarySpecList.Chest.Row, tofieldnum, UpgradeListDBVar.char.PrimarySpecList.Chest.Row[fromfieldnum]);
					table.remove(UpgradeListDBVar.char.PrimarySpecList.Chest.Row, fromfieldnum + 1);
					for i = 1, #UpgradeListDBVar.char.PrimarySpecList.Chest.Row, 1 do
						UpgradeListDBVar.char.PrimarySpecList.Chest.Row[i][1] = i;
					end
				else
					table.insert(UpgradeListDBVar.char.PrimarySpecList.Chest.Row, tofieldnum + 1, UpgradeListDBVar.char.PrimarySpecList.Chest.Row[fromfieldnum]);
					table.remove(UpgradeListDBVar.char.PrimarySpecList.Chest.Row, fromfieldnum);
					for i = 1, #UpgradeListDBVar.char.PrimarySpecList.Chest.Row, 1 do
						UpgradeListDBVar.char.PrimarySpecList.Chest.Row[i][1] = i;
					end
				end
				statusbarfont:SetTextColor(0, 1, 0);
				statusbarfont:SetText("Successfully moved row " .. fromfieldnum .. " to row " .. tofieldnum .. " in your Primary Spec's Chest list.");
				fromfield:SetText("");
				fromfield:ClearFocus();
				tofield:SetText("");
				tofield:ClearFocus();
				UpgradeList:RefreshWindow()
			end
		else --If the Secondary spec checkbox is checked
			if fromfieldnum >= UpgradeListDBVar.char.SecondarySpecList.Chest.Count or fromfieldnum == 0 then
				statusbarfont:SetTextColor(1, 0, 0);
				statusbarfont:SetText("From field does not match an item in your Secondary Spec's Chest list.");
				fromfield:HighlightText();
			elseif tofieldnum >= UpgradeListDBVar.char.SecondarySpecList.Chest.Count or tofieldnum == 0 then
				statusbarfont:SetTextColor(1, 0, 0);
				statusbarfont:SetText("To field does not match an item in your Secondary Spec's Chest list.");
				tofield:HighlightText();
			elseif tofieldnum == fromfieldnum then
				statusbarfont:SetTextColor(1, 0, 0);
				statusbarfont:SetText("From Field and To Field match, cannot move any items.");
				tofield:HighlightText();
			else
				if fromfieldnum > tofieldnum then
					table.insert(UpgradeListDBVar.char.SecondarySpecList.Chest.Row, tofieldnum, UpgradeListDBVar.char.SecondarySpecList.Chest.Row[fromfieldnum]);
					table.remove(UpgradeListDBVar.char.SecondarySpecList.Chest.Row, fromfieldnum + 1);
					for i = 1, #UpgradeListDBVar.char.SecondarySpecList.Chest.Row, 1 do
						UpgradeListDBVar.char.SecondarySpecList.Chest.Row[i][1] = i;
					end
				else
					table.insert(UpgradeListDBVar.char.SecondarySpecList.Chest.Row, tofieldnum + 1, UpgradeListDBVar.char.SecondarySpecList.Chest.Row[fromfieldnum]);
					table.remove(UpgradeListDBVar.char.SecondarySpecList.Chest.Row, fromfieldnum);
					for i = 1, #UpgradeListDBVar.char.SecondarySpecList.Chest.Row, 1 do
						UpgradeListDBVar.char.SecondarySpecList.Chest.Row[i][1] = i;
					end
				end
				statusbarfont:SetTextColor(0, 1, 0);
				statusbarfont:SetText("Successfully moved row " .. fromfieldnum .. " to row " .. tofieldnum .. " in your Secondary Spec's Chest list.");
				fromfield:SetText("");
				fromfield:ClearFocus();
				tofield:SetText("");
				tofield:ClearFocus();
				UpgradeList:RefreshWindow()
			end
		end
	elseif PanelTemplates_GetSelectedTab(UpgradeListMainFrame) == 6 then --If the Wrist tab is selected
		if UpgradeListDBVar.char.SavedOptions.PrimaryCheck:GetChecked() == 1 then --If the primary spec checkbox is checked
			if fromfieldnum >= UpgradeListDBVar.char.PrimarySpecList.Wrist.Count or fromfieldnum == 0 then
				statusbarfont:SetTextColor(1, 0, 0);
				statusbarfont:SetText("From field does not match an item in your Primary Spec's Wrist list.");
				fromfield:HighlightText();
			elseif tofieldnum >= UpgradeListDBVar.char.PrimarySpecList.Wrist.Count or tofieldnum == 0 then
				statusbarfont:SetTextColor(1, 0, 0);
				statusbarfont:SetText("To field does not match an item in your Primary Spec's Wrist list.");
				tofield:HighlightText();
			elseif tofieldnum == fromfieldnum then
				statusbarfont:SetTextColor(1, 0, 0);
				statusbarfont:SetText("From Field and To Field match, cannot move any items.");
				tofield:HighlightText();
			else
				if fromfieldnum > tofieldnum then
					table.insert(UpgradeListDBVar.char.PrimarySpecList.Wrist.Row, tofieldnum, UpgradeListDBVar.char.PrimarySpecList.Wrist.Row[fromfieldnum]);
					table.remove(UpgradeListDBVar.char.PrimarySpecList.Wrist.Row, fromfieldnum + 1);
					for i = 1, #UpgradeListDBVar.char.PrimarySpecList.Wrist.Row, 1 do
						UpgradeListDBVar.char.PrimarySpecList.Wrist.Row[i][1] = i;
					end
				else
					table.insert(UpgradeListDBVar.char.PrimarySpecList.Wrist.Row, tofieldnum + 1, UpgradeListDBVar.char.PrimarySpecList.Wrist.Row[fromfieldnum]);
					table.remove(UpgradeListDBVar.char.PrimarySpecList.Wrist.Row, fromfieldnum);
					for i = 1, #UpgradeListDBVar.char.PrimarySpecList.Wrist.Row, 1 do
						UpgradeListDBVar.char.PrimarySpecList.Wrist.Row[i][1] = i;
					end
				end
				statusbarfont:SetTextColor(0, 1, 0);
				statusbarfont:SetText("Successfully moved row " .. fromfieldnum .. " to row " .. tofieldnum .. " in your Primary Spec's Wrist list.");
				fromfield:SetText("");
				fromfield:ClearFocus();
				tofield:SetText("");
				tofield:ClearFocus();
				UpgradeList:RefreshWindow()
			end
		else --If the Secondary spec checkbox is checked
			if fromfieldnum >= UpgradeListDBVar.char.SecondarySpecList.Wrist.Count or fromfieldnum == 0 then
				statusbarfont:SetTextColor(1, 0, 0);
				statusbarfont:SetText("From field does not match an item in your Secondary Spec's Wrist list.");
				fromfield:HighlightText();
			elseif tofieldnum >= UpgradeListDBVar.char.SecondarySpecList.Wrist.Count or tofieldnum == 0 then
				statusbarfont:SetTextColor(1, 0, 0);
				statusbarfont:SetText("To field does not match an item in your Secondary Spec's Wrist list.");
				tofield:HighlightText();
			elseif tofieldnum == fromfieldnum then
				statusbarfont:SetTextColor(1, 0, 0);
				statusbarfont:SetText("From Field and To Field match, cannot move any items.");
				tofield:HighlightText();
			else
				if fromfieldnum > tofieldnum then
					table.insert(UpgradeListDBVar.char.SecondarySpecList.Wrist.Row, tofieldnum, UpgradeListDBVar.char.SecondarySpecList.Wrist.Row[fromfieldnum]);
					table.remove(UpgradeListDBVar.char.SecondarySpecList.Wrist.Row, fromfieldnum + 1);
					for i = 1, #UpgradeListDBVar.char.SecondarySpecList.Wrist.Row, 1 do
						UpgradeListDBVar.char.SecondarySpecList.Wrist.Row[i][1] = i;
					end
				else
					table.insert(UpgradeListDBVar.char.SecondarySpecList.Wrist.Row, tofieldnum + 1, UpgradeListDBVar.char.SecondarySpecList.Wrist.Row[fromfieldnum]);
					table.remove(UpgradeListDBVar.char.SecondarySpecList.Wrist.Row, fromfieldnum);
					for i = 1, #UpgradeListDBVar.char.SecondarySpecList.Wrist.Row, 1 do
						UpgradeListDBVar.char.SecondarySpecList.Wrist.Row[i][1] = i;
					end
				end
				statusbarfont:SetTextColor(0, 1, 0);
				statusbarfont:SetText("Successfully moved row " .. fromfieldnum .. " to row " .. tofieldnum .. " in your Secondary Spec's Wrist list.");
				fromfield:SetText("");
				fromfield:ClearFocus();
				tofield:SetText("");
				tofield:ClearFocus();
				UpgradeList:RefreshWindow()
			end
		end
	elseif PanelTemplates_GetSelectedTab(UpgradeListMainFrame) == 7 then --If the Hand tab is selected
		if UpgradeListDBVar.char.SavedOptions.PrimaryCheck:GetChecked() == 1 then --If the primary spec checkbox is checked
			if fromfieldnum >= UpgradeListDBVar.char.PrimarySpecList.Hand.Count or fromfieldnum == 0 then
				statusbarfont:SetTextColor(1, 0, 0);
				statusbarfont:SetText("From field does not match an item in your Primary Spec's Hand list.");
				fromfield:HighlightText();
			elseif tofieldnum >= UpgradeListDBVar.char.PrimarySpecList.Hand.Count or tofieldnum == 0 then
				statusbarfont:SetTextColor(1, 0, 0);
				statusbarfont:SetText("To field does not match an item in your Primary Spec's Hand list.");
				tofield:HighlightText();
			elseif tofieldnum == fromfieldnum then
				statusbarfont:SetTextColor(1, 0, 0);
				statusbarfont:SetText("From Field and To Field match, cannot move any items.");
				tofield:HighlightText();
			else
				if fromfieldnum > tofieldnum then
					table.insert(UpgradeListDBVar.char.PrimarySpecList.Hand.Row, tofieldnum, UpgradeListDBVar.char.PrimarySpecList.Hand.Row[fromfieldnum]);
					table.remove(UpgradeListDBVar.char.PrimarySpecList.Hand.Row, fromfieldnum + 1);
					for i = 1, #UpgradeListDBVar.char.PrimarySpecList.Hand.Row, 1 do
						UpgradeListDBVar.char.PrimarySpecList.Hand.Row[i][1] = i;
					end
				else
					table.insert(UpgradeListDBVar.char.PrimarySpecList.Hand.Row, tofieldnum + 1, UpgradeListDBVar.char.PrimarySpecList.Hand.Row[fromfieldnum]);
					table.remove(UpgradeListDBVar.char.PrimarySpecList.Hand.Row, fromfieldnum);
					for i = 1, #UpgradeListDBVar.char.PrimarySpecList.Hand.Row, 1 do
						UpgradeListDBVar.char.PrimarySpecList.Hand.Row[i][1] = i;
					end
				end
				statusbarfont:SetTextColor(0, 1, 0);
				statusbarfont:SetText("Successfully moved row " .. fromfieldnum .. " to row " .. tofieldnum .. " in your Primary Spec's Hand list.");
				fromfield:SetText("");
				fromfield:ClearFocus();
				tofield:SetText("");
				tofield:ClearFocus();
				UpgradeList:RefreshWindow()
			end
		else --If the Secondary spec checkbox is checked
			if fromfieldnum >= UpgradeListDBVar.char.SecondarySpecList.Hand.Count or fromfieldnum == 0 then
				statusbarfont:SetTextColor(1, 0, 0);
				statusbarfont:SetText("From field does not match an item in your Secondary Spec's Hand list.");
				fromfield:HighlightText();
			elseif tofieldnum >= UpgradeListDBVar.char.SecondarySpecList.Hand.Count or tofieldnum == 0 then
				statusbarfont:SetTextColor(1, 0, 0);
				statusbarfont:SetText("To field does not match an item in your Secondary Spec's Hand list.");
				tofield:HighlightText();
			elseif tofieldnum == fromfieldnum then
				statusbarfont:SetTextColor(1, 0, 0);
				statusbarfont:SetText("From Field and To Field match, cannot move any items.");
				tofield:HighlightText();
			else
				if fromfieldnum > tofieldnum then
					table.insert(UpgradeListDBVar.char.SecondarySpecList.Hand.Row, tofieldnum, UpgradeListDBVar.char.SecondarySpecList.Hand.Row[fromfieldnum]);
					table.remove(UpgradeListDBVar.char.SecondarySpecList.Hand.Row, fromfieldnum + 1);
					for i = 1, #UpgradeListDBVar.char.SecondarySpecList.Hand.Row, 1 do
						UpgradeListDBVar.char.SecondarySpecList.Hand.Row[i][1] = i;
					end
				else
					table.insert(UpgradeListDBVar.char.SecondarySpecList.Hand.Row, tofieldnum + 1, UpgradeListDBVar.char.SecondarySpecList.Hand.Row[fromfieldnum]);
					table.remove(UpgradeListDBVar.char.SecondarySpecList.Hand.Row, fromfieldnum);
					for i = 1, #UpgradeListDBVar.char.SecondarySpecList.Hand.Row, 1 do
						UpgradeListDBVar.char.SecondarySpecList.Hand.Row[i][1] = i;
					end
				end
				statusbarfont:SetTextColor(0, 1, 0);
				statusbarfont:SetText("Successfully moved row " .. fromfieldnum .. " to row " .. tofieldnum .. " in your Secondary Spec's Hand list.");
				fromfield:SetText("");
				fromfield:ClearFocus();
				tofield:SetText("");
				tofield:ClearFocus();
				UpgradeList:RefreshWindow()
			end
		end
	elseif PanelTemplates_GetSelectedTab(UpgradeListMainFrame) == 8 then --If the Waist tab is selected
		if UpgradeListDBVar.char.SavedOptions.PrimaryCheck:GetChecked() == 1 then --If the primary spec checkbox is checked
			if fromfieldnum >= UpgradeListDBVar.char.PrimarySpecList.Waist.Count or fromfieldnum == 0 then
				statusbarfont:SetTextColor(1, 0, 0);
				statusbarfont:SetText("From field does not match an item in your Primary Spec's Waist list.");
				fromfield:HighlightText();
			elseif tofieldnum >= UpgradeListDBVar.char.PrimarySpecList.Waist.Count or tofieldnum == 0 then
				statusbarfont:SetTextColor(1, 0, 0);
				statusbarfont:SetText("To field does not match an item in your Primary Spec's Waist list.");
				tofield:HighlightText();
			elseif tofieldnum == fromfieldnum then
				statusbarfont:SetTextColor(1, 0, 0);
				statusbarfont:SetText("From Field and To Field match, cannot move any items.");
				tofield:HighlightText();
			else
				if fromfieldnum > tofieldnum then
					table.insert(UpgradeListDBVar.char.PrimarySpecList.Waist.Row, tofieldnum, UpgradeListDBVar.char.PrimarySpecList.Waist.Row[fromfieldnum]);
					table.remove(UpgradeListDBVar.char.PrimarySpecList.Waist.Row, fromfieldnum + 1);
					for i = 1, #UpgradeListDBVar.char.PrimarySpecList.Waist.Row, 1 do
						UpgradeListDBVar.char.PrimarySpecList.Waist.Row[i][1] = i;
					end
				else
					table.insert(UpgradeListDBVar.char.PrimarySpecList.Waist.Row, tofieldnum + 1, UpgradeListDBVar.char.PrimarySpecList.Waist.Row[fromfieldnum]);
					table.remove(UpgradeListDBVar.char.PrimarySpecList.Waist.Row, fromfieldnum);
					for i = 1, #UpgradeListDBVar.char.PrimarySpecList.Waist.Row, 1 do
						UpgradeListDBVar.char.PrimarySpecList.Waist.Row[i][1] = i;
					end
				end
				statusbarfont:SetTextColor(0, 1, 0);
				statusbarfont:SetText("Successfully moved row " .. fromfieldnum .. " to row " .. tofieldnum .. " in your Primary Spec's Waist list.");
				fromfield:SetText("");
				fromfield:ClearFocus();
				tofield:SetText("");
				tofield:ClearFocus();
				UpgradeList:RefreshWindow()
			end
		else --If the Secondary spec checkbox is checked
			if fromfieldnum >= UpgradeListDBVar.char.SecondarySpecList.Waist.Count or fromfieldnum == 0 then
				statusbarfont:SetTextColor(1, 0, 0);
				statusbarfont:SetText("From field does not match an item in your Secondary Spec's Waist list.");
				fromfield:HighlightText();
			elseif tofieldnum >= UpgradeListDBVar.char.SecondarySpecList.Waist.Count or tofieldnum == 0 then
				statusbarfont:SetTextColor(1, 0, 0);
				statusbarfont:SetText("To field does not match an item in your Secondary Spec's Waist list.");
				tofield:HighlightText();
			elseif tofieldnum == fromfieldnum then
				statusbarfont:SetTextColor(1, 0, 0);
				statusbarfont:SetText("From Field and To Field match, cannot move any items.");
				tofield:HighlightText();
			else
				if fromfieldnum > tofieldnum then
					table.insert(UpgradeListDBVar.char.SecondarySpecList.Waist.Row, tofieldnum, UpgradeListDBVar.char.SecondarySpecList.Waist.Row[fromfieldnum]);
					table.remove(UpgradeListDBVar.char.SecondarySpecList.Waist.Row, fromfieldnum + 1);
					for i = 1, #UpgradeListDBVar.char.SecondarySpecList.Waist.Row, 1 do
						UpgradeListDBVar.char.SecondarySpecList.Waist.Row[i][1] = i;
					end
				else
					table.insert(UpgradeListDBVar.char.SecondarySpecList.Waist.Row, tofieldnum + 1, UpgradeListDBVar.char.SecondarySpecList.Waist.Row[fromfieldnum]);
					table.remove(UpgradeListDBVar.char.SecondarySpecList.Waist.Row, fromfieldnum);
					for i = 1, #UpgradeListDBVar.char.SecondarySpecList.Waist.Row, 1 do
						UpgradeListDBVar.char.SecondarySpecList.Waist.Row[i][1] = i;
					end
				end
				statusbarfont:SetTextColor(0, 1, 0);
				statusbarfont:SetText("Successfully moved row " .. fromfieldnum .. " to row " .. tofieldnum .. " in your Secondary Spec's Waist list.");
				fromfield:SetText("");
				fromfield:ClearFocus();
				tofield:SetText("");
				tofield:ClearFocus();
				UpgradeList:RefreshWindow()
			end
		end
	elseif PanelTemplates_GetSelectedTab(UpgradeListMainFrame) == 9 then --If the Leg tab is selected
		if UpgradeListDBVar.char.SavedOptions.PrimaryCheck:GetChecked() == 1 then --If the primary spec checkbox is checked
			if fromfieldnum >= UpgradeListDBVar.char.PrimarySpecList.Leg.Count or fromfieldnum == 0 then
				statusbarfont:SetTextColor(1, 0, 0);
				statusbarfont:SetText("From field does not match an item in your Primary Spec's Leg list.");
				fromfield:HighlightText();
			elseif tofieldnum >= UpgradeListDBVar.char.PrimarySpecList.Leg.Count or tofieldnum == 0 then
				statusbarfont:SetTextColor(1, 0, 0);
				statusbarfont:SetText("To field does not match an item in your Primary Spec's Leg list.");
				tofield:HighlightText();
			elseif tofieldnum == fromfieldnum then
				statusbarfont:SetTextColor(1, 0, 0);
				statusbarfont:SetText("From Field and To Field match, cannot move any items.");
				tofield:HighlightText();
			else
				if fromfieldnum > tofieldnum then
					table.insert(UpgradeListDBVar.char.PrimarySpecList.Leg.Row, tofieldnum, UpgradeListDBVar.char.PrimarySpecList.Leg.Row[fromfieldnum]);
					table.remove(UpgradeListDBVar.char.PrimarySpecList.Leg.Row, fromfieldnum + 1);
					for i = 1, #UpgradeListDBVar.char.PrimarySpecList.Leg.Row, 1 do
						UpgradeListDBVar.char.PrimarySpecList.Leg.Row[i][1] = i;
					end
				else
					table.insert(UpgradeListDBVar.char.PrimarySpecList.Leg.Row, tofieldnum + 1, UpgradeListDBVar.char.PrimarySpecList.Leg.Row[fromfieldnum]);
					table.remove(UpgradeListDBVar.char.PrimarySpecList.Leg.Row, fromfieldnum);
					for i = 1, #UpgradeListDBVar.char.PrimarySpecList.Leg.Row, 1 do
						UpgradeListDBVar.char.PrimarySpecList.Leg.Row[i][1] = i;
					end
				end
				statusbarfont:SetTextColor(0, 1, 0);
				statusbarfont:SetText("Successfully moved row " .. fromfieldnum .. " to row " .. tofieldnum .. " in your Primary Spec's Leg list.");
				fromfield:SetText("");
				fromfield:ClearFocus();
				tofield:SetText("");
				tofield:ClearFocus();
				UpgradeList:RefreshWindow()
			end
		else --If the Secondary spec checkbox is checked
			if fromfieldnum >= UpgradeListDBVar.char.SecondarySpecList.Leg.Count or fromfieldnum == 0 then
				statusbarfont:SetTextColor(1, 0, 0);
				statusbarfont:SetText("From field does not match an item in your Secondary Spec's Leg list.");
				fromfield:HighlightText();
			elseif tofieldnum >= UpgradeListDBVar.char.SecondarySpecList.Leg.Count or tofieldnum == 0 then
				statusbarfont:SetTextColor(1, 0, 0);
				statusbarfont:SetText("To field does not match an item in your Secondary Spec's Leg list.");
				tofield:HighlightText();
			elseif tofieldnum == fromfieldnum then
				statusbarfont:SetTextColor(1, 0, 0);
				statusbarfont:SetText("From Field and To Field match, cannot move any items.");
				tofield:HighlightText();
			else
				if fromfieldnum > tofieldnum then
					table.insert(UpgradeListDBVar.char.SecondarySpecList.Leg.Row, tofieldnum, UpgradeListDBVar.char.SecondarySpecList.Leg.Row[fromfieldnum]);
					table.remove(UpgradeListDBVar.char.SecondarySpecList.Leg.Row, fromfieldnum + 1);
					for i = 1, #UpgradeListDBVar.char.SecondarySpecList.Leg.Row, 1 do
						UpgradeListDBVar.char.SecondarySpecList.Leg.Row[i][1] = i;
					end
				else
					table.insert(UpgradeListDBVar.char.SecondarySpecList.Leg.Row, tofieldnum + 1, UpgradeListDBVar.char.SecondarySpecList.Leg.Row[fromfieldnum]);
					table.remove(UpgradeListDBVar.char.SecondarySpecList.Leg.Row, fromfieldnum);
					for i = 1, #UpgradeListDBVar.char.SecondarySpecList.Leg.Row, 1 do
						UpgradeListDBVar.char.SecondarySpecList.Leg.Row[i][1] = i;
					end
				end
				statusbarfont:SetTextColor(0, 1, 0);
				statusbarfont:SetText("Successfully moved row " .. fromfieldnum .. " to row " .. tofieldnum .. " in your Secondary Spec's Leg list.");
				fromfield:SetText("");
				fromfield:ClearFocus();
				tofield:SetText("");
				tofield:ClearFocus();
				UpgradeList:RefreshWindow()
			end
		end
	elseif PanelTemplates_GetSelectedTab(UpgradeListMainFrame) == 10 then --If the Foot tab is selected
		if UpgradeListDBVar.char.SavedOptions.PrimaryCheck:GetChecked() == 1 then --If the primary spec checkbox is checked
			if fromfieldnum >= UpgradeListDBVar.char.PrimarySpecList.Foot.Count or fromfieldnum == 0 then
				statusbarfont:SetTextColor(1, 0, 0);
				statusbarfont:SetText("From field does not match an item in your Primary Spec's Foot list.");
				fromfield:HighlightText();
			elseif tofieldnum >= UpgradeListDBVar.char.PrimarySpecList.Foot.Count or tofieldnum == 0 then
				statusbarfont:SetTextColor(1, 0, 0);
				statusbarfont:SetText("To field does not match an item in your Primary Spec's Foot list.");
				tofield:HighlightText();
			elseif tofieldnum == fromfieldnum then
				statusbarfont:SetTextColor(1, 0, 0);
				statusbarfont:SetText("From Field and To Field match, cannot move any items.");
				tofield:HighlightText();
			else
				if fromfieldnum > tofieldnum then
					table.insert(UpgradeListDBVar.char.PrimarySpecList.Foot.Row, tofieldnum, UpgradeListDBVar.char.PrimarySpecList.Foot.Row[fromfieldnum]);
					table.remove(UpgradeListDBVar.char.PrimarySpecList.Foot.Row, fromfieldnum + 1);
					for i = 1, #UpgradeListDBVar.char.PrimarySpecList.Foot.Row, 1 do
						UpgradeListDBVar.char.PrimarySpecList.Foot.Row[i][1] = i;
					end
				else
					table.insert(UpgradeListDBVar.char.PrimarySpecList.Foot.Row, tofieldnum + 1, UpgradeListDBVar.char.PrimarySpecList.Foot.Row[fromfieldnum]);
					table.remove(UpgradeListDBVar.char.PrimarySpecList.Foot.Row, fromfieldnum);
					for i = 1, #UpgradeListDBVar.char.PrimarySpecList.Foot.Row, 1 do
						UpgradeListDBVar.char.PrimarySpecList.Foot.Row[i][1] = i;
					end
				end
				statusbarfont:SetTextColor(0, 1, 0);
				statusbarfont:SetText("Successfully moved row " .. fromfieldnum .. " to row " .. tofieldnum .. " in your Primary Spec's Foot list.");
				fromfield:SetText("");
				fromfield:ClearFocus();
				tofield:SetText("");
				tofield:ClearFocus();
				UpgradeList:RefreshWindow()
			end
		else --If the Secondary spec checkbox is checked
			if fromfieldnum >= UpgradeListDBVar.char.SecondarySpecList.Foot.Count or fromfieldnum == 0 then
				statusbarfont:SetTextColor(1, 0, 0);
				statusbarfont:SetText("From field does not match an item in your Secondary Spec's Foot list.");
				fromfield:HighlightText();
			elseif tofieldnum >= UpgradeListDBVar.char.SecondarySpecList.Foot.Count or tofieldnum == 0 then
				statusbarfont:SetTextColor(1, 0, 0);
				statusbarfont:SetText("To field does not match an item in your Secondary Spec's Foot list.");
				tofield:HighlightText();
			elseif tofieldnum == fromfieldnum then
				statusbarfont:SetTextColor(1, 0, 0);
				statusbarfont:SetText("From Field and To Field match, cannot move any items.");
				tofield:HighlightText();
			else
				if fromfieldnum > tofieldnum then
					table.insert(UpgradeListDBVar.char.SecondarySpecList.Foot.Row, tofieldnum, UpgradeListDBVar.char.SecondarySpecList.Foot.Row[fromfieldnum]);
					table.remove(UpgradeListDBVar.char.SecondarySpecList.Foot.Row, fromfieldnum + 1);
					for i = 1, #UpgradeListDBVar.char.SecondarySpecList.Foot.Row, 1 do
						UpgradeListDBVar.char.SecondarySpecList.Foot.Row[i][1] = i;
					end
				else
					table.insert(UpgradeListDBVar.char.SecondarySpecList.Foot.Row, tofieldnum + 1, UpgradeListDBVar.char.SecondarySpecList.Foot.Row[fromfieldnum]);
					table.remove(UpgradeListDBVar.char.SecondarySpecList.Foot.Row, fromfieldnum);
					for i = 1, #UpgradeListDBVar.char.SecondarySpecList.Foot.Row, 1 do
						UpgradeListDBVar.char.SecondarySpecList.Foot.Row[i][1] = i;
					end
				end
				statusbarfont:SetTextColor(0, 1, 0);
				statusbarfont:SetText("Successfully moved row " .. fromfieldnum .. " to row " .. tofieldnum .. " in your Secondary Spec's Foot list.");
				fromfield:SetText("");
				fromfield:ClearFocus();
				tofield:SetText("");
				tofield:ClearFocus();
				UpgradeList:RefreshWindow()
			end
		end
	elseif PanelTemplates_GetSelectedTab(UpgradeListMainFrame) == 11 then --If the Ring tab is selected
		if UpgradeListDBVar.char.SavedOptions.PrimaryCheck:GetChecked() == 1 then --If the primary spec checkbox is checked
			if fromfieldnum >= UpgradeListDBVar.char.PrimarySpecList.Ring.Count or fromfieldnum == 0 then
				statusbarfont:SetTextColor(1, 0, 0);
				statusbarfont:SetText("From field does not match an item in your Primary Spec's Ring list.");
				fromfield:HighlightText();
			elseif tofieldnum >= UpgradeListDBVar.char.PrimarySpecList.Ring.Count or tofieldnum == 0 then
				statusbarfont:SetTextColor(1, 0, 0);
				statusbarfont:SetText("To field does not match an item in your Primary Spec's Ring list.");
				tofield:HighlightText();
			elseif tofieldnum == fromfieldnum then
				statusbarfont:SetTextColor(1, 0, 0);
				statusbarfont:SetText("From Field and To Field match, cannot move any items.");
				tofield:HighlightText();
			else
				if fromfieldnum > tofieldnum then
					table.insert(UpgradeListDBVar.char.PrimarySpecList.Ring.Row, tofieldnum, UpgradeListDBVar.char.PrimarySpecList.Ring.Row[fromfieldnum]);
					table.remove(UpgradeListDBVar.char.PrimarySpecList.Ring.Row, fromfieldnum + 1);
					for i = 1, #UpgradeListDBVar.char.PrimarySpecList.Ring.Row, 1 do
						UpgradeListDBVar.char.PrimarySpecList.Ring.Row[i][1] = i;
					end
				else
					table.insert(UpgradeListDBVar.char.PrimarySpecList.Ring.Row, tofieldnum + 1, UpgradeListDBVar.char.PrimarySpecList.Ring.Row[fromfieldnum]);
					table.remove(UpgradeListDBVar.char.PrimarySpecList.Ring.Row, fromfieldnum);
					for i = 1, #UpgradeListDBVar.char.PrimarySpecList.Ring.Row, 1 do
						UpgradeListDBVar.char.PrimarySpecList.Ring.Row[i][1] = i;
					end
				end
				statusbarfont:SetTextColor(0, 1, 0);
				statusbarfont:SetText("Successfully moved row " .. fromfieldnum .. " to row " .. tofieldnum .. " in your Primary Spec's Ring list.");
				fromfield:SetText("");
				fromfield:ClearFocus();
				tofield:SetText("");
				tofield:ClearFocus();
				UpgradeList:RefreshWindow()
			end
		else --If the Secondary spec checkbox is checked
			if fromfieldnum >= UpgradeListDBVar.char.SecondarySpecList.Ring.Count or fromfieldnum == 0 then
				statusbarfont:SetTextColor(1, 0, 0);
				statusbarfont:SetText("From field does not match an item in your Secondary Spec's Ring list.");
				fromfield:HighlightText();
			elseif tofieldnum >= UpgradeListDBVar.char.SecondarySpecList.Ring.Count or tofieldnum == 0 then
				statusbarfont:SetTextColor(1, 0, 0);
				statusbarfont:SetText("To field does not match an item in your Secondary Spec's Ring list.");
				tofield:HighlightText();
			elseif tofieldnum == fromfieldnum then
				statusbarfont:SetTextColor(1, 0, 0);
				statusbarfont:SetText("From Field and To Field match, cannot move any items.");
				tofield:HighlightText();
			else
				if fromfieldnum > tofieldnum then
					table.insert(UpgradeListDBVar.char.SecondarySpecList.Ring.Row, tofieldnum, UpgradeListDBVar.char.SecondarySpecList.Ring.Row[fromfieldnum]);
					table.remove(UpgradeListDBVar.char.SecondarySpecList.Ring.Row, fromfieldnum + 1);
					for i = 1, #UpgradeListDBVar.char.SecondarySpecList.Ring.Row, 1 do
						UpgradeListDBVar.char.SecondarySpecList.Ring.Row[i][1] = i;
					end
				else
					table.insert(UpgradeListDBVar.char.SecondarySpecList.Ring.Row, tofieldnum + 1, UpgradeListDBVar.char.SecondarySpecList.Ring.Row[fromfieldnum]);
					table.remove(UpgradeListDBVar.char.SecondarySpecList.Ring.Row, fromfieldnum);
					for i = 1, #UpgradeListDBVar.char.SecondarySpecList.Ring.Row, 1 do
						UpgradeListDBVar.char.SecondarySpecList.Ring.Row[i][1] = i;
					end
				end
				statusbarfont:SetTextColor(0, 1, 0);
				statusbarfont:SetText("Successfully moved row " .. fromfieldnum .. " to row " .. tofieldnum .. " in your Secondary Spec's Ring list.");
				fromfield:SetText("");
				fromfield:ClearFocus();
				tofield:SetText("");
				tofield:ClearFocus();
				UpgradeList:RefreshWindow()
			end
		end
	elseif PanelTemplates_GetSelectedTab(UpgradeListMainFrame) == 12 then --If the Trinket tab is selected
		if UpgradeListDBVar.char.SavedOptions.PrimaryCheck:GetChecked() == 1 then --If the primary spec checkbox is checked
			if fromfieldnum >= UpgradeListDBVar.char.PrimarySpecList.Trinket.Count or fromfieldnum == 0 then
				statusbarfont:SetTextColor(1, 0, 0);
				statusbarfont:SetText("From field does not match an item in your Primary Spec's Trinket list.");
				fromfield:HighlightText();
			elseif tofieldnum >= UpgradeListDBVar.char.PrimarySpecList.Trinket.Count or tofieldnum == 0 then
				statusbarfont:SetTextColor(1, 0, 0);
				statusbarfont:SetText("To field does not match an item in your Primary Spec's Trinket list.");
				tofield:HighlightText();
			elseif tofieldnum == fromfieldnum then
				statusbarfont:SetTextColor(1, 0, 0);
				statusbarfont:SetText("From Field and To Field match, cannot move any items.");
				tofield:HighlightText();
			else
				if fromfieldnum > tofieldnum then
					table.insert(UpgradeListDBVar.char.PrimarySpecList.Trinket.Row, tofieldnum, UpgradeListDBVar.char.PrimarySpecList.Trinket.Row[fromfieldnum]);
					table.remove(UpgradeListDBVar.char.PrimarySpecList.Trinket.Row, fromfieldnum + 1);
					for i = 1, #UpgradeListDBVar.char.PrimarySpecList.Trinket.Row, 1 do
						UpgradeListDBVar.char.PrimarySpecList.Trinket.Row[i][1] = i;
					end
				else
					table.insert(UpgradeListDBVar.char.PrimarySpecList.Trinket.Row, tofieldnum + 1, UpgradeListDBVar.char.PrimarySpecList.Trinket.Row[fromfieldnum]);
					table.remove(UpgradeListDBVar.char.PrimarySpecList.Trinket.Row, fromfieldnum);
					for i = 1, #UpgradeListDBVar.char.PrimarySpecList.Trinket.Row, 1 do
						UpgradeListDBVar.char.PrimarySpecList.Trinket.Row[i][1] = i;
					end
				end
				statusbarfont:SetTextColor(0, 1, 0);
				statusbarfont:SetText("Successfully moved row " .. fromfieldnum .. " to row " .. tofieldnum .. " in your Primary Spec's Trinket list.");
				fromfield:SetText("");
				fromfield:ClearFocus();
				tofield:SetText("");
				tofield:ClearFocus();
				UpgradeList:RefreshWindow()
			end
		else --If the Secondary spec checkbox is checked
			if fromfieldnum >= UpgradeListDBVar.char.SecondarySpecList.Trinket.Count or fromfieldnum == 0 then
				statusbarfont:SetTextColor(1, 0, 0);
				statusbarfont:SetText("From field does not match an item in your Secondary Spec's Trinket list.");
				fromfield:HighlightText();
			elseif tofieldnum >= UpgradeListDBVar.char.SecondarySpecList.Trinket.Count or tofieldnum == 0 then
				statusbarfont:SetTextColor(1, 0, 0);
				statusbarfont:SetText("To field does not match an item in your Secondary Spec's Trinket list.");
				tofield:HighlightText();
			elseif tofieldnum == fromfieldnum then
				statusbarfont:SetTextColor(1, 0, 0);
				statusbarfont:SetText("From Field and To Field match, cannot move any items.");
				tofield:HighlightText();
			else
				if fromfieldnum > tofieldnum then
					table.insert(UpgradeListDBVar.char.SecondarySpecList.Trinket.Row, tofieldnum, UpgradeListDBVar.char.SecondarySpecList.Trinket.Row[fromfieldnum]);
					table.remove(UpgradeListDBVar.char.SecondarySpecList.Trinket.Row, fromfieldnum + 1);
					for i = 1, #UpgradeListDBVar.char.SecondarySpecList.Trinket.Row, 1 do
						UpgradeListDBVar.char.SecondarySpecList.Trinket.Row[i][1] = i;
					end
				else
					table.insert(UpgradeListDBVar.char.SecondarySpecList.Trinket.Row, tofieldnum + 1, UpgradeListDBVar.char.SecondarySpecList.Trinket.Row[fromfieldnum]);
					table.remove(UpgradeListDBVar.char.SecondarySpecList.Trinket.Row, fromfieldnum);
					for i = 1, #UpgradeListDBVar.char.SecondarySpecList.Trinket.Row, 1 do
						UpgradeListDBVar.char.SecondarySpecList.Trinket.Row[i][1] = i;
					end
				end
				statusbarfont:SetTextColor(0, 1, 0);
				statusbarfont:SetText("Successfully moved row " .. fromfieldnum .. " to row " .. tofieldnum .. " in your Secondary Spec's Trinket list.");
				fromfield:SetText("");
				fromfield:ClearFocus();
				tofield:SetText("");
				tofield:ClearFocus();
				UpgradeList:RefreshWindow()
			end
		end
	elseif PanelTemplates_GetSelectedTab(UpgradeListMainFrame) == 13 then --If the Main tab is selected
		if UpgradeListDBVar.char.SavedOptions.PrimaryCheck:GetChecked() == 1 then --If the primary spec checkbox is checked
			if fromfieldnum >= UpgradeListDBVar.char.PrimarySpecList.Main.Count or fromfieldnum == 0 then
				statusbarfont:SetTextColor(1, 0, 0);
				statusbarfont:SetText("From field does not match an item in your Primary Spec's Main list.");
				fromfield:HighlightText();
			elseif tofieldnum >= UpgradeListDBVar.char.PrimarySpecList.Main.Count or tofieldnum == 0 then
				statusbarfont:SetTextColor(1, 0, 0);
				statusbarfont:SetText("To field does not match an item in your Primary Spec's Main list.");
				tofield:HighlightText();
			elseif tofieldnum == fromfieldnum then
				statusbarfont:SetTextColor(1, 0, 0);
				statusbarfont:SetText("From Field and To Field match, cannot move any items.");
				tofield:HighlightText();
			else
				if fromfieldnum > tofieldnum then
					table.insert(UpgradeListDBVar.char.PrimarySpecList.Main.Row, tofieldnum, UpgradeListDBVar.char.PrimarySpecList.Main.Row[fromfieldnum]);
					table.remove(UpgradeListDBVar.char.PrimarySpecList.Main.Row, fromfieldnum + 1);
					for i = 1, #UpgradeListDBVar.char.PrimarySpecList.Main.Row, 1 do
						UpgradeListDBVar.char.PrimarySpecList.Main.Row[i][1] = i;
					end
				else
					table.insert(UpgradeListDBVar.char.PrimarySpecList.Main.Row, tofieldnum + 1, UpgradeListDBVar.char.PrimarySpecList.Main.Row[fromfieldnum]);
					table.remove(UpgradeListDBVar.char.PrimarySpecList.Main.Row, fromfieldnum);
					for i = 1, #UpgradeListDBVar.char.PrimarySpecList.Main.Row, 1 do
						UpgradeListDBVar.char.PrimarySpecList.Main.Row[i][1] = i;
					end
				end
				statusbarfont:SetTextColor(0, 1, 0);
				statusbarfont:SetText("Successfully moved row " .. fromfieldnum .. " to row " .. tofieldnum .. " in your Primary Spec's Main list.");
				fromfield:SetText("");
				fromfield:ClearFocus();
				tofield:SetText("");
				tofield:ClearFocus();
				UpgradeList:RefreshWindow()
			end
		else --If the Secondary spec checkbox is checked
			if fromfieldnum >= UpgradeListDBVar.char.SecondarySpecList.Main.Count or fromfieldnum == 0 then
				statusbarfont:SetTextColor(1, 0, 0);
				statusbarfont:SetText("From field does not match an item in your Secondary Spec's Main list.");
				fromfield:HighlightText();
			elseif tofieldnum >= UpgradeListDBVar.char.SecondarySpecList.Main.Count or tofieldnum == 0 then
				statusbarfont:SetTextColor(1, 0, 0);
				statusbarfont:SetText("To field does not match an item in your Secondary Spec's Main list.");
				tofield:HighlightText();
			elseif tofieldnum == fromfieldnum then
				statusbarfont:SetTextColor(1, 0, 0);
				statusbarfont:SetText("From Field and To Field match, cannot move any items.");
				tofield:HighlightText();
			else
				if fromfieldnum > tofieldnum then
					table.insert(UpgradeListDBVar.char.SecondarySpecList.Main.Row, tofieldnum, UpgradeListDBVar.char.SecondarySpecList.Main.Row[fromfieldnum]);
					table.remove(UpgradeListDBVar.char.SecondarySpecList.Main.Row, fromfieldnum + 1);
					for i = 1, #UpgradeListDBVar.char.SecondarySpecList.Main.Row, 1 do
						UpgradeListDBVar.char.SecondarySpecList.Main.Row[i][1] = i;
					end
				else
					table.insert(UpgradeListDBVar.char.SecondarySpecList.Main.Row, tofieldnum + 1, UpgradeListDBVar.char.SecondarySpecList.Main.Row[fromfieldnum]);
					table.remove(UpgradeListDBVar.char.SecondarySpecList.Main.Row, fromfieldnum);
					for i = 1, #UpgradeListDBVar.char.SecondarySpecList.Main.Row, 1 do
						UpgradeListDBVar.char.SecondarySpecList.Main.Row[i][1] = i;
					end
				end
				statusbarfont:SetTextColor(0, 1, 0);
				statusbarfont:SetText("Successfully moved row " .. fromfieldnum .. " to row " .. tofieldnum .. " in your Secondary Spec's Main list.");
				fromfield:SetText("");
				fromfield:ClearFocus();
				tofield:SetText("");
				tofield:ClearFocus();
				UpgradeList:RefreshWindow()
			end
		end
	elseif PanelTemplates_GetSelectedTab(UpgradeListMainFrame) == 14 then --If the Off tab is selected
		if UpgradeListDBVar.char.SavedOptions.PrimaryCheck:GetChecked() == 1 then --If the primary spec checkbox is checked
			if fromfieldnum >= UpgradeListDBVar.char.PrimarySpecList.Off.Count or fromfieldnum == 0 then
				statusbarfont:SetTextColor(1, 0, 0);
				statusbarfont:SetText("From field does not match an item in your Primary Spec's Off list.");
				fromfield:HighlightText();
			elseif tofieldnum >= UpgradeListDBVar.char.PrimarySpecList.Off.Count or tofieldnum == 0 then
				statusbarfont:SetTextColor(1, 0, 0);
				statusbarfont:SetText("To field does not match an item in your Primary Spec's Off list.");
				tofield:HighlightText();
			elseif tofieldnum == fromfieldnum then
				statusbarfont:SetTextColor(1, 0, 0);
				statusbarfont:SetText("From Field and To Field match, cannot move any items.");
				tofield:HighlightText();
			else
				if fromfieldnum > tofieldnum then
					table.insert(UpgradeListDBVar.char.PrimarySpecList.Off.Row, tofieldnum, UpgradeListDBVar.char.PrimarySpecList.Off.Row[fromfieldnum]);
					table.remove(UpgradeListDBVar.char.PrimarySpecList.Off.Row, fromfieldnum + 1);
					for i = 1, #UpgradeListDBVar.char.PrimarySpecList.Off.Row, 1 do
						UpgradeListDBVar.char.PrimarySpecList.Off.Row[i][1] = i;
					end
				else
					table.insert(UpgradeListDBVar.char.PrimarySpecList.Off.Row, tofieldnum + 1, UpgradeListDBVar.char.PrimarySpecList.Off.Row[fromfieldnum]);
					table.remove(UpgradeListDBVar.char.PrimarySpecList.Off.Row, fromfieldnum);
					for i = 1, #UpgradeListDBVar.char.PrimarySpecList.Off.Row, 1 do
						UpgradeListDBVar.char.PrimarySpecList.Off.Row[i][1] = i;
					end
				end
				statusbarfont:SetTextColor(0, 1, 0);
				statusbarfont:SetText("Successfully moved row " .. fromfieldnum .. " to row " .. tofieldnum .. " in your Primary Spec's Off list.");
				fromfield:SetText("");
				fromfield:ClearFocus();
				tofield:SetText("");
				tofield:ClearFocus();
				UpgradeList:RefreshWindow()
			end
		else --If the Secondary spec checkbox is checked
			if fromfieldnum >= UpgradeListDBVar.char.SecondarySpecList.Off.Count or fromfieldnum == 0 then
				statusbarfont:SetTextColor(1, 0, 0);
				statusbarfont:SetText("From field does not match an item in your Secondary Spec's Off list.");
				fromfield:HighlightText();
			elseif tofieldnum >= UpgradeListDBVar.char.SecondarySpecList.Off.Count or tofieldnum == 0 then
				statusbarfont:SetTextColor(1, 0, 0);
				statusbarfont:SetText("To field does not match an item in your Secondary Spec's Off list.");
				tofield:HighlightText();
			elseif tofieldnum == fromfieldnum then
				statusbarfont:SetTextColor(1, 0, 0);
				statusbarfont:SetText("From Field and To Field match, cannot move any items.");
				tofield:HighlightText();
			else
				if fromfieldnum > tofieldnum then
					table.insert(UpgradeListDBVar.char.SecondarySpecList.Off.Row, tofieldnum, UpgradeListDBVar.char.SecondarySpecList.Off.Row[fromfieldnum]);
					table.remove(UpgradeListDBVar.char.SecondarySpecList.Off.Row, fromfieldnum + 1);
					for i = 1, #UpgradeListDBVar.char.SecondarySpecList.Off.Row, 1 do
						UpgradeListDBVar.char.SecondarySpecList.Off.Row[i][1] = i;
					end
				else
					table.insert(UpgradeListDBVar.char.SecondarySpecList.Off.Row, tofieldnum + 1, UpgradeListDBVar.char.SecondarySpecList.Off.Row[fromfieldnum]);
					table.remove(UpgradeListDBVar.char.SecondarySpecList.Off.Row, fromfieldnum);
					for i = 1, #UpgradeListDBVar.char.SecondarySpecList.Off.Row, 1 do
						UpgradeListDBVar.char.SecondarySpecList.Off.Row[i][1] = i;
					end
				end
				statusbarfont:SetTextColor(0, 1, 0);
				statusbarfont:SetText("Successfully moved row " .. fromfieldnum .. " to row " .. tofieldnum .. " in your Secondary Spec's Off list.");
				fromfield:SetText("");
				fromfield:ClearFocus();
				tofield:SetText("");
				tofield:ClearFocus();
				UpgradeList:RefreshWindow()
			end
		end
	elseif PanelTemplates_GetSelectedTab(UpgradeListMainFrame) == 15 then --If the Ranged tab is selected
		if UpgradeListDBVar.char.SavedOptions.PrimaryCheck:GetChecked() == 1 then --If the primary spec checkbox is checked
			if fromfieldnum >= UpgradeListDBVar.char.PrimarySpecList.Ranged.Count or fromfieldnum == 0 then
				statusbarfont:SetTextColor(1, 0, 0);
				statusbarfont:SetText("From field does not match an item in your Primary Spec's Ranged list.");
				fromfield:HighlightText();
			elseif tofieldnum >= UpgradeListDBVar.char.PrimarySpecList.Ranged.Count or tofieldnum == 0 then
				statusbarfont:SetTextColor(1, 0, 0);
				statusbarfont:SetText("To field does not match an item in your Primary Spec's Ranged list.");
				tofield:HighlightText();
			elseif tofieldnum == fromfieldnum then
				statusbarfont:SetTextColor(1, 0, 0);
				statusbarfont:SetText("From Field and To Field match, cannot move any items.");
				tofield:HighlightText();
			else
				if fromfieldnum > tofieldnum then
					table.insert(UpgradeListDBVar.char.PrimarySpecList.Ranged.Row, tofieldnum, UpgradeListDBVar.char.PrimarySpecList.Ranged.Row[fromfieldnum]);
					table.remove(UpgradeListDBVar.char.PrimarySpecList.Ranged.Row, fromfieldnum + 1);
					for i = 1, #UpgradeListDBVar.char.PrimarySpecList.Ranged.Row, 1 do
						UpgradeListDBVar.char.PrimarySpecList.Ranged.Row[i][1] = i;
					end
				else
					table.insert(UpgradeListDBVar.char.PrimarySpecList.Ranged.Row, tofieldnum + 1, UpgradeListDBVar.char.PrimarySpecList.Ranged.Row[fromfieldnum]);
					table.remove(UpgradeListDBVar.char.PrimarySpecList.Ranged.Row, fromfieldnum);
					for i = 1, #UpgradeListDBVar.char.PrimarySpecList.Ranged.Row, 1 do
						UpgradeListDBVar.char.PrimarySpecList.Ranged.Row[i][1] = i;
					end
				end
				statusbarfont:SetTextColor(0, 1, 0);
				statusbarfont:SetText("Successfully moved row " .. fromfieldnum .. " to row " .. tofieldnum .. " in your Primary Spec's Ranged list.");
				fromfield:SetText("");
				fromfield:ClearFocus();
				tofield:SetText("");
				tofield:ClearFocus();
				UpgradeList:RefreshWindow()
			end
		else --If the Secondary spec checkbox is checked
			if fromfieldnum >= UpgradeListDBVar.char.SecondarySpecList.Ranged.Count or fromfieldnum == 0 then
				statusbarfont:SetTextColor(1, 0, 0);
				statusbarfont:SetText("From field does not match an item in your Secondary Spec's Ranged list.");
				fromfield:HighlightText();
			elseif tofieldnum >= UpgradeListDBVar.char.SecondarySpecList.Ranged.Count or tofieldnum == 0 then
				statusbarfont:SetTextColor(1, 0, 0);
				statusbarfont:SetText("To field does not match an item in your Secondary Spec's Ranged list.");
				tofield:HighlightText();
			elseif tofieldnum == fromfieldnum then
				statusbarfont:SetTextColor(1, 0, 0);
				statusbarfont:SetText("From Field and To Field match, cannot move any items.");
				tofield:HighlightText();
			else
				if fromfieldnum > tofieldnum then
					table.insert(UpgradeListDBVar.char.SecondarySpecList.Ranged.Row, tofieldnum, UpgradeListDBVar.char.SecondarySpecList.Ranged.Row[fromfieldnum]);
					table.remove(UpgradeListDBVar.char.SecondarySpecList.Ranged.Row, fromfieldnum + 1);
					for i = 1, #UpgradeListDBVar.char.SecondarySpecList.Ranged.Row, 1 do
						UpgradeListDBVar.char.SecondarySpecList.Ranged.Row[i][1] = i;
					end
				else
					table.insert(UpgradeListDBVar.char.SecondarySpecList.Ranged.Row, tofieldnum + 1, UpgradeListDBVar.char.SecondarySpecList.Ranged.Row[fromfieldnum]);
					table.remove(UpgradeListDBVar.char.SecondarySpecList.Ranged.Row, fromfieldnum);
					for i = 1, #UpgradeListDBVar.char.SecondarySpecList.Ranged.Row, 1 do
						UpgradeListDBVar.char.SecondarySpecList.Ranged.Row[i][1] = i;
					end
				end
				statusbarfont:SetTextColor(0, 1, 0);
				statusbarfont:SetText("Successfully moved row " .. fromfieldnum .. " to row " .. tofieldnum .. " in your Secondary Spec's Ranged list.");
				fromfield:SetText("");
				fromfield:ClearFocus();
				tofield:SetText("");
				tofield:ClearFocus();
				UpgradeList:RefreshWindow()
			end
		end
	elseif PanelTemplates_GetSelectedTab(UpgradeListMainFrame) == 16 then --If the Other tab is selected
		if UpgradeListDBVar.char.SavedOptions.PrimaryCheck:GetChecked() == 1 then --If the primary spec checkbox is checked
			if fromfieldnum >= UpgradeListDBVar.char.PrimarySpecList.Other.Count or fromfieldnum == 0 then
				statusbarfont:SetTextColor(1, 0, 0);
				statusbarfont:SetText("From field does not match an item in your Primary Spec's Other list.");
				fromfield:HighlightText();
			elseif tofieldnum >= UpgradeListDBVar.char.PrimarySpecList.Other.Count or tofieldnum == 0 then
				statusbarfont:SetTextColor(1, 0, 0);
				statusbarfont:SetText("To field does not match an item in your Primary Spec's Other list.");
				tofield:HighlightText();
			elseif tofieldnum == fromfieldnum then
				statusbarfont:SetTextColor(1, 0, 0);
				statusbarfont:SetText("From Field and To Field match, cannot move any items.");
				tofield:HighlightText();
			else
				if fromfieldnum > tofieldnum then
					table.insert(UpgradeListDBVar.char.PrimarySpecList.Other.Row, tofieldnum, UpgradeListDBVar.char.PrimarySpecList.Other.Row[fromfieldnum]);
					table.remove(UpgradeListDBVar.char.PrimarySpecList.Other.Row, fromfieldnum + 1);
					for i = 1, #UpgradeListDBVar.char.PrimarySpecList.Other.Row, 1 do
						UpgradeListDBVar.char.PrimarySpecList.Other.Row[i][1] = i;
					end
				else
					table.insert(UpgradeListDBVar.char.PrimarySpecList.Other.Row, tofieldnum + 1, UpgradeListDBVar.char.PrimarySpecList.Other.Row[fromfieldnum]);
					table.remove(UpgradeListDBVar.char.PrimarySpecList.Other.Row, fromfieldnum);
					for i = 1, #UpgradeListDBVar.char.PrimarySpecList.Other.Row, 1 do
						UpgradeListDBVar.char.PrimarySpecList.Other.Row[i][1] = i;
					end
				end
				statusbarfont:SetTextColor(0, 1, 0);
				statusbarfont:SetText("Successfully moved row " .. fromfieldnum .. " to row " .. tofieldnum .. " in your Primary Spec's Other list.");
				fromfield:SetText("");
				fromfield:ClearFocus();
				tofield:SetText("");
				tofield:ClearFocus();
				UpgradeList:RefreshWindow()
			end
		else --If the Secondary spec checkbox is checked
			if fromfieldnum >= UpgradeListDBVar.char.SecondarySpecList.Other.Count or fromfieldnum == 0 then
				statusbarfont:SetTextColor(1, 0, 0);
				statusbarfont:SetText("From field does not match an item in your Secondary Spec's Other list.");
				fromfield:HighlightText();
			elseif tofieldnum >= UpgradeListDBVar.char.SecondarySpecList.Other.Count or tofieldnum == 0 then
				statusbarfont:SetTextColor(1, 0, 0);
				statusbarfont:SetText("To field does not match an item in your Secondary Spec's Other list.");
				tofield:HighlightText();
			elseif tofieldnum == fromfieldnum then
				statusbarfont:SetTextColor(1, 0, 0);
				statusbarfont:SetText("From Field and To Field match, cannot move any items.");
				tofield:HighlightText();
			else
				if fromfieldnum > tofieldnum then
					table.insert(UpgradeListDBVar.char.SecondarySpecList.Other.Row, tofieldnum, UpgradeListDBVar.char.SecondarySpecList.Other.Row[fromfieldnum]);
					table.remove(UpgradeListDBVar.char.SecondarySpecList.Other.Row, fromfieldnum + 1);
					for i = 1, #UpgradeListDBVar.char.SecondarySpecList.Other.Row, 1 do
						UpgradeListDBVar.char.SecondarySpecList.Other.Row[i][1] = i;
					end
				else
					table.insert(UpgradeListDBVar.char.SecondarySpecList.Other.Row, tofieldnum + 1, UpgradeListDBVar.char.SecondarySpecList.Other.Row[fromfieldnum]);
					table.remove(UpgradeListDBVar.char.SecondarySpecList.Other.Row, fromfieldnum);
					for i = 1, #UpgradeListDBVar.char.SecondarySpecList.Other.Row, 1 do
						UpgradeListDBVar.char.SecondarySpecList.Other.Row[i][1] = i;
					end
				end
				statusbarfont:SetTextColor(0, 1, 0);
				statusbarfont:SetText("Successfully moved row " .. fromfieldnum .. " to row " .. tofieldnum .. " in your Secondary Spec's Other list.");
				fromfield:SetText("");
				fromfield:ClearFocus();
				tofield:SetText("");
				tofield:ClearFocus();
				UpgradeList:RefreshWindow()
			end
		end
	else
		statusbarfont:SetTextColor(1, 0, 0);
		statusbarfont:SetText("ERROR: Unable to determine selected tab.");
	end
end

function UpgradeList:RemoveMultipleItems(itemID, itemEquipLocation, spec, onehandweaponslot) --spec can be "mainspec" or "offspec" | onehandweaponslot can be "mainhand" or "offhand"
	if spec == "mainspec" then --Main Spec items
		if onehandweaponslot == "mainhand" then --Main Spec Main Hand 1-handed weapons
			local rownum = 0;
			repeat
				rownum = rownum + 1;
			until (UpgradeListDBVar.char.PrimarySpecList.Main.Row[rownum][8] == itemID or UpgradeListDBVar.char.PrimarySpecList.Main.Row[rownum] == nil);
			if UpgradeListDBVar.profile.autodelete.messages then
				if UpgradeListDBVar.profile.autodelete.messagelocation == "chatwindow" then
					DEFAULT_CHAT_FRAME:AddMessage("|cFFE08800Upgrade List:|r Auto-deleting " .. UpgradeListDBVar.char.PrimarySpecList.Main.Row[rownum][3] .. " from your Primary Spec's Main Hand list.");
				elseif UpgradeListDBVar.profile.autodelete.messagelocation == "scrollwindow" then
					UpgradeListDBVar.profile.messages.scrollwindow:AddMessage("Auto-deleting " .. UpgradeListDBVar.char.PrimarySpecList.Main.Row[rownum][3] .. " from your Primary Spec's Main Hand list.");
				end
			end
			for i = #UpgradeListDBVar.char.PrimarySpecList.Main.Row, rownum, -1 do
				table.remove(UpgradeListDBVar.char.PrimarySpecList.Main.Row);
				UpgradeListDBVar.char.PrimarySpecList.Main.Count = UpgradeListDBVar.char.PrimarySpecList.Main.Count - 1;
			end
		elseif onehandweaponslot == "offhand" then --Main Spec Off Hand 1-handed weapons
			local rownum = 0;
			repeat
				rownum = rownum + 1;
			until (UpgradeListDBVar.char.PrimarySpecList.Off.Row[rownum][8] == itemID or UpgradeListDBVar.char.PrimarySpecList.Off.Row[rownum] == nil);
			if UpgradeListDBVar.profile.autodelete.messages then
				if UpgradeListDBVar.profile.autodelete.messagelocation == "chatwindow" then
					DEFAULT_CHAT_FRAME:AddMessage("|cFFE08800Upgrade List:|r Auto-deleting " .. UpgradeListDBVar.char.PrimarySpecList.Off.Row[rownum][3] .. " from your Primary Spec's Off Hand list.");
				elseif UpgradeListDBVar.profile.autodelete.messagelocation == "scrollwindow" then
					UpgradeListDBVar.profile.messages.scrollwindow:AddMessage("Auto-deleting " .. UpgradeListDBVar.char.PrimarySpecList.Off.Row[rownum][3] .. " from your Primary Spec's Off Hand list.");
				end
			end
			for i = #UpgradeListDBVar.char.PrimarySpecList.Off.Row, rownum, -1 do
				table.remove(UpgradeListDBVar.char.PrimarySpecList.Off.Row);
				UpgradeListDBVar.char.PrimarySpecList.Off.Count = UpgradeListDBVar.char.PrimarySpecList.Off.Count - 1;
			end
		else --Main Spec non 1-handed items
			if itemEquipLocation == "INVTYPE_HEAD" then
				local rownum = 0;
				repeat
					rownum = rownum + 1;
				until (UpgradeListDBVar.char.PrimarySpecList.Head.Row[rownum][8] == itemID or UpgradeListDBVar.char.PrimarySpecList.Head.Row[rownum] == nil);
				if UpgradeListDBVar.profile.autodelete.messages then
					if UpgradeListDBVar.profile.autodelete.messagelocation == "chatwindow" then
						DEFAULT_CHAT_FRAME:AddMessage("|cFFE08800Upgrade List:|r Auto-deleting " .. UpgradeListDBVar.char.PrimarySpecList.Head.Row[rownum][3] .. " from your Primary Spec's Head list.");
					elseif UpgradeListDBVar.profile.autodelete.messagelocation == "scrollwindow" then
						UpgradeListDBVar.profile.messages.scrollwindow:AddMessage("Auto-deleting " .. UpgradeListDBVar.char.PrimarySpecList.Head.Row[rownum][3] .. " from your Primary Spec's Head list.");
					end
				end
				for i = #UpgradeListDBVar.char.PrimarySpecList.Head.Row, rownum, -1 do
					table.remove(UpgradeListDBVar.char.PrimarySpecList.Head.Row);
					UpgradeListDBVar.char.PrimarySpecList.Head.Count = UpgradeListDBVar.char.PrimarySpecList.Head.Count - 1;
				end
			elseif itemEquipLocation == "INVTYPE_NECK" then
				local rownum = 0;
				repeat
					rownum = rownum + 1;
				until (UpgradeListDBVar.char.PrimarySpecList.Neck.Row[rownum][8] == itemID or UpgradeListDBVar.char.PrimarySpecList.Neck.Row[rownum] == nil);
				if UpgradeListDBVar.profile.autodelete.messages then
					if UpgradeListDBVar.profile.autodelete.messagelocation == "chatwindow" then
						DEFAULT_CHAT_FRAME:AddMessage("|cFFE08800Upgrade List:|r Auto-deleting " .. UpgradeListDBVar.char.PrimarySpecList.Neck.Row[rownum][3] .. " from your Primary Spec's Neck list.");
					elseif UpgradeListDBVar.profile.autodelete.messagelocation == "scrollwindow" then
						UpgradeListDBVar.profile.messages.scrollwindow:AddMessage("Auto-deleting " .. UpgradeListDBVar.char.PrimarySpecList.Neck.Row[rownum][3] .. " from your Primary Spec's Neck list.");
					end
				end
				for i = #UpgradeListDBVar.char.PrimarySpecList.Neck.Row, rownum, -1 do
					table.remove(UpgradeListDBVar.char.PrimarySpecList.Neck.Row);
					UpgradeListDBVar.char.PrimarySpecList.Neck.Count = UpgradeListDBVar.char.PrimarySpecList.Neck.Count - 1;
				end
			elseif itemEquipLocation == "INVTYPE_SHOULDER" then
				local rownum = 0;
				repeat
					rownum = rownum + 1;
				until (UpgradeListDBVar.char.PrimarySpecList.Shoulder.Row[rownum][8] == itemID or UpgradeListDBVar.char.PrimarySpecList.Shoulder.Row[rownum] == nil);
				if UpgradeListDBVar.profile.autodelete.messages then
					if UpgradeListDBVar.profile.autodelete.messagelocation == "chatwindow" then
						DEFAULT_CHAT_FRAME:AddMessage("|cFFE08800Upgrade List:|r Auto-deleting " .. UpgradeListDBVar.char.PrimarySpecList.Shoulder.Row[rownum][3] .. " from your Primary Spec's Shoulder list.");
					elseif UpgradeListDBVar.profile.autodelete.messagelocation == "scrollwindow" then
						UpgradeListDBVar.profile.messages.scrollwindow:AddMessage("Auto-deleting " .. UpgradeListDBVar.char.PrimarySpecList.Shoulder.Row[rownum][3] .. " from your Primary Spec's Shoulder list.");
					end
				end
				for i = #UpgradeListDBVar.char.PrimarySpecList.Shoulder.Row, rownum, -1 do
					table.remove(UpgradeListDBVar.char.PrimarySpecList.Shoulder.Row);
					UpgradeListDBVar.char.PrimarySpecList.Shoulder.Count = UpgradeListDBVar.char.PrimarySpecList.Shoulder.Count - 1;
				end
			elseif itemEquipLocation == "INVTYPE_CLOAK" then
				local rownum = 0;
				repeat
					rownum = rownum + 1;
				until (UpgradeListDBVar.char.PrimarySpecList.Back.Row[rownum][8] == itemID or UpgradeListDBVar.char.PrimarySpecList.Back.Row[rownum] == nil);
				if UpgradeListDBVar.profile.autodelete.messages then
					if UpgradeListDBVar.profile.autodelete.messagelocation == "chatwindow" then
						DEFAULT_CHAT_FRAME:AddMessage("|cFFE08800Upgrade List:|r Auto-deleting " .. UpgradeListDBVar.char.PrimarySpecList.Back.Row[rownum][3] .. " from your Primary Spec's Back list.");
					elseif UpgradeListDBVar.profile.autodelete.messagelocation == "scrollwindow" then
						UpgradeListDBVar.profile.messages.scrollwindow:AddMessage("Auto-deleting " .. UpgradeListDBVar.char.PrimarySpecList.Back.Row[rownum][3] .. " from your Primary Spec's Back list.");
					end
				end
				for i = #UpgradeListDBVar.char.PrimarySpecList.Back.Row, rownum, -1 do
					table.remove(UpgradeListDBVar.char.PrimarySpecList.Back.Row);
					UpgradeListDBVar.char.PrimarySpecList.Back.Count = UpgradeListDBVar.char.PrimarySpecList.Back.Count - 1;
				end
			elseif itemEquipLocation == "INVTYPE_CHEST" or itemEquipLocation == "INVTYPE_ROBE" then
				local rownum = 0;
				repeat
					rownum = rownum + 1;
				until (UpgradeListDBVar.char.PrimarySpecList.Chest.Row[rownum][8] == itemID or UpgradeListDBVar.char.PrimarySpecList.Chest.Row[rownum] == nil);
				if UpgradeListDBVar.profile.autodelete.messages then
					if UpgradeListDBVar.profile.autodelete.messagelocation == "chatwindow" then
						DEFAULT_CHAT_FRAME:AddMessage("|cFFE08800Upgrade List:|r Auto-deleting " .. UpgradeListDBVar.char.PrimarySpecList.Chest.Row[rownum][3] .. " from your Primary Spec's Chest list.");
					elseif UpgradeListDBVar.profile.autodelete.messagelocation == "scrollwindow" then
						UpgradeListDBVar.profile.messages.scrollwindow:AddMessage("Auto-deleting " .. UpgradeListDBVar.char.PrimarySpecList.Chest.Row[rownum][3] .. " from your Primary Spec's Chest list.");
					end
				end
				for i = #UpgradeListDBVar.char.PrimarySpecList.Chest.Row, rownum, -1 do
					table.remove(UpgradeListDBVar.char.PrimarySpecList.Chest.Row);
					UpgradeListDBVar.char.PrimarySpecList.Chest.Count = UpgradeListDBVar.char.PrimarySpecList.Chest.Count - 1;
				end
			elseif itemEquipLocation == "INVTYPE_WRIST" then
				local rownum = 0;
				repeat
					rownum = rownum + 1;
				until (UpgradeListDBVar.char.PrimarySpecList.Wrist.Row[rownum][8] == itemID or UpgradeListDBVar.char.PrimarySpecList.Wrist.Row[rownum] == nil);
				if UpgradeListDBVar.profile.autodelete.messages then
					if UpgradeListDBVar.profile.autodelete.messagelocation == "chatwindow" then
						DEFAULT_CHAT_FRAME:AddMessage("|cFFE08800Upgrade List:|r Auto-deleting " .. UpgradeListDBVar.char.PrimarySpecList.Wrist.Row[rownum][3] .. " from your Primary Spec's Wrist list.");
					elseif UpgradeListDBVar.profile.autodelete.messagelocation == "scrollwindow" then
						UpgradeListDBVar.profile.messages.scrollwindow:AddMessage("Auto-deleting " .. UpgradeListDBVar.char.PrimarySpecList.Wrist.Row[rownum][3] .. " from your Primary Spec's Wrist list.");
					end
				end
				for i = #UpgradeListDBVar.char.PrimarySpecList.Wrist.Row, rownum, -1 do
					table.remove(UpgradeListDBVar.char.PrimarySpecList.Wrist.Row);
					UpgradeListDBVar.char.PrimarySpecList.Wrist.Count = UpgradeListDBVar.char.PrimarySpecList.Wrist.Count - 1;
				end
			elseif itemEquipLocation == "INVTYPE_HAND" then
				local rownum = 0;
				repeat
					rownum = rownum + 1;
				until (UpgradeListDBVar.char.PrimarySpecList.Hand.Row[rownum][8] == itemID or UpgradeListDBVar.char.PrimarySpecList.Hand.Row[rownum] == nil);
				if UpgradeListDBVar.profile.autodelete.messages then
					if UpgradeListDBVar.profile.autodelete.messagelocation == "chatwindow" then
						DEFAULT_CHAT_FRAME:AddMessage("|cFFE08800Upgrade List:|r Auto-deleting " .. UpgradeListDBVar.char.PrimarySpecList.Hand.Row[rownum][3] .. " from your Primary Spec's Hand list.");
					elseif UpgradeListDBVar.profile.autodelete.messagelocation == "scrollwindow" then
						UpgradeListDBVar.profile.messages.scrollwindow:AddMessage("Auto-deleting " .. UpgradeListDBVar.char.PrimarySpecList.Hand.Row[rownum][3] .. " from your Primary Spec's Hand list.");
					end
				end
				for i = #UpgradeListDBVar.char.PrimarySpecList.Hand.Row, rownum, -1 do
					table.remove(UpgradeListDBVar.char.PrimarySpecList.Hand.Row);
					UpgradeListDBVar.char.PrimarySpecList.Hand.Count = UpgradeListDBVar.char.PrimarySpecList.Hand.Count - 1;
				end
			elseif itemEquipLocation == "INVTYPE_WAIST" then
				local rownum = 0;
				repeat
					rownum = rownum + 1;
				until (UpgradeListDBVar.char.PrimarySpecList.Waist.Row[rownum][8] == itemID or UpgradeListDBVar.char.PrimarySpecList.Waist.Row[rownum] == nil);
				if UpgradeListDBVar.profile.autodelete.messages then
					if UpgradeListDBVar.profile.autodelete.messagelocation == "chatwindow" then
						DEFAULT_CHAT_FRAME:AddMessage("|cFFE08800Upgrade List:|r Auto-deleting " .. UpgradeListDBVar.char.PrimarySpecList.Waist.Row[rownum][3] .. " from your Primary Spec's Waist list.");
					elseif UpgradeListDBVar.profile.autodelete.messagelocation == "scrollwindow" then
						UpgradeListDBVar.profile.messages.scrollwindow:AddMessage("Auto-deleting " .. UpgradeListDBVar.char.PrimarySpecList.Waist.Row[rownum][3] .. " from your Primary Spec's Waist list.");
					end
				end
				for i = #UpgradeListDBVar.char.PrimarySpecList.Waist.Row, rownum, -1 do
					table.remove(UpgradeListDBVar.char.PrimarySpecList.Waist.Row);
					UpgradeListDBVar.char.PrimarySpecList.Waist.Count = UpgradeListDBVar.char.PrimarySpecList.Waist.Count - 1;
				end
			elseif itemEquipLocation == "INVTYPE_LEGS" then
				local rownum = 0;
				repeat
					rownum = rownum + 1;
				until (UpgradeListDBVar.char.PrimarySpecList.Leg.Row[rownum][8] == itemID or UpgradeListDBVar.char.PrimarySpecList.Leg.Row[rownum] == nil);
				if UpgradeListDBVar.profile.autodelete.messages then
					if UpgradeListDBVar.profile.autodelete.messagelocation == "chatwindow" then
						DEFAULT_CHAT_FRAME:AddMessage("|cFFE08800Upgrade List:|r Auto-deleting " .. UpgradeListDBVar.char.PrimarySpecList.Leg.Row[rownum][3] .. " from your Primary Spec's Leg list.");
					elseif UpgradeListDBVar.profile.autodelete.messagelocation == "scrollwindow" then
						UpgradeListDBVar.profile.messages.scrollwindow:AddMessage("Auto-deleting " .. UpgradeListDBVar.char.PrimarySpecList.Leg.Row[rownum][3] .. " from your Primary Spec's Leg list.");
					end
				end
				for i = #UpgradeListDBVar.char.PrimarySpecList.Leg.Row, rownum, -1 do
					table.remove(UpgradeListDBVar.char.PrimarySpecList.Leg.Row);
					UpgradeListDBVar.char.PrimarySpecList.Leg.Count = UpgradeListDBVar.char.PrimarySpecList.Leg.Count - 1;
				end
			elseif itemEquipLocation == "INVTYPE_FEET" then
				local rownum = 0;
				repeat
					rownum = rownum + 1;
				until (UpgradeListDBVar.char.PrimarySpecList.Foot.Row[rownum][8] == itemID or UpgradeListDBVar.char.PrimarySpecList.Foot.Row[rownum] == nil);
				if UpgradeListDBVar.profile.autodelete.messages then
					if UpgradeListDBVar.profile.autodelete.messagelocation == "chatwindow" then
						DEFAULT_CHAT_FRAME:AddMessage("|cFFE08800Upgrade List:|r Auto-deleting " .. UpgradeListDBVar.char.PrimarySpecList.Foot.Row[rownum][3] .. " from your Primary Spec's Foot list.");
					elseif UpgradeListDBVar.profile.autodelete.messagelocation == "scrollwindow" then
						UpgradeListDBVar.profile.messages.scrollwindow:AddMessage("Auto-deleting " .. UpgradeListDBVar.char.PrimarySpecList.Foot.Row[rownum][3] .. " from your Primary Spec's Foot list.");
					end
				end
				for i = #UpgradeListDBVar.char.PrimarySpecList.Foot.Row, rownum, -1 do
					table.remove(UpgradeListDBVar.char.PrimarySpecList.Foot.Row);
					UpgradeListDBVar.char.PrimarySpecList.Foot.Count = UpgradeListDBVar.char.PrimarySpecList.Foot.Count - 1;
				end
			elseif itemEquipLocation == "INVTYPE_FINGER" then
				local rownum = 0;
				repeat
					rownum = rownum + 1;
				until (UpgradeListDBVar.char.PrimarySpecList.Ring.Row[rownum][8] == itemID or UpgradeListDBVar.char.PrimarySpecList.Ring.Row[rownum] == nil);
				if UpgradeListDBVar.profile.autodelete.messages then
					if UpgradeListDBVar.profile.autodelete.messagelocation == "chatwindow" then
						DEFAULT_CHAT_FRAME:AddMessage("|cFFE08800Upgrade List:|r Auto-deleting " .. UpgradeListDBVar.char.PrimarySpecList.Ring.Row[rownum][3] .. " from your Primary Spec's Finger list.");
					elseif UpgradeListDBVar.profile.autodelete.messagelocation == "scrollwindow" then
						UpgradeListDBVar.profile.messages.scrollwindow:AddMessage("Auto-deleting " .. UpgradeListDBVar.char.PrimarySpecList.Ring.Row[rownum][3] .. " from your Primary Spec's Finger list.");
					end
				end
				for i = #UpgradeListDBVar.char.PrimarySpecList.Ring.Row, rownum, -1 do
					table.remove(UpgradeListDBVar.char.PrimarySpecList.Ring.Row);
					UpgradeListDBVar.char.PrimarySpecList.Ring.Count = UpgradeListDBVar.char.PrimarySpecList.Ring.Count - 1;
				end
			elseif itemEquipLocation == "INVTYPE_TRINKET" then
				local rownum = 0;
				repeat
					rownum = rownum + 1;
				until (UpgradeListDBVar.char.PrimarySpecList.Trinket.Row[rownum][8] == itemID or UpgradeListDBVar.char.PrimarySpecList.Trinket.Row[rownum] == nil);
				if UpgradeListDBVar.profile.autodelete.messages then
					if UpgradeListDBVar.profile.autodelete.messagelocation == "chatwindow" then
						DEFAULT_CHAT_FRAME:AddMessage("|cFFE08800Upgrade List:|r Auto-deleting " .. UpgradeListDBVar.char.PrimarySpecList.Trinket.Row[rownum][3] .. " from your Primary Spec's Trinket list.");
					elseif UpgradeListDBVar.profile.autodelete.messagelocation == "scrollwindow" then
						UpgradeListDBVar.profile.messages.scrollwindow:AddMessage("Auto-deleting " .. UpgradeListDBVar.char.PrimarySpecList.Trinket.Row[rownum][3] .. " from your Primary Spec's Trinket list.");
					end
				end
				for i = #UpgradeListDBVar.char.PrimarySpecList.Trinket.Row, rownum, -1 do
					table.remove(UpgradeListDBVar.char.PrimarySpecList.Trinket.Row);
					UpgradeListDBVar.char.PrimarySpecList.Trinket.Count = UpgradeListDBVar.char.PrimarySpecList.Trinket.Count - 1;
				end
			elseif itemEquipLocation == "INVTYPE_WEAPONMAINHAND" or itemEquipLocation == "INVTYPE_2HWEAPON" then
				local rownum = 0;
				repeat
					rownum = rownum + 1;
				until (UpgradeListDBVar.char.PrimarySpecList.Main.Row[rownum][8] == itemID or UpgradeListDBVar.char.PrimarySpecList.Main.Row[rownum] == nil);
				if UpgradeListDBVar.profile.autodelete.messages then
					if UpgradeListDBVar.profile.autodelete.messagelocation == "chatwindow" then
						DEFAULT_CHAT_FRAME:AddMessage("|cFFE08800Upgrade List:|r Auto-deleting " .. UpgradeListDBVar.char.PrimarySpecList.Main.Row[rownum][3] .. " from your Primary Spec's Main Hand list.");
					elseif UpgradeListDBVar.profile.autodelete.messagelocation == "scrollwindow" then
						UpgradeListDBVar.profile.messages.scrollwindow:AddMessage("Auto-deleting " .. UpgradeListDBVar.char.PrimarySpecList.Main.Row[rownum][3] .. " from your Primary Spec's Main Hand list.");
					end
				end
				for i = #UpgradeListDBVar.char.PrimarySpecList.Main.Row, rownum, -1 do
					table.remove(UpgradeListDBVar.char.PrimarySpecList.Main.Row);
					UpgradeListDBVar.char.PrimarySpecList.Main.Count = UpgradeListDBVar.char.PrimarySpecList.Main.Count - 1;
				end
			elseif itemEquipLocation == "INVTYPE_WEAPONOFFHAND" or itemEquipLocation == "INVTYPE_SHIELD" or itemEquipLocation == "INVTYPE_HOLDABLE" then
				local rownum = 0;
				repeat
					rownum = rownum + 1;
				until (UpgradeListDBVar.char.PrimarySpecList.Off.Row[rownum][8] == itemID or UpgradeListDBVar.char.PrimarySpecList.Off.Row[rownum] == nil);
				if UpgradeListDBVar.profile.autodelete.messages then
					if UpgradeListDBVar.profile.autodelete.messagelocation == "chatwindow" then
						DEFAULT_CHAT_FRAME:AddMessage("|cFFE08800Upgrade List:|r Auto-deleting " .. UpgradeListDBVar.char.PrimarySpecList.Off.Row[rownum][3] .. " from your Primary Spec's Off Hand list.");
					elseif UpgradeListDBVar.profile.autodelete.messagelocation == "scrollwindow" then
						UpgradeListDBVar.profile.messages.scrollwindow:AddMessage("Auto-deleting " .. UpgradeListDBVar.char.PrimarySpecList.Off.Row[rownum][3] .. " from your Primary Spec's Off Hand list.");
					end
				end
				for i = #UpgradeListDBVar.char.PrimarySpecList.Off.Row, rownum, -1 do
					table.remove(UpgradeListDBVar.char.PrimarySpecList.Off.Row);
					UpgradeListDBVar.char.PrimarySpecList.Off.Count = UpgradeListDBVar.char.PrimarySpecList.Off.Count - 1;
				end
			elseif itemEquipLocation == "INVTYPE_RANGED" or itemEquipLocation == "INVTYPE_THROWN" or itemEquipLocation == "INVTYPE_RANGEDRIGHT" or itemEquipLocation == "INVTYPE_RELIC" then
				local rownum = 0;
				repeat
					rownum = rownum + 1;
				until (UpgradeListDBVar.char.PrimarySpecList.Ranged.Row[rownum][8] == itemID or UpgradeListDBVar.char.PrimarySpecList.Ranged.Row[rownum] == nil);
				if UpgradeListDBVar.profile.autodelete.messages then
					if UpgradeListDBVar.profile.autodelete.messagelocation == "chatwindow" then
						DEFAULT_CHAT_FRAME:AddMessage("|cFFE08800Upgrade List:|r Auto-deleting " .. UpgradeListDBVar.char.PrimarySpecList.Ranged.Row[rownum][3] .. " from your Primary Spec's Ranged list.");
					elseif UpgradeListDBVar.profile.autodelete.messagelocation == "scrollwindow" then
						UpgradeListDBVar.profile.messages.scrollwindow:AddMessage("Auto-deleting " .. UpgradeListDBVar.char.PrimarySpecList.Ranged.Row[rownum][3] .. " from your Primary Spec's Ranged list.");
					end
				end
				for i = #UpgradeListDBVar.char.PrimarySpecList.Ranged.Row, rownum, -1 do
					table.remove(UpgradeListDBVar.char.PrimarySpecList.Ranged.Row);
					UpgradeListDBVar.char.PrimarySpecList.Ranged.Count = UpgradeListDBVar.char.PrimarySpecList.Ranged.Count - 1;
				end
			end
		end
	else --Off Spec items
		if onehandweaponslot == "mainhand" then --Off Spec Main Hand 1-handed weapons
			local rownum = 0;
			repeat
				rownum = rownum + 1;
			until (UpgradeListDBVar.char.SecondarySpecList.Main.Row[rownum][8] == itemID or UpgradeListDBVar.char.SecondarySpecList.Main.Row[rownum] == nil);
			if UpgradeListDBVar.profile.autodelete.messages then
				if UpgradeListDBVar.profile.autodelete.messagelocation == "chatwindow" then
					DEFAULT_CHAT_FRAME:AddMessage("|cFFE08800Upgrade List:|r Auto-deleting " .. UpgradeListDBVar.char.SecondarySpecList.Main.Row[rownum][3] .. " from your Secondary Spec's Main Hand list.");
				elseif UpgradeListDBVar.profile.autodelete.messagelocation == "scrollwindow" then
					UpgradeListDBVar.profile.messages.scrollwindow:AddMessage("Auto-deleting " .. UpgradeListDBVar.char.SecondarySpecList.Main.Row[rownum][3] .. " from your Secondary Spec's Main Hand list.");
				end
			end
			for i = #UpgradeListDBVar.char.SecondarySpecList.Main.Row, rownum, -1 do
				table.remove(UpgradeListDBVar.char.SecondarySpecList.Main.Row);
				UpgradeListDBVar.char.SecondarySpecList.Main.Count = UpgradeListDBVar.char.SecondarySpecList.Main.Count - 1;
			end
		elseif onehandweaponslot == "offhand" then --Off Spec Off Hand 1-handed weapons
			local rownum = 0;
			repeat
				rownum = rownum + 1;
			until (UpgradeListDBVar.char.SecondarySpecList.Off.Row[rownum][8] == itemID or UpgradeListDBVar.char.SecondarySpecList.Off.Row[rownum] == nil);
			if UpgradeListDBVar.profile.autodelete.messages then
				if UpgradeListDBVar.profile.autodelete.messagelocation == "chatwindow" then
					DEFAULT_CHAT_FRAME:AddMessage("|cFFE08800Upgrade List:|r Auto-deleting " .. UpgradeListDBVar.char.SecondarySpecList.Off.Row[rownum][3] .. " from your Secondary Spec's Off Hand list.");
				elseif UpgradeListDBVar.profile.autodelete.messagelocation == "scrollwindow" then
					UpgradeListDBVar.profile.messages.scrollwindow:AddMessage("Auto-deleting " .. UpgradeListDBVar.char.SecondarySpecList.Off.Row[rownum][3] .. " from your Secondary Spec's Off Hand list.");
				end
			end
			for i = #UpgradeListDBVar.char.SecondarySpecList.Off.Row, rownum, -1 do
				table.remove(UpgradeListDBVar.char.SecondarySpecList.Off.Row);
				UpgradeListDBVar.char.SecondarySpecList.Off.Count = UpgradeListDBVar.char.SecondarySpecList.Off.Count - 1;
			end
		else --Off Spec non 1-handed items
			if itemEquipLocation == "INVTYPE_HEAD" then
				local rownum = 0;
				repeat
					rownum = rownum + 1;
				until (UpgradeListDBVar.char.SecondarySpecList.Head.Row[rownum][8] == itemID or UpgradeListDBVar.char.SecondarySpecList.Head.Row[rownum] == nil);
				if UpgradeListDBVar.profile.autodelete.messages then
					if UpgradeListDBVar.profile.autodelete.messagelocation == "chatwindow" then
						DEFAULT_CHAT_FRAME:AddMessage("|cFFE08800Upgrade List:|r Auto-deleting " .. UpgradeListDBVar.char.SecondarySpecList.Head.Row[rownum][3] .. " from your Secondary Spec's Head list.");
					elseif UpgradeListDBVar.profile.autodelete.messagelocation == "scrollwindow" then
						UpgradeListDBVar.profile.messages.scrollwindow:AddMessage("Auto-deleting " .. UpgradeListDBVar.char.SecondarySpecList.Head.Row[rownum][3] .. " from your Secondary Spec's Head list.");
					end
				end
				for i = #UpgradeListDBVar.char.SecondarySpecList.Head.Row, rownum, -1 do
					table.remove(UpgradeListDBVar.char.SecondarySpecList.Head.Row);
					UpgradeListDBVar.char.SecondarySpecList.Head.Count = UpgradeListDBVar.char.SecondarySpecList.Head.Count - 1;
				end
			elseif itemEquipLocation == "INVTYPE_NECK" then
				local rownum = 0;
				repeat
					rownum = rownum + 1;
				until (UpgradeListDBVar.char.SecondarySpecList.Neck.Row[rownum][8] == itemID or UpgradeListDBVar.char.SecondarySpecList.Neck.Row[rownum] == nil);
				if UpgradeListDBVar.profile.autodelete.messages then
					if UpgradeListDBVar.profile.autodelete.messagelocation == "chatwindow" then
						DEFAULT_CHAT_FRAME:AddMessage("|cFFE08800Upgrade List:|r Auto-deleting " .. UpgradeListDBVar.char.SecondarySpecList.Neck.Row[rownum][3] .. " from your Secondary Spec's Neck list.");
					elseif UpgradeListDBVar.profile.autodelete.messagelocation == "scrollwindow" then
						UpgradeListDBVar.profile.messages.scrollwindow:AddMessage("Auto-deleting " .. UpgradeListDBVar.char.SecondarySpecList.Neck.Row[rownum][3] .. " from your Secondary Spec's Neck list.");
					end
				end
				for i = #UpgradeListDBVar.char.SecondarySpecList.Neck.Row, rownum, -1 do
					table.remove(UpgradeListDBVar.char.SecondarySpecList.Neck.Row);
					UpgradeListDBVar.char.SecondarySpecList.Neck.Count = UpgradeListDBVar.char.SecondarySpecList.Neck.Count - 1;
				end
			elseif itemEquipLocation == "INVTYPE_SHOULDER" then
				local rownum = 0;
				repeat
					rownum = rownum + 1;
				until (UpgradeListDBVar.char.SecondarySpecList.Shoulder.Row[rownum][8] == itemID or UpgradeListDBVar.char.SecondarySpecList.Shoulder.Row[rownum] == nil);
				if UpgradeListDBVar.profile.autodelete.messages then
					if UpgradeListDBVar.profile.autodelete.messagelocation == "chatwindow" then
						DEFAULT_CHAT_FRAME:AddMessage("|cFFE08800Upgrade List:|r Auto-deleting " .. UpgradeListDBVar.char.SecondarySpecList.Shoulder.Row[rownum][3] .. " from your Secondary Spec's Shoulder list.");
					elseif UpgradeListDBVar.profile.autodelete.messagelocation == "scrollwindow" then
						UpgradeListDBVar.profile.messages.scrollwindow:AddMessage("Auto-deleting " .. UpgradeListDBVar.char.SecondarySpecList.Shoulder.Row[rownum][3] .. " from your Secondary Spec's Shoulder list.");
					end
				end
				for i = #UpgradeListDBVar.char.SecondarySpecList.Shoulder.Row, rownum, -1 do
					table.remove(UpgradeListDBVar.char.SecondarySpecList.Shoulder.Row);
					UpgradeListDBVar.char.SecondarySpecList.Shoulder.Count = UpgradeListDBVar.char.SecondarySpecList.Shoulder.Count - 1;
				end
			elseif itemEquipLocation == "INVTYPE_CLOAK" then
				local rownum = 0;
				repeat
					rownum = rownum + 1;
				until (UpgradeListDBVar.char.SecondarySpecList.Back.Row[rownum][8] == itemID or UpgradeListDBVar.char.SecondarySpecList.Back.Row[rownum] == nil);
				if UpgradeListDBVar.profile.autodelete.messages then
					if UpgradeListDBVar.profile.autodelete.messagelocation == "chatwindow" then
						DEFAULT_CHAT_FRAME:AddMessage("|cFFE08800Upgrade List:|r Auto-deleting " .. UpgradeListDBVar.char.SecondarySpecList.Back.Row[rownum][3] .. " from your Secondary Spec's Back list.");
					elseif UpgradeListDBVar.profile.autodelete.messagelocation == "scrollwindow" then
						UpgradeListDBVar.profile.messages.scrollwindow:AddMessage("Auto-deleting " .. UpgradeListDBVar.char.SecondarySpecList.Back.Row[rownum][3] .. " from your Secondary Spec's Back list.");
					end
				end
				for i = #UpgradeListDBVar.char.SecondarySpecList.Back.Row, rownum, -1 do
					table.remove(UpgradeListDBVar.char.SecondarySpecList.Back.Row);
					UpgradeListDBVar.char.SecondarySpecList.Back.Count = UpgradeListDBVar.char.SecondarySpecList.Back.Count - 1;
				end
			elseif itemEquipLocation == "INVTYPE_CHEST" or itemEquipLocation == "INVTYPE_ROBE" then
				local rownum = 0;
				repeat
					rownum = rownum + 1;
				until (UpgradeListDBVar.char.SecondarySpecList.Chest.Row[rownum][8] == itemID or UpgradeListDBVar.char.SecondarySpecList.Chest.Row[rownum] == nil);
				if UpgradeListDBVar.profile.autodelete.messages then
					if UpgradeListDBVar.profile.autodelete.messagelocation == "chatwindow" then
						DEFAULT_CHAT_FRAME:AddMessage("|cFFE08800Upgrade List:|r Auto-deleting " .. UpgradeListDBVar.char.SecondarySpecList.Chest.Row[rownum][3] .. " from your Secondary Spec's Chest list.");
					elseif UpgradeListDBVar.profile.autodelete.messagelocation == "scrollwindow" then
						UpgradeListDBVar.profile.messages.scrollwindow:AddMessage("Auto-deleting " .. UpgradeListDBVar.char.SecondarySpecList.Chest.Row[rownum][3] .. " from your Secondary Spec's Chest list.");
					end
				end
				for i = #UpgradeListDBVar.char.SecondarySpecList.Chest.Row, rownum, -1 do
					table.remove(UpgradeListDBVar.char.SecondarySpecList.Chest.Row);
					UpgradeListDBVar.char.SecondarySpecList.Chest.Count = UpgradeListDBVar.char.SecondarySpecList.Chest.Count - 1;
				end
			elseif itemEquipLocation == "INVTYPE_WRIST" then
				local rownum = 0;
				repeat
					rownum = rownum + 1;
				until (UpgradeListDBVar.char.SecondarySpecList.Wrist.Row[rownum][8] == itemID or UpgradeListDBVar.char.SecondarySpecList.Wrist.Row[rownum] == nil);
				if UpgradeListDBVar.profile.autodelete.messages then
					if UpgradeListDBVar.profile.autodelete.messagelocation == "chatwindow" then
						DEFAULT_CHAT_FRAME:AddMessage("|cFFE08800Upgrade List:|r Auto-deleting " .. UpgradeListDBVar.char.SecondarySpecList.Wrist.Row[rownum][3] .. " from your Secondary Spec's Wrist list.");
					elseif UpgradeListDBVar.profile.autodelete.messagelocation == "scrollwindow" then
						UpgradeListDBVar.profile.messages.scrollwindow:AddMessage("Auto-deleting " .. UpgradeListDBVar.char.SecondarySpecList.Wrist.Row[rownum][3] .. " from your Secondary Spec's Wrist list.");
					end
				end
				for i = #UpgradeListDBVar.char.SecondarySpecList.Wrist.Row, rownum, -1 do
					table.remove(UpgradeListDBVar.char.SecondarySpecList.Wrist.Row);
					UpgradeListDBVar.char.SecondarySpecList.Wrist.Count = UpgradeListDBVar.char.SecondarySpecList.Wrist.Count - 1;
				end
			elseif itemEquipLocation == "INVTYPE_HAND" then
				local rownum = 0;
				repeat
					rownum = rownum + 1;
				until (UpgradeListDBVar.char.SecondarySpecList.Hand.Row[rownum][8] == itemID or UpgradeListDBVar.char.SecondarySpecList.Hand.Row[rownum] == nil);
				if UpgradeListDBVar.profile.autodelete.messages then
					if UpgradeListDBVar.profile.autodelete.messagelocation == "chatwindow" then
						DEFAULT_CHAT_FRAME:AddMessage("|cFFE08800Upgrade List:|r Auto-deleting " .. UpgradeListDBVar.char.SecondarySpecList.Hand.Row[rownum][3] .. " from your Secondary Spec's Hand list.");
					elseif UpgradeListDBVar.profile.autodelete.messagelocation == "scrollwindow" then
						UpgradeListDBVar.profile.messages.scrollwindow:AddMessage("Auto-deleting " .. UpgradeListDBVar.char.SecondarySpecList.Hand.Row[rownum][3] .. " from your Secondary Spec's Hand list.");
					end
				end
				for i = #UpgradeListDBVar.char.SecondarySpecList.Hand.Row, rownum, -1 do
					table.remove(UpgradeListDBVar.char.SecondarySpecList.Hand.Row);
					UpgradeListDBVar.char.SecondarySpecList.Hand.Count = UpgradeListDBVar.char.SecondarySpecList.Hand.Count - 1;
				end
			elseif itemEquipLocation == "INVTYPE_WAIST" then
				local rownum = 0;
				repeat
					rownum = rownum + 1;
				until (UpgradeListDBVar.char.SecondarySpecList.Waist.Row[rownum][8] == itemID or UpgradeListDBVar.char.SecondarySpecList.Waist.Row[rownum] == nil);
				if UpgradeListDBVar.profile.autodelete.messages then
					if UpgradeListDBVar.profile.autodelete.messagelocation == "chatwindow" then
						DEFAULT_CHAT_FRAME:AddMessage("|cFFE08800Upgrade List:|r Auto-deleting " .. UpgradeListDBVar.char.SecondarySpecList.Waist.Row[rownum][3] .. " from your Secondary Spec's Waist list.");
					elseif UpgradeListDBVar.profile.autodelete.messagelocation == "scrollwindow" then
						UpgradeListDBVar.profile.messages.scrollwindow:AddMessage("Auto-deleting " .. UpgradeListDBVar.char.SecondarySpecList.Waist.Row[rownum][3] .. " from your Secondary Spec's Waist list.");
					end
				end
				for i = #UpgradeListDBVar.char.SecondarySpecList.Waist.Row, rownum, -1 do
					table.remove(UpgradeListDBVar.char.SecondarySpecList.Waist.Row);
					UpgradeListDBVar.char.SecondarySpecList.Waist.Count = UpgradeListDBVar.char.SecondarySpecList.Waist.Count - 1;
				end
			elseif itemEquipLocation == "INVTYPE_LEGS" then
				local rownum = 0;
				repeat
					rownum = rownum + 1;
				until (UpgradeListDBVar.char.SecondarySpecList.Leg.Row[rownum][8] == itemID or UpgradeListDBVar.char.SecondarySpecList.Leg.Row[rownum] == nil);
				if UpgradeListDBVar.profile.autodelete.messages then
					if UpgradeListDBVar.profile.autodelete.messagelocation == "chatwindow" then
						DEFAULT_CHAT_FRAME:AddMessage("|cFFE08800Upgrade List:|r Auto-deleting " .. UpgradeListDBVar.char.SecondarySpecList.Leg.Row[rownum][3] .. " from your Secondary Spec's Leg list.");
					elseif UpgradeListDBVar.profile.autodelete.messagelocation == "scrollwindow" then
						UpgradeListDBVar.profile.messages.scrollwindow:AddMessage("Auto-deleting " .. UpgradeListDBVar.char.SecondarySpecList.Leg.Row[rownum][3] .. " from your Secondary Spec's Leg list.");
					end
				end
				for i = #UpgradeListDBVar.char.SecondarySpecList.Leg.Row, rownum, -1 do
					table.remove(UpgradeListDBVar.char.SecondarySpecList.Leg.Row);
					UpgradeListDBVar.char.SecondarySpecList.Leg.Count = UpgradeListDBVar.char.SecondarySpecList.Leg.Count - 1;
				end
			elseif itemEquipLocation == "INVTYPE_FEET" then
				local rownum = 0;
				repeat
					rownum = rownum + 1;
				until (UpgradeListDBVar.char.SecondarySpecList.Foot.Row[rownum][8] == itemID or UpgradeListDBVar.char.SecondarySpecList.Foot.Row[rownum] == nil);
				if UpgradeListDBVar.profile.autodelete.messages then
					if UpgradeListDBVar.profile.autodelete.messagelocation == "chatwindow" then
						DEFAULT_CHAT_FRAME:AddMessage("|cFFE08800Upgrade List:|r Auto-deleting " .. UpgradeListDBVar.char.SecondarySpecList.Foot.Row[rownum][3] .. " from your Secondary Spec's Foot list.");
					elseif UpgradeListDBVar.profile.autodelete.messagelocation == "scrollwindow" then
						UpgradeListDBVar.profile.messages.scrollwindow:AddMessage("Auto-deleting " .. UpgradeListDBVar.char.SecondarySpecList.Foot.Row[rownum][3] .. " from your Secondary Spec's Foot list.");
					end
				end
				for i = #UpgradeListDBVar.char.SecondarySpecList.Foot.Row, rownum, -1 do
					table.remove(UpgradeListDBVar.char.SecondarySpecList.Foot.Row);
					UpgradeListDBVar.char.SecondarySpecList.Foot.Count = UpgradeListDBVar.char.SecondarySpecList.Foot.Count - 1;
				end
			elseif itemEquipLocation == "INVTYPE_FINGER" then
				local rownum = 0;
				repeat
					rownum = rownum + 1;
				until (UpgradeListDBVar.char.SecondarySpecList.Ring.Row[rownum][8] == itemID or UpgradeListDBVar.char.SecondarySpecList.Ring.Row[rownum] == nil);
				if UpgradeListDBVar.profile.autodelete.messages then
					if UpgradeListDBVar.profile.autodelete.messagelocation == "chatwindow" then
						DEFAULT_CHAT_FRAME:AddMessage("|cFFE08800Upgrade List:|r Auto-deleting " .. UpgradeListDBVar.char.SecondarySpecList.Ring.Row[rownum][3] .. " from your Secondary Spec's Finger list.");
					elseif UpgradeListDBVar.profile.autodelete.messagelocation == "scrollwindow" then
						UpgradeListDBVar.profile.messages.scrollwindow:AddMessage("Auto-deleting " .. UpgradeListDBVar.char.SecondarySpecList.Ring.Row[rownum][3] .. " from your Secondary Spec's Finger list.");
					end
				end
				for i = #UpgradeListDBVar.char.SecondarySpecList.Ring.Row, rownum, -1 do
					table.remove(UpgradeListDBVar.char.SecondarySpecList.Ring.Row);
					UpgradeListDBVar.char.SecondarySpecList.Ring.Count = UpgradeListDBVar.char.SecondarySpecList.Ring.Count - 1;
				end
			elseif itemEquipLocation == "INVTYPE_TRINKET" then
				local rownum = 0;
				repeat
					rownum = rownum + 1;
				until (UpgradeListDBVar.char.SecondarySpecList.Trinket.Row[rownum][8] == itemID or UpgradeListDBVar.char.SecondarySpecList.Trinket.Row[rownum] == nil);
				if UpgradeListDBVar.profile.autodelete.messages then
					if UpgradeListDBVar.profile.autodelete.messagelocation == "chatwindow" then
						DEFAULT_CHAT_FRAME:AddMessage("|cFFE08800Upgrade List:|r Auto-deleting " .. UpgradeListDBVar.char.SecondarySpecList.Trinket.Row[rownum][3] .. " from your Secondary Spec's Trinket list.");
					elseif UpgradeListDBVar.profile.autodelete.messagelocation == "scrollwindow" then
						UpgradeListDBVar.profile.messages.scrollwindow:AddMessage("Auto-deleting " .. UpgradeListDBVar.char.SecondarySpecList.Trinket.Row[rownum][3] .. " from your Secondary Spec's Trinket list.");
					end
				end
				for i = #UpgradeListDBVar.char.SecondarySpecList.Trinket.Row, rownum, -1 do
					table.remove(UpgradeListDBVar.char.SecondarySpecList.Trinket.Row);
					UpgradeListDBVar.char.SecondarySpecList.Trinket.Count = UpgradeListDBVar.char.SecondarySpecList.Trinket.Count - 1;
				end
			elseif itemEquipLocation == "INVTYPE_WEAPONMAINHAND" or itemEquipLocation == "INVTYPE_2HWEAPON" then
				local rownum = 0;
				repeat
					rownum = rownum + 1;
				until (UpgradeListDBVar.char.SecondarySpecList.Main.Row[rownum][8] == itemID or UpgradeListDBVar.char.SecondarySpecList.Main.Row[rownum] == nil);
				if UpgradeListDBVar.profile.autodelete.messages then
					if UpgradeListDBVar.profile.autodelete.messagelocation == "chatwindow" then
						DEFAULT_CHAT_FRAME:AddMessage("|cFFE08800Upgrade List:|r Auto-deleting " .. UpgradeListDBVar.char.SecondarySpecList.Main.Row[rownum][3] .. " from your Secondary Spec's Main Hand list.");
					elseif UpgradeListDBVar.profile.autodelete.messagelocation == "scrollwindow" then
						UpgradeListDBVar.profile.messages.scrollwindow:AddMessage("Auto-deleting " .. UpgradeListDBVar.char.SecondarySpecList.Main.Row[rownum][3] .. " from your Secondary Spec's Main Hand list.");
					end
				end
				for i = #UpgradeListDBVar.char.SecondarySpecList.Main.Row, rownum, -1 do
					table.remove(UpgradeListDBVar.char.SecondarySpecList.Main.Row);
					UpgradeListDBVar.char.SecondarySpecList.Main.Count = UpgradeListDBVar.char.SecondarySpecList.Main.Count - 1;
				end
			elseif itemEquipLocation == "INVTYPE_WEAPONOFFHAND" or itemEquipLocation == "INVTYPE_SHIELD" or itemEquipLocation == "INVTYPE_HOLDABLE" then
				local rownum = 0;
				repeat
					rownum = rownum + 1;
				until (UpgradeListDBVar.char.SecondarySpecList.Off.Row[rownum][8] == itemID or UpgradeListDBVar.char.SecondarySpecList.Off.Row[rownum] == nil);
				if UpgradeListDBVar.profile.autodelete.messages then
					if UpgradeListDBVar.profile.autodelete.messagelocation == "chatwindow" then
						DEFAULT_CHAT_FRAME:AddMessage("|cFFE08800Upgrade List:|r Auto-deleting " .. UpgradeListDBVar.char.SecondarySpecList.Off.Row[rownum][3] .. " from your Secondary Spec's Off Hand list.");
					elseif UpgradeListDBVar.profile.autodelete.messagelocation == "scrollwindow" then
						UpgradeListDBVar.profile.messages.scrollwindow:AddMessage("Auto-deleting " .. UpgradeListDBVar.char.SecondarySpecList.Off.Row[rownum][3] .. " from your Secondary Spec's Off Hand list.");
					end
				end
				for i = #UpgradeListDBVar.char.SecondarySpecList.Off.Row, rownum, -1 do
					table.remove(UpgradeListDBVar.char.SecondarySpecList.Off.Row);
					UpgradeListDBVar.char.SecondarySpecList.Off.Count = UpgradeListDBVar.char.SecondarySpecList.Off.Count - 1;
				end
			elseif itemEquipLocation == "INVTYPE_RANGED" or itemEquipLocation == "INVTYPE_THROWN" or itemEquipLocation == "INVTYPE_RANGEDRIGHT" or itemEquipLocation == "INVTYPE_RELIC" then
				local rownum = 0;
				repeat
					rownum = rownum + 1;
				until (UpgradeListDBVar.char.SecondarySpecList.Ranged.Row[rownum][8] == itemID or UpgradeListDBVar.char.SecondarySpecList.Ranged.Row[rownum] == nil);
				if UpgradeListDBVar.profile.autodelete.messages then
					if UpgradeListDBVar.profile.autodelete.messagelocation == "chatwindow" then
						DEFAULT_CHAT_FRAME:AddMessage("|cFFE08800Upgrade List:|r Auto-deleting " .. UpgradeListDBVar.char.SecondarySpecList.Ranged.Row[rownum][3] .. " from your Secondary Spec's Ranged list.");
					elseif UpgradeListDBVar.profile.autodelete.messagelocation == "scrollwindow" then
						UpgradeListDBVar.profile.messages.scrollwindow:AddMessage("Auto-deleting " .. UpgradeListDBVar.char.SecondarySpecList.Ranged.Row[rownum][3] .. " from your Secondary Spec's Ranged list.");
					end
				end
				for i = #UpgradeListDBVar.char.SecondarySpecList.Ranged.Row, rownum, -1 do
					table.remove(UpgradeListDBVar.char.SecondarySpecList.Ranged.Row);
					UpgradeListDBVar.char.SecondarySpecList.Ranged.Count = UpgradeListDBVar.char.SecondarySpecList.Ranged.Count - 1;
				end
			end
		end
	end
end

local function DecideMainorOffHand(itemID, itemEquipLocation, spec)
	MainHandorOffHand:Show();
	MainHandorOffHandOK:SetScript("OnClick", function (self, button, down)
		if WeaponInMain:GetChecked() then
			UpgradeList:RemoveMultipleItems(itemID, itemEquipLocation, spec, "mainhand");
		elseif WeaponInOff:GetChecked() then
			UpgradeList:RemoveMultipleItems(itemID, itemEquipLocation, spec, "offhand");
		end
		MainHandorOffHand:Hide();
		WeaponInOff:SetChecked(false);
		WeaponInMain:SetChecked(true);
		UpgradeListMainFrame:EnableMouse(true)
		CloseButton:EnableMouse(true)
		ToggleButton:EnableMouse(true)
		UpgradeListDBVar.char.SavedOptions.PrimaryCheck:EnableMouse(true)
		UpgradeListDBVar.char.SavedOptions.SecondaryCheck:EnableMouse(true)
		OptionsFrame:EnableMouse(true)
		ItemEntryBox:EnableMouse(true)
		DropDown_Button:EnableMouse(true)
		NoteEntryBox:EnableMouse(true)
		PrimarySpecRadioButton:EnableMouse(true)
		SecondarySpecRadioButton:EnableMouse(true)
		priorityfield:EnableMouse(true)
		AddButton:EnableMouse(true)
		tofield:EnableMouse(true)
		fromfield:EnableMouse(true)
		MoveButton:EnableMouse(true)
		DeleteButton:EnableMouse(true)
		deletefield:EnableMouse(true)
	end);
end

local function DecideSpec(itemID, itemEquipLocation, weaponinmainprimary, weaponinoffprimary, weaponinmainsecondary, weaponinoffsecondary)
	SpecInput:Show();
	SpecInputOK:SetScript("OnClick", function (self, button, down)
		if MainSpecCheck:GetChecked() then
			if weaponinmainprimary == true and weaponinoffprimary == true then
				SpecInput:Hide();
				DecideMainorOffHand(itemID, itemEqiupLocation, "mainspec")
			else
				UpgradeList:RemoveMultipleItems(itemID, itemEquipLocation, "mainspec", nil);
			end
		elseif OffSpecCheck:GetChecked() then
			if weaponinmainsecondary == true and weaponinoffsecondary == true then
				SpecInput:Hide();
				DecideMainorOffHand(itemID, itemEquipLocation, "offspec")
			else
				UpgradeList:RemoveMultipleItems(itemID, itemEquipLocation, "offspec", nil);
			end
		end
		SpecInput:Hide();
		OffSpecCheck:SetChecked(false);
		MainSpecCheck:SetChecked(true);
		UpgradeListMainFrame:EnableMouse(true)
		CloseButton:EnableMouse(true)
		ToggleButton:EnableMouse(true)
		UpgradeListDBVar.char.SavedOptions.PrimaryCheck:EnableMouse(true)
		UpgradeListDBVar.char.SavedOptions.SecondaryCheck:EnableMouse(true)
		OptionsFrame:EnableMouse(true)
		ItemEntryBox:EnableMouse(true)
		DropDown_Button:EnableMouse(true)
		NoteEntryBox:EnableMouse(true)
		PrimarySpecRadioButton:EnableMouse(true)
		SecondarySpecRadioButton:EnableMouse(true)
		priorityfield:EnableMouse(true)
		AddButton:EnableMouse(true)
		tofield:EnableMouse(true)
		fromfield:EnableMouse(true)
		MoveButton:EnableMouse(true)
		DeleteButton:EnableMouse(true)
		deletefield:EnableMouse(true)
	end);
end

function UpgradeList:AutoDelete(itemID, itemEquipLocation, primaryspecflag, secondaryspecflag, weaponinmainprimary, weaponinoffprimary, weaponinmainsecondary, weaponinoffsecondary)
	if primaryspecflag == true and secondaryspecflag == true then --if acquired item was in both specs
		if UpgradeListDBVar.profile.autodelete.choice == 1 then
			--Consider the item for the player's main spec
			if weaponinmainprimary == true and weaponinoffprimary == true then --if the acquired item is a 1-handed weapon in the primary spec's Main Hand list and Off Hand list
				if UpgradeListDBVar.profile.onehandweapon.choice == 1 then --Consider the weapon as in the Main Hand list
					UpgradeList:RemoveMultipleItems(itemID, itemEquipLocation, "mainspec", "mainhand");
				elseif UpgradeListDBVar.profile.onehandweapon.choice == 2 then --Consider the weapon as in the Off Hand list
					UpgradeList:RemoveMultipleItems(itemID, itemEquipLocation, "mainspec", "offhand");
				elseif UpgradeListDBVar.profile.onehandweapon.choice == 4 then --Ask the user which list the weapon is in
					DecideMainorOffHand(itemID, itemEquipLocation, "mainspec");
				else
					return;
				end
			elseif weaponinmainprimary == true then
				UpgradeList:RemoveMultipleItems(itemID, itemEquipLocation, "mainspec", "mainhand");
			elseif weaponinoffprimary == true then
				UpgradeList:RemoveMultipleItems(itemID, itemEquipLocation, "mainspec", "offhand");
			else
				UpgradeList:RemoveMultipleItems(itemID, itemEquipLocation, "mainspec", nil); --Not a 1-handed weapon in main spec
			end
		elseif UpgradeListDBVar.profile.autodelete.choice == 2 then
			--Consider the item for the player's off spec
			if weaponinmainsecondary == true and weaponinoffsecondary == true then --if the acquired item is a 1-handed weapon in the secondary spec's Main Hand list and Off Hand list
				if UpgradeListDBVar.profile.onehandweapon.choice == 1 then --Consider the weapon as in the Main Hand list
					UpgradeList:RemoveMultipleItems(itemID, itemEquipLocation, "offspec", "mainhand");
				elseif UpgradeListDBVar.profile.onehandweapon.choice == 2 then --Consider the weapon as in the Off Hand list
					UpgradeList:RemoveMultipleItems(itemID, itemEquipLocation, "offspec", "offhand");
				elseif UpgradeListDBVar.profile.onehandweapon.choice == 4 then --Ask the user which list the weapon is in
					DecideMainorOffHand(itemID, itemEquipLocation, "offspec");
				else --Do nothing
					return;
				end
			elseif weaponinmainsecondary == true then
				UpgradeList:RemoveMultipleItems(itemID, itemEquipLocation, "offspec", "mainhand");
			elseif weaponinoffsecondary == true then
				UpgradeList:RemoveMultipleItems(itemID, itemEquipLocation, "offspec", "offhand");
			else
				UpgradeList:RemoveMultipleItems(itemID, itemEquipLocation, "offspec", nil); --Not a 1-handed weapon in off spec
			end
		elseif UpgradeListDBVar.profile.autodelete.choice == 4 then
			DecideSpec(itemID, itemEquipLocation, weaponinmainprimary, weaponinoffprimary, weaponinmainsecondary, weaponinoffsecondary); --Figures out spec & if the item is a 1-handed weapon
		else
			return;
		end
	elseif primaryspecflag == true then --if acquired item was in main spec list only
		--Delete the item and those below it from the main spec list
		if weaponinmainprimary == true and weaponinoffprimary == true then --if the acquired item is a 1-handed weapon in the primary spec's Main Hand list and Off Hand list
			if UpgradeListDBVar.profile.onehandweapon.choice == 1 then --Consider the weapon as in the Main Hand list
				UpgradeList:RemoveMultipleItems(itemID, itemEquipLocation, "mainspec", "mainhand");
			elseif UpgradeListDBVar.profile.onehandweapon.choice == 2 then --Consider the weapon as in the Off Hand list
				UpgradeList:RemoveMultipleItems(itemID, itemEquipLocation, "mainspec", "offhand");
			elseif UpgradeListDBVar.profile.onehandweapon.choice == 4 then --Ask the user which list the weapon is in
				DecideMainorOffHand(itemID, itemEquipLocation, "mainspec");
			else
				return;
			end
		elseif weaponinmainprimary == true and weaponinoffprimary == false then --if the acquired item is a 1-handed weapon in the primary spec's Main Hand list only
			UpgradeList:RemoveMultipleItems(itemID, itemEquipLocation, "mainspec", "mainhand");
		elseif weaponinmainprimary == false and weaponinoffprimary == true then --if the acquired item is a 1-handed weapon in the primary spec's Off Hand list only
			UpgradeList:RemoveMultipleItems(itemID, itemEquipLocation, "mainspec", "offhand");
		else
			UpgradeList:RemoveMultipleItems(itemID, itemEquipLocation, "mainspec", nil); --Not a 1-handed weapon in main spec
		end
	else -- if acquired item was in off spec list only
		--Delete the item and those below it from the off spec list
		if weaponinmainsecondary == true and weaponinoffsecondary == true then --if the acquired item is a 1-handed weapon in the secondary spec's Main Hand list and Off Hand list
			if UpgradeListDBVar.profile.onehandweapon.choice == 1 then --Consider the weapon as in the Main Hand list
				UpgradeList:RemoveMultipleItems(itemID, itemEquipLocation, "offspec", "mainhand");
			elseif UpgradeListDBVar.profile.onehandweapon.choice == 2 then --Consider the weapon as in the Off Hand list
				UpgradeList:RemoveMultipleItems(itemID, itemEquipLocation, "offspec", "offhand");
			elseif UpgradeListDBVar.profile.onehandweapon.choice == 4 then --Ask the user which list the weapon is in
				DecideMainorOffHand(itemID, itemEquipLocation, "offspec");
			else
				return;
			end
		elseif weaponinmainsecondary == true and weaponinoffsecondary == false then --if the acquired item is a 1-handed weapon in the secondary spec's Main Hand list only
			UpgradeList:RemoveMultipleItems(itemID, itemEquipLocation, "offspec", "mainhand");
		elseif weaponinmainsecondary == false and weaponinoffsecondary == true then --if the acquired item is a 1-handed weapon in the secondary spec's Off Hand list only
			UpgradeList:RemoveMultipleItems(itemID, itemEquipLocation, "offspec", "offhand");
		else
			UpgradeList:RemoveMultipleItems(itemID, itemEquipLocation, "offspec", nil); --Not a 1-handed weapon in off spec
		end
	end
end

local function Compare(itemID, itemEquipLocation, attainability)
	local primaryspecflag = false;
	local secondaryspecflag = false;
	local weaponinmainprimary = false;
	local weaponinoffprimary = false;
	local weaponinmainsecondary = false;
	local weaponinoffsecondary = false;
	local otherflag = false;
	if itemEquipLocation == "INVTYPE_HEAD" then
		if UpgradeListDBVar.char.PrimarySpecList.Head.Count > 1 then
			local i = 0;
			repeat
				i = i + 1;
				if itemID == UpgradeListDBVar.char.PrimarySpecList.Head.Row[i][8] then
					if attainability == "potential" then
						if UpgradeListDBVar.profile.messages.potential then
							if UpgradeListDBVar.profile.messages.potentiallocation == "chatwindow" then
								DEFAULT_CHAT_FRAME:AddMessage("|cFFE08800Upgrade List:|r Upgrade Detected for Primary Spec: " .. UpgradeListDBVar.char.PrimarySpecList.Head.Row[i][3]);
							elseif UpgradeListDBVar.profile.messages.potentiallocation == "scrollwindow" then
								UpgradeListDBVar.profile.messages.scrollwindow:AddMessage("Upgrade Detected for Primary Spec: " .. UpgradeListDBVar.char.PrimarySpecList.Head.Row[i][3]);
							end
						end
						if UpgradeListDBVar.profile.sound.potential then
							PlaySoundFile(LSM:Fetch("sound", UpgradeListDBVar.profile.sound.potentialchoice))
						end
					else
						if UpgradeListDBVar.profile.messages.acquired then
							if UpgradeListDBVar.profile.messages.acquiredlocation == "chatwindow" then
								DEFAULT_CHAT_FRAME:AddMessage("|cFFE08800Upgrade List:|r Upgrade Acquired for Primary Spec: " .. UpgradeListDBVar.char.PrimarySpecList.Head.Row[i][3]);
							elseif UpgradeListDBVar.profile.messages.acquiredlocation == "scrollwindow" then
								UpgradeListDBVar.profile.messages.scrollwindow:AddMessage("Upgrade Acquired for Primary Spec: " .. UpgradeListDBVar.char.PrimarySpecList.Head.Row[i][3]);
							end
						end
						if UpgradeListDBVar.profile.sound.acquired then
							PlaySoundFile(LSM:Fetch("sound", UpgradeListDBVar.profile.sound.acquiredchoice))
						end
						primaryspecflag = true;
					end
				end
			until (itemID == UpgradeListDBVar.char.PrimarySpecList.Head.Row[i][8] or i == #UpgradeListDBVar.char.PrimarySpecList.Head.Row);
		end
	elseif itemEquipLocation == "INVTYPE_NECK" then
		if UpgradeListDBVar.char.PrimarySpecList.Neck.Count > 1 then
			local i = 0;
			repeat
				i = i + 1;
				if itemID == UpgradeListDBVar.char.PrimarySpecList.Neck.Row[i][8] then
					if attainability == "potential" then
						if UpgradeListDBVar.profile.messages.potential then
							if UpgradeListDBVar.profile.messages.potentiallocation == "chatwindow" then
								DEFAULT_CHAT_FRAME:AddMessage("|cFFE08800Upgrade List:|r Upgrade Detected for Primary Spec: " .. UpgradeListDBVar.char.PrimarySpecList.Neck.Row[i][3]);
							elseif UpgradeListDBVar.profile.messages.potentiallocation == "scrollwindow" then
								UpgradeListDBVar.profile.messages.scrollwindow:AddMessage("Upgrade Detected for Primary Spec: " .. UpgradeListDBVar.char.PrimarySpecList.Neck.Row[i][3]);
							end
						end
						if UpgradeListDBVar.profile.sound.potential then
							PlaySoundFile(LSM:Fetch("sound", UpgradeListDBVar.profile.sound.potentialchoice))
						end
					else
						if UpgradeListDBVar.profile.messages.acquired then
							if UpgradeListDBVar.profile.messages.acquiredlocation == "chatwindow" then
								DEFAULT_CHAT_FRAME:AddMessage("|cFFE08800Upgrade List:|r Upgrade Acquired for Primary Spec: " .. UpgradeListDBVar.char.PrimarySpecList.Neck.Row[i][3]);
							elseif UpgradeListDBVar.profile.messages.acquiredlocation == "scrollwindow" then
								UpgradeListDBVar.profile.messages.scrollwindow:AddMessage("Upgrade Acquired for Primary Spec: " .. UpgradeListDBVar.char.PrimarySpecList.Neck.Row[i][3]);
							end
						end
						if UpgradeListDBVar.profile.sound.acquired then
							PlaySoundFile(LSM:Fetch("sound", UpgradeListDBVar.profile.sound.acquiredchoice))
						end
						primaryspecflag = true;
					end
				end
			until (itemID == UpgradeListDBVar.char.PrimarySpecList.Neck.Row[i][8] or i == #UpgradeListDBVar.char.PrimarySpecList.Neck.Row);
		end
	elseif itemEquipLocation == "INVTYPE_SHOULDER" then
		if UpgradeListDBVar.char.PrimarySpecList.Shoulder.Count > 1 then
			local i = 0;
			repeat
				i = i + 1;
				if itemID == UpgradeListDBVar.char.PrimarySpecList.Shoulder.Row[i][8] then
					if attainability == "potential" then
						if UpgradeListDBVar.profile.messages.potential then
							if UpgradeListDBVar.profile.messages.potentiallocation == "chatwindow" then
								DEFAULT_CHAT_FRAME:AddMessage("|cFFE08800Upgrade List:|r Upgrade Detected for Primary Spec: " .. UpgradeListDBVar.char.PrimarySpecList.Shoulder.Row[i][3]);
							elseif UpgradeListDBVar.profile.messages.potentiallocation == "scrollwindow" then
								UpgradeListDBVar.profile.messages.scrollwindow:AddMessage("Upgrade Detected for Primary Spec: " .. UpgradeListDBVar.char.PrimarySpecList.Shoulder.Row[i][3]);
							end
						end
						if UpgradeListDBVar.profile.sound.potential then
							PlaySoundFile(LSM:Fetch("sound", UpgradeListDBVar.profile.sound.potentialchoice))
						end
					else
						if UpgradeListDBVar.profile.messages.acquired then
							if UpgradeListDBVar.profile.messages.acquiredlocation == "chatwindow" then
								DEFAULT_CHAT_FRAME:AddMessage("|cFFE08800Upgrade List:|r Upgrade Acquired for Primary Spec: " .. UpgradeListDBVar.char.PrimarySpecList.Shoulder.Row[i][3]);
							elseif UpgradeListDBVar.profile.messages.acquiredlocation == "scrollwindow" then
								UpgradeListDBVar.profile.messages.scrollwindow:AddMessage("Upgrade Acquired for Primary Spec: " .. UpgradeListDBVar.char.PrimarySpecList.Shoulder.Row[i][3]);
							end
						end
						if UpgradeListDBVar.profile.sound.acquired then
							PlaySoundFile(LSM:Fetch("sound", UpgradeListDBVar.profile.sound.acquiredchoice))
						end
						primaryspecflag = true;
					end
				end
			until (itemID == UpgradeListDBVar.char.PrimarySpecList.Shoulder.Row[i][8] or i == #UpgradeListDBVar.char.PrimarySpecList.Shoulder.Row);
		end
	elseif itemEquipLocation == "INVTYPE_CLOAK" then
		if UpgradeListDBVar.char.PrimarySpecList.Back.Count > 1 then
			local i = 0;
			repeat
				i = i + 1;
				if itemID == UpgradeListDBVar.char.PrimarySpecList.Back.Row[i][8] then
					if attainability == "potential" then
						if UpgradeListDBVar.profile.messages.potential then
							if UpgradeListDBVar.profile.messages.potentiallocation == "chatwindow" then
								DEFAULT_CHAT_FRAME:AddMessage("|cFFE08800Upgrade List:|r Upgrade Detected for Primary Spec: " .. UpgradeListDBVar.char.PrimarySpecList.Back.Row[i][3]);
							elseif UpgradeListDBVar.profile.messages.potentiallocation == "scrollwindow" then
								UpgradeListDBVar.profile.messages.scrollwindow:AddMessage("Upgrade Detected for Primary Spec: " .. UpgradeListDBVar.char.PrimarySpecList.Back.Row[i][3]);
							end
						end
						if UpgradeListDBVar.profile.sound.potential then
							PlaySoundFile(LSM:Fetch("sound", UpgradeListDBVar.profile.sound.potentialchoice))
						end
					else
						if UpgradeListDBVar.profile.messages.acquired then
							if UpgradeListDBVar.profile.messages.acquiredlocation == "chatwindow" then
								DEFAULT_CHAT_FRAME:AddMessage("|cFFE08800Upgrade List:|r Upgrade Acquired for Primary Spec: " .. UpgradeListDBVar.char.PrimarySpecList.Back.Row[i][3]);
							elseif UpgradeListDBVar.profile.messages.acquiredlocation == "scrollwindow" then
								UpgradeListDBVar.profile.messages.scrollwindow:AddMessage("Upgrade Acquired for Primary Spec: " .. UpgradeListDBVar.char.PrimarySpecList.Back.Row[i][3]);
							end
						end
						if UpgradeListDBVar.profile.sound.acquired then
							PlaySoundFile(LSM:Fetch("sound", UpgradeListDBVar.profile.sound.acquiredchoice))
						end
						primaryspecflag = true;
					end
				end
			until (itemID == UpgradeListDBVar.char.PrimarySpecList.Back.Row[i][8] or i == #UpgradeListDBVar.char.PrimarySpecList.Back.Row);
		end
	elseif itemEquipLocation == "INVTYPE_CHEST" or itemEquipLocation == "INVTYPE_ROBE" then
		if UpgradeListDBVar.char.PrimarySpecList.Chest.Count > 1 then
			local i = 0;
			repeat
				i = i + 1;
				if itemID == UpgradeListDBVar.char.PrimarySpecList.Chest.Row[i][8] then
					if attainability == "potential" then
						if UpgradeListDBVar.profile.messages.potential then
							if UpgradeListDBVar.profile.messages.potentiallocation == "chatwindow" then
								DEFAULT_CHAT_FRAME:AddMessage("|cFFE08800Upgrade List:|r Upgrade Detected for Primary Spec: " .. UpgradeListDBVar.char.PrimarySpecList.Chest.Row[i][3]);
							elseif UpgradeListDBVar.profile.messages.potentiallocation == "scrollwindow" then
								UpgradeListDBVar.profile.messages.scrollwindow:AddMessage("Upgrade Detected for Primary Spec: " .. UpgradeListDBVar.char.PrimarySpecList.Chest.Row[i][3]);
							end
						end
						if UpgradeListDBVar.profile.sound.potential then
							PlaySoundFile(LSM:Fetch("sound", UpgradeListDBVar.profile.sound.potentialchoice))
						end
					else
						if UpgradeListDBVar.profile.messages.acquired then
							if UpgradeListDBVar.profile.messages.acquiredlocation == "chatwindow" then
								DEFAULT_CHAT_FRAME:AddMessage("|cFFE08800Upgrade List:|r Upgrade Acquired for Primary Spec: " .. UpgradeListDBVar.char.PrimarySpecList.Chest.Row[i][3]);
							elseif UpgradeListDBVar.profile.messages.acquiredlocation == "scrollwindow" then
								UpgradeListDBVar.profile.messages.scrollwindow:AddMessage("Upgrade Acquired for Primary Spec: " .. UpgradeListDBVar.char.PrimarySpecList.Chest.Row[i][3]);
							end
						end
						if UpgradeListDBVar.profile.sound.acquired then
							PlaySoundFile(LSM:Fetch("sound", UpgradeListDBVar.profile.sound.acquiredchoice))
						end
						primaryspecflag = true;
					end
				end
			until (itemID == UpgradeListDBVar.char.PrimarySpecList.Chest.Row[i][8] or i == #UpgradeListDBVar.char.PrimarySpecList.Chest.Row);
		end
	elseif itemEquipLocation == "INVTYPE_WRIST" then
		if UpgradeListDBVar.char.PrimarySpecList.Wrist.Count > 1 then
			local i = 0;
			repeat
				i = i + 1;
				if itemID == UpgradeListDBVar.char.PrimarySpecList.Wrist.Row[i][8] then
					if attainability == "potential" then
						if UpgradeListDBVar.profile.messages.potential then
							if UpgradeListDBVar.profile.messages.potentiallocation == "chatwindow" then
								DEFAULT_CHAT_FRAME:AddMessage("|cFFE08800Upgrade List:|r Upgrade Detected for Primary Spec: " .. UpgradeListDBVar.char.PrimarySpecList.Wrist.Row[i][3]);
							elseif UpgradeListDBVar.profile.messages.potentiallocation == "scrollwindow" then
								UpgradeListDBVar.profile.messages.scrollwindow:AddMessage("Upgrade Detected for Primary Spec: " .. UpgradeListDBVar.char.PrimarySpecList.Wrist.Row[i][3]);
							end
						end
						if UpgradeListDBVar.profile.sound.potential then
							PlaySoundFile(LSM:Fetch("sound", UpgradeListDBVar.profile.sound.potentialchoice))
						end
					else
						if UpgradeListDBVar.profile.messages.acquired then
							if UpgradeListDBVar.profile.messages.acquiredlocation == "chatwindow" then
								DEFAULT_CHAT_FRAME:AddMessage("|cFFE08800Upgrade List:|r Upgrade Acquired for Primary Spec: " .. UpgradeListDBVar.char.PrimarySpecList.Wrist.Row[i][3]);
							elseif UpgradeListDBVar.profile.messages.acquiredlocation == "scrollwindow" then
								UpgradeListDBVar.profile.messages.scrollwindow:AddMessage("Upgrade Acquired for Primary Spec: " .. UpgradeListDBVar.char.PrimarySpecList.Wrist.Row[i][3]);
							end
						end
						if UpgradeListDBVar.profile.sound.acquired then
							PlaySoundFile(LSM:Fetch("sound", UpgradeListDBVar.profile.sound.acquiredchoice))
						end
						primaryspecflag = true;
					end
				end
			until (itemID == UpgradeListDBVar.char.PrimarySpecList.Wrist.Row[i][8] or i == #UpgradeListDBVar.char.PrimarySpecList.Wrist.Row);
		end
	elseif itemEquipLocation == "INVTYPE_HAND" then
		if UpgradeListDBVar.char.PrimarySpecList.Hand.Count > 1 then
			local i = 0;
			repeat
				i = i + 1;
				if itemID == UpgradeListDBVar.char.PrimarySpecList.Hand.Row[i][8] then
					if attainability == "potential" then
						if UpgradeListDBVar.profile.messages.potential then
							if UpgradeListDBVar.profile.messages.potentiallocation == "chatwindow" then
								DEFAULT_CHAT_FRAME:AddMessage("|cFFE08800Upgrade List:|r Upgrade Detected for Primary Spec: " .. UpgradeListDBVar.char.PrimarySpecList.Hand.Row[i][3]);
							elseif UpgradeListDBVar.profile.messages.potentiallocation == "scrollwindow" then
								UpgradeListDBVar.profile.messages.scrollwindow:AddMessage("Upgrade Detected for Primary Spec: " .. UpgradeListDBVar.char.PrimarySpecList.Hand.Row[i][3]);
							end						end
						if UpgradeListDBVar.profile.sound.potential then
							PlaySoundFile(LSM:Fetch("sound", UpgradeListDBVar.profile.sound.potentialchoice))
						end
					else
						if UpgradeListDBVar.profile.messages.acquired then
							if UpgradeListDBVar.profile.messages.acquiredlocation == "chatwindow" then
								DEFAULT_CHAT_FRAME:AddMessage("|cFFE08800Upgrade List:|r Upgrade Acquired for Primary Spec: " .. UpgradeListDBVar.char.PrimarySpecList.Hand.Row[i][3]);
							elseif UpgradeListDBVar.profile.messages.acquiredlocation == "scrollwindow" then
								UpgradeListDBVar.profile.messages.scrollwindow:AddMessage("Upgrade Acquired for Primary Spec: " .. UpgradeListDBVar.char.PrimarySpecList.Hand.Row[i][3]);
							end
						end
						if UpgradeListDBVar.profile.sound.acquired then
							PlaySoundFile(LSM:Fetch("sound", UpgradeListDBVar.profile.sound.acquiredchoice))
						end
						primaryspecflag = true;
					end
				end
			until (itemID == UpgradeListDBVar.char.PrimarySpecList.Hand.Row[i][8] or i == #UpgradeListDBVar.char.PrimarySpecList.Hand.Row);
		end
	elseif itemEquipLocation == "INVTYPE_WAIST" then
		if UpgradeListDBVar.char.PrimarySpecList.Waist.Count > 1 then
			local i = 0;
			repeat
				i = i + 1;
				if itemID == UpgradeListDBVar.char.PrimarySpecList.Waist.Row[i][8] then
					if attainability == "potential" then
						if UpgradeListDBVar.profile.messages.potential then
							if UpgradeListDBVar.profile.messages.potentiallocation == "chatwindow" then
								DEFAULT_CHAT_FRAME:AddMessage("|cFFE08800Upgrade List:|r Upgrade Detected for Primary Spec: " .. UpgradeListDBVar.char.PrimarySpecList.Waist.Row[i][3]);
							elseif UpgradeListDBVar.profile.messages.potentiallocation == "scrollwindow" then
								UpgradeListDBVar.profile.messages.scrollwindow:AddMessage("Upgrade Detected for Primary Spec: " .. UpgradeListDBVar.char.PrimarySpecList.Waist.Row[i][3]);
							end
						end
						if UpgradeListDBVar.profile.sound.potential then
							PlaySoundFile(LSM:Fetch("sound", UpgradeListDBVar.profile.sound.potentialchoice))
						end
					else
						if UpgradeListDBVar.profile.messages.acquired then
							if UpgradeListDBVar.profile.messages.acquiredlocation == "chatwindow" then
								DEFAULT_CHAT_FRAME:AddMessage("|cFFE08800Upgrade List:|r Upgrade Acquired for Primary Spec: " .. UpgradeListDBVar.char.PrimarySpecList.Waist.Row[i][3]);
							elseif UpgradeListDBVar.profile.messages.acquiredlocation == "scrollwindow" then
								UpgradeListDBVar.profile.messages.scrollwindow:AddMessage("Upgrade Acquired for Primary Spec: " .. UpgradeListDBVar.char.PrimarySpecList.Waist.Row[i][3]);
							end
						end
						if UpgradeListDBVar.profile.sound.acquired then
							PlaySoundFile(LSM:Fetch("sound", UpgradeListDBVar.profile.sound.acquiredchoice))
						end
						primaryspecflag = true;
					end
				end
			until (itemID == UpgradeListDBVar.char.PrimarySpecList.Waist.Row[i][8] or i == #UpgradeListDBVar.char.PrimarySpecList.Waist.Row);
		end
	elseif itemEquipLocation == "INVTYPE_LEGS" then
		if UpgradeListDBVar.char.PrimarySpecList.Leg.Count > 1 then
			local i = 0;
			repeat
				i = i + 1;
				if itemID == UpgradeListDBVar.char.PrimarySpecList.Leg.Row[i][8] then
					if attainability == "potential" then
						if UpgradeListDBVar.profile.messages.potential then
							if UpgradeListDBVar.profile.messages.potentiallocation == "chatwindow" then
								DEFAULT_CHAT_FRAME:AddMessage("|cFFE08800Upgrade List:|r Upgrade Detected for Primary Spec: " .. UpgradeListDBVar.char.PrimarySpecList.Leg.Row[i][3]);
							elseif UpgradeListDBVar.profile.messages.potentiallocation == "scrollwindow" then
								UpgradeListDBVar.profile.messages.scrollwindow:AddMessage("Upgrade Detected for Primary Spec: " .. UpgradeListDBVar.char.PrimarySpecList.Leg.Row[i][3]);
							end
						end
						if UpgradeListDBVar.profile.sound.potential then
							PlaySoundFile(LSM:Fetch("sound", UpgradeListDBVar.profile.sound.potentialchoice))
						end
					else
						if UpgradeListDBVar.profile.messages.acquired then
							if UpgradeListDBVar.profile.messages.acquiredlocation == "chatwindow" then
								DEFAULT_CHAT_FRAME:AddMessage("|cFFE08800Upgrade List:|r Upgrade Acquired for Primary Spec: " .. UpgradeListDBVar.char.PrimarySpecList.Leg.Row[i][3]);
							elseif UpgradeListDBVar.profile.messages.acquiredlocation == "scrollwindow" then
								UpgradeListDBVar.profile.messages.scrollwindow:AddMessage("Upgrade Acquired for Primary Spec: " .. UpgradeListDBVar.char.PrimarySpecList.Leg.Row[i][3]);
							end
						end
						if UpgradeListDBVar.profile.sound.acquired then
							PlaySoundFile(LSM:Fetch("sound", UpgradeListDBVar.profile.sound.acquiredchoice))
						end
						primaryspecflag = true;
					end
				end
			until (itemID == UpgradeListDBVar.char.PrimarySpecList.Leg.Row[i][8] or i == #UpgradeListDBVar.char.PrimarySpecList.Leg.Row);
		end
	elseif itemEquipLocation == "INVTYPE_FEET" then
		if UpgradeListDBVar.char.PrimarySpecList.Foot.Count > 1 then
			local i = 0;
			repeat
				i = i + 1;
				if itemID == UpgradeListDBVar.char.PrimarySpecList.Foot.Row[i][8] then
					if attainability == "potential" then
						if UpgradeListDBVar.profile.messages.potential then
							if UpgradeListDBVar.profile.messages.potentiallocation == "chatwindow" then
								DEFAULT_CHAT_FRAME:AddMessage("|cFFE08800Upgrade List:|r Upgrade Detected for Primary Spec: " .. UpgradeListDBVar.char.PrimarySpecList.Foot.Row[i][3]);
							elseif UpgradeListDBVar.profile.messages.potentiallocation == "scrollwindow" then
								UpgradeListDBVar.profile.messages.scrollwindow:AddMessage("Upgrade Detected for Primary Spec: " .. UpgradeListDBVar.char.PrimarySpecList.Foot.Row[i][3]);
							end
						end
						if UpgradeListDBVar.profile.sound.potential then
							PlaySoundFile(LSM:Fetch("sound", UpgradeListDBVar.profile.sound.potentialchoice))
						end
					else
						if UpgradeListDBVar.profile.messages.acquired then
							if UpgradeListDBVar.profile.messages.acquiredlocation == "chatwindow" then
								DEFAULT_CHAT_FRAME:AddMessage("|cFFE08800Upgrade List:|r Upgrade Acquired for Primary Spec: " .. UpgradeListDBVar.char.PrimarySpecList.Foot.Row[i][3]);
							elseif UpgradeListDBVar.profile.messages.acquiredlocation == "scrollwindow" then
								UpgradeListDBVar.profile.messages.scrollwindow:AddMessage("Upgrade Acquired for Primary Spec: " .. UpgradeListDBVar.char.PrimarySpecList.Foot.Row[i][3]);
							end
						end
						if UpgradeListDBVar.profile.sound.acquired then
							PlaySoundFile(LSM:Fetch("sound", UpgradeListDBVar.profile.sound.acquiredchoice))
						end
						primaryspecflag = true;
					end
				end
			until (itemID == UpgradeListDBVar.char.PrimarySpecList.Foot.Row[i][8] or i == #UpgradeListDBVar.char.PrimarySpecList.Foot.Row);
		end
	elseif itemEquipLocation == "INVTYPE_FINGER" then
		if UpgradeListDBVar.char.PrimarySpecList.Ring.Count > 1 then
			local i = 0;
			repeat
				i = i + 1;
				if itemID == UpgradeListDBVar.char.PrimarySpecList.Ring.Row[i][8] then
					if attainability == "potential" then
						if UpgradeListDBVar.profile.messages.potential then
							if UpgradeListDBVar.profile.messages.potentiallocation == "chatwindow" then
								DEFAULT_CHAT_FRAME:AddMessage("|cFFE08800Upgrade List:|r Upgrade Detected for Primary Spec: " .. UpgradeListDBVar.char.PrimarySpecList.Ring.Row[i][3]);
							elseif UpgradeListDBVar.profile.messages.potentiallocation == "scrollwindow" then
								UpgradeListDBVar.profile.messages.scrollwindow:AddMessage("Upgrade Detected for Primary Spec: " .. UpgradeListDBVar.char.PrimarySpecList.Ring.Row[i][3]);
							end
						end
						if UpgradeListDBVar.profile.sound.potential then
							PlaySoundFile(LSM:Fetch("sound", UpgradeListDBVar.profile.sound.potentialchoice))
						end
					else
						if UpgradeListDBVar.profile.messages.acquired then
							if UpgradeListDBVar.profile.messages.acquiredlocation == "chatwindow" then
								DEFAULT_CHAT_FRAME:AddMessage("|cFFE08800Upgrade List:|r Upgrade Acquired for Primary Spec: " .. UpgradeListDBVar.char.PrimarySpecList.Ring.Row[i][3]);
							elseif UpgradeListDBVar.profile.messages.acquiredlocation == "scrollwindow" then
								UpgradeListDBVar.profile.messages.scrollwindow:AddMessage("Upgrade Acquired for Primary Spec: " .. UpgradeListDBVar.char.PrimarySpecList.Ring.Row[i][3]);
							end
						end
						if UpgradeListDBVar.profile.sound.acquired then
							PlaySoundFile(LSM:Fetch("sound", UpgradeListDBVar.profile.sound.acquiredchoice))
						end
						primaryspecflag = true;
					end
				end
			until (itemID == UpgradeListDBVar.char.PrimarySpecList.Ring.Row[i][8] or i == #UpgradeListDBVar.char.PrimarySpecList.Ring.Row);
		end
	elseif itemEquipLocation == "INVTYPE_TRINKET" then
		if UpgradeListDBVar.char.PrimarySpecList.Trinket.Count > 1 then
			local i = 0;
			repeat
				i = i + 1;
				if itemID == UpgradeListDBVar.char.PrimarySpecList.Trinket.Row[i][8] then
					if attainability == "potential" then
						if UpgradeListDBVar.profile.messages.potential then
							if UpgradeListDBVar.profile.messages.potentiallocation == "chatwindow" then
								DEFAULT_CHAT_FRAME:AddMessage("|cFFE08800Upgrade List:|r Upgrade Detected for Primary Spec: " .. UpgradeListDBVar.char.PrimarySpecList.Trinket.Row[i][3]);
							elseif UpgradeListDBVar.profile.messages.potentiallocation == "scrollwindow" then
								UpgradeListDBVar.profile.messages.scrollwindow:AddMessage("Upgrade Detected for Primary Spec: " .. UpgradeListDBVar.char.PrimarySpecList.Trinket.Row[i][3]);
							end
						end
						if UpgradeListDBVar.profile.sound.potential then
							PlaySoundFile(LSM:Fetch("sound", UpgradeListDBVar.profile.sound.potentialchoice))
						end
					else
						if UpgradeListDBVar.profile.messages.acquired then
							if UpgradeListDBVar.profile.messages.acquiredlocation == "chatwindow" then
								DEFAULT_CHAT_FRAME:AddMessage("|cFFE08800Upgrade List:|r Upgrade Acquired for Primary Spec: " .. UpgradeListDBVar.char.PrimarySpecList.Trinket.Row[i][3]);
							elseif UpgradeListDBVar.profile.messages.acquiredlocation == "scrollwindow" then
								UpgradeListDBVar.profile.messages.scrollwindow:AddMessage("Upgrade Acquired for Primary Spec: " .. UpgradeListDBVar.char.PrimarySpecList.Trinket.Row[i][3]);
							end
						end
						if UpgradeListDBVar.profile.sound.acquired then
							PlaySoundFile(LSM:Fetch("sound", UpgradeListDBVar.profile.sound.acquiredchoice))
						end
						primaryspecflag = true;
					end
				end
			until (itemID == UpgradeListDBVar.char.PrimarySpecList.Trinket.Row[i][8] or i == #UpgradeListDBVar.char.PrimarySpecList.Trinket.Row);
		end
	elseif itemEquipLocation == "INVTYPE_2HWEAPON" or itemEquipLocation == "INVTYPE_MAINHANDWEAPON" then
		if UpgradeListDBVar.char.PrimarySpecList.Main.Count > 1 then
			local i = 0;
			repeat
				i = i + 1;
				if itemID == UpgradeListDBVar.char.PrimarySpecList.Main.Row[i][8] then
					if attainability == "potential" then
						if UpgradeListDBVar.profile.messages.potential then
							if UpgradeListDBVar.profile.messages.potentiallocation == "chatwindow" then
								DEFAULT_CHAT_FRAME:AddMessage("|cFFE08800Upgrade List:|r Upgrade Detected for Primary Spec: " .. UpgradeListDBVar.char.PrimarySpecList.Main.Row[i][3]);
							elseif UpgradeListDBVar.profile.messages.potentiallocation == "scrollwindow" then
								UpgradeListDBVar.profile.messages.scrollwindow:AddMessage("Upgrade Detected for Primary Spec: " .. UpgradeListDBVar.char.PrimarySpecList.Main.Row[i][3]);
							end
						end
						if UpgradeListDBVar.profile.sound.potential then
							PlaySoundFile(LSM:Fetch("sound", UpgradeListDBVar.profile.sound.potentialchoice))
						end
					else
						if UpgradeListDBVar.profile.messages.acquired then
							if UpgradeListDBVar.profile.messages.acquiredlocation == "chatwindow" then
								DEFAULT_CHAT_FRAME:AddMessage("|cFFE08800Upgrade List:|r Upgrade Acquired for Primary Spec: " .. UpgradeListDBVar.char.PrimarySpecList.Main.Row[i][3]);
							elseif UpgradeListDBVar.profile.messages.acquiredlocation == "scrollwindow" then
								UpgradeListDBVar.profile.messages.scrollwindow:AddMessage("Upgrade Acquired for Primary Spec: " .. UpgradeListDBVar.char.PrimarySpecList.Main.Row[i][3]);
							end
						end
						if UpgradeListDBVar.profile.sound.acquired then
							PlaySoundFile(LSM:Fetch("sound", UpgradeListDBVar.profile.sound.acquiredchoice))
						end
						primaryspecflag = true;
					end
				end
			until (itemID == UpgradeListDBVar.char.PrimarySpecList.Main.Row[i][8] or i == #UpgradeListDBVar.char.PrimarySpecList.Main.Row);
		end
	elseif itemEquipLocation == "INVTYPE_SHIELD" or itemEquipLocation == "INVTYPE_OFFHANDWEAPON" or itemEquipLocation == "INVTYPE_HOLDABLE" then
		if UpgradeListDBVar.char.PrimarySpecList.Off.Count > 1 then
			local i = 0;
			repeat
				i = i + 1;
				if itemID == UpgradeListDBVar.char.PrimarySpecList.Off.Row[i][8] then
					if attainability == "potential" then
						if UpgradeListDBVar.profile.messages.potential then
							if UpgradeListDBVar.profile.messages.potentiallocation == "chatwindow" then
								DEFAULT_CHAT_FRAME:AddMessage("|cFFE08800Upgrade List:|r Upgrade Detected for Primary Spec: " .. UpgradeListDBVar.char.PrimarySpecList.Off.Row[i][3]);
							elseif UpgradeListDBVar.profile.messages.potentiallocation == "scrollwindow" then
								UpgradeListDBVar.profile.messages.scrollwindow:AddMessage("Upgrade Detected for Primary Spec: " .. UpgradeListDBVar.char.PrimarySpecList.Off.Row[i][3]);
							end
						end
						if UpgradeListDBVar.profile.sound.potential then
							PlaySoundFile(LSM:Fetch("sound", UpgradeListDBVar.profile.sound.potentialchoice))
						end
					else
						if UpgradeListDBVar.profile.messages.acquired then
							if UpgradeListDBVar.profile.messages.acquiredlocation == "chatwindow" then
								DEFAULT_CHAT_FRAME:AddMessage("|cFFE08800Upgrade List:|r Upgrade Acquired for Primary Spec: " .. UpgradeListDBVar.char.PrimarySpecList.Off.Row[i][3]);
							elseif UpgradeListDBVar.profile.messages.acquiredlocation == "scrollwindow" then
								UpgradeListDBVar.profile.messages.scrollwindow:AddMessage("Upgrade Acquired for Primary Spec: " .. UpgradeListDBVar.char.PrimarySpecList.Off.Row[i][3]);
							end
						end
						if UpgradeListDBVar.profile.sound.acquired then
							PlaySoundFile(LSM:Fetch("sound", UpgradeListDBVar.profile.sound.acquiredchoice))
						end
						primaryspecflag = true;
					end
				end
			until (itemID == UpgradeListDBVar.char.PrimarySpecList.Off.Row[i][8] or i == #UpgradeListDBVar.char.PrimarySpecList.Off.Row);
		end
	elseif itemEquipLocation == "INVTYPE_RANGED" or itemEquipLocation == "INVTYPE_THROWN" or itemEquipLocation == "INVTYPE_RANGEDRIGHT" or itemEquipLocation == "INVTYPE_RELIC" then
		if UpgradeListDBVar.char.PrimarySpecList.Ranged.Count > 1 then
			local i = 0;
			repeat
				i = i + 1;
				if itemID == UpgradeListDBVar.char.PrimarySpecList.Ranged.Row[i][8] then
					if attainability == "potential" then
						if UpgradeListDBVar.profile.messages.potential then
							if UpgradeListDBVar.profile.messages.potentiallocation == "chatwindow" then
								DEFAULT_CHAT_FRAME:AddMessage("|cFFE08800Upgrade List:|r Upgrade Detected for Primary Spec: " .. UpgradeListDBVar.char.PrimarySpecList.Ranged.Row[i][3]);
							elseif UpgradeListDBVar.profile.messages.potentiallocation == "scrollwindow" then
								UpgradeListDBVar.profile.messages.scrollwindow:AddMessage("Upgrade Detected for Primary Spec: " .. UpgradeListDBVar.char.PrimarySpecList.Ranged.Row[i][3]);
							end
						end
						if UpgradeListDBVar.profile.sound.potential then
							PlaySoundFile(LSM:Fetch("sound", UpgradeListDBVar.profile.sound.potentialchoice))
						end
					else
						if UpgradeListDBVar.profile.messages.acquired then
							if UpgradeListDBVar.profile.messages.acquiredlocation == "chatwindow" then
								DEFAULT_CHAT_FRAME:AddMessage("|cFFE08800Upgrade List:|r Upgrade Acquired for Primary Spec: " .. UpgradeListDBVar.char.PrimarySpecList.Ranged.Row[i][3]);
							elseif UpgradeListDBVar.profile.messages.acquiredlocation == "scrollwindow" then
								UpgradeListDBVar.profile.messages.scrollwindow:AddMessage("Upgrade Acquired for Primary Spec: " .. UpgradeListDBVar.char.PrimarySpecList.Ranged.Row[i][3]);
							end
						end
						if UpgradeListDBVar.profile.sound.acquired then
							PlaySoundFile(LSM:Fetch("sound", UpgradeListDBVar.profile.sound.acquiredchoice))
						end
						primaryspecflag = true;
					end
				end
			until (itemID == UpgradeListDBVar.char.PrimarySpecList.Ranged.Row[i][8] or i == #UpgradeListDBVar.char.PrimarySpecList.Ranged.Row);
		end
	elseif itemEquipLocation == "INVTYPE_WEAPON" then
		if UpgradeListDBVar.char.PrimarySpecList.Main.Count > 1 then
			local i = 0;
			repeat
				i = i + 1;
				if itemID == UpgradeListDBVar.char.PrimarySpecList.Main.Row[i][8] then
					if attainability == "potential" then
						if UpgradeListDBVar.profile.messages.potential then
							if UpgradeListDBVar.profile.messages.potentiallocation == "chatwindow" then
								DEFAULT_CHAT_FRAME:AddMessage("|cFFE08800Upgrade List:|r Upgrade Detected for Primary Spec: " .. UpgradeListDBVar.char.PrimarySpecList.Main.Row[i][3]);
							elseif UpgradeListDBVar.profile.messages.potentiallocation == "scrollwindow" then
								UpgradeListDBVar.profile.messages.scrollwindow:AddMessage("Upgrade Detected for Primary Spec: " .. UpgradeListDBVar.char.PrimarySpecList.Main.Row[i][3]);
							end
						end
						if UpgradeListDBVar.profile.sound.potential then
							PlaySoundFile(LSM:Fetch("sound", UpgradeListDBVar.profile.sound.potentialchoice))
						end
					else
						if UpgradeListDBVar.profile.messages.acquired then
							if UpgradeListDBVar.profile.messages.acquiredlocation == "chatwindow" then
								DEFAULT_CHAT_FRAME:AddMessage("|cFFE08800Upgrade List:|r Upgrade Acquired for Primary Spec: " .. UpgradeListDBVar.char.PrimarySpecList.Main.Row[i][3]);
							elseif UpgradeListDBVar.profile.messages.acquiredlocation == "scrollwindow" then
								UpgradeListDBVar.profile.messages.scrollwindow:AddMessage("Upgrade Acquired for Primary Spec: " .. UpgradeListDBVar.char.PrimarySpecList.Main.Row[i][3]);
							end
						end
						if UpgradeListDBVar.profile.sound.acquired then
							PlaySoundFile(LSM:Fetch("sound", UpgradeListDBVar.profile.sound.acquiredchoice))
						end
						primaryspecflag = true;
						weaponinmainprimary = true;
					end
				end
			until (itemID == UpgradeListDBVar.char.PrimarySpecList.Main.Row[i][8] or i == #UpgradeListDBVar.char.PrimarySpecList.Main.Row);
		end
		if UpgradeListDBVar.char.PrimarySpecList.Off.Count > 1 then
			local i = 0;
			repeat
				i = i + 1;
				if itemID == UpgradeListDBVar.char.PrimarySpecList.Off.Row[i][8] then
					if attainability == "potential" then
						if UpgradeListDBVar.profile.messages.potential and weaponinmainprimary == false then
							if UpgradeListDBVar.profile.messages.potentiallocation == "chatwindow" then
								DEFAULT_CHAT_FRAME:AddMessage("|cFFE08800Upgrade List:|r Upgrade Detected for Primary Spec: " .. UpgradeListDBVar.char.PrimarySpecList.Off.Row[i][3]);
							elseif UpgradeListDBVar.profile.messages.potentiallocation == "scrollwindow" then
								UpgradeListDBVar.profile.messages.scrollwindow:AddMessage("Upgrade Detected for Primary Spec: " .. UpgradeListDBVar.char.PrimarySpecList.Off.Row[i][3]);
							end
						end
						if UpgradeListDBVar.profile.sound.potential and weaponinmainprimary == false then
							PlaySoundFile(LSM:Fetch("sound", UpgradeListDBVar.profile.sound.potentialchoice))
						end
					else
						if UpgradeListDBVar.profile.messages.acquired and weaponinmainprimary == false then
							if UpgradeListDBVar.profile.messages.acquiredlocation == "chatwindow" then
								DEFAULT_CHAT_FRAME:AddMessage("|cFFE08800Upgrade List:|r Upgrade Acquired for Primary Spec: " .. UpgradeListDBVar.char.PrimarySpecList.Off.Row[i][3]);
							elseif UpgradeListDBVar.profile.messages.acquiredlocation == "scrollwindow" then
								UpgradeListDBVar.profile.messages.scrollwindow:AddMessage("Upgrade Acquired for Primary Spec: " .. UpgradeListDBVar.char.PrimarySpecList.Off.Row[i][3]);
							end
						end
						if UpgradeListDBVar.profile.sound.acquired and weaponinmainprimary == false then
							PlaySoundFile(LSM:Fetch("sound", UpgradeListDBVar.profile.sound.acquiredchoice))
						end
						primaryspecflag = true;
						weaponinoffprimary = true;
					end
				end
			until (itemID == UpgradeListDBVar.char.PrimarySpecList.Off.Row[i][8] or i == #UpgradeListDBVar.char.PrimarySpecList.Off.Row);
		end
	else
		if UpgradeListDBVar.char.PrimarySpecList.Other.Count > 1 then
			local i = 0;
			repeat
				i = i + 1;
				if itemID == UpgradeListDBVar.char.PrimarySpecList.Other.Row[i][8] then
					if attainability == "potential" then
						if UpgradeListDBVar.profile.messages.potential then
							if UpgradeListDBVar.profile.messages.potentiallocation == "chatwindow" then
								DEFAULT_CHAT_FRAME:AddMessage("|cFFE08800Upgrade List:|r Item Detected in Primary Spec's \"Other\" Tab: " .. UpgradeListDBVar.char.PrimarySpecList.Other.Row[i][3]);
							elseif UpgradeListDBVar.profile.messages.potentiallocation == "scrollwindow" then
								UpgradeListDBVar.profile.messages.scrollwindow:AddMessage("Item Detected in Primary Spec's \"Other\" Tab: " .. UpgradeListDBVar.char.PrimarySpecList.Other.Row[i][3]);
							end
						end
						if UpgradeListDBVar.profile.sound.potential then
							PlaySoundFile(LSM:Fetch("sound", UpgradeListDBVar.profile.sound.potentialchoice))
						end
					else
						if UpgradeListDBVar.profile.messages.acquired then					
							if UpgradeListDBVar.profile.messages.acquiredlocation == "chatwindow" then
								DEFAULT_CHAT_FRAME:AddMessage("|cFFE08800Upgrade List:|r Upgrade Acquired for Primary Spec: " .. UpgradeListDBVar.char.PrimarySpecList.Other.Row[i][3]);
							elseif UpgradeListDBVar.profile.messages.acquiredlocation == "scrollwindow" then
								UpgradeListDBVar.profile.messages.scrollwindow:AddMessage("Upgrade Acquired for Primary Spec: " .. UpgradeListDBVar.char.PrimarySpecList.Other.Row[i][3]);
							end
						end
						if UpgradeListDBVar.profile.messages.acquired then
							PlaySoundFile(LSM:Fetch("sound", UpgradeListDBVar.profile.sound.acquiredchoice))
						end
						otherflag = true;
					end
				end
			until (itemID == UpgradeListDBVar.char.PrimarySpecList.Other.Row[i][8] or i == #UpgradeListDBVar.char.PrimarySpecList.Other.Row);
		end
	end
	if GetNumTalentGroups("player") > 1 then --If the player has a second spec
		if itemEquipLocation == "INVTYPE_HEAD" then
			if UpgradeListDBVar.char.SecondarySpecList.Head.Count > 1 then
				local i = 0;
				repeat
					i = i + 1;
					if itemID == UpgradeListDBVar.char.SecondarySpecList.Head.Row[i][8] then
						if attainability == "potential" then
							if UpgradeListDBVar.profile.messages.potential then
								if UpgradeListDBVar.profile.messages.potentiallocation == "chatwindow" then
									DEFAULT_CHAT_FRAME:AddMessage("|cFFE08800Upgrade List:|r Upgrade Detected for Secondary Spec: " .. UpgradeListDBVar.char.SecondarySpecList.Head.Row[i][3]);
								elseif UpgradeListDBVar.profile.messages.potentiallocation == "scrollwindow" then
									UpgradeListDBVar.profile.messages.scrollwindow:AddMessage("Upgrade Detected for Secondary Spec: " .. UpgradeListDBVar.char.SecondarySpecList.Head.Row[i][3]);
								end
							end
							if UpgradeListDBVar.profile.sound.potential and primaryspecflag == false then
								PlaySoundFile(LSM:Fetch("sound", UpgradeListDBVar.profile.sound.potentialchoice))
							end
						else
							if UpgradeListDBVar.profile.messages.acquired and primaryspecflag == false then
								if UpgradeListDBVar.profile.messages.acquiredlocation == "chatwindow" then
									DEFAULT_CHAT_FRAME:AddMessage("|cFFE08800Upgrade List:|r Upgrade Acquired for Secondary Spec: " .. UpgradeListDBVar.char.SecondarySpecList.Head.Row[i][3]);
								elseif UpgradeListDBVar.profile.messages.acquiredlocation == "scrollwindow" then
									UpgradeListDBVar.profile.messages.scrollwindow:AddMessage("Upgrade Acquired for Secondary Spec: " .. UpgradeListDBVar.char.SecondarySpecList.Head.Row[i][3]);
								end
							end
							if UpgradeListDBVar.profile.sound.acquired and primaryspecflag == false then
								PlaySoundFile(LSM:Fetch("sound", UpgradeListDBVar.profile.sound.acquiredchoice))
							end
							secondaryspecflag = true;
						end
					end
				until (itemID == UpgradeListDBVar.char.SecondarySpecList.Head.Row[i][8] or i == #UpgradeListDBVar.char.SecondarySpecList.Head.Row);
			end
		elseif itemEquipLocation == "INVTYPE_NECK" then
			if UpgradeListDBVar.char.SecondarySpecList.Neck.Count > 1 then
				local i = 0;
				repeat
					i = i + 1;
					if itemID == UpgradeListDBVar.char.SecondarySpecList.Neck.Row[i][8] then
						if attainability == "potential" then
							if UpgradeListDBVar.profile.messages.potential then
								if UpgradeListDBVar.profile.messages.potentiallocation == "chatwindow" then
									DEFAULT_CHAT_FRAME:AddMessage("|cFFE08800Upgrade List:|r Upgrade Detected for Secondary Spec: " .. UpgradeListDBVar.char.SecondarySpecList.Neck.Row[i][3]);
								elseif UpgradeListDBVar.profile.messages.potentiallocation == "scrollwindow" then
									UpgradeListDBVar.profile.messages.scrollwindow:AddMessage("Upgrade Detected for Secondary Spec: " .. UpgradeListDBVar.char.SecondarySpecList.Neck.Row[i][3]);
								end
							end
							if UpgradeListDBVar.profile.sound.potential and primaryspecflag == false then
								PlaySoundFile(LSM:Fetch("sound", UpgradeListDBVar.profile.sound.potentialchoice))
							end
						else
							if UpgradeListDBVar.profile.messages.acquired and primaryspecflag == false then
								if UpgradeListDBVar.profile.messages.acquiredlocation == "chatwindow" then
									DEFAULT_CHAT_FRAME:AddMessage("|cFFE08800Upgrade List:|r Upgrade Acquired for Secondary Spec: " .. UpgradeListDBVar.char.SecondarySpecList.Neck.Row[i][3]);
								elseif UpgradeListDBVar.profile.messages.acquiredlocation == "scrollwindow" then
									UpgradeListDBVar.profile.messages.scrollwindow:AddMessage("Upgrade Acquired for Secondary Spec: " .. UpgradeListDBVar.char.SecondarySpecList.Neck.Row[i][3]);
								end
							end
							if UpgradeListDBVar.profile.sound.acquired and primaryspecflag == false then
								PlaySoundFile(LSM:Fetch("sound", UpgradeListDBVar.profile.sound.acquiredchoice))
							end
							secondaryspecflag = true;
						end
					end
				until (itemID == UpgradeListDBVar.char.SecondarySpecList.Neck.Row[i][8] or i == #UpgradeListDBVar.char.SecondarySpecList.Neck.Row);
			end
		elseif itemEquipLocation == "INVTYPE_SHOULDER" then
			if UpgradeListDBVar.char.SecondarySpecList.Shoulder.Count > 1 then
				local i = 0;
				repeat
					i = i + 1;
					if itemID == UpgradeListDBVar.char.SecondarySpecList.Shoulder.Row[i][8] then
						if attainability == "potential" then
							if UpgradeListDBVar.profile.messages.potential then
								if UpgradeListDBVar.profile.messages.potentiallocation == "chatwindow" then
									DEFAULT_CHAT_FRAME:AddMessage("|cFFE08800Upgrade List:|r Upgrade Detected for Secondary Spec: " .. UpgradeListDBVar.char.SecondarySpecList.Shoulder.Row[i][3]);
								elseif UpgradeListDBVar.profile.messages.potentiallocation == "scrollwindow" then
									UpgradeListDBVar.profile.messages.scrollwindow:AddMessage("Upgrade Detected for Secondary Spec: " .. UpgradeListDBVar.char.SecondarySpecList.Shoulder.Row[i][3]);
								end
							end
							if UpgradeListDBVar.profile.sound.potential and primaryspecflag == false then
								PlaySoundFile(LSM:Fetch("sound", UpgradeListDBVar.profile.sound.potentialchoice))
							end
						else
							if UpgradeListDBVar.profile.messages.acquired and primaryspecflag == false then
								if UpgradeListDBVar.profile.messages.acquiredlocation == "chatwindow" then
									DEFAULT_CHAT_FRAME:AddMessage("|cFFE08800Upgrade List:|r Upgrade Acquired for Secondary Spec: " .. UpgradeListDBVar.char.SecondarySpecList.Shoulder.Row[i][3]);
								elseif UpgradeListDBVar.profile.messages.acquiredlocation == "scrollwindow" then
									UpgradeListDBVar.profile.messages.scrollwindow:AddMessage("Upgrade Acquired for Secondary Spec: " .. UpgradeListDBVar.char.SecondarySpecList.Shoulder.Row[i][3]);
								end
							end
							if UpgradeListDBVar.profile.sound.acquired and primaryspecflag == false then
								PlaySoundFile(LSM:Fetch("sound", UpgradeListDBVar.profile.sound.acquiredchoice))
							end
							secondaryspecflag = true;
						end
					end
				until (itemID == UpgradeListDBVar.char.SecondarySpecList.Shoulder.Row[i][8] or i == #UpgradeListDBVar.char.SecondarySpecList.Shoulder.Row);
			end
		elseif itemEquipLocation == "INVTYPE_CLOAK" then
			if UpgradeListDBVar.char.SecondarySpecList.Back.Count > 1 then
				local i = 0;
				repeat
					i = i + 1;
					if itemID == UpgradeListDBVar.char.SecondarySpecList.Back.Row[i][8] then
						if attainability == "potential" then
							if UpgradeListDBVar.profile.messages.potential then
								if UpgradeListDBVar.profile.messages.potentiallocation == "chatwindow" then
									DEFAULT_CHAT_FRAME:AddMessage("|cFFE08800Upgrade List:|r Upgrade Detected for Secondary Spec: " .. UpgradeListDBVar.char.SecondarySpecList.Back.Row[i][3]);
								elseif UpgradeListDBVar.profile.messages.potentiallocation == "scrollwindow" then
									UpgradeListDBVar.profile.messages.scrollwindow:AddMessage("Upgrade Detected for Secondary Spec: " .. UpgradeListDBVar.char.SecondarySpecList.Back.Row[i][3]);
								end
							end
							if UpgradeListDBVar.profile.sound.potential and primaryspecflag == false then
								PlaySoundFile(LSM:Fetch("sound", UpgradeListDBVar.profile.sound.potentialchoice))
							end
						else
							if UpgradeListDBVar.profile.messages.acquired and primaryspecflag == false then
								if UpgradeListDBVar.profile.messages.acquiredlocation == "chatwindow" then
									DEFAULT_CHAT_FRAME:AddMessage("|cFFE08800Upgrade List:|r Upgrade Acquired for Secondary Spec: " .. UpgradeListDBVar.char.SecondarySpecList.Back.Row[i][3]);
								elseif UpgradeListDBVar.profile.messages.acquiredlocation == "scrollwindow" then
									UpgradeListDBVar.profile.messages.scrollwindow:AddMessage("Upgrade Acquired for Secondary Spec: " .. UpgradeListDBVar.char.SecondarySpecList.Back.Row[i][3]);
								end
							end
							if UpgradeListDBVar.profile.sound.acquired and primaryspecflag == false then
								PlaySoundFile(LSM:Fetch("sound", UpgradeListDBVar.profile.sound.acquiredchoice))
							end
							secondaryspecflag = true;
						end
					end
				until (itemID == UpgradeListDBVar.char.SecondarySpecList.Back.Row[i][8] or i == #UpgradeListDBVar.char.SecondarySpecList.Back.Row);
			end
		elseif itemEquipLocation == "INVTYPE_CHEST" or itemEquipLocation == "INVTYPE_ROBE" then
			if UpgradeListDBVar.char.SecondarySpecList.Chest.Count > 1 then
				local i = 0;
				repeat
					i = i + 1;
					if itemID == UpgradeListDBVar.char.SecondarySpecList.Chest.Row[i][8] then
						if attainability == "potential" then
							if UpgradeListDBVar.profile.messages.potential then
								if UpgradeListDBVar.profile.messages.potentiallocation == "chatwindow" then
									DEFAULT_CHAT_FRAME:AddMessage("|cFFE08800Upgrade List:|r Upgrade Detected for Secondary Spec: " .. UpgradeListDBVar.char.SecondarySpecList.Chest.Row[i][3]);
								elseif UpgradeListDBVar.profile.messages.potentiallocation == "scrollwindow" then
									UpgradeListDBVar.profile.messages.scrollwindow:AddMessage("Upgrade Detected for Secondary Spec: " .. UpgradeListDBVar.char.SecondarySpecList.Chest.Row[i][3]);
								end
							end
							if UpgradeListDBVar.profile.sound.potential and primaryspecflag == false then
								PlaySoundFile(LSM:Fetch("sound", UpgradeListDBVar.profile.sound.potentialchoice))
							end
						else
							if UpgradeListDBVar.profile.messages.acquired and primaryspecflag == false then
								if UpgradeListDBVar.profile.messages.acquiredlocation == "chatwindow" then
									DEFAULT_CHAT_FRAME:AddMessage("|cFFE08800Upgrade List:|r Upgrade Acquired for Secondary Spec: " .. UpgradeListDBVar.char.SecondarySpecList.Chest.Row[i][3]);
								elseif UpgradeListDBVar.profile.messages.acquiredlocation == "scrollwindow" then
									UpgradeListDBVar.profile.messages.scrollwindow:AddMessage("Upgrade Acquired for Secondary Spec: " .. UpgradeListDBVar.char.SecondarySpecList.Chest.Row[i][3]);
								end
							end
							if UpgradeListDBVar.profile.sound.acquired and primaryspecflag == false then
								PlaySoundFile(LSM:Fetch("sound", UpgradeListDBVar.profile.sound.acquiredchoice))
							end
							secondaryspecflag = true;
						end
					end
				until (itemID == UpgradeListDBVar.char.SecondarySpecList.Chest.Row[i][8] or i == #UpgradeListDBVar.char.SecondarySpecList.Chest.Row);
			end
		elseif itemEquipLocation == "INVTYPE_WRIST" then
			if UpgradeListDBVar.char.SecondarySpecList.Wrist.Count > 1 then
				local i = 0;
				repeat
					i = i + 1;
					if itemID == UpgradeListDBVar.char.SecondarySpecList.Wrist.Row[i][8] then
						if attainability == "potential" then
							if UpgradeListDBVar.profile.messages.potential then
								if UpgradeListDBVar.profile.messages.potentiallocation == "chatwindow" then
									DEFAULT_CHAT_FRAME:AddMessage("|cFFE08800Upgrade List:|r Upgrade Detected for Secondary Spec: " .. UpgradeListDBVar.char.SecondarySpecList.Wrist.Row[i][3]);
								elseif UpgradeListDBVar.profile.messages.potentiallocation == "scrollwindow" then
									UpgradeListDBVar.profile.messages.scrollwindow:AddMessage("Upgrade Detected for Secondary Spec: " .. UpgradeListDBVar.char.SecondarySpecList.Wrist.Row[i][3]);
								end
							end
							if UpgradeListDBVar.profile.sound.potential and primaryspecflag == false then
								PlaySoundFile(LSM:Fetch("sound", UpgradeListDBVar.profile.sound.potentialchoice))
							end
						else
							if UpgradeListDBVar.profile.messages.acquired and primaryspecflag == false then
								if UpgradeListDBVar.profile.messages.acquiredlocation == "chatwindow" then
									DEFAULT_CHAT_FRAME:AddMessage("|cFFE08800Upgrade List:|r Upgrade Acquired for Secondary Spec: " .. UpgradeListDBVar.char.SecondarySpecList.Wrist.Row[i][3]);
								elseif UpgradeListDBVar.profile.messages.acquiredlocation == "scrollwindow" then
									UpgradeListDBVar.profile.messages.scrollwindow:AddMessage("Upgrade Acquired for Secondary Spec: " .. UpgradeListDBVar.char.SecondarySpecList.Wrist.Row[i][3]);
								end
							end
							if UpgradeListDBVar.profile.sound.acquired and primaryspecflag == false then
								PlaySoundFile(LSM:Fetch("sound", UpgradeListDBVar.profile.sound.acquiredchoice))
							end
							secondaryspecflag = true;
						end
					end
				until (itemID == UpgradeListDBVar.char.SecondarySpecList.Wrist.Row[i][8] or i == #UpgradeListDBVar.char.SecondarySpecList.Wrist.Row);
			end
		elseif itemEquipLocation == "INVTYPE_HAND" then
			if UpgradeListDBVar.char.SecondarySpecList.Hand.Count > 1 then
				local i = 0;
				repeat
					i = i + 1;
					if itemID == UpgradeListDBVar.char.SecondarySpecList.Hand.Row[i][8] then
						if attainability == "potential" then
							if UpgradeListDBVar.profile.messages.potential then
								if UpgradeListDBVar.profile.messages.potentiallocation == "chatwindow" then
									DEFAULT_CHAT_FRAME:AddMessage("|cFFE08800Upgrade List:|r Upgrade Detected for Secondary Spec: " .. UpgradeListDBVar.char.SecondarySpecList.Hand.Row[i][3]);
								elseif UpgradeListDBVar.profile.messages.potentiallocation == "scrollwindow" then
									UpgradeListDBVar.profile.messages.scrollwindow:AddMessage("Upgrade Detected for Secondary Spec: " .. UpgradeListDBVar.char.SecondarySpecList.Hand.Row[i][3]);
								end
							end
							if UpgradeListDBVar.profile.sound.potential and primaryspecflag == false then
								PlaySoundFile(LSM:Fetch("sound", UpgradeListDBVar.profile.sound.potentialchoice))
							end
						else
							if UpgradeListDBVar.profile.messages.acquired and primaryspecflag == false then
								if UpgradeListDBVar.profile.messages.acquiredlocation == "chatwindow" then
									DEFAULT_CHAT_FRAME:AddMessage("|cFFE08800Upgrade List:|r Upgrade Acquired for Secondary Spec: " .. UpgradeListDBVar.char.SecondarySpecList.Hand.Row[i][3]);
								elseif UpgradeListDBVar.profile.messages.acquiredlocation == "scrollwindow" then
									UpgradeListDBVar.profile.messages.scrollwindow:AddMessage("Upgrade Acquired for Secondary Spec: " .. UpgradeListDBVar.char.SecondarySpecList.Hand.Row[i][3]);
								end
							end
							if UpgradeListDBVar.profile.sound.acquired and primaryspecflag == false then
								PlaySoundFile(LSM:Fetch("sound", UpgradeListDBVar.profile.sound.acquiredchoice))
							end
							secondaryspecflag = true;
						end
					end
				until (itemID == UpgradeListDBVar.char.SecondarySpecList.Hand.Row[i][8] or i == #UpgradeListDBVar.char.SecondarySpecList.Hand.Row);
			end
		elseif itemEquipLocation == "INVTYPE_WAIST" then
			if UpgradeListDBVar.char.SecondarySpecList.Waist.Count > 1 then
				local i = 0;
				repeat
					i = i + 1;
					if itemID == UpgradeListDBVar.char.SecondarySpecList.Waist.Row[i][8] then
						if attainability == "potential" then
							if UpgradeListDBVar.profile.messages.potential then
								if UpgradeListDBVar.profile.messages.potentiallocation == "chatwindow" then
									DEFAULT_CHAT_FRAME:AddMessage("|cFFE08800Upgrade List:|r Upgrade Detected for Secondary Spec: " .. UpgradeListDBVar.char.SecondarySpecList.Waist.Row[i][3]);
								elseif UpgradeListDBVar.profile.messages.potentiallocation == "scrollwindow" then
									UpgradeListDBVar.profile.messages.scrollwindow:AddMessage("Upgrade Detected for Secondary Spec: " .. UpgradeListDBVar.char.SecondarySpecList.Waist.Row[i][3]);
								end
							end
							if UpgradeListDBVar.profile.sound.potential and primaryspecflag == false then
								PlaySoundFile(LSM:Fetch("sound", UpgradeListDBVar.profile.sound.potentialchoice))
							end
						else
							if UpgradeListDBVar.profile.messages.acquired and primaryspecflag == false then
								if UpgradeListDBVar.profile.messages.acquiredlocation == "chatwindow" then
									DEFAULT_CHAT_FRAME:AddMessage("|cFFE08800Upgrade List:|r Upgrade Acquired for Secondary Spec: " .. UpgradeListDBVar.char.SecondarySpecList.Waist.Row[i][3]);
								elseif UpgradeListDBVar.profile.messages.acquiredlocation == "scrollwindow" then
									UpgradeListDBVar.profile.messages.scrollwindow:AddMessage("Upgrade Acquired for Secondary Spec: " .. UpgradeListDBVar.char.SecondarySpecList.Waist.Row[i][3]);
								end
							end
							if UpgradeListDBVar.profile.sound.acquired and primaryspecflag == false then
								PlaySoundFile(LSM:Fetch("sound", UpgradeListDBVar.profile.sound.acquiredchoice))
							end
							secondaryspecflag = true;
						end
					end
				until (itemID == UpgradeListDBVar.char.SecondarySpecList.Waist.Row[i][8] or i == #UpgradeListDBVar.char.SecondarySpecList.Waist.Row);
			end
		elseif itemEquipLocation == "INVTYPE_LEGS" then
			if UpgradeListDBVar.char.SecondarySpecList.Leg.Count > 1 then
				local i = 0;
				repeat
					 i = i + 1;
					if itemID == UpgradeListDBVar.char.SecondarySpecList.Leg.Row[i][8] then
						if attainability == "potential" then
							if UpgradeListDBVar.profile.messages.potential then
								if UpgradeListDBVar.profile.messages.potentiallocation == "chatwindow" then
									DEFAULT_CHAT_FRAME:AddMessage("|cFFE08800Upgrade List:|r Upgrade Detected for Secondary Spec: " .. UpgradeListDBVar.char.SecondarySpecList.Leg.Row[i][3]);
								elseif UpgradeListDBVar.profile.messages.potentiallocation == "scrollwindow" then
									UpgradeListDBVar.profile.messages.scrollwindow:AddMessage("Upgrade Detected for Secondary Spec: " .. UpgradeListDBVar.char.SecondarySpecList.Leg.Row[i][3]);
								end
							end
							if UpgradeListDBVar.profile.sound.potential and primaryspecflag == false then
								PlaySoundFile(LSM:Fetch("sound", UpgradeListDBVar.profile.sound.potentialchoice))
							end
						else
							if UpgradeListDBVar.profile.messages.acquired and primaryspecflag == false then
								if UpgradeListDBVar.profile.messages.acquiredlocation == "chatwindow" then
									DEFAULT_CHAT_FRAME:AddMessage("|cFFE08800Upgrade List:|r Upgrade Acquired for Secondary Spec: " .. UpgradeListDBVar.char.SecondarySpecList.Leg.Row[i][3]);
								elseif UpgradeListDBVar.profile.messages.acquiredlocation == "scrollwindow" then
									UpgradeListDBVar.profile.messages.scrollwindow:AddMessage("Upgrade Acquired for Secondary Spec: " .. UpgradeListDBVar.char.SecondarySpecList.Leg.Row[i][3]);
								end
							end
							if UpgradeListDBVar.profile.sound.acquired and primaryspecflag == false then
								PlaySoundFile(LSM:Fetch("sound", UpgradeListDBVar.profile.sound.acquiredchoice))
							end
							secondaryspecflag = true;
						end
					end
				until (itemID == UpgradeListDBVar.char.SecondarySpecList.Leg.Row[i][8] or i == #UpgradeListDBVar.char.SecondarySpecList.Leg.Row);
			end
		elseif itemEquipLocation == "INVTYPE_FEET" then
			if UpgradeListDBVar.char.SecondarySpecList.Foot.Count > 1 then
				local i = 0;
				repeat
					i = i + 1;
					if itemID == UpgradeListDBVar.char.SecondarySpecList.Foot.Row[i][8] then
						if attainability == "potential" then
							if UpgradeListDBVar.profile.messages.potential then
								if UpgradeListDBVar.profile.messages.potentiallocation == "chatwindow" then
									DEFAULT_CHAT_FRAME:AddMessage("|cFFE08800Upgrade List:|r Upgrade Detected for Secondary Spec: " .. UpgradeListDBVar.char.SecondarySpecList.Foot.Row[i][3]);
								elseif UpgradeListDBVar.profile.messages.potentiallocation == "scrollwindow" then
									UpgradeListDBVar.profile.messages.scrollwindow:AddMessage("Upgrade Detected for Secondary Spec: " .. UpgradeListDBVar.char.SecondarySpecList.Foot.Row[i][3]);
								end
							end
							if UpgradeListDBVar.profile.sound.potential and primaryspecflag == false then
								PlaySoundFile(LSM:Fetch("sound", UpgradeListDBVar.profile.sound.potentialchoice))
							end
						else
							if UpgradeListDBVar.profile.messages.acquired and primaryspecflag == false then
								if UpgradeListDBVar.profile.messages.acquiredlocation == "chatwindow" then
									DEFAULT_CHAT_FRAME:AddMessage("|cFFE08800Upgrade List:|r Upgrade Acquired for Secondary Spec: " .. UpgradeListDBVar.char.SecondarySpecList.Foot.Row[i][3]);
								elseif UpgradeListDBVar.profile.messages.acquiredlocation == "scrollwindow" then
									UpgradeListDBVar.profile.messages.scrollwindow:AddMessage("Upgrade Acquired for Secondary Spec: " .. UpgradeListDBVar.char.SecondarySpecList.Foot.Row[i][3]);
								end
							end
							if UpgradeListDBVar.profile.sound.acquired and primaryspecflag == false then
								PlaySoundFile(LSM:Fetch("sound", UpgradeListDBVar.profile.sound.acquiredchoice))
							end
							secondaryspecflag = true;
						end
					end
				until (itemID == UpgradeListDBVar.char.SecondarySpecList.Foot.Row[i][8] or i == #UpgradeListDBVar.char.SecondarySpecList.Foot.Row);
			end
		elseif itemEquipLocation == "INVTYPE_FINGER" then
			if UpgradeListDBVar.char.SecondarySpecList.Ring.Count > 1 then
				local i = 0;
				repeat
					i = i + 1;
					if itemID == UpgradeListDBVar.char.SecondarySpecList.Ring.Row[i][8] then
						if attainability == "potential" then
							if UpgradeListDBVar.profile.messages.potential then
								if UpgradeListDBVar.profile.messages.potentiallocation == "chatwindow" then
									DEFAULT_CHAT_FRAME:AddMessage("|cFFE08800Upgrade List:|r Upgrade Detected for Secondary Spec: " .. UpgradeListDBVar.char.SecondarySpecList.Ring.Row[i][3]);
								elseif UpgradeListDBVar.profile.messages.potentiallocation == "scrollwindow" then
									UpgradeListDBVar.profile.messages.scrollwindow:AddMessage("Upgrade Detected for Secondary Spec: " .. UpgradeListDBVar.char.SecondarySpecList.Ring.Row[i][3]);
								end
							end
							if UpgradeListDBVar.profile.sound.potential and primaryspecflag == false then
								PlaySoundFile(LSM:Fetch("sound", UpgradeListDBVar.profile.sound.potentialchoice))
							end
						else
							if UpgradeListDBVar.profile.messages.acquired and primaryspecflag == false then
								if UpgradeListDBVar.profile.messages.acquiredlocation == "chatwindow" then
									DEFAULT_CHAT_FRAME:AddMessage("|cFFE08800Upgrade List:|r Upgrade Acquired for Secondary Spec: " .. UpgradeListDBVar.char.SecondarySpecList.Ring.Row[i][3]);
								elseif UpgradeListDBVar.profile.messages.acquiredlocation == "scrollwindow" then
									UpgradeListDBVar.profile.messages.scrollwindow:AddMessage("Upgrade Acquired for Secondary Spec: " .. UpgradeListDBVar.char.SecondarySpecList.Ring.Row[i][3]);
								end
							end
							if UpgradeListDBVar.profile.sound.acquired and primaryspecflag == false then
								PlaySoundFile(LSM:Fetch("sound", UpgradeListDBVar.profile.sound.acquiredchoice))
							end
							secondaryspecflag = true;
						end
					end
				until (itemID == UpgradeListDBVar.char.SecondarySpecList.Ring.Row[i][8] or i == #UpgradeListDBVar.char.SecondarySpecList.Ring.Row);
			end
		elseif itemEquipLocation == "INVTYPE_TRINKET" then
			if UpgradeListDBVar.char.SecondarySpecList.Trinket.Count > 1 then
				local i = 0;
				repeat
					i = i + 1;
					if itemID == UpgradeListDBVar.char.SecondarySpecList.Trinket.Row[i][8] then
						if attainability == "potential" then
							if UpgradeListDBVar.profile.messages.potential then
								if UpgradeListDBVar.profile.messages.potentiallocation == "chatwindow" then
									DEFAULT_CHAT_FRAME:AddMessage("|cFFE08800Upgrade List:|r Upgrade Detected for Secondary Spec: " .. UpgradeListDBVar.char.SecondarySpecList.Trinket.Row[i][3]);
								elseif UpgradeListDBVar.profile.messages.potentiallocation == "scrollwindow" then
									UpgradeListDBVar.profile.messages.scrollwindow:AddMessage("Upgrade Detected for Secondary Spec: " .. UpgradeListDBVar.char.SecondarySpecList.Trinket.Row[i][3]);
								end
							end
							if UpgradeListDBVar.profile.sound.potential and primaryspecflag == false then
								PlaySoundFile(LSM:Fetch("sound", UpgradeListDBVar.profile.sound.potentialchoice))
							end
						else
							if UpgradeListDBVar.profile.messages.acquired and primaryspecflag == false then
								if UpgradeListDBVar.profile.messages.acquiredlocation == "chatwindow" then
									DEFAULT_CHAT_FRAME:AddMessage("|cFFE08800Upgrade List:|r Upgrade Acquired for Secondary Spec: " .. UpgradeListDBVar.char.SecondarySpecList.Trinket.Row[i][3]);
								elseif UpgradeListDBVar.profile.messages.acquiredlocation == "scrollwindow" then
									UpgradeListDBVar.profile.messages.scrollwindow:AddMessage("Upgrade Acquired for Secondary Spec: " .. UpgradeListDBVar.char.SecondarySpecList.Trinket.Row[i][3]);
								end
							end
							if UpgradeListDBVar.profile.sound.acquired and primaryspecflag == false then
								PlaySoundFile(LSM:Fetch("sound", UpgradeListDBVar.profile.sound.acquiredchoice))
							end
							secondaryspecflag = true;
						end
					end
				until (itemID == UpgradeListDBVar.char.SecondarySpecList.Trinket.Row[i][8] or i == #UpgradeListDBVar.char.SecondarySpecList.Trinket.Row);
			end
		elseif itemEquipLocation == "INVTYPE_2HWEAPON" or itemEquipLocation == "INVTYPE_MAINHANDWEAPON" then
			if UpgradeListDBVar.char.SecondarySpecList.Main.Count > 1 then
				local i = 0;
				repeat
					i = i + 1;
					if itemID == UpgradeListDBVar.char.SecondarySpecList.Main.Row[i][8] then
						if attainability == "potential" then
							if UpgradeListDBVar.profile.messages.potential then
								if UpgradeListDBVar.profile.messages.potentiallocation == "chatwindow" then
									DEFAULT_CHAT_FRAME:AddMessage("|cFFE08800Upgrade List:|r Upgrade Detected for Secondary Spec: " .. UpgradeListDBVar.char.SecondarySpecList.Main.Row[i][3]);
								elseif UpgradeListDBVar.profile.messages.potentiallocation == "scrollwindow" then
									UpgradeListDBVar.profile.messages.scrollwindow:AddMessage("Upgrade Detected for Secondary Spec: " .. UpgradeListDBVar.char.SecondarySpecList.Main.Row[i][3]);
								end
							end
							if UpgradeListDBVar.profile.sound.potential and primaryspecflag == false then
								PlaySoundFile(LSM:Fetch("sound", UpgradeListDBVar.profile.sound.potentialchoice))
							end
						else
							if UpgradeListDBVar.profile.messages.acquired and primaryspecflag == false then
								if UpgradeListDBVar.profile.messages.acquiredlocation == "chatwindow" then
									DEFAULT_CHAT_FRAME:AddMessage("|cFFE08800Upgrade List:|r Upgrade Acquired for Secondary Spec: " .. UpgradeListDBVar.char.SecondarySpecList.Main.Row[i][3]);
								elseif UpgradeListDBVar.profile.messages.acquiredlocation == "scrollwindow" then
									UpgradeListDBVar.profile.messages.scrollwindow:AddMessage("Upgrade Acquired for Secondary Spec: " .. UpgradeListDBVar.char.SecondarySpecList.Main.Row[i][3]);
								end
							end
							if UpgradeListDBVar.profile.sound.acquired and primaryspecflag == false then
								PlaySoundFile(LSM:Fetch("sound", UpgradeListDBVar.profile.sound.acquiredchoice))
							end
							secondaryspecflag = true;
						end
					end
				until (itemID == UpgradeListDBVar.char.SecondarySpecList.Main.Row[i][8] or i == #UpgradeListDBVar.char.SecondarySpecList.Main.Row);
			end
		elseif itemEquipLocation == "INVTYPE_SHIELD" or itemEquipLocation == "INVTYPE_OFFHANDWEAPON" or itemEquipLocation == "INVTYPE_HOLDABLE" then
			if UpgradeListDBVar.char.SecondarySpecList.Off.Count > 1 then
				local i = 0;
				repeat
					i = i + 1;
					if itemID == UpgradeListDBVar.char.SecondarySpecList.Off.Row[i][8] then
						if attainability == "potential" then
							if UpgradeListDBVar.profile.messages.potential then
								if UpgradeListDBVar.profile.messages.potentiallocation == "chatwindow" then
									DEFAULT_CHAT_FRAME:AddMessage("|cFFE08800Upgrade List:|r Upgrade Detected for Secondary Spec: " .. UpgradeListDBVar.char.SecondarySpecList.Off.Row[i][3]);
								elseif UpgradeListDBVar.profile.messages.potentiallocation == "scrollwindow" then
									UpgradeListDBVar.profile.messages.scrollwindow:AddMessage("Upgrade Detected for Secondary Spec: " .. UpgradeListDBVar.char.SecondarySpecList.Off.Row[i][3]);
								end
							end
							if UpgradeListDBVar.profile.sound.potential and primaryspecflag == false then
								PlaySoundFile(LSM:Fetch("sound", UpgradeListDBVar.profile.sound.potentialchoice))
							end
						else
							if UpgradeListDBVar.profile.messages.acquired and primaryspecflag == false then
								if UpgradeListDBVar.profile.messages.acquiredlocation == "chatwindow" then
									DEFAULT_CHAT_FRAME:AddMessage("|cFFE08800Upgrade List:|r Upgrade Acquired for Secondary Spec: " .. UpgradeListDBVar.char.SecondarySpecList.Off.Row[i][3]);
								elseif UpgradeListDBVar.profile.messages.acquiredlocation == "scrollwindow" then
									UpgradeListDBVar.profile.messages.scrollwindow:AddMessage("Upgrade Acquired for Secondary Spec: " .. UpgradeListDBVar.char.SecondarySpecList.Off.Row[i][3]);
								end
							end
							if UpgradeListDBVar.profile.sound.acquired and primaryspecflag == false then
								PlaySoundFile(LSM:Fetch("sound", UpgradeListDBVar.profile.sound.acquiredchoice))
							end
							secondaryspecflag = true;
						end
					end
				until (itemID == UpgradeListDBVar.char.SecondarySpecList.Off.Row[i][8] or i == #UpgradeListDBVar.char.SecondarySpecList.Off.Row);
			end
		elseif itemEquipLocation == "INVTYPE_RANGED" or itemEquipLocation == "INVTYPE_THROWN" or itemEquipLocation == "INVTYPE_RANGEDRIGHT" or itemEquipLocation == "INVTYPE_RELIC" then
			if UpgradeListDBVar.char.SecondarySpecList.Ranged.Count > 1 then
				local i = 0;
				repeat
					i = i + 1;
					if itemID == UpgradeListDBVar.char.SecondarySpecList.Ranged.Row[i][8] then
						if attainability == "potential" then
							if UpgradeListDBVar.profile.messages.potential then
								if UpgradeListDBVar.profile.messages.potentiallocation == "chatwindow" then
									DEFAULT_CHAT_FRAME:AddMessage("|cFFE08800Upgrade List:|r Upgrade Detected for Secondary Spec: " .. UpgradeListDBVar.char.SecondarySpecList.Ranged.Row[i][3]);
								elseif UpgradeListDBVar.profile.messages.potentiallocation == "scrollwindow" then
									UpgradeListDBVar.profile.messages.scrollwindow:AddMessage("Upgrade Detected for Secondary Spec: " .. UpgradeListDBVar.char.SecondarySpecList.Ranged.Row[i][3]);
								end
							end
							if UpgradeListDBVar.profile.sound.potential and primaryspecflag == false then
								PlaySoundFile(LSM:Fetch("sound", UpgradeListDBVar.profile.sound.potentialchoice))
							end
						else
							if UpgradeListDBVar.profile.messages.acquired and primaryspecflag == false then
								if UpgradeListDBVar.profile.messages.acquiredlocation == "chatwindow" then
									DEFAULT_CHAT_FRAME:AddMessage("|cFFE08800Upgrade List:|r Upgrade Acquired for Secondary Spec: " .. UpgradeListDBVar.char.SecondarySpecList.Ranged.Row[i][3]);
								elseif UpgradeListDBVar.profile.messages.acquiredlocation == "scrollwindow" then
									UpgradeListDBVar.profile.messages.scrollwindow:AddMessage("Upgrade Acquired for Secondary Spec: " .. UpgradeListDBVar.char.SecondarySpecList.Ranged.Row[i][3]);
								end
							end
							if UpgradeListDBVar.profile.sound.acquired and primaryspecflag == false then
								PlaySoundFile(LSM:Fetch("sound", UpgradeListDBVar.profile.sound.acquiredchoice))
							end
							secondaryspecflag = true;
						end
					end
				until (itemID == UpgradeListDBVar.char.SecondarySpecList.Ranged.Row[i][8] or i == #UpgradeListDBVar.char.SecondarySpecList.Ranged.Row);
			end
		elseif itemEquipLocation == "INVTYPE_WEAPON" then
			if UpgradeListDBVar.char.SecondarySpecList.Main.Count > 1 then
				local i = 0;
				repeat
					i = i + 1;
					if itemID == UpgradeListDBVar.char.SecondarySpecList.Main.Row[i][8] then
						if attainability == "potential" then
							if UpgradeListDBVar.profile.messages.potential then
								if UpgradeListDBVar.profile.messages.potentiallocation == "chatwindow" then
									DEFAULT_CHAT_FRAME:AddMessage("|cFFE08800Upgrade List:|r Upgrade Detected for Secondary Spec: " .. UpgradeListDBVar.char.SecondarySpecList.Main.Row[i][3]);
								elseif UpgradeListDBVar.profile.messages.potentiallocation == "scrollwindow" then
									UpgradeListDBVar.profile.messages.scrollwindow:AddMessage("Upgrade Detected for Secondary Spec: " .. UpgradeListDBVar.char.SecondarySpecList.Main.Row[i][3]);
								end
							end
							if UpgradeListDBVar.profile.sound.potential and primaryspecflag == false then
								PlaySoundFile(LSM:Fetch("sound", UpgradeListDBVar.profile.sound.potentialchoice))
							end
						else
							if UpgradeListDBVar.profile.messages.acquired and primaryspecflag == false then
								if UpgradeListDBVar.profile.messages.acquiredlocation == "chatwindow" then
									DEFAULT_CHAT_FRAME:AddMessage("|cFFE08800Upgrade List:|r Upgrade Acquired for Secondary Spec: " .. UpgradeListDBVar.char.SecondarySpecList.Main.Row[i][3]);
								elseif UpgradeListDBVar.profile.messages.acquiredlocation == "scrollwindow" then
									UpgradeListDBVar.profile.messages.scrollwindow:AddMessage("Upgrade Acquired for Secondary Spec: " .. UpgradeListDBVar.char.SecondarySpecList.Main.Row[i][3]);
								end
							end
							if UpgradeListDBVar.profile.sound.acquired and primaryspecflag == false then
								PlaySoundFile(LSM:Fetch("sound", UpgradeListDBVar.profile.sound.acquiredchoice))
							end
							secondaryspecflag = true;
							weaponinmainsecondary = true;
						end
					end
				until (itemID == UpgradeListDBVar.char.SecondarySpecList.Main.Row[i][8] or i == #UpgradeListDBVar.char.SecondarySpecList.Main.Row);
			end
			if UpgradeListDBVar.char.SecondarySpecList.Off.Count > 1 then
				local i = 0;
				repeat
					i = i + 1;
					if itemID == UpgradeListDBVar.char.SecondarySpecList.Off.Row[i][8] then
						if attainability == "potential" then
							if UpgradeListDBVar.profile.messages.potential and weaponinmainsecondary == false then
								if UpgradeListDBVar.profile.messages.potentiallocation == "chatwindow" then
									DEFAULT_CHAT_FRAME:AddMessage("|cFFE08800Upgrade List:|r Upgrade Detected for Secondary Spec: " .. UpgradeListDBVar.char.SecondarySpecList.Off.Row[i][3]);
								elseif UpgradeListDBVar.profile.messages.potentiallocation == "scrollwindow" then
									UpgradeListDBVar.profile.messages.scrollwindow:AddMessage("Upgrade Detected for Secondary Spec: " .. UpgradeListDBVar.char.SecondarySpecList.Off.Row[i][3]);
								end
							end
							if UpgradeListDBVar.profile.sound.potential and primaryspecflag == false and weaponinmainsecondary == false then
								PlaySoundFile(LSM:Fetch("sound", UpgradeListDBVar.profile.sound.potentialchoice))
							end
						else
							if UpgradeListDBVar.profile.messages.acquired and primaryspecflag == false and weaponinmainsecondary == false then
								if UpgradeListDBVar.profile.messages.acquiredlocation == "chatwindow" then
									DEFAULT_CHAT_FRAME:AddMessage("|cFFE08800Upgrade List:|r Upgrade Acquired for Secondary Spec: " .. UpgradeListDBVar.char.SecondarySpecList.Off.Row[i][3]);
								elseif UpgradeListDBVar.profile.messages.acquiredlocation == "scrollwindow" then
									UpgradeListDBVar.profile.messages.scrollwindow:AddMessage("Upgrade Acquired for Secondary Spec: " .. UpgradeListDBVar.char.SecondarySpecList.Off.Row[i][3]);
								end
							end
							if UpgradeListDBVar.profile.sound.acquired and primaryspecflag == false and weaponinmainsecondary == false then
								PlaySoundFile(LSM:Fetch("sound", UpgradeListDBVar.profile.sound.acquiredchoice))
							end
							secondaryspecflag = true;
							weaponinoffsecondary = true;
						end
					end
				until (itemID == UpgradeListDBVar.char.SecondarySpecList.Off.Row[i][8] or i == #UpgradeListDBVar.char.SecondarySpecList.Off.Row);
			end
		else
			if UpgradeListDBVar.char.SecondarySpecList.Other.Count > 1 then
				local i = 0;
				repeat
					i = i + 1;
					if itemID == UpgradeListDBVar.char.SecondarySpecList.Other.Row[i][8] then
						if attainability == "potential" then
							if UpgradeListDBVar.profile.messages.potential and otherflag == false then
								if UpgradeListDBVar.profile.messages.potentiallocation == "chatwindow" then
									DEFAULT_CHAT_FRAME:AddMessage("|cFFE08800Upgrade List:|r Item Detected in Secondary Spec's \"Other\" Tab: " .. UpgradeListDBVar.char.SecondarySpecList.Other.Row[i][3]);
								elseif UpgradeListDBVar.profile.messages.potentiallocation == "scrollwindow" then
									UpgradeListDBVar.profile.messages.scrollwindow:AddMessage("Item Detected in Secondary Spec's \"Other\" Tab: " .. UpgradeListDBVar.char.SecondarySpecList.Other.Row[i][3]);
								end
							end
							if UpgradeListDBVar.profile.sound.potential then
								PlaySoundFile(LSM:Fetch("sound", UpgradeListDBVar.profile.sound.potentialchoice))
							end
						else
							if UpgradeListDBVar.profile.messages.acquired then					
								if UpgradeListDBVar.profile.messages.acquiredlocation == "chatwindow" then
									DEFAULT_CHAT_FRAME:AddMessage("|cFFE08800Upgrade List:|r Item Acquired in Secondary Spec's \"Other\" Tab: " .. UpgradeListDBVar.char.SecondarySpecList.Other.Row[i][3]);
								elseif UpgradeListDBVar.profile.messages.acquiredlocation == "scrollwindow" then
									UpgradeListDBVar.profile.messages.scrollwindow:AddMessage("Item Acquired in Secondary Spec's \"Other\" Tab: " .. UpgradeListDBVar.char.SecondarySpecList.Other.Row[i][3]);
								end
							end
							if UpgradeListDBVar.profile.messages.acquired then
								PlaySoundFile(LSM:Fetch("sound", UpgradeListDBVar.profile.sound.acquiredchoice))
							end
							otherflag = true;
						end
					end
				until (itemID == UpgradeListDBVar.char.SecondarySpecList.Other.Row[i][8] or i == #UpgradeListDBVar.char.SecondarySpecList.Other.Row);
			end
		end
	end
	if otherflag == false and (primaryspecflag == true or secondaryspecflag == true) then --if item was not in "Other" tab ("Other" tab does not auto-delete) and was acquired
		if UpgradeListDBVar.profile.autodelete.enable then
			if itemEquipLocation ~= "INVTYPE_FINGER" and itemEquipLocation ~= "INVTYPE_TRINKET" or (itemEquipLocation == "INVTYPE_FINGER" and UpgradeListDBVar.profile.ignoreflags.rings == false) or (itemEquipLocation == "INVTYPE_TRINKET" and UpgradeListDBVar.profile.ignoreflags.trinkets == false) then --if the acquired item is not a ring or trinket, or if it was a ring and the ignore rings checkbox is unchecked, or if it was a trinket and the ignore trinkets checkbox is unchecked
				UpgradeList:AutoDelete(itemID, itemEquipLocation, primaryspecflag, secondaryspecflag, weaponinmainprimary, weaponinoffprimary, weaponinmainsecondary, weaponinoffsecondary);
			elseif itemEquipLocation == "INVTYPE_FINGER" and UpgradeListDBVar.profile.ignoreflags.rings == true then
				local itemName, itemLink = GetItemInfo(itemID);
				DEFAULT_CHAT_FRAME:AddMessage("|cFFE08800Upgrade List:|r " .. itemLink .. " acquired, remember to manually update your Ring list!");
			elseif itemEquipLocation == "INVTYPE_TRINKET" and UpgradeListDBVar.profile.ignoreflags.trinkets == true then
				local itemName, itemLink = GetItemInfo(itemID);
				DEFAULT_CHAT_FRAME:AddMessage("|cFFE08800Upgrade List:|r " .. itemLink .. " acquired, remember to manually update your Trinket list!");
			end
		end
	elseif otherflag == true then
		local itemName, itemLink = GetItemInfo(itemID);
		DEFAULT_CHAT_FRAME:AddMessage("|cFFE08800Upgrade List:|r " .. itemLink .. " acquired, remember to manually update your Other list!");
	end
	primaryspecflag = false;
	secondaryspecflag = false;
	weaponinmainprimary = false;
	weaponinoffprimary = false;
	weaponinmainsecondary = false;
	weaponinoffsecondary = false;
	otherflag = false;
end

local function ToggleOptions()
	if OptionsFrame:IsShown() then
		OptionsFrame:Hide()
		UpgradeListDBVar.profile.mainframe.showoptions = false;
	else
		OptionsFrame:Show()
		UpgradeListDBVar.profile.mainframe.showoptions = true;
	end
end
--[[
function UpgradeList:HighlightGear(name, difficulty)
	local count = 1;
	local InstancyHighlightColor = {
		["r"] = 0.0,
		["g"] = 0.0,
		["b"] = 0.0,
		["a"] = 1.0,
	};
	while UpgradeListDBVar.char.PrimarySpecList.Head.Row[count] ~= nil do
		if UpgradeListDBVar.char.PrimarySpecList.Head.Row[count][5] == name and UpgradeListDBVar.char.PrimarySpecList.Head.Row[count][4] == difficulty then
			--Highlight that particular row
			UpgradeListDBVar.char.SavedOptions.tableUL
		end
		count = count + 1;
	end
end
--]]
--function UpgradeList:PLAYER_GUILD_UPDATE() --Redo the dropdown list if a player's guild info changes
	--UIDropDownMenu_Initialize(self, DropDown_InitializeDropDown)
--end

function UpgradeList:CHAT_MSG_LOOT(eventName, arg1)
	if string.match(arg1, 'You receive loot: ') or string.match(arg1, 'You receive item: ') then
		local minitable = { strsplit(" [", arg1) };
		local itemName, itemLink, itemRarity, itemLevel, itemMinLevel, itemType, itemSubType, itemStackCount, itemEquipLoc, itemTexture, itemSellPrice;
		for i = 1, #minitable, 1 do
			if string.sub(minitable[i], 1, 1) == "|" then --In minitable, if the first character of a variable is a "|" symbol, that is the item string, so use that entry of minitable to get the itemEquipLoc
				itemName, itemLink, itemRarity, itemLevel, itemMinLevel, itemType, itemSubType, itemStackCount, itemEquipLoc, itemTexture, itemSellPrice = GetItemInfo(minitable[i]);
			end
		end
		local _, _, Color, Ltype, ID = string.find(itemLink, "|?c?f?f?(%x*)|?H?([^:]*):?(%d+):?(%d*):?(%d*):?(%d*):?(%d*):?(%d*):?(%-?%d*):?(%-?%d*):?(%d*):?(%d*)|?h?%[?([^%[%]]*)%]?|?h?|?r?");
		Compare(ID, itemEquipLoc, "acquired");
	end
end

function UpgradeList:CHAT_MSG_SYSTEM(eventName, arg1)
	if string.match(arg1, 'Received item:') or string.match(arg1, 'Received .. of item:') then
		UpgradeList:CHAT_MSG_LOOT(self, arg1);
		local minitable = { strsplit(" [", arg1) };
		local itemName, itemLink, itemRarity, itemLevel, itemMinLevel, itemType, itemSubType, itemStackCount, itemEquipLoc, itemTexture, itemSellPrice;
		for i = 1, #minitable, 1 do
			if string.sub(minitable[i], 1, 1) == "|" then --In minitable, if the first character of a variable is a "|" symbol, that is the item string, so use that entry of minitable to get the itemEquipLoc
				itemName, itemLink, itemRarity, itemLevel, itemMinLevel, itemType, itemSubType, itemStackCount, itemEquipLoc, itemTexture, itemSellPrice = GetItemInfo(minitable[i]);
			end
		end
		local _, _, Color, Ltype, ID = string.find(itemLink, "|?c?f?f?(%x*)|?H?([^:]*):?(%d+):?(%d*):?(%d*):?(%d*):?(%d*):?(%d*):?(%-?%d*):?(%-?%d*):?(%d*):?(%d*)|?h?%[?([^%[%]]*)%]?|?h?|?r?");
		Compare(ID, itemEquipLoc, "acquired");	
	end
end

function UpgradeList:LOOT_OPENED()
	for index = 1, GetNumLootItems() do
		if (LootSlotIsItem(index)) then
			local itemLink = GetLootSlotLink(index);
			local _, _, Color, Ltype, ID = string.find(itemLink, "|?c?f?f?(%x*)|?H?([^:]*):?(%d+):?(%d*):?(%d*):?(%d*):?(%d*):?(%d*):?(%-?%d*):?(%-?%d*):?(%d*):?(%d*)|?h?%[?([^%[%]]*)%]?|?h?|?r?");
			local itemName, itemLink, itemRarity, itemLevel, itemMinLevel, itemType, itemSubType, itemStackCount, itemEquipLoc, itemTexture, itemSellPrice = GetItemInfo(itemLink);
			Compare(ID, itemEquipLoc, "potential");
		end
	end
end

function UpgradeList:START_LOOT_ROLL(eventName, arg1, arg2) --This and Loot Opened fire when looting something in a group, figure out how to only have Loot Opened fire when opening loot.
	local itemLink = GetLootRollItemLink(arg1);
	local _, _, Color, Ltype, ID = string.find(itemLink, "|?c?f?f?(%x*)|?H?([^:]*):?(%d+):?(%d*):?(%d*):?(%d*):?(%d*):?(%d*):?(%-?%d*):?(%-?%d*):?(%d*):?(%d*)|?h?%[?([^%[%]]*)%]?|?h?|?r?");
	local itemName, itemLink, itemRarity, itemLevel, itemMinLevel, itemType, itemSubType, itemStackCount, itemEquipLoc, itemTexture, itemSellPrice = GetItemInfo(itemLink);
	Compare(ID, itemEquipLoc, "potential");
end

function UpgradeList:PLAYER_ENTERING_WORLD()
	local inInstance, instanceType = IsInInstance();
	if inInstance == 1 and (instanceType == "party" or instanceType == "raid") then --if you're in an instance
		local instanceflag = true;
		local name, instancetype, difficultyIndex, difficultyName, maxPlayers, dynamicDifficulty, isDynamic = GetInstanceInfo();
		if instanceType == "party" and difficultyIndex == 1 then --Normal 5 mans
			UpgradeList:RefreshWindow(name, "Normal", instanceflag);
		elseif instanceType == "party" and difficultyIndex == 2 then --Heroic 5 mans
			UpgradeList:RefreshWindow(name, "Heoric", instanceflag);
		elseif instanceType == "raid" and (difficultyIndex == 1 or difficultyIndex == 2) then --10/25 man Normal raids
			UpgradeList:RefreshWindow(name, "Normal", instanceflag);
		elseif instanceType == "raid" and (difficultyIndex == 3 or difficultyIndex == 4) then --10/25 man Heroic raids
			UpgradeList:RefreshWindow(name, "Heroic", instanceflag);
		end
	end
end

--function UpgradeList:UPDATE_FACTION()

--end

local function ScanQuestItems()
	local num = GetNumQuestChoices();
	if num > 0 then
		for i = 1, num, 1 do
			local itemLink = GetQuestItemLink("choice", i);
			if itemLink == nil then
				print("UpgradeList: Error occurred while scanning quest items.");
			else
				local _, _, Color, Ltype, ID = string.find(itemLink, "|?c?f?f?(%x*)|?H?([^:]*):?(%d+):?(%d*):?(%d*):?(%d*):?(%d*):?(%d*):?(%-?%d*):?(%-?%d*):?(%d*):?(%d*)|?h?%[?([^%[%]]*)%]?|?h?|?r?");
				local itemName, itemLink, itemRarity, itemLevel, itemMinLevel, itemType, itemSubType, itemStackCount, itemEquipLoc, itemTexture, itemSellPrice = GetItemInfo(itemLink);
				Compare(ID, itemEquipLoc, "potential");
			end
		end
	end
end

function UpgradeList:QUEST_DETAIL()
	UpgradeList_wait(.5, ScanQuestItems)
end

function UpgradeList:QUEST_COMPLETE()
	UpgradeList_wait(.5, ScanQuestItems)
end

function UpgradeList:CHAT_MSG_RAID(arg1, arg2, arg3)
	local lootmethod, masterlooterPartyID, masterlooterRaidID = GetLootMethod()
	if lootmethod == "master" and UnitInRaid("player") then
		local name = GetRaidRosterInfo(masterlooterRaidID)
		if arg3 == name and name ~= UnitName("player") then
			local itemName, itemLink, itemRarity, itemLevel, itemMinLevel, itemType, itemSubType, itemStackCount, itemEquipLoc, itemTexture, itemSellPrice = GetItemInfo(arg2);
			local _, _, Color, Ltype, ID = string.find(itemLink, "|?c?f?f?(%x*)|?H?([^:]*):?(%d+):?(%d*):?(%d*):?(%d*):?(%d*):?(%d*):?(%-?%d*):?(%-?%d*):?(%d*):?(%d*)|?h?%[?([^%[%]]*)%]?|?h?|?r?");
			Compare(ID, itemEquipLoc, "potential");
		end
	end
end

function UpgradeList:CHAT_MSG_RAID_WARNING(arg1, arg2, arg3)
	local lootmethod, masterlooterPartyID, masterlooterRaidID = GetLootMethod()
	if lootmethod == "master" and UnitInRaid("player") then
		local name = GetRaidRosterInfo(masterlooterRaidID)
		if arg3 == name and name ~= UnitName("player") then
			local itemName, itemLink, itemRarity, itemLevel, itemMinLevel, itemType, itemSubType, itemStackCount, itemEquipLoc, itemTexture, itemSellPrice = GetItemInfo(arg2);
			local _, _, Color, Ltype, ID = string.find(itemLink, "|?c?f?f?(%x*)|?H?([^:]*):?(%d+):?(%d*):?(%d*):?(%d*):?(%d*):?(%d*):?(%-?%d*):?(%-?%d*):?(%d*):?(%d*)|?h?%[?([^%[%]]*)%]?|?h?|?r?");
			Compare(ID, itemEquipLoc, "potential");
		end
	end
end

function UpgradeList:ACHIEVEMENT_EARNED(eventName, arg1) --Enables the checkbox and radio button for the secondary spec if the player earns the Duel-Talent specialization achievement.
	if arg1 == 2716 then
		UpgradeListDBVar.char.SavedOptions.SecondaryCheck:Enable();
		SecondarySpecRadioButton:Enable();
	end
end

function UpgradeList:ChatEdit_InsertLink(lnk) --Called when a player shift-clicks an item, if the ItemEntryBox has focus, it will add the item's link to the box.
	if ItemEntryBox:HasFocus() then
		ItemEntryBox:SetText(lnk)
	end
end


function UpgradeList:OnEnable()
	--Register for Events
	--UpgradeList:RegisterEvent("PLAYER_GUILD_UPDATE")
	UpgradeList:RegisterEvent("CHAT_MSG_LOOT")
	UpgradeList:RegisterEvent("CHAT_MSG_SYSTEM")
	UpgradeList:RegisterEvent("LOOT_OPENED")
	UpgradeList:RegisterEvent("START_LOOT_ROLL")
	UpgradeList:RegisterEvent("PLAYER_ENTERING_WORLD")
	--UpgradeList:RegisterEvent("UPDATE_FACTION")
	UpgradeList:RegisterEvent("QUEST_DETAIL")
	UpgradeList:RegisterEvent("QUEST_COMPLETE")
	UpgradeList:RegisterEvent("CHAT_MSG_RAID")
	UpgradeList:RegisterEvent("CHAT_MSG_RAID_WARNING")
	if GetNumTalentGroups("player") == 1 then
		UpgradeList:RegisterEvent("ACHIEVEMENT_EARNED")
	end
	
	--Hooks
	UpgradeList:SecureHook("ChatEdit_InsertLink") --Happens when a player shift-clicks an item
	
	--Create Scrolling Window
	UpgradeListDBVar.profile.messages.scrollwindow = CreateFrame("ScrollingMessageFrame", "Scrolling Window", UIParent, "ChatFrameTemplate");
	UpgradeListDBVar.profile.messages.scrollwindow:SetPoint("CENTER", 0, 200);
	--[[
	UpgradeListDBVar.profile.messages.scrollwindow:SetBackdrop({bgFile = "Interface/DialogFrame/UI-DialogBox-Background", 
		tile = true, tileSize = 32, edgeSize = 32, 
		insets = { left = 11, right = 11, top = 10, bottom = 10 }});
	--]]
	UpgradeListDBVar.profile.messages.scrollwindow:SetWidth(UIParent:GetWidth() - 200);
	UpgradeListDBVar.profile.messages.scrollwindow:SetHeight(50);
	UpgradeListDBVar.profile.messages.scrollwindow:SetFadeDuration(2);
	UpgradeListDBVar.profile.messages.scrollwindow:SetFading(true);
	UpgradeListDBVar.profile.messages.scrollwindow:SetHyperlinksEnabled(true);
	UpgradeListDBVar.profile.messages.scrollwindow:SetInsertMode("top");
	UpgradeListDBVar.profile.messages.scrollwindow:SetMaxLines(5);
	UpgradeListDBVar.profile.messages.scrollwindow:SetTimeVisible(10);
	UpgradeListDBVar.profile.messages.scrollwindow:SetJustifyH("CENTER");
	UpgradeListDBVar.profile.messages.scrollwindow:SetJustifyV("CENTER");
	UpgradeListDBVar.profile.messages.scrollwindow:SetFontObject(GameFontNormalHuge);
	UpgradeListDBVar.profile.messages.scrollwindow:SetTextColor(1, 1, 1); --white
	UpgradeListDBVar.profile.messages.scrollwindow:EnableMouse(false);
	UpgradeListDBVar.profile.messages.scrollwindow:Show();
	

	--Create Main Frame (UpgradeListMainFrame)
	local UpgradeListMainFrame = CreateFrame("Frame","UpgradeListMainFrame",UIParent);
	UpgradeListMainFrame:SetFrameStrata("DIALOG");
	UpgradeListMainFrame:SetWidth(1257);
	UpgradeListMainFrame:SetHeight(280);
	UpgradeListMainFrame:SetScale(UpgradeListDBVar.profile.mainframe.scale);
	
	UpgradeListMainFrame:SetBackdrop({bgFile = "Interface/DialogFrame/UI-DialogBox-Background-Dark", 
		edgeFile = "Interface/DialogFrame/UI-DialogBox-Border",
		tile = true, tileSize = 32, edgeSize = 32, 
		insets = { left = 11, right = 11, top = 10, bottom = 10 }});

	UpgradeListMainFrame:SetBackdropColor(0,0,0,1);

	UpgradeListMainFrame:SetPoint("TOP",0,-80);
	
	--Makes the Main Frame (and therefore all frames attached to it) draggable
	if UpgradeListDBVar.profile.mainframe.lock == false then
		UpgradeListMainFrame:SetMovable(true)
		UpgradeListMainFrame:EnableMouse(true)
	end
	UpgradeListMainFrame:RegisterForDrag("LeftButton")
	UpgradeListMainFrame:SetScript("OnDragStart", UpgradeListMainFrame.StartMoving)
	UpgradeListMainFrame:SetScript("OnDragStop", UpgradeListMainFrame.StopMovingOrSizing)


	--Make a title section for the Main Frame 
	local MF_titleBG = UpgradeListMainFrame:CreateTexture(nil,"ARTWORK");
	MF_titleBG:SetTexture("Interface/DialogFrame/UI-DialogBox-Header");
	MF_titleBG:SetWidth(280);
	MF_titleBG:SetHeight(64);
	MF_titleBG:SetPoint("TOP", UpgradeListMainFrame, 0, 12);
	UpgradeListMainFrame.texture = MF_titleBG;

	local MF_titleText = UpgradeListMainFrame:CreateFontString(nil, "ARTWORK", "GameFontNormalSmall");
	MF_titleText:SetText('Upgrade List');
	MF_titleText:SetPoint("TOP", UpgradeListMainFrame, 0, -3);
	
	--Version Identification
	VersionHeading = CreateFrame('Frame', "VersionHeading", UpgradeListMainFrame);
	VersionHeadingFont = VersionHeading:CreateFontString("VersionHeading", "ARTWORK", "GameFontWhiteTiny");
	VersionHeadingFont:SetText("v " .. UPGRADELIST_VERSION);
	VersionHeadingFont:SetPoint("TOPLEFT", UpgradeListMainFrame, "TOPLEFT", 13, -11);
	VersionHeadingFont:SetWidth(VersionHeadingFont:GetStringWidth() + 5);
	VersionHeadingFont:SetHeight(VersionHeadingFont:GetStringHeight());
	
	--Make an invisible frame within the Main Frame that will contain the UpgradeListDBVar.char.SavedOptions.tableUL
	local TableContainer = CreateFrame("Frame", "TableContainer", UpgradeListMainFrame);
	TableContainer:SetWidth(1265);
	TableContainer:SetHeight(235);
	TableContainer:SetPoint("TOPLEFT", UpgradeListMainFrame, "TOPLEFT", 0, -30);
	TableContainer:SetPoint("BOTTOMRIGHT", UpgradeListMainFrame, "BOTTOMRIGHT", 0, -12);

	
	--Create the UpgradeListDBVar.char.SavedOptions.tableUL by defining the columns, rows, height of the rows, then creating the UpgradeListDBVar.char.SavedOptions.tableUL
	local cols = {
		{  -- col 1
			name	= "Priority",
			width	= 42,
			defaultsort = "asc",
			align = "CENTER",
			bgcolor = {
				["r"] = 0.0, 
				["g"] = 0.0, 
				["b"] = 0.0, 
				["a"] = 1.0, 
			},
		},
		{  -- col 2
			name	= "iLvl",
			width	= 35,
			align = "CENTER",
			bgcolor = {
				["r"] = 0.0, 
				["g"] = 0.0, 
				["b"] = 0.0, 
				["a"] = 1.0, 
			},
		},
		{  -- col 3
			name	= "Item",
			width	= 240,
			align = "CENTER",
			bgcolor = {
				["r"] = 0.0, 
				["g"] = 0.0, 
				["b"] = 0.0, 
				["a"] = 1.0, 
			},
		},
		{  -- col 4
			name	= "Difficulty",
			width	= 80,
			align = "CENTER",
			bgcolor = {
				["r"] = 0.0, 
				["g"] = 0.0, 
				["b"] = 0.0, 
				["a"] = 1.0, 
			},
		},
		{  -- col 5
			name	= "Instance/Reputation/Point Type/Token",
			width	= 250,
			align = "CENTER",
			bgcolor = {
				["r"] = 0.0, 
				["g"] = 0.0, 
				["b"] = 0.0, 
				["a"] = 1.0, 
			},
		},
		{  -- col 6
			name	= "Boss/Reputation Level/Points Needed/Token Location",
			width	= 280,
			align = "CENTER",
			bgcolor = {
				["r"] = 0.0, 
				["g"] = 0.0, 
				["b"] = 0.0, 
				["a"] = 1.0, 
			},
		},
		{  -- col 7
			name	= "Note",
			width	= 280,
			align = "CENTER",
			bgcolor = {
				["r"] = 0.0, 
				["g"] = 0.0, 
				["b"] = 0.0, 
				["a"] = 1.0, 
			},
		},
	};

	local rows = 14
	local height = 15
	local ScrollingTable = LibStub("ScrollingTableUL");
	UpgradeListDBVar.char.SavedOptions.tableUL = ScrollingTable:CreateST(cols, rows, height, nil, TableContainer); --UpgradeListDBVar.char.SavedOptions.tableUL
	UpgradeListDBVar.char.SavedOptions.tableUL:RegisterEvents({
		["OnClick"] = function (rowFrame, cellFrame, data, cols, row, realrow, column, scrollingTable, ...)		
			ItemRefTooltip:SetOwner(UIParent, "ANCHOR_PRESERVE")
			if IsModifiedClick("CTRL") then
				EditNote:Show();
				UpgradeListMainFrame:EnableMouse(false)
				CloseButton:EnableMouse(false)
				ToggleButton:EnableMouse(false)
				UpgradeListDBVar.char.SavedOptions.PrimaryCheck:EnableMouse(false)
				UpgradeListDBVar.char.SavedOptions.SecondaryCheck:EnableMouse(false)
				OptionsFrame:EnableMouse(false)
				ItemEntryBox:EnableMouse(false)
				DropDown_Button:EnableMouse(false)
				NoteEntryBox:EnableMouse(false)
				PrimarySpecRadioButton:EnableMouse(false)
				SecondarySpecRadioButton:EnableMouse(false)
				priorityfield:EnableMouse(false)
				AddButton:EnableMouse(false)
				tofield:EnableMouse(false)
				fromfield:EnableMouse(false)
				MoveButton:EnableMouse(false)
				DeleteButton:EnableMouse(false)
				deletefield:EnableMouse(false)
			end
			if UpgradeListDBVar.char.SavedOptions.PrimaryCheck:GetChecked() then --If the primary checkbox is checked
				if PanelTemplates_GetSelectedTab(UpgradeListMainFrame) == 1 then
					if IsModifiedClick("CTRL") then
						EditNoteOK:SetScript("OnClick", function (self, button, down)
							local newnote = EditNoteBox:GetText();
							EditNote:Hide();
							EditNoteBox:SetText("");
							UpgradeListDBVar.char.PrimarySpecList.Head.Row[row][7] = newnote;
							UpgradeListMainFrame:EnableMouse(true)
							CloseButton:EnableMouse(true)
							ToggleButton:EnableMouse(true)
							UpgradeListDBVar.char.SavedOptions.PrimaryCheck:EnableMouse(true)
							UpgradeListDBVar.char.SavedOptions.SecondaryCheck:EnableMouse(true)
							OptionsFrame:EnableMouse(true)
							ItemEntryBox:EnableMouse(true)
							DropDown_Button:EnableMouse(true)
							NoteEntryBox:EnableMouse(true)
							PrimarySpecRadioButton:EnableMouse(true)
							SecondarySpecRadioButton:EnableMouse(true)
							priorityfield:EnableMouse(true)
							AddButton:EnableMouse(true)
							tofield:EnableMouse(true)
							fromfield:EnableMouse(true)
							MoveButton:EnableMouse(true)
							DeleteButton:EnableMouse(true)
							deletefield:EnableMouse(true)
							UpgradeList:RefreshWindow()
						end);
					elseif IsModifiedClick("SHIFT") then
						ChatEdit_InsertLink(UpgradeListDBVar.char.PrimarySpecList.Head.Row[row][3])
					else
						ItemRefTooltip:SetHyperlink(UpgradeListDBVar.char.PrimarySpecList.Head.Row[row][3]);
					end
				elseif PanelTemplates_GetSelectedTab(UpgradeListMainFrame) == 2 then
					if IsModifiedClick("CTRL") then
						EditNoteOK:SetScript("OnClick", function (self, button, down)
							local newnote = EditNoteBox:GetText();
							EditNote:Hide();
							EditNoteBox:SetText("");
							UpgradeListDBVar.char.PrimarySpecList.Neck.Row[row][7] = newnote;
							UpgradeListMainFrame:EnableMouse(true)
							CloseButton:EnableMouse(true)
							ToggleButton:EnableMouse(true)
							UpgradeListDBVar.char.SavedOptions.PrimaryCheck:EnableMouse(true)
							UpgradeListDBVar.char.SavedOptions.SecondaryCheck:EnableMouse(true)
							OptionsFrame:EnableMouse(true)
							ItemEntryBox:EnableMouse(true)
							DropDown_Button:EnableMouse(true)
							NoteEntryBox:EnableMouse(true)
							PrimarySpecRadioButton:EnableMouse(true)
							SecondarySpecRadioButton:EnableMouse(true)
							priorityfield:EnableMouse(true)
							AddButton:EnableMouse(true)
							tofield:EnableMouse(true)
							fromfield:EnableMouse(true)
							MoveButton:EnableMouse(true)
							DeleteButton:EnableMouse(true)
							deletefield:EnableMouse(true)
							UpgradeList:RefreshWindow()
						end);
					elseif IsModifiedClick("SHIFT") then
						ChatEdit_InsertLink(UpgradeListDBVar.char.PrimarySpecList.Neck.Row[row][3])
					else
						ItemRefTooltip:SetHyperlink(UpgradeListDBVar.char.PrimarySpecList.Neck.Row[row][3]);
					end
				elseif PanelTemplates_GetSelectedTab(UpgradeListMainFrame) == 3 then
					if IsModifiedClick("CTRL") then
						EditNoteOK:SetScript("OnClick", function (self, button, down)
							local newnote = EditNoteBox:GetText();
							EditNote:Hide();
							EditNoteBox:SetText("");
							UpgradeListDBVar.char.PrimarySpecList.Shoulder.Row[row][7] = newnote;
							UpgradeListMainFrame:EnableMouse(true)
							CloseButton:EnableMouse(true)
							ToggleButton:EnableMouse(true)
							UpgradeListDBVar.char.SavedOptions.PrimaryCheck:EnableMouse(true)
							UpgradeListDBVar.char.SavedOptions.SecondaryCheck:EnableMouse(true)
							OptionsFrame:EnableMouse(true)
							ItemEntryBox:EnableMouse(true)
							DropDown_Button:EnableMouse(true)
							NoteEntryBox:EnableMouse(true)
							PrimarySpecRadioButton:EnableMouse(true)
							SecondarySpecRadioButton:EnableMouse(true)
							priorityfield:EnableMouse(true)
							AddButton:EnableMouse(true)
							tofield:EnableMouse(true)
							fromfield:EnableMouse(true)
							MoveButton:EnableMouse(true)
							DeleteButton:EnableMouse(true)
							deletefield:EnableMouse(true)
							UpgradeList:RefreshWindow()
						end);
					elseif IsModifiedClick("SHIFT") then
						ChatEdit_InsertLink(UpgradeListDBVar.char.PrimarySpecList.Shoulder.Row[row][3])
					else
						ItemRefTooltip:SetHyperlink(UpgradeListDBVar.char.PrimarySpecList.Shoulder.Row[row][3]);
					end
				elseif PanelTemplates_GetSelectedTab(UpgradeListMainFrame) == 4 then
					if IsModifiedClick("CTRL") then
						EditNoteOK:SetScript("OnClick", function (self, button, down)
							local newnote = EditNoteBox:GetText();
							EditNote:Hide();
							EditNoteBox:SetText("");
							UpgradeListDBVar.char.PrimarySpecList.Back.Row[row][7] = newnote;
							UpgradeListMainFrame:EnableMouse(true)
							CloseButton:EnableMouse(true)
							ToggleButton:EnableMouse(true)
							UpgradeListDBVar.char.SavedOptions.PrimaryCheck:EnableMouse(true)
							UpgradeListDBVar.char.SavedOptions.SecondaryCheck:EnableMouse(true)
							OptionsFrame:EnableMouse(true)
							ItemEntryBox:EnableMouse(true)
							DropDown_Button:EnableMouse(true)
							NoteEntryBox:EnableMouse(true)
							PrimarySpecRadioButton:EnableMouse(true)
							SecondarySpecRadioButton:EnableMouse(true)
							priorityfield:EnableMouse(true)
							AddButton:EnableMouse(true)
							tofield:EnableMouse(true)
							fromfield:EnableMouse(true)
							MoveButton:EnableMouse(true)
							DeleteButton:EnableMouse(true)
							deletefield:EnableMouse(true)
							UpgradeList:RefreshWindow()
						end);
					elseif IsModifiedClick("SHIFT") then
						ChatEdit_InsertLink(UpgradeListDBVar.char.PrimarySpecList.Back.Row[row][3])
					else
						ItemRefTooltip:SetHyperlink(UpgradeListDBVar.char.PrimarySpecList.Back.Row[row][3]);
					end
				elseif PanelTemplates_GetSelectedTab(UpgradeListMainFrame) == 5 then
					if IsModifiedClick("CTRL") then
						EditNoteOK:SetScript("OnClick", function (self, button, down)
							local newnote = EditNoteBox:GetText();
							EditNote:Hide();
							EditNoteBox:SetText("");
							UpgradeListDBVar.char.PrimarySpecList.Chest.Row[row][7] = newnote;
							UpgradeListMainFrame:EnableMouse(true)
							CloseButton:EnableMouse(true)
							ToggleButton:EnableMouse(true)
							UpgradeListDBVar.char.SavedOptions.PrimaryCheck:EnableMouse(true)
							UpgradeListDBVar.char.SavedOptions.SecondaryCheck:EnableMouse(true)
							OptionsFrame:EnableMouse(true)
							ItemEntryBox:EnableMouse(true)
							DropDown_Button:EnableMouse(true)
							NoteEntryBox:EnableMouse(true)
							PrimarySpecRadioButton:EnableMouse(true)
							SecondarySpecRadioButton:EnableMouse(true)
							priorityfield:EnableMouse(true)
							AddButton:EnableMouse(true)
							tofield:EnableMouse(true)
							fromfield:EnableMouse(true)
							MoveButton:EnableMouse(true)
							DeleteButton:EnableMouse(true)
							deletefield:EnableMouse(true)
							UpgradeList:RefreshWindow()
						end);
					elseif IsModifiedClick("SHIFT") then
						ChatEdit_InsertLink(UpgradeListDBVar.char.PrimarySpecList.Chest.Row[row][3])
					else
						ItemRefTooltip:SetHyperlink(UpgradeListDBVar.char.PrimarySpecList.Chest.Row[row][3]);
					end
				elseif PanelTemplates_GetSelectedTab(UpgradeListMainFrame) == 6 then
					if IsModifiedClick("CTRL") then
						EditNoteOK:SetScript("OnClick", function (self, button, down)
							local newnote = EditNoteBox:GetText();
							EditNote:Hide();
							EditNoteBox:SetText("");
							UpgradeListDBVar.char.PrimarySpecList.Wrist.Row[row][7] = newnote;
							UpgradeListMainFrame:EnableMouse(true)
							CloseButton:EnableMouse(true)
							ToggleButton:EnableMouse(true)
							UpgradeListDBVar.char.SavedOptions.PrimaryCheck:EnableMouse(true)
							UpgradeListDBVar.char.SavedOptions.SecondaryCheck:EnableMouse(true)
							OptionsFrame:EnableMouse(true)
							ItemEntryBox:EnableMouse(true)
							DropDown_Button:EnableMouse(true)
							NoteEntryBox:EnableMouse(true)
							PrimarySpecRadioButton:EnableMouse(true)
							SecondarySpecRadioButton:EnableMouse(true)
							priorityfield:EnableMouse(true)
							AddButton:EnableMouse(true)
							tofield:EnableMouse(true)
							fromfield:EnableMouse(true)
							MoveButton:EnableMouse(true)
							DeleteButton:EnableMouse(true)
							deletefield:EnableMouse(true)
							UpgradeList:RefreshWindow()
						end);
					elseif IsModifiedClick("SHIFT") then
						ChatEdit_InsertLink(UpgradeListDBVar.char.PrimarySpecList.Wrist.Row[row][3])
					else
						ItemRefTooltip:SetHyperlink(UpgradeListDBVar.char.PrimarySpecList.Wrist.Row[row][3]);
					end
				elseif PanelTemplates_GetSelectedTab(UpgradeListMainFrame) == 7 then
					if IsModifiedClick("CTRL") then
						EditNoteOK:SetScript("OnClick", function (self, button, down)
							local newnote = EditNoteBox:GetText();
							EditNote:Hide();
							EditNoteBox:SetText("");
							UpgradeListDBVar.char.PrimarySpecList.Hand.Row[row][7] = newnote;
							UpgradeListMainFrame:EnableMouse(true)
							CloseButton:EnableMouse(true)
							ToggleButton:EnableMouse(true)
							UpgradeListDBVar.char.SavedOptions.PrimaryCheck:EnableMouse(true)
							UpgradeListDBVar.char.SavedOptions.SecondaryCheck:EnableMouse(true)
							OptionsFrame:EnableMouse(true)
							ItemEntryBox:EnableMouse(true)
							DropDown_Button:EnableMouse(true)
							NoteEntryBox:EnableMouse(true)
							PrimarySpecRadioButton:EnableMouse(true)
							SecondarySpecRadioButton:EnableMouse(true)
							priorityfield:EnableMouse(true)
							AddButton:EnableMouse(true)
							tofield:EnableMouse(true)
							fromfield:EnableMouse(true)
							MoveButton:EnableMouse(true)
							DeleteButton:EnableMouse(true)
							deletefield:EnableMouse(true)
							UpgradeList:RefreshWindow()
						end);
					elseif IsModifiedClick("SHIFT") then
						ChatEdit_InsertLink(UpgradeListDBVar.char.PrimarySpecList.Hand.Row[row][3])
					else
						ItemRefTooltip:SetHyperlink(UpgradeListDBVar.char.PrimarySpecList.Hand.Row[row][3]);
					end
				elseif PanelTemplates_GetSelectedTab(UpgradeListMainFrame) == 8 then
					if IsModifiedClick("CTRL") then
						EditNoteOK:SetScript("OnClick", function (self, button, down)
							local newnote = EditNoteBox:GetText();
							EditNote:Hide();
							EditNoteBox:SetText("");
							UpgradeListDBVar.char.PrimarySpecList.Waist.Row[row][7] = newnote;
							UpgradeListMainFrame:EnableMouse(true)
							CloseButton:EnableMouse(true)
							ToggleButton:EnableMouse(true)
							UpgradeListDBVar.char.SavedOptions.PrimaryCheck:EnableMouse(true)
							UpgradeListDBVar.char.SavedOptions.SecondaryCheck:EnableMouse(true)
							OptionsFrame:EnableMouse(true)
							ItemEntryBox:EnableMouse(true)
							DropDown_Button:EnableMouse(true)
							NoteEntryBox:EnableMouse(true)
							PrimarySpecRadioButton:EnableMouse(true)
							SecondarySpecRadioButton:EnableMouse(true)
							priorityfield:EnableMouse(true)
							AddButton:EnableMouse(true)
							tofield:EnableMouse(true)
							fromfield:EnableMouse(true)
							MoveButton:EnableMouse(true)
							DeleteButton:EnableMouse(true)
							deletefield:EnableMouse(true)
							UpgradeList:RefreshWindow()
						end);
					elseif IsModifiedClick("SHIFT") then
						ChatEdit_InsertLink(UpgradeListDBVar.char.PrimarySpecList.Waist.Row[row][3])
					else
						ItemRefTooltip:SetHyperlink(UpgradeListDBVar.char.PrimarySpecList.Waist.Row[row][3]);
					end
				elseif PanelTemplates_GetSelectedTab(UpgradeListMainFrame) == 9 then
					if IsModifiedClick("CTRL") then
						EditNoteOK:SetScript("OnClick", function (self, button, down)
							local newnote = EditNoteBox:GetText();
							EditNote:Hide();
							EditNoteBox:SetText("");
							UpgradeListDBVar.char.PrimarySpecList.Leg.Row[row][7] = newnote;
							UpgradeListMainFrame:EnableMouse(true)
							CloseButton:EnableMouse(true)
							ToggleButton:EnableMouse(true)
							UpgradeListDBVar.char.SavedOptions.PrimaryCheck:EnableMouse(true)
							UpgradeListDBVar.char.SavedOptions.SecondaryCheck:EnableMouse(true)
							OptionsFrame:EnableMouse(true)
							ItemEntryBox:EnableMouse(true)
							DropDown_Button:EnableMouse(true)
							NoteEntryBox:EnableMouse(true)
							PrimarySpecRadioButton:EnableMouse(true)
							SecondarySpecRadioButton:EnableMouse(true)
							priorityfield:EnableMouse(true)
							AddButton:EnableMouse(true)
							tofield:EnableMouse(true)
							fromfield:EnableMouse(true)
							MoveButton:EnableMouse(true)
							DeleteButton:EnableMouse(true)
							deletefield:EnableMouse(true)
							UpgradeList:RefreshWindow()
						end);
					elseif IsModifiedClick("SHIFT") then
						ChatEdit_InsertLink(UpgradeListDBVar.char.PrimarySpecList.Leg.Row[row][3])
					else
						ItemRefTooltip:SetHyperlink(UpgradeListDBVar.char.PrimarySpecList.Leg.Row[row][3]);
					end
				elseif PanelTemplates_GetSelectedTab(UpgradeListMainFrame) == 10 then
					if IsModifiedClick("CTRL") then
						EditNoteOK:SetScript("OnClick", function (self, button, down)
							local newnote = EditNoteBox:GetText();
							EditNote:Hide();
							EditNoteBox:SetText("");
							UpgradeListDBVar.char.PrimarySpecList.Foot.Row[row][7] = newnote;
							UpgradeListMainFrame:EnableMouse(true)
							CloseButton:EnableMouse(true)
							ToggleButton:EnableMouse(true)
							UpgradeListDBVar.char.SavedOptions.PrimaryCheck:EnableMouse(true)
							UpgradeListDBVar.char.SavedOptions.SecondaryCheck:EnableMouse(true)
							OptionsFrame:EnableMouse(true)
							ItemEntryBox:EnableMouse(true)
							DropDown_Button:EnableMouse(true)
							NoteEntryBox:EnableMouse(true)
							PrimarySpecRadioButton:EnableMouse(true)
							SecondarySpecRadioButton:EnableMouse(true)
							priorityfield:EnableMouse(true)
							AddButton:EnableMouse(true)
							tofield:EnableMouse(true)
							fromfield:EnableMouse(true)
							MoveButton:EnableMouse(true)
							DeleteButton:EnableMouse(true)
							deletefield:EnableMouse(true)
							UpgradeList:RefreshWindow()
						end);
					elseif IsModifiedClick("SHIFT") then
						ChatEdit_InsertLink(UpgradeListDBVar.char.PrimarySpecList.Foot.Row[row][3])
					else
						ItemRefTooltip:SetHyperlink(UpgradeListDBVar.char.PrimarySpecList.Foot.Row[row][3]);
					end
				elseif PanelTemplates_GetSelectedTab(UpgradeListMainFrame) == 11 then
					if IsModifiedClick("CTRL") then
						EditNoteOK:SetScript("OnClick", function (self, button, down)
							local newnote = EditNoteBox:GetText();
							EditNote:Hide();
							EditNoteBox:SetText("");
							UpgradeListDBVar.char.PrimarySpecList.Ring.Row[row][7] = newnote;
							UpgradeListMainFrame:EnableMouse(true)
							CloseButton:EnableMouse(true)
							ToggleButton:EnableMouse(true)
							UpgradeListDBVar.char.SavedOptions.PrimaryCheck:EnableMouse(true)
							UpgradeListDBVar.char.SavedOptions.SecondaryCheck:EnableMouse(true)
							OptionsFrame:EnableMouse(true)
							ItemEntryBox:EnableMouse(true)
							DropDown_Button:EnableMouse(true)
							NoteEntryBox:EnableMouse(true)
							PrimarySpecRadioButton:EnableMouse(true)
							SecondarySpecRadioButton:EnableMouse(true)
							priorityfield:EnableMouse(true)
							AddButton:EnableMouse(true)
							tofield:EnableMouse(true)
							fromfield:EnableMouse(true)
							MoveButton:EnableMouse(true)
							DeleteButton:EnableMouse(true)
							deletefield:EnableMouse(true)
							UpgradeList:RefreshWindow()
						end);
					elseif IsModifiedClick("SHIFT") then
						ChatEdit_InsertLink(UpgradeListDBVar.char.PrimarySpecList.Ring.Row[row][3])
					else
						ItemRefTooltip:SetHyperlink(UpgradeListDBVar.char.PrimarySpecList.Ring.Row[row][3]);
					end
				elseif PanelTemplates_GetSelectedTab(UpgradeListMainFrame) == 12 then
					if IsModifiedClick("CTRL") then
						EditNoteOK:SetScript("OnClick", function (self, button, down)
							local newnote = EditNoteBox:GetText();
							EditNote:Hide();
							EditNoteBox:SetText("");
							UpgradeListDBVar.char.PrimarySpecList.Trinket.Row[row][7] = newnote;
							UpgradeListMainFrame:EnableMouse(true)
							CloseButton:EnableMouse(true)
							ToggleButton:EnableMouse(true)
							UpgradeListDBVar.char.SavedOptions.PrimaryCheck:EnableMouse(true)
							UpgradeListDBVar.char.SavedOptions.SecondaryCheck:EnableMouse(true)
							OptionsFrame:EnableMouse(true)
							ItemEntryBox:EnableMouse(true)
							DropDown_Button:EnableMouse(true)
							NoteEntryBox:EnableMouse(true)
							PrimarySpecRadioButton:EnableMouse(true)
							SecondarySpecRadioButton:EnableMouse(true)
							priorityfield:EnableMouse(true)
							AddButton:EnableMouse(true)
							tofield:EnableMouse(true)
							fromfield:EnableMouse(true)
							MoveButton:EnableMouse(true)
							DeleteButton:EnableMouse(true)
							deletefield:EnableMouse(true)
							UpgradeList:RefreshWindow()
						end);
					elseif IsModifiedClick("SHIFT") then
						ChatEdit_InsertLink(UpgradeListDBVar.char.PrimarySpecList.Trinket.Row[row][3])
					else
						ItemRefTooltip:SetHyperlink(UpgradeListDBVar.char.PrimarySpecList.Trinket.Row[row][3]);
					end
				elseif PanelTemplates_GetSelectedTab(UpgradeListMainFrame) == 13 then
					if IsModifiedClick("CTRL") then
						EditNoteOK:SetScript("OnClick", function (self, button, down)
							local newnote = EditNoteBox:GetText();
							EditNote:Hide();
							EditNoteBox:SetText("");
							UpgradeListDBVar.char.PrimarySpecList.Main.Row[row][7] = newnote;
							UpgradeListMainFrame:EnableMouse(true)
							CloseButton:EnableMouse(true)
							ToggleButton:EnableMouse(true)
							UpgradeListDBVar.char.SavedOptions.PrimaryCheck:EnableMouse(true)
							UpgradeListDBVar.char.SavedOptions.SecondaryCheck:EnableMouse(true)
							OptionsFrame:EnableMouse(true)
							ItemEntryBox:EnableMouse(true)
							DropDown_Button:EnableMouse(true)
							NoteEntryBox:EnableMouse(true)
							PrimarySpecRadioButton:EnableMouse(true)
							SecondarySpecRadioButton:EnableMouse(true)
							priorityfield:EnableMouse(true)
							AddButton:EnableMouse(true)
							tofield:EnableMouse(true)
							fromfield:EnableMouse(true)
							MoveButton:EnableMouse(true)
							DeleteButton:EnableMouse(true)
							deletefield:EnableMouse(true)
							UpgradeList:RefreshWindow()
						end);
					elseif IsModifiedClick("SHIFT") then
						ChatEdit_InsertLink(UpgradeListDBVar.char.PrimarySpecList.Main.Row[row][3])
					else
						ItemRefTooltip:SetHyperlink(UpgradeListDBVar.char.PrimarySpecList.Main.Row[row][3]);
					end
				elseif PanelTemplates_GetSelectedTab(UpgradeListMainFrame) == 14 then
					if IsModifiedClick("CTRL") then
						EditNoteOK:SetScript("OnClick", function (self, button, down)
							local newnote = EditNoteBox:GetText();
							EditNote:Hide();
							EditNoteBox:SetText("");
							UpgradeListDBVar.char.PrimarySpecList.Off.Row[row][7] = newnote;
							UpgradeListMainFrame:EnableMouse(true)
							CloseButton:EnableMouse(true)
							ToggleButton:EnableMouse(true)
							UpgradeListDBVar.char.SavedOptions.PrimaryCheck:EnableMouse(true)
							UpgradeListDBVar.char.SavedOptions.SecondaryCheck:EnableMouse(true)
							OptionsFrame:EnableMouse(true)
							ItemEntryBox:EnableMouse(true)
							DropDown_Button:EnableMouse(true)
							NoteEntryBox:EnableMouse(true)
							PrimarySpecRadioButton:EnableMouse(true)
							SecondarySpecRadioButton:EnableMouse(true)
							priorityfield:EnableMouse(true)
							AddButton:EnableMouse(true)
							tofield:EnableMouse(true)
							fromfield:EnableMouse(true)
							MoveButton:EnableMouse(true)
							DeleteButton:EnableMouse(true)
							deletefield:EnableMouse(true)
							UpgradeList:RefreshWindow()
						end);
					elseif IsModifiedClick("SHIFT") then
						ChatEdit_InsertLink(UpgradeListDBVar.char.PrimarySpecList.Off.Row[row][3])
					else
						ItemRefTooltip:SetHyperlink(UpgradeListDBVar.char.PrimarySpecList.Off.Row[row][3]);
					end
				elseif PanelTemplates_GetSelectedTab(UpgradeListMainFrame) == 15 then
					if IsModifiedClick("CTRL") then
						EditNoteOK:SetScript("OnClick", function (self, button, down)
							local newnote = EditNoteBox:GetText();
							EditNote:Hide();
							EditNoteBox:SetText("");
							UpgradeListDBVar.char.PrimarySpecList.Ranged.Row[row][7] = newnote;
							UpgradeListMainFrame:EnableMouse(true)
							CloseButton:EnableMouse(true)
							ToggleButton:EnableMouse(true)
							UpgradeListDBVar.char.SavedOptions.PrimaryCheck:EnableMouse(true)
							UpgradeListDBVar.char.SavedOptions.SecondaryCheck:EnableMouse(true)
							OptionsFrame:EnableMouse(true)
							ItemEntryBox:EnableMouse(true)
							DropDown_Button:EnableMouse(true)
							NoteEntryBox:EnableMouse(true)
							PrimarySpecRadioButton:EnableMouse(true)
							SecondarySpecRadioButton:EnableMouse(true)
							priorityfield:EnableMouse(true)
							AddButton:EnableMouse(true)
							tofield:EnableMouse(true)
							fromfield:EnableMouse(true)
							MoveButton:EnableMouse(true)
							DeleteButton:EnableMouse(true)
							deletefield:EnableMouse(true)
							UpgradeList:RefreshWindow()
						end);
					elseif IsModifiedClick("SHIFT") then
						ChatEdit_InsertLink(UpgradeListDBVar.char.PrimarySpecList.Ranged.Row[row][3])
					else
						ItemRefTooltip:SetHyperlink(UpgradeListDBVar.char.PrimarySpecList.Ranged.Row[row][3]);
					end
				elseif PanelTemplates_GetSelectedTab(UpgradeListMainFrame) == 16 then
					if IsModifiedClick("CTRL") then
						EditNoteOK:SetScript("OnClick", function (self, button, down)
							local newnote = EditNoteBox:GetText();
							EditNote:Hide();
							EditNoteBox:SetText("");
							UpgradeListDBVar.char.PrimarySpecList.Other.Row[row][7] = newnote;
							UpgradeListMainFrame:EnableMouse(true)
							CloseButton:EnableMouse(true)
							ToggleButton:EnableMouse(true)
							UpgradeListDBVar.char.SavedOptions.PrimaryCheck:EnableMouse(true)
							UpgradeListDBVar.char.SavedOptions.SecondaryCheck:EnableMouse(true)
							OptionsFrame:EnableMouse(true)
							ItemEntryBox:EnableMouse(true)
							DropDown_Button:EnableMouse(true)
							NoteEntryBox:EnableMouse(true)
							PrimarySpecRadioButton:EnableMouse(true)
							SecondarySpecRadioButton:EnableMouse(true)
							priorityfield:EnableMouse(true)
							AddButton:EnableMouse(true)
							tofield:EnableMouse(true)
							fromfield:EnableMouse(true)
							MoveButton:EnableMouse(true)
							DeleteButton:EnableMouse(true)
							deletefield:EnableMouse(true)
							UpgradeList:RefreshWindow()
						end);
					elseif IsModifiedClick("SHIFT") then
						ChatEdit_InsertLink(UpgradeListDBVar.char.PrimarySpecList.Other.Row[row][3])
					else
						ItemRefTooltip:SetHyperlink(UpgradeListDBVar.char.PrimarySpecList.Other.Row[row][3]);
					end
				end
			else --The secondary checkbox is checked
				if PanelTemplates_GetSelectedTab(UpgradeListMainFrame) == 1 then
					if IsModifiedClick("CTRL") then
						EditNoteOK:SetScript("OnClick", function (self, button, down)
							local newnote = EditNoteBox:GetText();
							EditNote:Hide();
							EditNoteBox:SetText("");
							UpgradeListDBVar.char.SecondarySpecList.Head.Row[row][7] = newnote;
							UpgradeListMainFrame:EnableMouse(true)
							CloseButton:EnableMouse(true)
							ToggleButton:EnableMouse(true)
							UpgradeListDBVar.char.SavedOptions.PrimaryCheck:EnableMouse(true)
							UpgradeListDBVar.char.SavedOptions.SecondaryCheck:EnableMouse(true)
							OptionsFrame:EnableMouse(true)
							ItemEntryBox:EnableMouse(true)
							DropDown_Button:EnableMouse(true)
							NoteEntryBox:EnableMouse(true)
							PrimarySpecRadioButton:EnableMouse(true)
							SecondarySpecRadioButton:EnableMouse(true)
							priorityfield:EnableMouse(true)
							AddButton:EnableMouse(true)
							tofield:EnableMouse(true)
							fromfield:EnableMouse(true)
							MoveButton:EnableMouse(true)
							DeleteButton:EnableMouse(true)
							deletefield:EnableMouse(true)
							UpgradeList:RefreshWindow()
						end);
					elseif IsModifiedClick("SHIFT") then
						ChatEdit_InsertLink(UpgradeListDBVar.char.SecondarySpecList.Head.Row[row][3])
					else
						ItemRefTooltip:SetHyperlink(UpgradeListDBVar.char.SecondarySpecList.Head.Row[row][3]);
					end
				elseif PanelTemplates_GetSelectedTab(UpgradeListMainFrame) == 2 then
					if IsModifiedClick("CTRL") then
						EditNoteOK:SetScript("OnClick", function (self, button, down)
							local newnote = EditNoteBox:GetText();
							EditNote:Hide();
							EditNoteBox:SetText("");
							UpgradeListDBVar.char.SecondarySpecList.Neck.Row[row][7] = newnote;
							UpgradeListMainFrame:EnableMouse(true)
							CloseButton:EnableMouse(true)
							ToggleButton:EnableMouse(true)
							UpgradeListDBVar.char.SavedOptions.PrimaryCheck:EnableMouse(true)
							UpgradeListDBVar.char.SavedOptions.SecondaryCheck:EnableMouse(true)
							OptionsFrame:EnableMouse(true)
							ItemEntryBox:EnableMouse(true)
							DropDown_Button:EnableMouse(true)
							NoteEntryBox:EnableMouse(true)
							PrimarySpecRadioButton:EnableMouse(true)
							SecondarySpecRadioButton:EnableMouse(true)
							priorityfield:EnableMouse(true)
							AddButton:EnableMouse(true)
							tofield:EnableMouse(true)
							fromfield:EnableMouse(true)
							MoveButton:EnableMouse(true)
							DeleteButton:EnableMouse(true)
							deletefield:EnableMouse(true)
							UpgradeList:RefreshWindow()
						end);
					elseif IsModifiedClick("SHIFT") then
						ChatEdit_InsertLink(UpgradeListDBVar.char.SecondarySpecList.Neck.Row[row][3])
					else
						ItemRefTooltip:SetHyperlink(UpgradeListDBVar.char.SecondarySpecList.Neck.Row[row][3]);
					end
				elseif PanelTemplates_GetSelectedTab(UpgradeListMainFrame) == 3 then
					if IsModifiedClick("CTRL") then
						EditNoteOK:SetScript("OnClick", function (self, button, down)
							local newnote = EditNoteBox:GetText();
							EditNote:Hide();
							EditNoteBox:SetText("");
							UpgradeListDBVar.char.SecondarySpecList.Shoulder.Row[row][7] = newnote;
							UpgradeListMainFrame:EnableMouse(true)
							CloseButton:EnableMouse(true)
							ToggleButton:EnableMouse(true)
							UpgradeListDBVar.char.SavedOptions.PrimaryCheck:EnableMouse(true)
							UpgradeListDBVar.char.SavedOptions.SecondaryCheck:EnableMouse(true)
							OptionsFrame:EnableMouse(true)
							ItemEntryBox:EnableMouse(true)
							DropDown_Button:EnableMouse(true)
							NoteEntryBox:EnableMouse(true)
							PrimarySpecRadioButton:EnableMouse(true)
							SecondarySpecRadioButton:EnableMouse(true)
							priorityfield:EnableMouse(true)
							AddButton:EnableMouse(true)
							tofield:EnableMouse(true)
							fromfield:EnableMouse(true)
							MoveButton:EnableMouse(true)
							DeleteButton:EnableMouse(true)
							deletefield:EnableMouse(true)
							UpgradeList:RefreshWindow()
						end);
					elseif IsModifiedClick("SHIFT") then
						ChatEdit_InsertLink(UpgradeListDBVar.char.SecondarySpecList.Shoulder.Row[row][3])
					else
						ItemRefTooltip:SetHyperlink(UpgradeListDBVar.char.SecondarySpecList.Shoulder.Row[row][3]);
					end
				elseif PanelTemplates_GetSelectedTab(UpgradeListMainFrame) == 4 then
					if IsModifiedClick("CTRL") then
						EditNoteOK:SetScript("OnClick", function (self, button, down)
							local newnote = EditNoteBox:GetText();
							EditNote:Hide();
							EditNoteBox:SetText("");
							UpgradeListDBVar.char.SecondarySpecList.Back.Row[row][7] = newnote;
							UpgradeListMainFrame:EnableMouse(true)
							CloseButton:EnableMouse(true)
							ToggleButton:EnableMouse(true)
							UpgradeListDBVar.char.SavedOptions.PrimaryCheck:EnableMouse(true)
							UpgradeListDBVar.char.SavedOptions.SecondaryCheck:EnableMouse(true)
							OptionsFrame:EnableMouse(true)
							ItemEntryBox:EnableMouse(true)
							DropDown_Button:EnableMouse(true)
							NoteEntryBox:EnableMouse(true)
							PrimarySpecRadioButton:EnableMouse(true)
							SecondarySpecRadioButton:EnableMouse(true)
							priorityfield:EnableMouse(true)
							AddButton:EnableMouse(true)
							tofield:EnableMouse(true)
							fromfield:EnableMouse(true)
							MoveButton:EnableMouse(true)
							DeleteButton:EnableMouse(true)
							deletefield:EnableMouse(true)
							UpgradeList:RefreshWindow()
						end);
					elseif IsModifiedClick("SHIFT") then
						ChatEdit_InsertLink(UpgradeListDBVar.char.SecondarySpecList.Back.Row[row][3])
					else
						ItemRefTooltip:SetHyperlink(UpgradeListDBVar.char.SecondarySpecList.Back.Row[row][3]);
					end
				elseif PanelTemplates_GetSelectedTab(UpgradeListMainFrame) == 5 then
					if IsModifiedClick("CTRL") then
						EditNoteOK:SetScript("OnClick", function (self, button, down)
							local newnote = EditNoteBox:GetText();
							EditNote:Hide();
							EditNoteBox:SetText("");
							UpgradeListDBVar.char.SecondarySpecList.Chest.Row[row][7] = newnote;
							UpgradeListMainFrame:EnableMouse(true)
							CloseButton:EnableMouse(true)
							ToggleButton:EnableMouse(true)
							UpgradeListDBVar.char.SavedOptions.PrimaryCheck:EnableMouse(true)
							UpgradeListDBVar.char.SavedOptions.SecondaryCheck:EnableMouse(true)
							OptionsFrame:EnableMouse(true)
							ItemEntryBox:EnableMouse(true)
							DropDown_Button:EnableMouse(true)
							NoteEntryBox:EnableMouse(true)
							PrimarySpecRadioButton:EnableMouse(true)
							SecondarySpecRadioButton:EnableMouse(true)
							priorityfield:EnableMouse(true)
							AddButton:EnableMouse(true)
							tofield:EnableMouse(true)
							fromfield:EnableMouse(true)
							MoveButton:EnableMouse(true)
							DeleteButton:EnableMouse(true)
							deletefield:EnableMouse(true)
							UpgradeList:RefreshWindow()
						end);
					elseif IsModifiedClick("SHIFT") then
						ChatEdit_InsertLink(UpgradeListDBVar.char.SecondarySpecList.Chest.Row[row][3])
					else
						ItemRefTooltip:SetHyperlink(UpgradeListDBVar.char.SecondarySpecList.Chest.Row[row][3]);
					end
				elseif PanelTemplates_GetSelectedTab(UpgradeListMainFrame) == 6 then
					if IsModifiedClick("CTRL") then
						EditNoteOK:SetScript("OnClick", function (self, button, down)
							local newnote = EditNoteBox:GetText();
							EditNote:Hide();
							EditNoteBox:SetText("");
							UpgradeListDBVar.char.SecondarySpecList.Wrist.Row[row][7] = newnote;
							UpgradeListMainFrame:EnableMouse(true)
							CloseButton:EnableMouse(true)
							ToggleButton:EnableMouse(true)
							UpgradeListDBVar.char.SavedOptions.PrimaryCheck:EnableMouse(true)
							UpgradeListDBVar.char.SavedOptions.SecondaryCheck:EnableMouse(true)
							OptionsFrame:EnableMouse(true)
							ItemEntryBox:EnableMouse(true)
							DropDown_Button:EnableMouse(true)
							NoteEntryBox:EnableMouse(true)
							PrimarySpecRadioButton:EnableMouse(true)
							SecondarySpecRadioButton:EnableMouse(true)
							priorityfield:EnableMouse(true)
							AddButton:EnableMouse(true)
							tofield:EnableMouse(true)
							fromfield:EnableMouse(true)
							MoveButton:EnableMouse(true)
							DeleteButton:EnableMouse(true)
							deletefield:EnableMouse(true)
							UpgradeList:RefreshWindow()
						end);
					elseif IsModifiedClick("SHIFT") then
						ChatEdit_InsertLink(UpgradeListDBVar.char.SecondarySpecList.Wrist.Row[row][3])
					else
						ItemRefTooltip:SetHyperlink(UpgradeListDBVar.char.SecondarySpecList.Wrist.Row[row][3]);
					end
				elseif PanelTemplates_GetSelectedTab(UpgradeListMainFrame) == 7 then
					if IsModifiedClick("CTRL") then
						EditNoteOK:SetScript("OnClick", function (self, button, down)
							local newnote = EditNoteBox:GetText();
							EditNote:Hide();
							EditNoteBox:SetText("");
							UpgradeListDBVar.char.SecondarySpecList.Hand.Row[row][7] = newnote;
							UpgradeListMainFrame:EnableMouse(true)
							CloseButton:EnableMouse(true)
							ToggleButton:EnableMouse(true)
							UpgradeListDBVar.char.SavedOptions.PrimaryCheck:EnableMouse(true)
							UpgradeListDBVar.char.SavedOptions.SecondaryCheck:EnableMouse(true)
							OptionsFrame:EnableMouse(true)
							ItemEntryBox:EnableMouse(true)
							DropDown_Button:EnableMouse(true)
							NoteEntryBox:EnableMouse(true)
							PrimarySpecRadioButton:EnableMouse(true)
							SecondarySpecRadioButton:EnableMouse(true)
							priorityfield:EnableMouse(true)
							AddButton:EnableMouse(true)
							tofield:EnableMouse(true)
							fromfield:EnableMouse(true)
							MoveButton:EnableMouse(true)
							DeleteButton:EnableMouse(true)
							deletefield:EnableMouse(true)
							UpgradeList:RefreshWindow()
						end);
					elseif IsModifiedClick("SHIFT") then
						ChatEdit_InsertLink(UpgradeListDBVar.char.SecondarySpecList.Hand.Row[row][3])
					else
						ItemRefTooltip:SetHyperlink(UpgradeListDBVar.char.SecondarySpecList.Hand.Row[row][3]);
					end
				elseif PanelTemplates_GetSelectedTab(UpgradeListMainFrame) == 8 then
					if IsModifiedClick("CTRL") then
						EditNoteOK:SetScript("OnClick", function (self, button, down)
							local newnote = EditNoteBox:GetText();
							EditNote:Hide();
							EditNoteBox:SetText("");
							UpgradeListDBVar.char.SecondarySpecList.Waist.Row[row][7] = newnote;
							UpgradeListMainFrame:EnableMouse(true)
							CloseButton:EnableMouse(true)
							ToggleButton:EnableMouse(true)
							UpgradeListDBVar.char.SavedOptions.PrimaryCheck:EnableMouse(true)
							UpgradeListDBVar.char.SavedOptions.SecondaryCheck:EnableMouse(true)
							OptionsFrame:EnableMouse(true)
							ItemEntryBox:EnableMouse(true)
							DropDown_Button:EnableMouse(true)
							NoteEntryBox:EnableMouse(true)
							PrimarySpecRadioButton:EnableMouse(true)
							SecondarySpecRadioButton:EnableMouse(true)
							priorityfield:EnableMouse(true)
							AddButton:EnableMouse(true)
							tofield:EnableMouse(true)
							fromfield:EnableMouse(true)
							MoveButton:EnableMouse(true)
							DeleteButton:EnableMouse(true)
							deletefield:EnableMouse(true)
							UpgradeList:RefreshWindow()
						end);
					elseif IsModifiedClick("SHIFT") then
						ChatEdit_InsertLink(UpgradeListDBVar.char.SecondarySpecList.Waist.Row[row][3])
					else
						ItemRefTooltip:SetHyperlink(UpgradeListDBVar.char.SecondarySpecList.Waist.Row[row][3]);
					end
				elseif PanelTemplates_GetSelectedTab(UpgradeListMainFrame) == 9 then
					if IsModifiedClick("CTRL") then
						EditNoteOK:SetScript("OnClick", function (self, button, down)
							local newnote = EditNoteBox:GetText();
							EditNote:Hide();
							EditNoteBox:SetText("");
							UpgradeListDBVar.char.SecondarySpecList.Leg.Row[row][7] = newnote;
							UpgradeListMainFrame:EnableMouse(true)
							CloseButton:EnableMouse(true)
							ToggleButton:EnableMouse(true)
							UpgradeListDBVar.char.SavedOptions.PrimaryCheck:EnableMouse(true)
							UpgradeListDBVar.char.SavedOptions.SecondaryCheck:EnableMouse(true)
							OptionsFrame:EnableMouse(true)
							ItemEntryBox:EnableMouse(true)
							DropDown_Button:EnableMouse(true)
							NoteEntryBox:EnableMouse(true)
							PrimarySpecRadioButton:EnableMouse(true)
							SecondarySpecRadioButton:EnableMouse(true)
							priorityfield:EnableMouse(true)
							AddButton:EnableMouse(true)
							tofield:EnableMouse(true)
							fromfield:EnableMouse(true)
							MoveButton:EnableMouse(true)
							DeleteButton:EnableMouse(true)
							deletefield:EnableMouse(true)
							UpgradeList:RefreshWindow()
						end);
					elseif IsModifiedClick("SHIFT") then
						ChatEdit_InsertLink(UpgradeListDBVar.char.SecondarySpecList.Leg.Row[row][3])
					else
						ItemRefTooltip:SetHyperlink(UpgradeListDBVar.char.SecondarySpecList.Leg.Row[row][3]);
					end
				elseif PanelTemplates_GetSelectedTab(UpgradeListMainFrame) == 10 then
					if IsModifiedClick("CTRL") then
						EditNoteOK:SetScript("OnClick", function (self, button, down)
							local newnote = EditNoteBox:GetText();
							EditNote:Hide();
							EditNoteBox:SetText("");
							UpgradeListDBVar.char.SecondarySpecList.Foot.Row[row][7] = newnote;
							UpgradeListMainFrame:EnableMouse(true)
							CloseButton:EnableMouse(true)
							ToggleButton:EnableMouse(true)
							UpgradeListDBVar.char.SavedOptions.PrimaryCheck:EnableMouse(true)
							UpgradeListDBVar.char.SavedOptions.SecondaryCheck:EnableMouse(true)
							OptionsFrame:EnableMouse(true)
							ItemEntryBox:EnableMouse(true)
							DropDown_Button:EnableMouse(true)
							NoteEntryBox:EnableMouse(true)
							PrimarySpecRadioButton:EnableMouse(true)
							SecondarySpecRadioButton:EnableMouse(true)
							priorityfield:EnableMouse(true)
							AddButton:EnableMouse(true)
							tofield:EnableMouse(true)
							fromfield:EnableMouse(true)
							MoveButton:EnableMouse(true)
							DeleteButton:EnableMouse(true)
							deletefield:EnableMouse(true)
							UpgradeList:RefreshWindow()
						end);
					elseif IsModifiedClick("SHIFT") then
						ChatEdit_InsertLink(UpgradeListDBVar.char.SecondarySpecList.Foot.Row[row][3])
					else
						ItemRefTooltip:SetHyperlink(UpgradeListDBVar.char.SecondarySpecList.Foot.Row[row][3]);
					end
				elseif PanelTemplates_GetSelectedTab(UpgradeListMainFrame) == 11 then
					if IsModifiedClick("CTRL") then
						EditNoteOK:SetScript("OnClick", function (self, button, down)
							local newnote = EditNoteBox:GetText();
							EditNote:Hide();
							EditNoteBox:SetText("");
							UpgradeListDBVar.char.SecondarySpecList.Ring.Row[row][7] = newnote;
							UpgradeListMainFrame:EnableMouse(true)
							CloseButton:EnableMouse(true)
							ToggleButton:EnableMouse(true)
							UpgradeListDBVar.char.SavedOptions.PrimaryCheck:EnableMouse(true)
							UpgradeListDBVar.char.SavedOptions.SecondaryCheck:EnableMouse(true)
							OptionsFrame:EnableMouse(true)
							ItemEntryBox:EnableMouse(true)
							DropDown_Button:EnableMouse(true)
							NoteEntryBox:EnableMouse(true)
							PrimarySpecRadioButton:EnableMouse(true)
							SecondarySpecRadioButton:EnableMouse(true)
							priorityfield:EnableMouse(true)
							AddButton:EnableMouse(true)
							tofield:EnableMouse(true)
							fromfield:EnableMouse(true)
							MoveButton:EnableMouse(true)
							DeleteButton:EnableMouse(true)
							deletefield:EnableMouse(true)
							UpgradeList:RefreshWindow()
						end);
					elseif IsModifiedClick("SHIFT") then
						ChatEdit_InsertLink(UpgradeListDBVar.char.SecondarySpecList.Ring.Row[row][3])
					else
						ItemRefTooltip:SetHyperlink(UpgradeListDBVar.char.SecondarySpecList.Ring.Row[row][3]);
					end
				elseif PanelTemplates_GetSelectedTab(UpgradeListMainFrame) == 12 then
					if IsModifiedClick("CTRL") then
						EditNoteOK:SetScript("OnClick", function (self, button, down)
							local newnote = EditNoteBox:GetText();
							EditNote:Hide();
							EditNoteBox:SetText("");
							UpgradeListDBVar.char.SecondarySpecList.Trinket.Row[row][7] = newnote;
							UpgradeListMainFrame:EnableMouse(true)
							CloseButton:EnableMouse(true)
							ToggleButton:EnableMouse(true)
							UpgradeListDBVar.char.SavedOptions.PrimaryCheck:EnableMouse(true)
							UpgradeListDBVar.char.SavedOptions.SecondaryCheck:EnableMouse(true)
							OptionsFrame:EnableMouse(true)
							ItemEntryBox:EnableMouse(true)
							DropDown_Button:EnableMouse(true)
							NoteEntryBox:EnableMouse(true)
							PrimarySpecRadioButton:EnableMouse(true)
							SecondarySpecRadioButton:EnableMouse(true)
							priorityfield:EnableMouse(true)
							AddButton:EnableMouse(true)
							tofield:EnableMouse(true)
							fromfield:EnableMouse(true)
							MoveButton:EnableMouse(true)
							DeleteButton:EnableMouse(true)
							deletefield:EnableMouse(true)
							UpgradeList:RefreshWindow()
						end);
					elseif IsModifiedClick("SHIFT") then
						ChatEdit_InsertLink(UpgradeListDBVar.char.SecondarySpecList.Trinket.Row[row][3])
					else
						ItemRefTooltip:SetHyperlink(UpgradeListDBVar.char.SecondarySpecList.Trinket.Row[row][3]);
					end
				elseif PanelTemplates_GetSelectedTab(UpgradeListMainFrame) == 13 then
					if IsModifiedClick("CTRL") then
						EditNoteOK:SetScript("OnClick", function (self, button, down)
							local newnote = EditNoteBox:GetText();
							EditNote:Hide();
							EditNoteBox:SetText("");
							UpgradeListDBVar.char.SecondarySpecList.Main.Row[row][7] = newnote;
							UpgradeListMainFrame:EnableMouse(true)
							CloseButton:EnableMouse(true)
							ToggleButton:EnableMouse(true)
							UpgradeListDBVar.char.SavedOptions.PrimaryCheck:EnableMouse(true)
							UpgradeListDBVar.char.SavedOptions.SecondaryCheck:EnableMouse(true)
							OptionsFrame:EnableMouse(true)
							ItemEntryBox:EnableMouse(true)
							DropDown_Button:EnableMouse(true)
							NoteEntryBox:EnableMouse(true)
							PrimarySpecRadioButton:EnableMouse(true)
							SecondarySpecRadioButton:EnableMouse(true)
							priorityfield:EnableMouse(true)
							AddButton:EnableMouse(true)
							tofield:EnableMouse(true)
							fromfield:EnableMouse(true)
							MoveButton:EnableMouse(true)
							DeleteButton:EnableMouse(true)
							deletefield:EnableMouse(true)
							UpgradeList:RefreshWindow()
						end);
					elseif IsModifiedClick("SHIFT") then
						ChatEdit_InsertLink(UpgradeListDBVar.char.SecondarySpecList.Main.Row[row][3])
					else
						ItemRefTooltip:SetHyperlink(UpgradeListDBVar.char.SecondarySpecList.Main.Row[row][3]);
					end
				elseif PanelTemplates_GetSelectedTab(UpgradeListMainFrame) == 14 then
					if IsModifiedClick("CTRL") then
						EditNoteOK:SetScript("OnClick", function (self, button, down)
							local newnote = EditNoteBox:GetText();
							EditNote:Hide();
							EditNoteBox:SetText("");
							UpgradeListDBVar.char.SecondarySpecList.Off.Row[row][7] = newnote;
							UpgradeListMainFrame:EnableMouse(true)
							CloseButton:EnableMouse(true)
							ToggleButton:EnableMouse(true)
							UpgradeListDBVar.char.SavedOptions.PrimaryCheck:EnableMouse(true)
							UpgradeListDBVar.char.SavedOptions.SecondaryCheck:EnableMouse(true)
							OptionsFrame:EnableMouse(true)
							ItemEntryBox:EnableMouse(true)
							DropDown_Button:EnableMouse(true)
							NoteEntryBox:EnableMouse(true)
							PrimarySpecRadioButton:EnableMouse(true)
							SecondarySpecRadioButton:EnableMouse(true)
							priorityfield:EnableMouse(true)
							AddButton:EnableMouse(true)
							tofield:EnableMouse(true)
							fromfield:EnableMouse(true)
							MoveButton:EnableMouse(true)
							DeleteButton:EnableMouse(true)
							deletefield:EnableMouse(true)
							UpgradeList:RefreshWindow()
						end);
					elseif IsModifiedClick("SHIFT") then
						ChatEdit_InsertLink(UpgradeListDBVar.char.SecondarySpecList.Off.Row[row][3])
					else
						ItemRefTooltip:SetHyperlink(UpgradeListDBVar.char.SecondarySpecList.Off.Row[row][3]);
					end
				elseif PanelTemplates_GetSelectedTab(UpgradeListMainFrame) == 15 then
					if IsModifiedClick("CTRL") then
						EditNoteOK:SetScript("OnClick", function (self, button, down)
							local newnote = EditNoteBox:GetText();
							EditNote:Hide();
							EditNoteBox:SetText("");
							UpgradeListDBVar.char.SecondarySpecList.Ranged.Row[row][7] = newnote;
							UpgradeListMainFrame:EnableMouse(true)
							CloseButton:EnableMouse(true)
							ToggleButton:EnableMouse(true)
							UpgradeListDBVar.char.SavedOptions.PrimaryCheck:EnableMouse(true)
							UpgradeListDBVar.char.SavedOptions.SecondaryCheck:EnableMouse(true)
							OptionsFrame:EnableMouse(true)
							ItemEntryBox:EnableMouse(true)
							DropDown_Button:EnableMouse(true)
							NoteEntryBox:EnableMouse(true)
							PrimarySpecRadioButton:EnableMouse(true)
							SecondarySpecRadioButton:EnableMouse(true)
							priorityfield:EnableMouse(true)
							AddButton:EnableMouse(true)
							tofield:EnableMouse(true)
							fromfield:EnableMouse(true)
							MoveButton:EnableMouse(true)
							DeleteButton:EnableMouse(true)
							deletefield:EnableMouse(true)
							UpgradeList:RefreshWindow()
						end);
					elseif IsModifiedClick("SHIFT") then
						ChatEdit_InsertLink(UpgradeListDBVar.char.SecondarySpecList.Ranged.Row[row][3])
					else
						ItemRefTooltip:SetHyperlink(UpgradeListDBVar.char.SecondarySpecList.Ranged.Row[row][3]);
					end
				elseif PanelTemplates_GetSelectedTab(UpgradeListMainFrame) == 16 then
					if IsModifiedClick("CTRL") then
						EditNoteOK:SetScript("OnClick", function (self, button, down)
							local newnote = EditNoteBox:GetText();
							EditNote:Hide();
							EditNoteBox:SetText("");
							UpgradeListDBVar.char.SecondarySpecList.Other.Row[row][7] = newnote;
							UpgradeListMainFrame:EnableMouse(true)
							CloseButton:EnableMouse(true)
							ToggleButton:EnableMouse(true)
							UpgradeListDBVar.char.SavedOptions.PrimaryCheck:EnableMouse(true)
							UpgradeListDBVar.char.SavedOptions.SecondaryCheck:EnableMouse(true)
							OptionsFrame:EnableMouse(true)
							ItemEntryBox:EnableMouse(true)
							DropDown_Button:EnableMouse(true)
							NoteEntryBox:EnableMouse(true)
							PrimarySpecRadioButton:EnableMouse(true)
							SecondarySpecRadioButton:EnableMouse(true)
							priorityfield:EnableMouse(true)
							AddButton:EnableMouse(true)
							tofield:EnableMouse(true)
							fromfield:EnableMouse(true)
							MoveButton:EnableMouse(true)
							DeleteButton:EnableMouse(true)
							deletefield:EnableMouse(true)
							UpgradeList:RefreshWindow()
						end);
					elseif IsModifiedClick("SHIFT") then
						ChatEdit_InsertLink(UpgradeListDBVar.char.SecondarySpecList.Other.Row[row][3])
					else
						ItemRefTooltip:SetHyperlink(UpgradeListDBVar.char.SecondarySpecList.Other.Row[row][3]);
					end
				end
			end
			ShowUIPanel(ItemRefTooltip)
		end,
	});
	
	--"Close" button
	local CloseButton = CreateFrame('Button', "CloseButton", UpgradeListMainFrame, "UIPanelCloseButton");
	CloseButton:SetPoint("TOPRIGHT", -1, -2);
	CloseButton:SetWidth(40);
	CloseButton:SetHeight(40);
	
	--"ToggleOptions" button
	local ToggleButton = CreateFrame('Button', "ToggleButton", UpgradeListMainFrame, "UIPanelButtonTemplate2");
	ToggleButton:SetPoint("RIGHT", CloseButton, "LEFT", 8, 0);
	ToggleButton:SetWidth(170);
	ToggleButton:SetHeight(20);
	ToggleButton:SetText("Toggle Options Window");
	ToggleButton:SetScript("OnClick", function (self, button, down)
		ToggleOptions();
	end);
	
	--"PrimarySpecView" button
	UpgradeListDBVar.char.SavedOptions.PrimaryCheck = CreateFrame('CheckButton', "UpgradeListDBVar.char.SavedOptions.PrimaryCheck", UpgradeListMainFrame, "UICheckButtonTemplate");
	UpgradeListDBVar.char.SavedOptions.PrimaryCheck:SetPoint("RIGHT", ToggleButton, "LEFT", -275, -2);
	UpgradeListDBVar.char.SavedOptions.PrimaryCheck:SetChecked(true);
	_G[UpgradeListDBVar.char.SavedOptions.PrimaryCheck:GetName() .. "Text"]:SetText("View Primary Spec");
	UpgradeListDBVar.char.SavedOptions.PrimaryCheck:SetScript("OnClick", function (self, button, down)
		if GetNumTalentGroups("player") == 1 then
			UpgradeListDBVar.char.SavedOptions.SecondaryCheck:Disable();
			UpgradeListDBVar.char.SavedOptions.PrimaryCheck:SetChecked(true);
		else
			UpgradeListDBVar.char.SavedOptions.SecondaryCheck:SetChecked(false);
			UpgradeList:RefreshWindow()
		end
	UpgradeListDBVar.char.SavedOptions.PrimaryCheck:SetChecked(true);
	end);
	
	--"SecondarySpecView" button
	UpgradeListDBVar.char.SavedOptions.SecondaryCheck = CreateFrame('CheckButton', "UpgradeListDBVar.char.SavedOptions.SecondaryCheck", UpgradeListMainFrame, "UICheckButtonTemplate");
	UpgradeListDBVar.char.SavedOptions.SecondaryCheck:SetPoint("RIGHT", ToggleButton, "LEFT", -125, -2);
	UpgradeListDBVar.char.SavedOptions.SecondaryCheck:SetChecked(false);
	_G[UpgradeListDBVar.char.SavedOptions.SecondaryCheck:GetName() .. "Text"]:SetText("View Secondary Spec");
	if GetNumTalentGroups("player") == 1 then
		_G[UpgradeListDBVar.char.SavedOptions.SecondaryCheck:GetName() .. "Text"]:SetTextColor(0.5, 0.5, 0.5);
		UpgradeListDBVar.char.SavedOptions.SecondaryCheck:Disable();
	end
	UpgradeListDBVar.char.SavedOptions.SecondaryCheck:SetScript("OnClick", function (self, button, down)
		UpgradeListDBVar.char.SavedOptions.SecondaryCheck:SetChecked(true);
		UpgradeListDBVar.char.SavedOptions.PrimaryCheck:SetChecked(false);
		UpgradeList:RefreshWindow()
	end);
	
	--Explanation of what the various clicks on the table do
	ExplanationHeading = CreateFrame('Frame', "ExplanationHeading", UpgradeListMainFrame);
	ExplanationHeadingFont = ExplanationHeading:CreateFontString("ExplanationHeading", "ARTWORK", "GameFontWhiteTiny");
	ExplanationHeadingFont:SetText("Clicking a row will show the tooltip for the item, Shift-clicking a row will allow you to add the item link into your chat window, Ctrl-clicking a row will allow you to edit the note for that row.");
	ExplanationHeadingFont:SetPoint("TOPLEFT", UpgradeListMainFrame, "TOPLEFT", 50, -11);
	ExplanationHeadingFont:SetWidth(500);
	ExplanationHeadingFont:SetHeight(ExplanationHeadingFont:GetStringHeight());
	ExplanationHeadingFont:SetJustifyH("LEFT");

	--Create all the 16 tabs for the equipment slots
	PanelTemplates_SetNumTabs(UpgradeListMainFrame, 16);
	UpgradeListDBVar.profile.tabcreate.Tab_1 = CreateFrame('Button', "$parentTab1", UpgradeListMainFrame, "CharacterFrameTabButtonTemplate");
	UpgradeListDBVar.profile.tabcreate.Tab_1:SetID(1);
	UpgradeListDBVar.profile.tabcreate.Tab_1:SetText('Head');
	UpgradeListDBVar.profile.tabcreate.Tab_1:SetPoint("TOP", UpgradeListMainFrame, "BOTTOM", -575, 6);
	PanelTemplates_TabResize(UpgradeListDBVar.profile.tabcreate.Tab_1, 0, 93, 94);
	UpgradeListDBVar.profile.tabcreate.Tab_1:RegisterForClicks("AnyUp");
	UpgradeListDBVar.profile.tabcreate.Tab_1:SetScript("OnClick", function (self, button, down)
		self:SetID(self:GetID());
		PanelTemplates_Tab_OnClick(UpgradeListDBVar.profile.tabcreate.Tab_1, UpgradeListMainFrame);
		UpgradeList:RefreshWindow()
	end);

	UpgradeListDBVar.profile.tabcreate.Tab_2 = CreateFrame('Button', "$parentTab2", UpgradeListMainFrame, "CharacterFrameTabButtonTemplate");
	UpgradeListDBVar.profile.tabcreate.Tab_2:SetID(2);
	UpgradeListDBVar.profile.tabcreate.Tab_2:SetText('Neck');
	UpgradeListDBVar.profile.tabcreate.Tab_2:SetPoint("TOP", UpgradeListMainFrame, "BOTTOM", -499, 6);
	PanelTemplates_TabResize(UpgradeListDBVar.profile.tabcreate.Tab_2, 0, 93, 94);
	UpgradeListDBVar.profile.tabcreate.Tab_2:RegisterForClicks("AnyUp");
	UpgradeListDBVar.profile.tabcreate.Tab_2:SetScript("OnClick", function (self, button, down)
		self:SetID(self:GetID());
		PanelTemplates_Tab_OnClick(UpgradeListDBVar.profile.tabcreate.Tab_2, UpgradeListMainFrame);
		UpgradeList:RefreshWindow()
	end);
	
	UpgradeListDBVar.profile.tabcreate.Tab_3 = CreateFrame('Button', "$parentTab3", UpgradeListMainFrame, "CharacterFrameTabButtonTemplate");
	UpgradeListDBVar.profile.tabcreate.Tab_3:SetID(3);
	UpgradeListDBVar.profile.tabcreate.Tab_3:SetText('Shoulders');
	UpgradeListDBVar.profile.tabcreate.Tab_3:SetPoint("TOP", UpgradeListMainFrame, "BOTTOM", -423, 6);
	PanelTemplates_TabResize(UpgradeListDBVar.profile.tabcreate.Tab_3, 0, 93, 94);
	UpgradeListDBVar.profile.tabcreate.Tab_3:RegisterForClicks("AnyUp");
	UpgradeListDBVar.profile.tabcreate.Tab_3:SetScript("OnClick", function (self, button, down)
		self:SetID(self:GetID());
		PanelTemplates_Tab_OnClick(UpgradeListDBVar.profile.tabcreate.Tab_3, UpgradeListMainFrame);
		UpgradeList:RefreshWindow()
	end);
	
	UpgradeListDBVar.profile.tabcreate.Tab_4 = CreateFrame('Button', "$parentTab4", UpgradeListMainFrame, "CharacterFrameTabButtonTemplate");
	UpgradeListDBVar.profile.tabcreate.Tab_4:SetID(4);
	UpgradeListDBVar.profile.tabcreate.Tab_4:SetText('Back');
	UpgradeListDBVar.profile.tabcreate.Tab_4:SetPoint("TOP", UpgradeListMainFrame, "BOTTOM", -347, 6);
	PanelTemplates_TabResize(UpgradeListDBVar.profile.tabcreate.Tab_4, 0, 93, 94);
	UpgradeListDBVar.profile.tabcreate.Tab_4:RegisterForClicks("AnyUp");
	UpgradeListDBVar.profile.tabcreate.Tab_4:SetScript("OnClick", function (self, button, down)
		self:SetID(self:GetID());
		PanelTemplates_Tab_OnClick(UpgradeListDBVar.profile.tabcreate.Tab_4, UpgradeListMainFrame);
		UpgradeList:RefreshWindow()
	end);
	
	UpgradeListDBVar.profile.tabcreate.Tab_5 = CreateFrame('Button', "$parentTab5", UpgradeListMainFrame, "CharacterFrameTabButtonTemplate");
	UpgradeListDBVar.profile.tabcreate.Tab_5:SetID(5);
	UpgradeListDBVar.profile.tabcreate.Tab_5:SetText('Chest');
	UpgradeListDBVar.profile.tabcreate.Tab_5:SetPoint("TOP", UpgradeListMainFrame, "BOTTOM", -271, 6);
	PanelTemplates_TabResize(UpgradeListDBVar.profile.tabcreate.Tab_5, 0, 93, 94);
	UpgradeListDBVar.profile.tabcreate.Tab_5:RegisterForClicks("AnyUp");
	UpgradeListDBVar.profile.tabcreate.Tab_5:SetScript("OnClick", function (self, button, down)
		self:SetID(self:GetID());
		PanelTemplates_Tab_OnClick(UpgradeListDBVar.profile.tabcreate.Tab_5, UpgradeListMainFrame);
		UpgradeList:RefreshWindow()
	end);
	
	UpgradeListDBVar.profile.tabcreate.Tab_6 = CreateFrame('Button', "$parentTab6", UpgradeListMainFrame, "CharacterFrameTabButtonTemplate");
	UpgradeListDBVar.profile.tabcreate.Tab_6:SetID(6);
	UpgradeListDBVar.profile.tabcreate.Tab_6:SetText('Wrists');
	UpgradeListDBVar.profile.tabcreate.Tab_6:SetPoint("TOP", UpgradeListMainFrame, "BOTTOM", -195, 6);
	PanelTemplates_TabResize(UpgradeListDBVar.profile.tabcreate.Tab_6, 0, 93, 94);
	UpgradeListDBVar.profile.tabcreate.Tab_6:RegisterForClicks("AnyUp");
	UpgradeListDBVar.profile.tabcreate.Tab_6:SetScript("OnClick", function (self, button, down)
		self:SetID(self:GetID());
		PanelTemplates_Tab_OnClick(UpgradeListDBVar.profile.tabcreate.Tab_6, UpgradeListMainFrame);
		UpgradeList:RefreshWindow()
	end);
	
	UpgradeListDBVar.profile.tabcreate.Tab_7 = CreateFrame('Button', "$parentTab7", UpgradeListMainFrame, "CharacterFrameTabButtonTemplate");
	UpgradeListDBVar.profile.tabcreate.Tab_7:SetID(7);
	UpgradeListDBVar.profile.tabcreate.Tab_7:SetText('Hands');
	UpgradeListDBVar.profile.tabcreate.Tab_7:SetPoint("TOP", UpgradeListMainFrame, "BOTTOM", -119, 6);
	PanelTemplates_TabResize(UpgradeListDBVar.profile.tabcreate.Tab_7, 0, 93, 94);
	UpgradeListDBVar.profile.tabcreate.Tab_7:RegisterForClicks("AnyUp");
	UpgradeListDBVar.profile.tabcreate.Tab_7:SetScript("OnClick", function (self, button, down)
		self:SetID(self:GetID());
		PanelTemplates_Tab_OnClick(UpgradeListDBVar.profile.tabcreate.Tab_7, UpgradeListMainFrame);
		UpgradeList:RefreshWindow()
	end);
	
	UpgradeListDBVar.profile.tabcreate.Tab_8 = CreateFrame('Button', "$parentTab8", UpgradeListMainFrame, "CharacterFrameTabButtonTemplate");
	UpgradeListDBVar.profile.tabcreate.Tab_8:SetID(8);
	UpgradeListDBVar.profile.tabcreate.Tab_8:SetText('Waist');
	UpgradeListDBVar.profile.tabcreate.Tab_8:SetPoint("TOP", UpgradeListMainFrame, "BOTTOM", -43, 6);
	PanelTemplates_TabResize(UpgradeListDBVar.profile.tabcreate.Tab_8, 0, 93, 94);
	UpgradeListDBVar.profile.tabcreate.Tab_8:RegisterForClicks("AnyUp");
	UpgradeListDBVar.profile.tabcreate.Tab_8:SetScript("OnClick", function (self, button, down)
		self:SetID(self:GetID());
		PanelTemplates_Tab_OnClick(UpgradeListDBVar.profile.tabcreate.Tab_8, UpgradeListMainFrame);
		UpgradeList:RefreshWindow()
	end);
	
	UpgradeListDBVar.profile.tabcreate.Tab_9 = CreateFrame('Button', "$parentTab9", UpgradeListMainFrame, "CharacterFrameTabButtonTemplate");
	UpgradeListDBVar.profile.tabcreate.Tab_9:SetID(9);
	UpgradeListDBVar.profile.tabcreate.Tab_9:SetText('Legs');
	UpgradeListDBVar.profile.tabcreate.Tab_9:SetPoint("TOP", UpgradeListMainFrame, "BOTTOM", 33, 6);
	PanelTemplates_TabResize(UpgradeListDBVar.profile.tabcreate.Tab_9, 0, 93, 94);
	UpgradeListDBVar.profile.tabcreate.Tab_9:RegisterForClicks("AnyUp");
	UpgradeListDBVar.profile.tabcreate.Tab_9:SetScript("OnClick", function (self, button, down)
		self:SetID(self:GetID());
		PanelTemplates_Tab_OnClick(UpgradeListDBVar.profile.tabcreate.Tab_9, UpgradeListMainFrame);
		UpgradeList:RefreshWindow()
	end);
	
	UpgradeListDBVar.profile.tabcreate.Tab_10 = CreateFrame('Button', "$parentTab10", UpgradeListMainFrame, "CharacterFrameTabButtonTemplate");
	UpgradeListDBVar.profile.tabcreate.Tab_10:SetID(10);
	UpgradeListDBVar.profile.tabcreate.Tab_10:SetText('Feet');
	UpgradeListDBVar.profile.tabcreate.Tab_10:SetPoint("TOP", UpgradeListMainFrame, "BOTTOM", 109, 6);
	PanelTemplates_TabResize(UpgradeListDBVar.profile.tabcreate.Tab_10, 0, 93, 94);
	UpgradeListDBVar.profile.tabcreate.Tab_10:RegisterForClicks("AnyUp");
	UpgradeListDBVar.profile.tabcreate.Tab_10:SetScript("OnClick", function (self, button, down)
		self:SetID(self:GetID());
		PanelTemplates_Tab_OnClick(UpgradeListDBVar.profile.tabcreate.Tab_10, UpgradeListMainFrame);
		UpgradeList:RefreshWindow()
	end);
	
	UpgradeListDBVar.profile.tabcreate.Tab_11 = CreateFrame('Button', "$parentTab11", UpgradeListMainFrame, "CharacterFrameTabButtonTemplate");
	UpgradeListDBVar.profile.tabcreate.Tab_11:SetID(11);
	UpgradeListDBVar.profile.tabcreate.Tab_11:SetText('Rings');
	UpgradeListDBVar.profile.tabcreate.Tab_11:SetPoint("TOP", UpgradeListMainFrame, "BOTTOM", 185, 6);
	PanelTemplates_TabResize(UpgradeListDBVar.profile.tabcreate.Tab_11, 0, 93, 94);
	UpgradeListDBVar.profile.tabcreate.Tab_11:RegisterForClicks("AnyUp");
	UpgradeListDBVar.profile.tabcreate.Tab_11:SetScript("OnClick", function (self, button, down)
		self:SetID(self:GetID());
		PanelTemplates_Tab_OnClick(UpgradeListDBVar.profile.tabcreate.Tab_11, UpgradeListMainFrame);
		UpgradeList:RefreshWindow()
	end);
	
	UpgradeListDBVar.profile.tabcreate.Tab_12 = CreateFrame('Button', "$parentTab12", UpgradeListMainFrame, "CharacterFrameTabButtonTemplate");
	UpgradeListDBVar.profile.tabcreate.Tab_12:SetID(12);
	UpgradeListDBVar.profile.tabcreate.Tab_12:SetText('Trinkets');
	UpgradeListDBVar.profile.tabcreate.Tab_12:SetPoint("TOP", UpgradeListMainFrame, "BOTTOM", 261, 6);
	PanelTemplates_TabResize(UpgradeListDBVar.profile.tabcreate.Tab_12, 0, 93, 94);
	UpgradeListDBVar.profile.tabcreate.Tab_12:RegisterForClicks("AnyUp");
	UpgradeListDBVar.profile.tabcreate.Tab_12:SetScript("OnClick", function (self, button, down)
		self:SetID(self:GetID());
		PanelTemplates_Tab_OnClick(UpgradeListDBVar.profile.tabcreate.Tab_12, UpgradeListMainFrame);
		UpgradeList:RefreshWindow()
	end);
	
	UpgradeListDBVar.profile.tabcreate.Tab_13 = CreateFrame('Button', "$parentTab13", UpgradeListMainFrame, "CharacterFrameTabButtonTemplate");
	UpgradeListDBVar.profile.tabcreate.Tab_13:SetID(13);
	UpgradeListDBVar.profile.tabcreate.Tab_13:SetText('Main Hand');
	UpgradeListDBVar.profile.tabcreate.Tab_13:SetPoint("TOP", UpgradeListMainFrame, "BOTTOM", 342, 6);
	PanelTemplates_TabResize(UpgradeListDBVar.profile.tabcreate.Tab_13, 0, 102, 90);
	UpgradeListDBVar.profile.tabcreate.Tab_13:RegisterForClicks("AnyUp");
	UpgradeListDBVar.profile.tabcreate.Tab_13:SetScript("OnClick", function (self, button, down)
		self:SetID(self:GetID());
		PanelTemplates_Tab_OnClick(UpgradeListDBVar.profile.tabcreate.Tab_13, UpgradeListMainFrame);
		UpgradeList:RefreshWindow()
	end);
	
	UpgradeListDBVar.profile.tabcreate.Tab_14 = CreateFrame('Button', "$parentTab14", UpgradeListMainFrame, "CharacterFrameTabButtonTemplate");
	UpgradeListDBVar.profile.tabcreate.Tab_14:SetID(14);
	UpgradeListDBVar.profile.tabcreate.Tab_14:SetText('Off Hand');
	UpgradeListDBVar.profile.tabcreate.Tab_14:SetPoint("TOP", UpgradeListMainFrame, "BOTTOM", 423, 6);
	PanelTemplates_TabResize(UpgradeListDBVar.profile.tabcreate.Tab_14, 0, 94, 94);
	UpgradeListDBVar.profile.tabcreate.Tab_14:RegisterForClicks("AnyUp");
	UpgradeListDBVar.profile.tabcreate.Tab_14:SetScript("OnClick", function (self, button, down)
		self:SetID(self:GetID());
		PanelTemplates_Tab_OnClick(UpgradeListDBVar.profile.tabcreate.Tab_14, UpgradeListMainFrame);
		UpgradeList:RefreshWindow()
	end);
	
	UpgradeListDBVar.profile.tabcreate.Tab_15 = CreateFrame('Button', "$parentTab15", UpgradeListMainFrame, "CharacterFrameTabButtonTemplate");
	UpgradeListDBVar.profile.tabcreate.Tab_15:SetID(15);
	UpgradeListDBVar.profile.tabcreate.Tab_15:SetText('Ranged');
	UpgradeListDBVar.profile.tabcreate.Tab_15:SetPoint("TOP", UpgradeListMainFrame, "BOTTOM", 499, 6);
	PanelTemplates_TabResize(UpgradeListDBVar.profile.tabcreate.Tab_15, 0, 94, 94);
	UpgradeListDBVar.profile.tabcreate.Tab_15:RegisterForClicks("AnyUp");
	UpgradeListDBVar.profile.tabcreate.Tab_15:SetScript("OnClick", function (self, button, down)
		self:SetID(self:GetID());
		PanelTemplates_Tab_OnClick(UpgradeListDBVar.profile.tabcreate.Tab_15, UpgradeListMainFrame);
		UpgradeList:RefreshWindow()
	end);
	
	UpgradeListDBVar.profile.tabcreate.Tab_16 = CreateFrame('Button', "$parentTab16", UpgradeListMainFrame, "CharacterFrameTabButtonTemplate");
	UpgradeListDBVar.profile.tabcreate.Tab_16:SetID(16);
	UpgradeListDBVar.profile.tabcreate.Tab_16:SetText('Other');
	UpgradeListDBVar.profile.tabcreate.Tab_16:SetPoint("TOP", UpgradeListMainFrame, "BOTTOM", 575, 6);
	PanelTemplates_TabResize(UpgradeListDBVar.profile.tabcreate.Tab_16, 0, 94, 94);
	UpgradeListDBVar.profile.tabcreate.Tab_16:RegisterForClicks("AnyUp");
	UpgradeListDBVar.profile.tabcreate.Tab_16:SetScript("OnClick", function (self, button, down)
		self:SetID(self:GetID());
		PanelTemplates_Tab_OnClick(UpgradeListDBVar.profile.tabcreate.Tab_16, UpgradeListMainFrame);
		UpgradeList:RefreshWindow()
	end);
	
	PanelTemplates_SetTab(UpgradeListMainFrame, 1);
	UpgradeList:RefreshWindow()
	
	--Create the options frame below the main frame
	OptionsFrame = CreateFrame("Frame", "OptionsFrame", UpgradeListMainFrame);
	OptionsFrame:SetWidth(850);
	OptionsFrame:SetHeight(330);
	OptionsFrame:SetPoint("TOP",UpgradeListMainFrame,"BOTTOM", 0, -30);
	OptionsFrame:SetBackdrop({bgFile = "Interface/DialogFrame/UI-DialogBox-Background", 
		edgeFile = "Interface/DialogFrame/UI-DialogBox-Border",
		tile = true, tileSize = 32, edgeSize = 32, 
		insets = { left = 11, right = 12, top = 12, bottom = 11 }});
	
	--Creation of the Item Entry Box
	ItemEntryBox = CreateFrame('EditBox', "ItemEntryBox", OptionsFrame, "InputBoxTemplate");
	ItemEntryBox:SetPoint("CENTER", 0, 125);
	ItemEntryBox:SetAutoFocus(false);
	ItemEntryBox:SetWidth(130);
    ItemEntryBox:SetHeight(24);
	
	ItemEntryBoxHeading = CreateFrame('Frame', "ItemEntryBoxHeading", OptionsFrame);
	HeadingFont = ItemEntryBoxHeading:CreateFontString("ItemHeading", "ARTWORK", "GameFontNormalSmallLeft");
	HeadingFont:SetText("Enter your item with an item link or an item ID number:");
	HeadingFont:SetPoint("BOTTOM", ItemEntryBox, "TOP");
	HeadingFont:SetWidth(HeadingFont:GetStringWidth() + 5);
	HeadingFont:SetHeight(HeadingFont:GetStringHeight());	

	--Creation of the dropdown menus
	CreateFrame("Button", "DropDown_Button", OptionsFrame, "UIDropDownMenuTemplate")
	DropDown_Button:ClearAllPoints()
	DropDown_Button:SetPoint("TOP", ItemEntryBox, "BOTTOM", 0, -20)
	DropDown_Button:Show()
	

	function DropDown_InitializeDropDown(self, level)

		--Top Level
		if level == 1 then
			local info = UIDropDownMenu_CreateInfo()

			info = UIDropDownMenu_CreateInfo()
			info.text = "Raid"
			info.hasArrow = true
			info.value = "Raid"
			info.notCheckable = 1
			UIDropDownMenu_AddButton(info, level)

			info = UIDropDownMenu_CreateInfo()
			info.text = "Dungeon"
			info.hasArrow = true
			info.value = "Dungeon"
			info.notCheckable = 1
			UIDropDownMenu_AddButton(info, level)
			
			info = UIDropDownMenu_CreateInfo()
			info.text = "Crafted"
			info.hasArrow = true
			info.value = "Crafted"
			info.notCheckable = 1
			UIDropDownMenu_AddButton(info, level)
			
			info = UIDropDownMenu_CreateInfo()
			info.text = "Quest Reward"
			info.hasArrow = true
			info.value = "Quest Reward"
			info.notCheckable = 1
			UIDropDownMenu_AddButton(info, level)
			
			info = UIDropDownMenu_CreateInfo()
			info.text = "Reputation Reward"
			info.hasArrow = true
			info.value = "Reputation Reward"
			info.notCheckable = 1
			UIDropDownMenu_AddButton(info, level)
			
			info = UIDropDownMenu_CreateInfo()
			info.text = "Purchasable"
			info.hasArrow = true
			info.value = "Purchasable"
			info.notCheckable = 1
			UIDropDownMenu_AddButton(info, level)
			
			info = UIDropDownMenu_CreateInfo()
			info.text = "World Drop"
			info.hasArrow = true
			info.value = "World Drop"
			info.notCheckable = 1
			UIDropDownMenu_AddButton(info, level)
			
			info = UIDropDownMenu_CreateInfo()
			info.text = "Other"
			info.notCheckable = 1
			function info.func()
				UIDropDownMenu_SetText(DropDown_Button, "Other");
				UpgradeListDBVar.char.SavedOptions.SelectedInstance = "Other";
				CloseDropDownMenus(1);
			end
			UIDropDownMenu_AddButton(info, level)
			
		--Raid Submenu
		elseif (level == 2) and (UIDROPDOWNMENU_MENU_VALUE == "Raid") then
			local info = UIDropDownMenu_CreateInfo()
			
			info.text = "Heroic"
			info.hasArrow = true
			info.value = "HeroicRaid"
			info.notCheckable = 1
			UIDropDownMenu_AddButton(info, level)
			
			info = UIDropDownMenu_CreateInfo()
			info.text = "Normal"
			info.hasArrow = true
			info.value = "NormalRaid"
			info.notCheckable = 1
			UIDropDownMenu_AddButton(info, level)
			
		--Dungeon Submenu
		elseif (level == 2) and (UIDROPDOWNMENU_MENU_VALUE == "Dungeon") then
			local info = UIDropDownMenu_CreateInfo()
			
			info.text = "Heroic"
			info.hasArrow = true
			info.value = "HeroicDungeon"
			info.notCheckable = 1
			UIDropDownMenu_AddButton(info, level)
			
			info.text = "Normal"
			info.hasArrow = true
			info.value = "NormalDungeon"
			info.notCheckable = 1
			UIDropDownMenu_AddButton(info, level)
			
		--Crafted Submenu
		elseif (level == 2) and (UIDROPDOWNMENU_MENU_VALUE == "Crafted") then
			local info = UIDropDownMenu_CreateInfo()
			
			info.text = "Archaeology"
			info.value = "Archaeology"
			info.notCheckable = true
			function info.func()
				UIDropDownMenu_SetText(DropDown_Button, "Archaeology");
				UpgradeListDBVar.char.SavedOptions.SelectedInstance = "Archaeology";
				CloseDropDownMenus(1);
			end
			UIDropDownMenu_AddButton(info, level)
			
			info.text = "Alchemy"
			info.value = "Alchemy"
			info.notCheckable = true
			function info.func()
				UIDropDownMenu_SetText(DropDown_Button, "Alchemy");
				UpgradeListDBVar.char.SavedOptions.SelectedInstance = "Alchemy";
				CloseDropDownMenus(1);
			end
			UIDropDownMenu_AddButton(info, level)
			
			info.text = "Blacksmithing"
			info.value = "Blacksmithing"
			info.notCheckable = true
			function info.func()
				UIDropDownMenu_SetText(DropDown_Button, "Blacksmithing");
				UpgradeListDBVar.char.SavedOptions.SelectedInstance = "Blacksmithing";
				CloseDropDownMenus(1);
			end
			UIDropDownMenu_AddButton(info, level)
			
			info.text = "Enchanting"
			info.value = "Enchanting"
			info.notCheckable = true
			function info.func()
				UIDropDownMenu_SetText(DropDown_Button, "Enchanting");
				UpgradeListDBVar.char.SavedOptions.SelectedInstance = "Enchanting";
				CloseDropDownMenus(1);
			end
			UIDropDownMenu_AddButton(info, level)
			
			info.text = "Engineering"
			info.value = "Engineering"
			info.notCheckable = true
			function info.func()
				UIDropDownMenu_SetText(DropDown_Button, "Engineering");
				UpgradeListDBVar.char.SavedOptions.SelectedInstance = "Engineering";
				CloseDropDownMenus(1);
			end
			UIDropDownMenu_AddButton(info, level)
			
			info.text = "Inscription"
			info.value = "Inscription"
			info.notCheckable = true
			function info.func()
				UIDropDownMenu_SetText(DropDown_Button, "Inscription");
				UpgradeListDBVar.char.SavedOptions.SelectedInstance = "Inscription";
				CloseDropDownMenus(1);
			end
			UIDropDownMenu_AddButton(info, level)
			
			info.text = "Jewelcrafting"
			info.value = "Jewelcrafting"
			info.notCheckable = true
			function info.func()
				UIDropDownMenu_SetText(DropDown_Button, "Jewelcrafting");
				UpgradeListDBVar.char.SavedOptions.SelectedInstance = "Jewelcrafting";
				CloseDropDownMenus(1);
			end
			UIDropDownMenu_AddButton(info, level)
			
			info.text = "Leatherworking"
			info.value = "Leatherworking"
			info.notCheckable = true
			function info.func()
				UIDropDownMenu_SetText(DropDown_Button, "Leatherworking");
				UpgradeListDBVar.char.SavedOptions.SelectedInstance = "Leatherworking";
				CloseDropDownMenus(1);
			end
			UIDropDownMenu_AddButton(info, level)
			
			info.text = "Tailoring"
			info.value = "Tailoring"
			info.notCheckable = true
			function info.func()
				UIDropDownMenu_SetText(DropDown_Button, "Tailoring");
				UpgradeListDBVar.char.SavedOptions.SelectedInstance = "Tailoring";
				CloseDropDownMenus(1);
			end
			UIDropDownMenu_AddButton(info, level)
			
		--Quest Reward Submenu
		elseif (level == 2) and (UIDROPDOWNMENU_MENU_VALUE == "Quest Reward") then
			local info = UIDropDownMenu_CreateInfo()
			--local DropLocation = "Quest Reward"
			
			info.text = "Quest Reward"
			info.value = "Quest Reward"
			info.notCheckable = true
			function info.func()
				UIDropDownMenu_SetText(DropDown_Button, "Quest Reward");
				UpgradeListDBVar.char.SavedOptions.SelectedInstance = "Quest Reward";
				CloseDropDownMenus(1);
			end
			UIDropDownMenu_AddButton(info, level)
			
			
			
		--Reputation Reward Submenu
		elseif (level == 2) and (UIDROPDOWNMENU_MENU_VALUE == "Reputation Reward") then
			local info = UIDropDownMenu_CreateInfo()
			
			info.text = "Guardians of Hyjal"
			info.hasArrow = true
			info.value = "Guardians of Hyjal"
			info.notCheckable = 1
			UIDropDownMenu_AddButton(info, level)
			
			info.text = "The Earthen Ring"
			info.hasArrow = true
			info.value = "The Earthen Ring"
			info.notCheckable = 1
			UIDropDownMenu_AddButton(info, level)
			
			info.text = "Therazane"
			info.hasArrow = true
			info.value = "Therazane"
			info.notCheckable = 1
			UIDropDownMenu_AddButton(info, level)
			
			info.text = "Ramkahen"
			info.hasArrow = true
			info.value = "Ramkahen"
			info.notCheckable = 1
			UIDropDownMenu_AddButton(info, level)
			
			--Check to see if player is Alliance or Horde & give them the correct reputation choices
			if UnitFactionGroup("player") == "Alliance" then
				info.text = "Wildhammer Clan"
				info.hasArrow = true
				info.value = "Wildhammer Clan"
				info.notCheckable = 1
				UIDropDownMenu_AddButton(info, level)
				
				info.text = "Baradin's Wardens"
				info.hasArrow = true
				info.value = "Baradin's Wardens"
				info.notCheckable = 1
				UIDropDownMenu_AddButton(info, level)
				
			elseif UnitFactionGroup("player") == "Horde" then
				info.text = "Dragonmaw Clan"
				info.hasArrow = true
				info.value = "Dragonmaw Clan"
				info.notCheckable = 1
				UIDropDownMenu_AddButton(info, level)
				
				info.text = "Hellscream's Reach"
				info.hasArrow = true
				info.value = "Hellscream's Reach"
				info.notCheckable = 1
				UIDropDownMenu_AddButton(info, level)
				
			else
				print ("UpgradeList: Unable to determine your faction!");
			end
			
			--Check to see if the player is in a guild, if they are they can select their guild from the dropdown
			if (IsInGuild()) then
				info.text = GetGuildInfo("player")
				info.hasArrow = true
				info.value = GetGuildInfo("player")
				info.notCheckable = 1
				UIDropDownMenu_AddButton(info, level)
			end
		
		--Purchasable Submenu
		elseif (level == 2) and (UIDROPDOWNMENU_MENU_VALUE == "Purchasable") then
			local info = UIDropDownMenu_CreateInfo()
			
			info.text = "Valor Points"
			info.value = "Valor Points"
			info.notCheckable = 1
			function info.func()
				CloseDropDownMenus(1);
				UIDropDownMenu_SetSelectedName(DropDown_Button, "Valor Points");
				PointInput:Show();
				PointInputBox:SetFocus();
				UpgradeListMainFrame:EnableMouse(false)
				CloseButton:EnableMouse(false)
				ToggleButton:EnableMouse(false)
				UpgradeListDBVar.char.SavedOptions.PrimaryCheck:EnableMouse(false)
				UpgradeListDBVar.char.SavedOptions.SecondaryCheck:EnableMouse(false)
				OptionsFrame:EnableMouse(false)
				ItemEntryBox:EnableMouse(false)
				DropDown_Button:EnableMouse(false)
				NoteEntryBox:EnableMouse(false)
				PrimarySpecRadioButton:EnableMouse(false)
				SecondarySpecRadioButton:EnableMouse(false)
				priorityfield:EnableMouse(false)
				AddButton:EnableMouse(false)
				tofield:EnableMouse(false)
				fromfield:EnableMouse(false)
				MoveButton:EnableMouse(false)
				DeleteButton:EnableMouse(false)
				deletefield:EnableMouse(false)
			end
			UIDropDownMenu_AddButton(info, level)
			
			info.text = "Justice Points"
			info.value = "Justice Points"
			info.notCheckable = 1
			function info.func()
				CloseDropDownMenus(1);
				UIDropDownMenu_SetSelectedName(DropDown_Button, "Justice Points");
				PointInput:Show();
				PointInputBox:SetFocus();
				UpgradeListMainFrame:EnableMouse(false)
				CloseButton:EnableMouse(false)
				ToggleButton:EnableMouse(false)
				UpgradeListDBVar.char.SavedOptions.PrimaryCheck:EnableMouse(false)
				UpgradeListDBVar.char.SavedOptions.SecondaryCheck:EnableMouse(false)
				OptionsFrame:EnableMouse(false)
				ItemEntryBox:EnableMouse(false)
				DropDown_Button:EnableMouse(false)
				NoteEntryBox:EnableMouse(false)
				PrimarySpecRadioButton:EnableMouse(false)
				SecondarySpecRadioButton:EnableMouse(false)
				priorityfield:EnableMouse(false)
				AddButton:EnableMouse(false)
				tofield:EnableMouse(false)
				fromfield:EnableMouse(false)
				MoveButton:EnableMouse(false)
				DeleteButton:EnableMouse(false)
				deletefield:EnableMouse(false)
			end
			UIDropDownMenu_AddButton(info, level)
			
			info.text = "Conquest Points"
			info.value = "Conquest Points"
			info.notCheckable = 1
			function info.func()
				CloseDropDownMenus(1);
				UIDropDownMenu_SetSelectedName(DropDown_Button, "Conquest Points");
				PointInput:Show();
				PointInputBox:SetFocus();
				UpgradeListMainFrame:EnableMouse(false)
				CloseButton:EnableMouse(false)
				ToggleButton:EnableMouse(false)
				UpgradeListDBVar.char.SavedOptions.PrimaryCheck:EnableMouse(false)
				UpgradeListDBVar.char.SavedOptions.SecondaryCheck:EnableMouse(false)
				OptionsFrame:EnableMouse(false)
				ItemEntryBox:EnableMouse(false)
				DropDown_Button:EnableMouse(false)
				NoteEntryBox:EnableMouse(false)
				PrimarySpecRadioButton:EnableMouse(false)
				SecondarySpecRadioButton:EnableMouse(false)
				priorityfield:EnableMouse(false)
				AddButton:EnableMouse(false)
				tofield:EnableMouse(false)
				fromfield:EnableMouse(false)
				MoveButton:EnableMouse(false)
				DeleteButton:EnableMouse(false)
				deletefield:EnableMouse(false)
			end
			UIDropDownMenu_AddButton(info, level)
			
			info.text = "Honor Points"
			info.value = "Honor Points"
			info.notCheckable = 1
			function info.func()
				CloseDropDownMenus(1);
				UIDropDownMenu_SetSelectedName(DropDown_Button, "Honor Points");
				PointInput:Show();
				PointInputBox:SetFocus();
				UpgradeListMainFrame:EnableMouse(false)
				CloseButton:EnableMouse(false)
				ToggleButton:EnableMouse(false)
				UpgradeListDBVar.char.SavedOptions.PrimaryCheck:EnableMouse(false)
				UpgradeListDBVar.char.SavedOptions.SecondaryCheck:EnableMouse(false)
				OptionsFrame:EnableMouse(false)
				ItemEntryBox:EnableMouse(false)
				DropDown_Button:EnableMouse(false)
				NoteEntryBox:EnableMouse(false)
				PrimarySpecRadioButton:EnableMouse(false)
				SecondarySpecRadioButton:EnableMouse(false)
				priorityfield:EnableMouse(false)
				AddButton:EnableMouse(false)
				tofield:EnableMouse(false)
				fromfield:EnableMouse(false)
				MoveButton:EnableMouse(false)
				DeleteButton:EnableMouse(false)
				deletefield:EnableMouse(false)
			end
			UIDropDownMenu_AddButton(info, level)
			
			info.text = "Gear Token"
			info.value = "Gear Token"
			info.notCheckable = true
			info.hasArrow = true
			UIDropDownMenu_AddButton(info, level)
			
		--World Drop Submenu
		elseif (level == 2) and (UIDROPDOWNMENU_MENU_VALUE == "World Drop") then
			local info = UIDropDownMenu_CreateInfo()
			
			info.text = "World Drop"
			info.value = "World Drop"
			info.notCheckable = true
			function info.func()
				UIDropDownMenu_SetText(DropDown_Button, "World Drop");
				UpgradeListDBVar.char.SavedOptions.SelectedInstance = "World Drop";
				CloseDropDownMenus(1);
			end
			UIDropDownMenu_AddButton(info, level)

		--List of heroic raids
		elseif (level == 3) and (UIDROPDOWNMENU_MENU_VALUE == "HeroicRaid") then
			local info = UIDropDownMenu_CreateInfo()
			
			info.text = "Baradin Hold"
			info.value = "Baradin Hold Heroic"
			info.hasArrow = true
			info.notCheckable = 1
			UIDropDownMenu_AddButton(info, level)
			
			info.text = "Bastion of Twilight"
			info.value = "Bastion of Twilight Heroic"
			info.hasArrow = true
			info.notCheckable = 1
			UIDropDownMenu_AddButton(info, level)

			info.text = "Blackwing Descent"
			info.value = "Blackwing Descent Heroic"
			info.hasArrow = true
			info.notCheckable = 1
			UIDropDownMenu_AddButton(info, level)
			
			info.text = "Throne of the Four Winds"
			info.value = "Throne of the Four Winds Heroic"
			info.hasArrow = true
			info.notCheckable = 1
			UIDropDownMenu_AddButton(info, level)
			
		--List of normal raids
		elseif (level == 3) and (UIDROPDOWNMENU_MENU_VALUE == "NormalRaid") then
			local info = UIDropDownMenu_CreateInfo()
			
			info.text = "Baradin Hold"
			info.value = "Baradin Hold Normal"
			info.hasArrow = true
			info.notCheckable = 1
			UIDropDownMenu_AddButton(info, level)
			
			info.text = "Bastion of Twilight"
			info.value = "Bastion of Twilight Normal"
			info.hasArrow = true
			info.notCheckable = 1
			UIDropDownMenu_AddButton(info, level)

			info.text = "Blackwing Descent"
			info.value = "Blackwing Descent Normal"
			info.hasArrow = true
			info.notCheckable = 1
			UIDropDownMenu_AddButton(info, level)
			
			info.text = "Throne of the Four Winds"
			info.value = "Throne of the Four Winds Normal"
			info.hasArrow = true
			info.notCheckable = 1
			UIDropDownMenu_AddButton(info, level)
		
		--Heroic Dungeons
		elseif (level == 3) and (UIDROPDOWNMENU_MENU_VALUE == "HeroicDungeon") then
			local info = UIDropDownMenu_CreateInfo()
			
			info.text = "Throne of the Tides"
			info.value = "Throne of the Tides Heroic"
			info.hasArrow = true
			info.notCheckable = 1
			UIDropDownMenu_AddButton(info, level)
			
			info.text = "Blackrock Caverns"
			info.value = "Blackrock Caverns Heroic"
			info.hasArrow = true
			info.notCheckable = 1
			UIDropDownMenu_AddButton(info, level)
			
			info.text = "The Stonecore"
			info.value = "The Stonecore Heroic"
			info.hasArrow = true
			info.notCheckable = 1
			UIDropDownMenu_AddButton(info, level)
			
			info.text = "The Vortex Pinnacle"
			info.value = "The Vortex Pinnacle Heroic"
			info.hasArrow = true
			info.notCheckable = 1
			UIDropDownMenu_AddButton(info, level)
			
			info.text = "Lost City of Tol'vir"
			info.value = "Lost City of Tol'vir Heroic"
			info.hasArrow = true
			info.notCheckable = 1
			UIDropDownMenu_AddButton(info, level)
			
			info.text = "Grim Batol"
			info.value = "Grim Batol Heroic"
			info.hasArrow = true
			info.notCheckable = 1
			UIDropDownMenu_AddButton(info, level)
			
			info.text = "Halls of Origination"
			info.value = "Halls of Origination Heroic"
			info.hasArrow = true
			info.notCheckable = 1
			UIDropDownMenu_AddButton(info, level)
			
			info.text = "The Deadmines"
			info.value = "The Deadmines Heroic"
			info.hasArrow = true
			info.notCheckable = 1
			UIDropDownMenu_AddButton(info, level)
			
			info.text = "Shadowfang Keep"
			info.value = "Shadowfang Keep Heroic"
			info.hasArrow = true
			info.notCheckable = 1
			UIDropDownMenu_AddButton(info, level)
			
		--Normal Dungeons
		elseif (level == 3) and (UIDROPDOWNMENU_MENU_VALUE == "NormalDungeon") then
			local info = UIDropDownMenu_CreateInfo()
			
			info.text = "Throne of the Tides"
			info.value = "Throne of the Tides Normal"
			info.hasArrow = true
			info.notCheckable = 1
			UIDropDownMenu_AddButton(info, level)
			
			info.text = "Blackrock Caverns"
			info.value = "Blackrock Caverns Normal"
			info.hasArrow = true
			info.notCheckable = 1
			UIDropDownMenu_AddButton(info, level)
			
			info.text = "The Stonecore"
			info.value = "The Stonecore Normal"
			info.hasArrow = true
			info.notCheckable = 1
			UIDropDownMenu_AddButton(info, level)
			
			info.text = "The Vortex Pinnacle"
			info.value = "The Vortex Pinnacle Normal"
			info.hasArrow = true
			info.notCheckable = 1
			UIDropDownMenu_AddButton(info, level)
			
			info.text = "Lost City of Tol'vir"
			info.value = "Lost City of Tol'vir Normal"
			info.hasArrow = true
			info.notCheckable = 1
			UIDropDownMenu_AddButton(info, level)
			
			info.text = "Grim Batol"
			info.value = "Grim Batol Normal"
			info.hasArrow = true
			info.notCheckable = 1
			UIDropDownMenu_AddButton(info, level)
			
			info.text = "Halls of Origination"
			info.value = "Halls of Origination Normal"
			info.hasArrow = true
			info.notCheckable = 1
			UIDropDownMenu_AddButton(info, level)
			
		--Guardians of Hyjal Rep
		elseif (level == 3) and (UIDROPDOWNMENU_MENU_VALUE == "Guardians of Hyjal") then
			local info = UIDropDownMenu_CreateInfo()
			
			info.text = "Exalted"
			info.notCheckable = true
			function info.func()
				UIDropDownMenu_SetText(DropDown_Button, "Guardians of Hyjal");
				UpgradeListDBVar.char.SavedOptions.SelectedBoss = "Exalted";
				UpgradeListDBVar.char.SavedOptions.SelectedInstance = "Guardians of Hyjal";
				CloseDropDownMenus(1);
			end
			UIDropDownMenu_AddButton(info, level)
			
			info.text = "Revered"
			info.notCheckable = true
			function info.func()
				UIDropDownMenu_SetText(DropDown_Button, "Guardians of Hyjal");
				UpgradeListDBVar.char.SavedOptions.SelectedBoss = "Revered";
				UpgradeListDBVar.char.SavedOptions.SelectedInstance = "Guardians of Hyjal";
				CloseDropDownMenus(1);
			end
			UIDropDownMenu_AddButton(info, level)
			
			info.text = "Honored"
			info.notCheckable = true
			function info.func()
				UIDropDownMenu_SetText(DropDown_Button, "Guardians of Hyjal");
				UpgradeListDBVar.char.SavedOptions.SelectedBoss = "Honored";
				UpgradeListDBVar.char.SavedOptions.SelectedInstance = "Guardians of Hyjal";
				CloseDropDownMenus(1);
			end
			UIDropDownMenu_AddButton(info, level)
			
			info.text = "Friendly"
			info.notCheckable = true
			function info.func()
				UIDropDownMenu_SetText(DropDown_Button, "Guardians of Hyjal");
				UpgradeListDBVar.char.SavedOptions.SelectedBoss = "Friendly";
				UpgradeListDBVar.char.SavedOptions.SelectedInstance = "Guardians of Hyjal";
				CloseDropDownMenus(1);
			end
			UIDropDownMenu_AddButton(info, level)
			
		--The Earthen Ring Rep
		elseif (level == 3) and (UIDROPDOWNMENU_MENU_VALUE == "The Earthen Ring") then
			local info = UIDropDownMenu_CreateInfo()
			
			info.text = "Exalted"
			info.notCheckable = true
			function info.func()
				UIDropDownMenu_SetText(DropDown_Button, "The Earthen Ring");
				UpgradeListDBVar.char.SavedOptions.SelectedBoss = "Exalted";
				UpgradeListDBVar.char.SavedOptions.SelectedInstance = "The Earthen Ring";
				CloseDropDownMenus(1);
			end
			UIDropDownMenu_AddButton(info, level)
			
			info.text = "Revered"
			info.notCheckable = true
			function info.func()
				UIDropDownMenu_SetText(DropDown_Button, "The Earthen Ring");
				UpgradeListDBVar.char.SavedOptions.SelectedBoss = "Revered";
				UpgradeListDBVar.char.SavedOptions.SelectedInstance = "The Earthen Ring";
				CloseDropDownMenus(1);
			end
			UIDropDownMenu_AddButton(info, level)
			
			info.text = "Honored"
			info.notCheckable = true
			function info.func()
				UIDropDownMenu_SetText(DropDown_Button, "The Earthen Ring");
				UpgradeListDBVar.char.SavedOptions.SelectedBoss = "Honored";
				UpgradeListDBVar.char.SavedOptions.SelectedInstance = "The Earthen Ring";
				CloseDropDownMenus(1);
			end
			UIDropDownMenu_AddButton(info, level)
			
			info.text = "Friendly"
			info.notCheckable = true
			function info.func()
				UIDropDownMenu_SetText(DropDown_Button, "The Earthen Ring");
				UpgradeListDBVar.char.SavedOptions.SelectedBoss = "Friendly";
				UpgradeListDBVar.char.SavedOptions.SelectedInstance = "The Earthen Ring";
				CloseDropDownMenus(1);
			end
			UIDropDownMenu_AddButton(info, level)
			
		--Therazane Rep
		elseif (level == 3) and (UIDROPDOWNMENU_MENU_VALUE == "Therazane") then
			local info = UIDropDownMenu_CreateInfo()
			
			info.text = "Exalted"
			info.notCheckable = true
			function info.func()
				UIDropDownMenu_SetText(DropDown_Button, "Therazane");
				UpgradeListDBVar.char.SavedOptions.SelectedBoss = "Exalted";
				UpgradeListDBVar.char.SavedOptions.SelectedInstance = "Therazane";
				CloseDropDownMenus(1);
			end
			UIDropDownMenu_AddButton(info, level)
			
			info.text = "Revered"
			info.notCheckable = true
			function info.func()
				UIDropDownMenu_SetText(DropDown_Button, "Therazane");
				UpgradeListDBVar.char.SavedOptions.SelectedBoss = "Revered";
				UpgradeListDBVar.char.SavedOptions.SelectedInstance = "Therazane";
				CloseDropDownMenus(1);
			end
			UIDropDownMenu_AddButton(info, level)
			
			info.text = "Honored"
			info.notCheckable = true
			function info.func()
				UIDropDownMenu_SetText(DropDown_Button, "Therazane");
				UpgradeListDBVar.char.SavedOptions.SelectedBoss = "Honored";
				UpgradeListDBVar.char.SavedOptions.SelectedInstance = "Therazane";
				CloseDropDownMenus(1);
			end
			UIDropDownMenu_AddButton(info, level)
			
			info.text = "Friendly"
			info.notCheckable = true
			function info.func()
				UIDropDownMenu_SetText(DropDown_Button, "Therazane");
				UpgradeListDBVar.char.SavedOptions.SelectedBoss = "Friendly";
				UpgradeListDBVar.char.SavedOptions.SelectedInstance = "Therazane";
				CloseDropDownMenus(1);
			end
			UIDropDownMenu_AddButton(info, level)
			
		--Ramkahen Rep
		elseif (level == 3) and (UIDROPDOWNMENU_MENU_VALUE == "Ramkahen") then
			local info = UIDropDownMenu_CreateInfo()
			
			info.text = "Exalted"
			info.notCheckable = true
			function info.func()
				UIDropDownMenu_SetText(DropDown_Button, "Ramkahen");
				UpgradeListDBVar.char.SavedOptions.SelectedBoss = "Exalted";
				UpgradeListDBVar.char.SavedOptions.SelectedInstance = "Ramkahen";
				CloseDropDownMenus(1);
			end
			UIDropDownMenu_AddButton(info, level)
			
			info.text = "Revered"
			info.notCheckable = true
			function info.func()
				UIDropDownMenu_SetText(DropDown_Button, "Ramkahen");
				UpgradeListDBVar.char.SavedOptions.SelectedBoss = "Revered";
				UpgradeListDBVar.char.SavedOptions.SelectedInstance = "Ramkahen";
				CloseDropDownMenus(1);
			end
			UIDropDownMenu_AddButton(info, level)
			
			info.text = "Honored"
			info.notCheckable = true
			function info.func()
				UIDropDownMenu_SetText(DropDown_Button, "Ramkahen");
				UpgradeListDBVar.char.SavedOptions.SelectedBoss = "Honored";
				UpgradeListDBVar.char.SavedOptions.SelectedInstance = "Ramkahen";
				CloseDropDownMenus(1);
			end
			UIDropDownMenu_AddButton(info, level)
			
			info.text = "Friendly"
			info.notCheckable = true
			function info.func()
				UIDropDownMenu_SetText(DropDown_Button, "Ramkahen");
				UpgradeListDBVar.char.SavedOptions.SelectedBoss = "Friendly";
				UpgradeListDBVar.char.SavedOptions.SelectedInstance = "Ramkahen";
				CloseDropDownMenus(1);
			end
			UIDropDownMenu_AddButton(info, level)
			
		--Wildhammer Clan Rep
		elseif (level == 3) and (UIDROPDOWNMENU_MENU_VALUE == "Wildhammer Clan") then
			local info = UIDropDownMenu_CreateInfo()
			
			info.text = "Exalted"
			info.notCheckable = true
			function info.func()
				UIDropDownMenu_SetText(DropDown_Button, "Wildhammer Clan");
				UpgradeListDBVar.char.SavedOptions.SelectedBoss = "Exalted";
				UpgradeListDBVar.char.SavedOptions.SelectedInstance = "Wildhammer Clan";
				CloseDropDownMenus(1);
			end
			UIDropDownMenu_AddButton(info, level)
			
			info.text = "Revered"
			info.notCheckable = true
			function info.func()
				UIDropDownMenu_SetText(DropDown_Button, "Wildhammer Clan");
				UpgradeListDBVar.char.SavedOptions.SelectedBoss = "Revered";
				UpgradeListDBVar.char.SavedOptions.SelectedInstance = "Wildhammer Clan";
				CloseDropDownMenus(1);
			end
			UIDropDownMenu_AddButton(info, level)
			
			info.text = "Honored"
			info.notCheckable = true
			function info.func()
				UIDropDownMenu_SetText(DropDown_Button, "Wildhammer Clan");
				UpgradeListDBVar.char.SavedOptions.SelectedBoss = "Honored";
				UpgradeListDBVar.char.SavedOptions.SelectedInstance = "Wildhammer Clan";
				CloseDropDownMenus(1);
			end
			UIDropDownMenu_AddButton(info, level)
			
			info.text = "Friendly"
			info.notCheckable = true
			function info.func()
				UIDropDownMenu_SetText(DropDown_Button, "Wildhammer Clan");
				UpgradeListDBVar.char.SavedOptions.SelectedBoss = "Friendly";
				UpgradeListDBVar.char.SavedOptions.SelectedInstance = "Wildhammer Clan";
				CloseDropDownMenus(1);
			end
			UIDropDownMenu_AddButton(info, level)
			
		--Dragonmaw Clan Rep
		elseif (level == 3) and (UIDROPDOWNMENU_MENU_VALUE == "Dragonmaw Clan") then
			local info = UIDropDownMenu_CreateInfo()
			
			info.text = "Exalted"
			info.notCheckable = true
			function info.func()
				UIDropDownMenu_SetText(DropDown_Button, "Dragonmaw Clan");
				UpgradeListDBVar.char.SavedOptions.SelectedBoss = "Exalted";
				UpgradeListDBVar.char.SavedOptions.SelectedInstance = "Dragonmaw Clan";
				CloseDropDownMenus(1);
			end
			UIDropDownMenu_AddButton(info, level)
			
			info.text = "Revered"
			info.notCheckable = true
			function info.func()
				UIDropDownMenu_SetText(DropDown_Button, "Dragonmaw Clan");
				UpgradeListDBVar.char.SavedOptions.SelectedBoss = "Revered";
				UpgradeListDBVar.char.SavedOptions.SelectedInstance = "Dragonmaw Clan";
				CloseDropDownMenus(1);
			end
			UIDropDownMenu_AddButton(info, level)
			
			info.text = "Honored"
			info.notCheckable = true
			function info.func()
				UIDropDownMenu_SetText(DropDown_Button, "Dragonmaw Clan");
				UpgradeListDBVar.char.SavedOptions.SelectedBoss = "Honored";
				UpgradeListDBVar.char.SavedOptions.SelectedInstance = "Dragonmaw Clan";
				CloseDropDownMenus(1);
			end
			UIDropDownMenu_AddButton(info, level)
			
			info.text = "Friendly"
			info.notCheckable = true
			function info.func()
				UIDropDownMenu_SetText(DropDown_Button, "Dragonmaw Clan");
				UpgradeListDBVar.char.SavedOptions.SelectedBoss = "Friendly";
				UpgradeListDBVar.char.SavedOptions.SelectedInstance = "Dragonmaw Clan";
				CloseDropDownMenus(1);
			end
			UIDropDownMenu_AddButton(info, level)
			
		--Baradin's Wardens Rep
		elseif (level == 3) and (UIDROPDOWNMENU_MENU_VALUE == "Baradin's Wardens") then
			local info = UIDropDownMenu_CreateInfo()
			
			info.text = "Exalted"
			info.notCheckable = true
			function info.func()
				UIDropDownMenu_SetText(DropDown_Button, "Baradin's Wardens");
				UpgradeListDBVar.char.SavedOptions.SelectedBoss = "Exalted";
				UpgradeListDBVar.char.SavedOptions.SelectedInstance = "Baradin's Wardens";
				CloseDropDownMenus(1);
			end
			UIDropDownMenu_AddButton(info, level)
			
			info.text = "Revered"
			info.notCheckable = true
			function info.func()
				UIDropDownMenu_SetText(DropDown_Button, "Baradin's Wardens");
				UpgradeListDBVar.char.SavedOptions.SelectedBoss = "Revered";
				UpgradeListDBVar.char.SavedOptions.SelectedInstance = "Baradin's Wardens";
				CloseDropDownMenus(1);
			end
			UIDropDownMenu_AddButton(info, level)
			
			info.text = "Honored"
			info.notCheckable = true
			function info.func()
				UIDropDownMenu_SetText(DropDown_Button, "Baradin's Wardens");
				UpgradeListDBVar.char.SavedOptions.SelectedBoss = "Honored";
				UpgradeListDBVar.char.SavedOptions.SelectedInstance = "Baradin's Wardens";
				CloseDropDownMenus(1);
			end
			UIDropDownMenu_AddButton(info, level)
			
			info.text = "Friendly"
			info.notCheckable = true
			function info.func()
				UIDropDownMenu_SetText(DropDown_Button, "Baradin's Wardens");
				UpgradeListDBVar.char.SavedOptions.SelectedBoss = "Friendly";
				UpgradeListDBVar.char.SavedOptions.SelectedInstance = "Baradin's Wardens";
				CloseDropDownMenus(1);
			end
			UIDropDownMenu_AddButton(info, level)
			
		--Hellscream's Reach Rep
		elseif (level == 3) and (UIDROPDOWNMENU_MENU_VALUE == "Hellscream's Reach") then
			local info = UIDropDownMenu_CreateInfo()
			
			info.text = "Exalted"
			info.notCheckable = true
			function info.func()
				UIDropDownMenu_SetText(DropDown_Button, "Hellscream's Reach");
				UpgradeListDBVar.char.SavedOptions.SelectedBoss = "Exalted";
				UpgradeListDBVar.char.SavedOptions.SelectedInstance = "Hellscream's Reach";
				CloseDropDownMenus(1);
			end
			UIDropDownMenu_AddButton(info, level)
			
			info.text = "Revered"
			info.notCheckable = true
			function info.func()
				UIDropDownMenu_SetText(DropDown_Button, "Hellscream's Reach");
				UpgradeListDBVar.char.SavedOptions.SelectedBoss = "Revered";
				UpgradeListDBVar.char.SavedOptions.SelectedInstance = "Hellscream's Reach";
				CloseDropDownMenus(1);
			end
			UIDropDownMenu_AddButton(info, level)
			
			info.text = "Honored"
			info.notCheckable = true
			function info.func()
				UIDropDownMenu_SetText(DropDown_Button, "Hellscream's Reach");
				UpgradeListDBVar.char.SavedOptions.SelectedBoss = "Honored";
				UpgradeListDBVar.char.SavedOptions.SelectedInstance = "Hellscream's Reach";
				CloseDropDownMenus(1);
			end
			UIDropDownMenu_AddButton(info, level)
			
			info.text = "Friendly"
			info.notCheckable = true
			function info.func()
				UIDropDownMenu_SetText(DropDown_Button, "Hellscream's Reach");
				UpgradeListDBVar.char.SavedOptions.SelectedBoss = "Friendly";
				UpgradeListDBVar.char.SavedOptions.SelectedInstance = "Hellscream's Reach";
				CloseDropDownMenus(1);
			end
			UIDropDownMenu_AddButton(info, level)
			
		--Guild Rep
		elseif (level == 3) and (UIDROPDOWNMENU_MENU_VALUE == GetGuildInfo("player")) then
			local info = UIDropDownMenu_CreateInfo()
			
			info.text = "Exalted"
			info.notCheckable = true
			function info.func()
				UIDropDownMenu_SetText(DropDown_Button, GetGuildInfo("player"));
				UpgradeListDBVar.char.SavedOptions.SelectedBoss = "Exalted";
				UpgradeListDBVar.char.SavedOptions.SelectedInstance = GetGuildInfo("player");
				CloseDropDownMenus(1);
			end
			UIDropDownMenu_AddButton(info, level)
			
			info.text = "Revered"
			info.notCheckable = true
			function info.func()
				UIDropDownMenu_SetText(DropDown_Button, GetGuildInfo("player"));
				UpgradeListDBVar.char.SavedOptions.SelectedBoss = "Revered";
				UpgradeListDBVar.char.SavedOptions.SelectedInstance = GetGuildInfo("player");
				CloseDropDownMenus(1);
			end
			UIDropDownMenu_AddButton(info, level)
			
			info.text = "Honored"
			info.notCheckable = true
			function info.func()
				UIDropDownMenu_SetText(DropDown_Button, GetGuildInfo("player"));
				UpgradeListDBVar.char.SavedOptions.SelectedBoss = "Honored";
				UpgradeListDBVar.char.SavedOptions.SelectedInstance = GetGuildInfo("player");
				CloseDropDownMenus(1);
			end
			UIDropDownMenu_AddButton(info, level)
			
			info.text = "Friendly"
			info.notCheckable = true
			function info.func()
				UIDropDownMenu_SetText(DropDown_Button, GetGuildInfo("player"));
				UpgradeListDBVar.char.SavedOptions.SelectedBoss = "Friendly";
				UpgradeListDBVar.char.SavedOptions.SelectedInstance = GetGuildInfo("player");
				CloseDropDownMenus(1);
			end
			UIDropDownMenu_AddButton(info, level)
			
		elseif (level == 3) and (UIDROPDOWNMENU_MENU_VALUE == "Gear Token") then
			local localizedClass, englishClass = UnitClass("player");
			local info = UIDropDownMenu_CreateInfo()
			if (englishClass == "DEATHKNIGHT") or (englishClass == "DRUID") or (englishClass == "MAGE") or (englishClass == "ROGUE") then
				info.text = "Crown of the Forlorn Vanquisher"
				info.notCheckable = true
				function info.func()
					UIDropDownMenu_SetText(DropDown_Button, "Crown of the Forlorn Vanquisher");
					UpgradeListDBVar.char.SavedOptions.SelectedBoss = "Nefarian or \"Essence of the Forlorn\" token";
					UpgradeListDBVar.char.SavedOptions.SelectedInstance = "Crown of the Forlorn Vanquisher";
					UpgradeListDBVar.char.SavedOptions.SelectedDifficulty = "Heroic";
					CloseDropDownMenus(1);
				end
				UIDropDownMenu_AddButton(info, level)
				
				info.text = "Shoulders of the Forlorn Vanquisher"
				info.notCheckable = true
				function info.func()
					UIDropDownMenu_SetText(DropDown_Button, "Shoulders of the Forlorn Vanquisher");
					UpgradeListDBVar.char.SavedOptions.SelectedBoss = "Cho'gall or \"Essence of the Forlorn\" token";
					UpgradeListDBVar.char.SavedOptions.SelectedInstance = "Shoulders of the Forlorn Vanquisher";
					UpgradeListDBVar.char.SavedOptions.SelectedDifficulty = "Heroic";
					CloseDropDownMenus(1);
				end
				UIDropDownMenu_AddButton(info, level)
				
				info.text = "Chest of the Forlorn Vanquisher"
				info.notCheckable = true
				function info.func()
					UIDropDownMenu_SetText(DropDown_Button, "Chest of the Forlorn Vanquisher");
					UpgradeListDBVar.char.SavedOptions.SelectedBoss = "Halfus Wyrmbreaker or \"Essence of the Forlorn\" token";
					UpgradeListDBVar.char.SavedOptions.SelectedInstance = "Chest of the Forlorn Vanquisher";
					UpgradeListDBVar.char.SavedOptions.SelectedDifficulty = "Heroic";
					CloseDropDownMenus(1);
				end
				UIDropDownMenu_AddButton(info, level)
				
				info.text = "Gauntlets of the Forlorn Vanquisher"
				info.notCheckable = true
				function info.func()
					UIDropDownMenu_SetText(DropDown_Button, "Gauntlets of the Forlorn Vanquisher");
					UpgradeListDBVar.char.SavedOptions.SelectedBoss = "Atramedes or \"Essence of the Forlorn\" token";
					UpgradeListDBVar.char.SavedOptions.SelectedInstance = "Gauntlets of the Forlorn Vanquisher";
					UpgradeListDBVar.char.SavedOptions.SelectedDifficulty = "Heroic";
					CloseDropDownMenus(1);
				end
				UIDropDownMenu_AddButton(info, level)
				
				info.text = "Leggings of the Forlorn Vanquisher"
				info.notCheckable = true
				function info.func()
					UIDropDownMenu_SetText(DropDown_Button, "Leggings of the Forlorn Vanquisher");
					UpgradeListDBVar.char.SavedOptions.SelectedBoss = "Maloriak or \"Essence of the Forlorn\" token";
					UpgradeListDBVar.char.SavedOptions.SelectedInstance = "Leggings of the Forlorn Vanquisher";
					UpgradeListDBVar.char.SavedOptions.SelectedDifficulty = "Heroic";
					CloseDropDownMenus(1);
				end
				UIDropDownMenu_AddButton(info, level)
				
				info.text = "Helm of the Forlorn Vanquisher"
				info.notCheckable = true
				function info.func()
					UIDropDownMenu_SetText(DropDown_Button, "Helm of the Forlorn Vanquisher");
					UpgradeListDBVar.char.SavedOptions.SelectedBoss = "Nefarian";
					UpgradeListDBVar.char.SavedOptions.SelectedInstance = "Helm of the Forlorn Vanquisher";
					UpgradeListDBVar.char.SavedOptions.SelectedDifficulty = "Normal";
					CloseDropDownMenus(1);
				end
				UIDropDownMenu_AddButton(info, level)
				
				info.text = "Mantle of the Forlorn Vanquisher"
				info.notCheckable = true
				function info.func()
					UIDropDownMenu_SetText(DropDown_Button, "Mantle of the Forlorn Vanquisher");
					UpgradeListDBVar.char.SavedOptions.SelectedBoss = "Cho'gall";
					UpgradeListDBVar.char.SavedOptions.SelectedInstance = "Mantle of the Forlorn Vanquisher";
					UpgradeListDBVar.char.SavedOptions.SelectedDifficulty = "Normal";
					CloseDropDownMenus(1);
				end
				UIDropDownMenu_AddButton(info, level)
			elseif (englishClass == "PALADIN") or (englishClass == "PRIEST") or (englishClass == "WARLOCK") then
				info.text = "Crown of the Forlorn Conqueror"
				info.notCheckable = true
				function info.func()
					UIDropDownMenu_SetText(DropDown_Button, "Crown of the Forlorn Conqueror");
					UpgradeListDBVar.char.SavedOptions.SelectedBoss = "Nefarian or \"Essence of the Forlorn\" token";
					UpgradeListDBVar.char.SavedOptions.SelectedInstance = "Crown of the Forlorn Conqueror";
					UpgradeListDBVar.char.SavedOptions.SelectedDifficulty = "Heroic";
					CloseDropDownMenus(1);
				end
				UIDropDownMenu_AddButton(info, level)
				
				info.text = "Shoulders of the Forlorn Conqueror"
				info.notCheckable = true
				function info.func()
					UIDropDownMenu_SetText(DropDown_Button, "Shoulders of the Forlorn Conqueror");
					UpgradeListDBVar.char.SavedOptions.SelectedBoss = "Cho'gall or \"Essence of the Forlorn\" token";
					UpgradeListDBVar.char.SavedOptions.SelectedInstance = "Shoulders of the Forlorn Conqueror";
					UpgradeListDBVar.char.SavedOptions.SelectedDifficulty = "Heroic";
					CloseDropDownMenus(1);
				end
				UIDropDownMenu_AddButton(info, level)
				
				info.text = "Chest of the Forlorn Conqueror"
				info.notCheckable = true
				function info.func()
					UIDropDownMenu_SetText(DropDown_Button, "Chest of the Forlorn Conqueror");
					UpgradeListDBVar.char.SavedOptions.SelectedBoss = "Halfus Wyrmbreaker or \"Essence of the Forlorn\" token";
					UpgradeListDBVar.char.SavedOptions.SelectedInstance = "Chest of the Forlorn Conqueror";
					UpgradeListDBVar.char.SavedOptions.SelectedDifficulty = "Heroic";
					CloseDropDownMenus(1);
				end
				UIDropDownMenu_AddButton(info, level)
				
				info.text = "Gauntlets of the Forlorn Conqueror"
				info.notCheckable = true
				function info.func()
					UIDropDownMenu_SetText(DropDown_Button, "Gauntlets of the Forlorn Conqueror");
					UpgradeListDBVar.char.SavedOptions.SelectedBoss = "Atramedes or \"Essence of the Forlorn\" token";
					UpgradeListDBVar.char.SavedOptions.SelectedInstance = "Gauntlets of the Forlorn Conqueror";
					UpgradeListDBVar.char.SavedOptions.SelectedDifficulty = "Heroic";
					CloseDropDownMenus(1);
				end
				UIDropDownMenu_AddButton(info, level)
				
				info.text = "Leggings of the Forlorn Conqueror"
				info.notCheckable = true
				function info.func()
					UIDropDownMenu_SetText(DropDown_Button, "Leggings of the Forlorn Conqueror");
					UpgradeListDBVar.char.SavedOptions.SelectedBoss = "Maloriak or \"Essence of the Forlorn\" token";
					UpgradeListDBVar.char.SavedOptions.SelectedInstance = "Leggings of the Forlorn Conqueror";
					UpgradeListDBVar.char.SavedOptions.SelectedDifficulty = "Heroic";
					CloseDropDownMenus(1);
				end
				UIDropDownMenu_AddButton(info, level)
				
				info.text = "Helm of the Forlorn Conqueror"
				info.notCheckable = true
				function info.func()
					UIDropDownMenu_SetText(DropDown_Button, "Helm of the Forlorn Conqueror");
					UpgradeListDBVar.char.SavedOptions.SelectedBoss = "Nefarian";
					UpgradeListDBVar.char.SavedOptions.SelectedInstance = "Helm of the Forlorn Conqueror";
					UpgradeListDBVar.char.SavedOptions.SelectedDifficulty = "Normal";
					CloseDropDownMenus(1);
				end
				UIDropDownMenu_AddButton(info, level)
				
				info.text = "Mantle of the Forlorn Conqueror"
				info.notCheckable = true
				function info.func()
					UIDropDownMenu_SetText(DropDown_Button, "Mantle of the Forlorn Conqueror");
					UpgradeListDBVar.char.SavedOptions.SelectedBoss = "Cho'gall";
					UpgradeListDBVar.char.SavedOptions.SelectedInstance = "Mantle of the Forlorn Conqueror";
					UpgradeListDBVar.char.SavedOptions.SelectedDifficulty = "Normal";
					CloseDropDownMenus(1);
				end
				UIDropDownMenu_AddButton(info, level)
			elseif (englishClass == "HUNTER") or (englishClass == "SHAMAN") or (englishClass == "WARRIOR") then
				info.text = "Crown of the Forlorn Protector"
				info.notCheckable = true
				function info.func()
					UIDropDownMenu_SetText(DropDown_Button, "Crown of the Forlorn Protector");
					UpgradeListDBVar.char.SavedOptions.SelectedBoss = "Nefarian or \"Essence of the Forlorn\" token";
					UpgradeListDBVar.char.SavedOptions.SelectedInstance = "Crown of the Forlorn Protector";
					UpgradeListDBVar.char.SavedOptions.SelectedDifficulty = "Heroic";
					CloseDropDownMenus(1);
				end
				UIDropDownMenu_AddButton(info, level)
				
				info.text = "Shoulders of the Forlorn Protector"
				info.notCheckable = true
				function info.func()
					UIDropDownMenu_SetText(DropDown_Button, "Shoulders of the Forlorn Protector");
					UpgradeListDBVar.char.SavedOptions.SelectedBoss = "Cho'gall or \"Essence of the Forlorn\" token";
					UpgradeListDBVar.char.SavedOptions.SelectedInstance = "Shoulders of the Forlorn Protector";
					UpgradeListDBVar.char.SavedOptions.SelectedDifficulty = "Heroic";
					CloseDropDownMenus(1);
				end
				UIDropDownMenu_AddButton(info, level)
				
				info.text = "Chest of the Forlorn Protector"
				info.notCheckable = true
				function info.func()
					UIDropDownMenu_SetText(DropDown_Button, "Chest of the Forlorn Protector");
					UpgradeListDBVar.char.SavedOptions.SelectedBoss = "Halfus Wyrmbreaker or \"Essence of the Forlorn\" token";
					UpgradeListDBVar.char.SavedOptions.SelectedInstance = "Chest of the Forlorn Protector";
					UpgradeListDBVar.char.SavedOptions.SelectedDifficulty = "Heroic";
					CloseDropDownMenus(1);
				end
				UIDropDownMenu_AddButton(info, level)
				
				info.text = "Gauntlets of the Forlorn Protector"
				info.notCheckable = true
				function info.func()
					UIDropDownMenu_SetText(DropDown_Button, "Gauntlets of the Forlorn Protector");
					UpgradeListDBVar.char.SavedOptions.SelectedBoss = "Atramedes or \"Essence of the Forlorn\" token";
					UpgradeListDBVar.char.SavedOptions.SelectedInstance = "Gauntlets of the Forlorn Protector";
					UpgradeListDBVar.char.SavedOptions.SelectedDifficulty = "Heroic";
					CloseDropDownMenus(1);
				end
				UIDropDownMenu_AddButton(info, level)
				
				info.text = "Leggings of the Forlorn Protector"
				info.notCheckable = true
				function info.func()
					UIDropDownMenu_SetText(DropDown_Button, "Leggings of the Forlorn Protector");
					UpgradeListDBVar.char.SavedOptions.SelectedBoss = "Maloriak or \"Essence of the Forlorn\" token";
					UpgradeListDBVar.char.SavedOptions.SelectedInstance = "Leggings of the Forlorn Protector";
					UpgradeListDBVar.char.SavedOptions.SelectedDifficulty = "Heroic";
					CloseDropDownMenus(1);
				end
				UIDropDownMenu_AddButton(info, level)
				
				info.text = "Helm of the Forlorn Protector"
				info.notCheckable = true
				function info.func()
					UIDropDownMenu_SetText(DropDown_Button, "Helm of the Forlorn Protector");
					UpgradeListDBVar.char.SavedOptions.SelectedBoss = "Nefarian";
					UpgradeListDBVar.char.SavedOptions.SelectedInstance = "Helm of the Forlorn Protector";
					UpgradeListDBVar.char.SavedOptions.SelectedDifficulty = "Normal";
					CloseDropDownMenus(1);
				end
				UIDropDownMenu_AddButton(info, level)
				
				info.text = "Mantle of the Forlorn Protector"
				info.notCheckable = true
				function info.func()
					UIDropDownMenu_SetText(DropDown_Button, "Mantle of the Forlorn Protector");
					UpgradeListDBVar.char.SavedOptions.SelectedBoss = "Cho'gall";
					UpgradeListDBVar.char.SavedOptions.SelectedInstance = "Mantle of the Forlorn Protector";
					UpgradeListDBVar.char.SavedOptions.SelectedDifficulty = "Normal";
					CloseDropDownMenus(1);
				end
				UIDropDownMenu_AddButton(info, level)
			else
				statusbarfont:SetTextColor(0, 1, 0);
				statusbarfont:SetText("ERROR: Unable to determine your class.");
			end
				
		--Normal Baradin Hold Bosses
		elseif (level == 4) and (UIDROPDOWNMENU_MENU_VALUE == "Baradin Hold Normal") then
			local info = UIDropDownMenu_CreateInfo()
			
			info.text = "Argaloth"
			info.notCheckable = true
			function info.func()
				UIDropDownMenu_SetText(DropDown_Button, "Argaloth");
				UpgradeListDBVar.char.SavedOptions.SelectedBoss = "Argaloth";
				UpgradeListDBVar.char.SavedOptions.SelectedInstance = "Baradin Hold";
				UpgradeListDBVar.char.SavedOptions.SelectedDifficulty = "Normal";
				CloseDropDownMenus(1);
			end
			UIDropDownMenu_AddButton(info, level)
			
			info.text = "(Trash Drop)"
			info.notCheckable = true
			function info.func()
				UIDropDownMenu_SetText(DropDown_Button, "(Trash Drop)");
				UpgradeListDBVar.char.SavedOptions.SelectedBoss = "(Trash Drop)";
				UpgradeListDBVar.char.SavedOptions.SelectedInstance = "Baradin Hold";
				UpgradeListDBVar.char.SavedOptions.SelectedDifficulty = "Normal";
				CloseDropDownMenus(1);
			end
			UIDropDownMenu_AddButton(info, level)
			
		--Heroic Baradin Hold Bosses
		elseif (level == 4) and (UIDROPDOWNMENU_MENU_VALUE == "Baradin Hold Heroic") then
			local info = UIDropDownMenu_CreateInfo()
			
			info.text = "Argaloth"
			info.notCheckable = true
			function info.func()
				UIDropDownMenu_SetText(DropDown_Button, "Argaloth");
				UpgradeListDBVar.char.SavedOptions.SelectedBoss = "Argaloth";
				UpgradeListDBVar.char.SavedOptions.SelectedInstance = "Baradin Hold";
				UpgradeListDBVar.char.SavedOptions.SelectedDifficulty = "Heroic";
				CloseDropDownMenus(1);
			end
			UIDropDownMenu_AddButton(info, level)
			
			info.text = "(Trash Drop)"
			info.notCheckable = true
			function info.func()
				UIDropDownMenu_SetText(DropDown_Button, "(Trash Drop)");
				UpgradeListDBVar.char.SavedOptions.SelectedBoss = "(Trash Drop)";
				UpgradeListDBVar.char.SavedOptions.SelectedInstance = "Baradin Hold";
				UpgradeListDBVar.char.SavedOptions.SelectedDifficulty = "Heroic";
				CloseDropDownMenus(1);
			end
			UIDropDownMenu_AddButton(info, level)
			
		--Normal Bastion of Twilight Bosses
		elseif (level == 4) and (UIDROPDOWNMENU_MENU_VALUE == "Bastion of Twilight Normal") then
			local info = UIDropDownMenu_CreateInfo()
			
			info.text = "Halfus Wyrmbreaker"
			info.notCheckable = true
			function info.func()
				UIDropDownMenu_SetText(DropDown_Button, "Halfus Wyrmbreaker");
				UpgradeListDBVar.char.SavedOptions.SelectedBoss = "Hyalfus Wyrmbreaker";
				UpgradeListDBVar.char.SavedOptions.SelectedInstance = "Bastion of Twilight";
				UpgradeListDBVar.char.SavedOptions.SelectedDifficulty = "Normal";
				CloseDropDownMenus(1);
			end
			UIDropDownMenu_AddButton(info, level)
			
			info.text = "Valiona & Theralion"
			info.notCheckable = true
			function info.func()
				UIDropDownMenu_SetText(DropDown_Button, "Valiona & Theralion");
				UpgradeListDBVar.char.SavedOptions.SelectedBoss = "Valiona & Theralion";
				UpgradeListDBVar.char.SavedOptions.SelectedInstance = "Bastion of Twilight";
				UpgradeListDBVar.char.SavedOptions.SelectedDifficulty = "Normal";
				CloseDropDownMenus(1);
			end
			UIDropDownMenu_AddButton(info, level)
			
			info.text = "Ascendent Council"
			info.notCheckable = true
			function info.func()
				UIDropDownMenu_SetText(DropDown_Button, "Ascendent Council");
				UpgradeListDBVar.char.SavedOptions.SelectedBoss = "Ascendent Council";
				UpgradeListDBVar.char.SavedOptions.SelectedInstance = "Bastion of Twilight";
				UpgradeListDBVar.char.SavedOptions.SelectedDifficulty = "Normal";
				CloseDropDownMenus(1);
			end
			UIDropDownMenu_AddButton(info, level)
			
			info.text = "Cho'gall"
			info.notCheckable = true
			function info.func()
				UIDropDownMenu_SetText(DropDown_Button, "Cho'gall");
				UpgradeListDBVar.char.SavedOptions.SelectedBoss = "Cho'gall";
				UpgradeListDBVar.char.SavedOptions.SelectedInstance = "Bastion of Twilight";
				UpgradeListDBVar.char.SavedOptions.SelectedDifficulty = "Normal";
				CloseDropDownMenus(1);
			end
			UIDropDownMenu_AddButton(info, level)
			
			info.text = "(Trash Drop)"
			info.notCheckable = true
			function info.func()
				UIDropDownMenu_SetText(DropDown_Button, "(Trash Drop)");
				UpgradeListDBVar.char.SavedOptions.SelectedBoss = "(Trash Drop)";
				UpgradeListDBVar.char.SavedOptions.SelectedInstance = "Bastion of Twilight";
				UpgradeListDBVar.char.SavedOptions.SelectedDifficulty = "Normal";
				CloseDropDownMenus(1);
			end
			UIDropDownMenu_AddButton(info, level)
		
		--Heroic Bastion of Twilight Bosses
		elseif (level == 4) and (UIDROPDOWNMENU_MENU_VALUE == "Bastion of Twilight Heroic") then
			local info = UIDropDownMenu_CreateInfo()
			
			info.text = "Halfus Wyrmbreaker"
			info.notCheckable = true
			function info.func()
				UIDropDownMenu_SetText(DropDown_Button, "Halfus Wyrmbreaker");
				UpgradeListDBVar.char.SavedOptions.SelectedBoss = "Hyalfus Wyrmbreaker";
				UpgradeListDBVar.char.SavedOptions.SelectedInstance = "Bastion of Twilight";
				UpgradeListDBVar.char.SavedOptions.SelectedDifficulty = "Heroic";
				CloseDropDownMenus(1);
			end
			UIDropDownMenu_AddButton(info, level)
			
			info.text = "Valiona & Theralion"
			info.notCheckable = true
			function info.func()
				UIDropDownMenu_SetText(DropDown_Button, "Valiona & Theralion");
				UpgradeListDBVar.char.SavedOptions.SelectedBoss = "Valiona & Theralion";
				UpgradeListDBVar.char.SavedOptions.SelectedInstance = "Bastion of Twilight";
				UpgradeListDBVar.char.SavedOptions.SelectedDifficulty = "Heroic";
				CloseDropDownMenus(1);
			end
			UIDropDownMenu_AddButton(info, level)
			
			info.text = "Ascendent Council"
			info.notCheckable = true
			function info.func()
				UIDropDownMenu_SetText(DropDown_Button, "Ascendent Council");
				UpgradeListDBVar.char.SavedOptions.SelectedBoss = "Ascendent Council";
				UpgradeListDBVar.char.SavedOptions.SelectedInstance = "Bastion of Twilight";
				UpgradeListDBVar.char.SavedOptions.SelectedDifficulty = "Heroic";
				CloseDropDownMenus(1);
			end
			UIDropDownMenu_AddButton(info, level)
			
			info.text = "Cho'gall"
			info.notCheckable = true
			function info.func()
				UIDropDownMenu_SetText(DropDown_Button, "Cho'gall");
				UpgradeListDBVar.char.SavedOptions.SelectedBoss = "Cho'gall";
				UpgradeListDBVar.char.SavedOptions.SelectedInstance = "Bastion of Twilight";
				UpgradeListDBVar.char.SavedOptions.SelectedDifficulty = "Heroic";
				CloseDropDownMenus(1);
			end
			UIDropDownMenu_AddButton(info, level)
			
			info.text = "Sinestra"
			info.notCheckable = true
			function info.func()
				UIDropDownMenu_SetText(DropDown_Button, "Sinestra");
				UpgradeListDBVar.char.SavedOptions.SelectedBoss = "Sinestra";
				UpgradeListDBVar.char.SavedOptions.SelectedInstance = "Bastion of Twilight";
				UpgradeListDBVar.char.SavedOptions.SelectedDifficulty = "Heroic";
				CloseDropDownMenus(1);
			end
			UIDropDownMenu_AddButton(info, level)
			
			info.text = "(Trash Drop)"
			info.notCheckable = true
			function info.func()
				UIDropDownMenu_SetText(DropDown_Button, "(Trash Drop)");
				UpgradeListDBVar.char.SavedOptions.SelectedBoss = "(Trash Drop)";
				UpgradeListDBVar.char.SavedOptions.SelectedInstance = "Bastion of Twilight";
				UpgradeListDBVar.char.SavedOptions.SelectedDifficulty = "Heroic";
				CloseDropDownMenus(1);
			end
			UIDropDownMenu_AddButton(info, level)
			
		--Normal Blackwing Descent Bosses
		elseif (level == 4) and (UIDROPDOWNMENU_MENU_VALUE == "Blackwing Descent Normal") then
			local info = UIDropDownMenu_CreateInfo()
			
			info.text = "Omnotron Defense System"
			info.notCheckable = true
			function info.func()
				UIDropDownMenu_SetText(DropDown_Button, "Omnotron Defense System");
				UpgradeListDBVar.char.SavedOptions.SelectedBoss = "Omnotron Defense System";
				UpgradeListDBVar.char.SavedOptions.SelectedInstance = "Blackwing Descent";
				UpgradeListDBVar.char.SavedOptions.SelectedDifficulty = "Normal";
				CloseDropDownMenus(1);
			end
			UIDropDownMenu_AddButton(info, level)
			
			info.text = "Magmaw"
			info.notCheckable = true
			function info.func()
				UIDropDownMenu_SetText(DropDown_Button, "Magmaw");
				UpgradeListDBVar.char.SavedOptions.SelectedBoss = "Magmaw";
				UpgradeListDBVar.char.SavedOptions.SelectedInstance = "Blackwing Descent";
				UpgradeListDBVar.char.SavedOptions.SelectedDifficulty = "Normal";
				CloseDropDownMenus(1);
			end
			UIDropDownMenu_AddButton(info, level)
			
			info.text = "Maloriak"
			info.notCheckable = true
			function info.func()
				UIDropDownMenu_SetText(DropDown_Button, "Maloriak");
				UpgradeListDBVar.char.SavedOptions.SelectedBoss = "Maloriak";
				UpgradeListDBVar.char.SavedOptions.SelectedInstance = "Blackwing Descent";
				UpgradeListDBVar.char.SavedOptions.SelectedDifficulty = "Normal";
				CloseDropDownMenus(1);
			end
			UIDropDownMenu_AddButton(info, level)
			
			info.text = "Atramedes"
			info.notCheckable = true
			function info.func()
				UIDropDownMenu_SetText(DropDown_Button, "Atramedes");
				UpgradeListDBVar.char.SavedOptions.SelectedBoss = "Atramedes";
				UpgradeListDBVar.char.SavedOptions.SelectedInstance = "Blackwing Descent";
				UpgradeListDBVar.char.SavedOptions.SelectedDifficulty = "Normal";
				CloseDropDownMenus(1);
			end
			UIDropDownMenu_AddButton(info, level)
			
			info.text = "Chimaeron"
			info.notCheckable = true
			function info.func()
				UIDropDownMenu_SetText(DropDown_Button, "Chimaeron");
				UpgradeListDBVar.char.SavedOptions.SelectedBoss = "Chimaeron";
				UpgradeListDBVar.char.SavedOptions.SelectedInstance = "Blackwing Descent";
				UpgradeListDBVar.char.SavedOptions.SelectedDifficulty = "Normal";
				CloseDropDownMenus(1);
			end
			UIDropDownMenu_AddButton(info, level)
			
			info.text = "Nefarian"
			info.notCheckable = true
			function info.func()
				UIDropDownMenu_SetText(DropDown_Button, "Nefarian");
				UpgradeListDBVar.char.SavedOptions.SelectedBoss = "Nefarian";
				UpgradeListDBVar.char.SavedOptions.SelectedInstance = "Blackwing Descent";
				UpgradeListDBVar.char.SavedOptions.SelectedDifficulty = "Normal";
				CloseDropDownMenus(1);
			end
			UIDropDownMenu_AddButton(info, level)
			
			info.text = "(Trash Drop)"
			info.notCheckable = true
			function info.func()
				UIDropDownMenu_SetText(DropDown_Button, "(Trash Drop)");
				UpgradeListDBVar.char.SavedOptions.SelectedBoss = "(Trash Drop)";
				UpgradeListDBVar.char.SavedOptions.SelectedInstance = "Blackwing Descent";
				UpgradeListDBVar.char.SavedOptions.SelectedDifficulty = "Normal";
				CloseDropDownMenus(1);
			end
			UIDropDownMenu_AddButton(info, level)
			
			--Heroic Blackwing Descent Bosses
		elseif (level == 4) and (UIDROPDOWNMENU_MENU_VALUE == "Blackwing Descent Heroic") then
			local info = UIDropDownMenu_CreateInfo()
			
			info.text = "Omnotron Defense System"
			info.notCheckable = true
			function info.func()
				UIDropDownMenu_SetText(DropDown_Button, "Omnotron Defense System");
				UpgradeListDBVar.char.SavedOptions.SelectedBoss = "Omnotron Defense System";
				UpgradeListDBVar.char.SavedOptions.SelectedInstance = "Blackwing Descent";
				UpgradeListDBVar.char.SavedOptions.SelectedDifficulty = "Heroic";
				CloseDropDownMenus(1);
			end
			UIDropDownMenu_AddButton(info, level)
			
			info.text = "Magmaw"
			info.notCheckable = true
			function info.func()
				UIDropDownMenu_SetText(DropDown_Button, "Magmaw");
				UpgradeListDBVar.char.SavedOptions.SelectedBoss = "Magmaw";
				UpgradeListDBVar.char.SavedOptions.SelectedInstance = "Blackwing Descent";
				UpgradeListDBVar.char.SavedOptions.SelectedDifficulty = "Heroic";
				CloseDropDownMenus(1);
			end
			UIDropDownMenu_AddButton(info, level)
			
			info.text = "Maloriak"
			info.notCheckable = true
			function info.func()
				UIDropDownMenu_SetText(DropDown_Button, "Maloriak");
				UpgradeListDBVar.char.SavedOptions.SelectedBoss = "Maloriak";
				UpgradeListDBVar.char.SavedOptions.SelectedInstance = "Blackwing Descent";
				UpgradeListDBVar.char.SavedOptions.SelectedDifficulty = "Heroic";
				CloseDropDownMenus(1);
			end
			UIDropDownMenu_AddButton(info, level)
			
			info.text = "Atramedes"
			info.notCheckable = true
			function info.func()
				UIDropDownMenu_SetText(DropDown_Button, "Atramedes");
				UpgradeListDBVar.char.SavedOptions.SelectedBoss = "Atramedes";
				UpgradeListDBVar.char.SavedOptions.SelectedInstance = "Blackwing Descent";
				UpgradeListDBVar.char.SavedOptions.SelectedDifficulty = "Heroic";
				CloseDropDownMenus(1);
			end
			UIDropDownMenu_AddButton(info, level)
			
			info.text = "Chimaeron"
			info.notCheckable = true
			function info.func()
				UIDropDownMenu_SetText(DropDown_Button, "Chimaeron");
				UpgradeListDBVar.char.SavedOptions.SelectedBoss = "Chimaeron";
				UpgradeListDBVar.char.SavedOptions.SelectedInstance = "Blackwing Descent";
				UpgradeListDBVar.char.SavedOptions.SelectedDifficulty = "Heroic";
				CloseDropDownMenus(1);
			end
			UIDropDownMenu_AddButton(info, level)
			
			info.text = "Nefarian"
			info.notCheckable = true
			function info.func()
				UIDropDownMenu_SetText(DropDown_Button, "Nefarian");
				UpgradeListDBVar.char.SavedOptions.SelectedBoss = "Nefarian";
				UpgradeListDBVar.char.SavedOptions.SelectedInstance = "Blackwing Descent";
				UpgradeListDBVar.char.SavedOptions.SelectedDifficulty = "Heroic";
				CloseDropDownMenus(1);
			end
			UIDropDownMenu_AddButton(info, level)
			
			info.text = "(Trash Drop)"
			info.notCheckable = true
			function info.func()
				UIDropDownMenu_SetText(DropDown_Button, "(Trash Drop)");
				UpgradeListDBVar.char.SavedOptions.SelectedBoss = "(Trash Drop)";
				UpgradeListDBVar.char.SavedOptions.SelectedInstance = "Blackwing Descent";
				UpgradeListDBVar.char.SavedOptions.SelectedDifficulty = "Heroic";
				CloseDropDownMenus(1);
			end
			UIDropDownMenu_AddButton(info, level)
		
		--Normal Throne of the Four Winds Bosses
		elseif (level == 4) and (UIDROPDOWNMENU_MENU_VALUE == "Throne of the Four Winds Normal") then
			local info = UIDropDownMenu_CreateInfo()
			
			info.text = "Conclave of Wind"
			info.notCheckable = true
			function info.func()
				UIDropDownMenu_SetText(DropDown_Button, "Conclave of Wind");
				UpgradeListDBVar.char.SavedOptions.SelectedBoss = "Conclave of Wind";
				UpgradeListDBVar.char.SavedOptions.SelectedInstance = "Throne of the Four Winds";
				UpgradeListDBVar.char.SavedOptions.SelectedDifficulty = "Normal";
				CloseDropDownMenus(1);
			end
			UIDropDownMenu_AddButton(info, level)
			
			info.text = "Al'Akir"
			info.notCheckable = true
			function info.func()
				UIDropDownMenu_SetText(DropDown_Button, "Al'Akir");
				UpgradeListDBVar.char.SavedOptions.SelectedBoss = "Al'Akir";
				UpgradeListDBVar.char.SavedOptions.SelectedInstance = "Throne of the Four Winds";
				UpgradeListDBVar.char.SavedOptions.SelectedDifficulty = "Normal";
				CloseDropDownMenus(1);
			end
			UIDropDownMenu_AddButton(info, level)
			
		--Heroic Throne of the Four Winds Bosses
		elseif (level == 4) and (UIDROPDOWNMENU_MENU_VALUE == "Throne of the Four Winds Heroic") then
			local info = UIDropDownMenu_CreateInfo()
			
			info.text = "Conclave of Wind"
			info.notCheckable = true
			function info.func()
				UIDropDownMenu_SetText(DropDown_Button, "Conclave of Wind");
				UpgradeListDBVar.char.SavedOptions.SelectedBoss = "Conclave of Wind";
				UpgradeListDBVar.char.SavedOptions.SelectedInstance = "Throne of the Four Winds";
				UpgradeListDBVar.char.SavedOptions.SelectedDifficulty = "Heroic";
				CloseDropDownMenus(1);
			end
			UIDropDownMenu_AddButton(info, level)
			
			info.text = "Al'Akir"
			info.notCheckable = true
			function info.func()
				UIDropDownMenu_SetText(DropDown_Button, "Al'Akir");
				UpgradeListDBVar.char.SavedOptions.SelectedBoss = "Al'Akir";
				UpgradeListDBVar.char.SavedOptions.SelectedInstance = "Throne of the Four Winds";
				UpgradeListDBVar.char.SavedOptions.SelectedDifficulty = "Heroic";
				CloseDropDownMenus(1);
			end
			UIDropDownMenu_AddButton(info, level)
			
		--Heroic Throne of Tides Bosses
		elseif (level == 4) and (UIDROPDOWNMENU_MENU_VALUE == "Throne of the Tides Heroic") then
			local info = UIDropDownMenu_CreateInfo()
			
			info.text = "Lady Naz'jar"
			info.notCheckable = true
			function info.func()
				UIDropDownMenu_SetText(DropDown_Button, "Lady Naz'jar");
				UpgradeListDBVar.char.SavedOptions.SelectedBoss = "Lady Naz'jar";
				UpgradeListDBVar.char.SavedOptions.SelectedInstance = "Throne of the Tides";
				UpgradeListDBVar.char.SavedOptions.SelectedDifficulty = "Heroic";
				CloseDropDownMenus(1);
			end
			UIDropDownMenu_AddButton(info, level)
			
			info.text = "Commander Ulthok"
			info.notCheckable = true
			function info.func()
				UIDropDownMenu_SetText(DropDown_Button, "Commander Ulthok");
				UpgradeListDBVar.char.SavedOptions.SelectedBoss = "Commander Ulthok";
				UpgradeListDBVar.char.SavedOptions.SelectedInstance = "Throne of the Tides";
				UpgradeListDBVar.char.SavedOptions.SelectedDifficulty = "Heroic";
				CloseDropDownMenus(1);
			end
			UIDropDownMenu_AddButton(info, level)
			
			info.text = "Mindbender Ghur'sha"
			info.notCheckable = true
			function info.func()
				UIDropDownMenu_SetText(DropDown_Button, "Mindbender Ghur'sha");
				UpgradeListDBVar.char.SavedOptions.SelectedBoss = "Mindbender Ghur'sha";
				UpgradeListDBVar.char.SavedOptions.SelectedInstance = "Throne of the Tides";
				UpgradeListDBVar.char.SavedOptions.SelectedDifficulty = "Heroic";
				CloseDropDownMenus(1);
			end
			UIDropDownMenu_AddButton(info, level)
			
			info.text = "Ozumat"
			info.notCheckable = true
			function info.func()
				UIDropDownMenu_SetText(DropDown_Button, "Ozumat");
				UpgradeListDBVar.char.SavedOptions.SelectedBoss = "Ozumat";
				UpgradeListDBVar.char.SavedOptions.SelectedInstance = "Throne of the Tides";
				UpgradeListDBVar.char.SavedOptions.SelectedDifficulty = "Heroic";
				CloseDropDownMenus(1);
			end
			UIDropDownMenu_AddButton(info, level)
			
			info.text = "(Trash Drop)"
			info.notCheckable = true
			function info.func()
				UIDropDownMenu_SetText(DropDown_Button, "(Trash Drop)");
				UpgradeListDBVar.char.SavedOptions.SelectedBoss = "(Trash Drop)";
				UpgradeListDBVar.char.SavedOptions.SelectedInstance = "Throne of the Tides";
				UpgradeListDBVar.char.SavedOptions.SelectedDifficulty = "Heroic";
				CloseDropDownMenus(1);
			end
			UIDropDownMenu_AddButton(info, level)
			
		--Heroic Blackrock Caverns Bosses
		elseif (level == 4) and (UIDROPDOWNMENU_MENU_VALUE == "Blackrock Caverns Heroic") then
			local info = UIDropDownMenu_CreateInfo()
			
			info.text = "Rom'ogg Bonecrusher"
			info.notCheckable = true
			function info.func()
				UIDropDownMenu_SetText(DropDown_Button, "Rom'ogg Bonecrusher");
				UpgradeListDBVar.char.SavedOptions.SelectedBoss = "Rom'ogg Bonecrusher";
				UpgradeListDBVar.char.SavedOptions.SelectedInstance = "Blackrock Caverns";
				UpgradeListDBVar.char.SavedOptions.SelectedDifficulty = "Heroic";
				CloseDropDownMenus(1);
			end
			UIDropDownMenu_AddButton(info, level)
			
			info.text = "Corla, Herald of Twilight"
			info.notCheckable = true
			function info.func()
				UIDropDownMenu_SetText(DropDown_Button, "Corla, Herald of Twilight");
				UpgradeListDBVar.char.SavedOptions.SelectedBoss = "Corla, Herald of Twilight";
				UpgradeListDBVar.char.SavedOptions.SelectedInstance = "Blackrock Caverns";
				UpgradeListDBVar.char.SavedOptions.SelectedDifficulty = "Heroic";
				CloseDropDownMenus(1);
			end
			UIDropDownMenu_AddButton(info, level)
			
			info.text = "Karsh Steelbender"
			info.notCheckable = true
			function info.func()
				UIDropDownMenu_SetText(DropDown_Button, "Karsh Steelbender");
				UpgradeListDBVar.char.SavedOptions.SelectedBoss = "Karsh Steelbender";
				UpgradeListDBVar.char.SavedOptions.SelectedInstance = "Blackrock Caverns";
				UpgradeListDBVar.char.SavedOptions.SelectedDifficulty = "Heroic";
				CloseDropDownMenus(1);
			end
			UIDropDownMenu_AddButton(info, level)
			
			info.text = "Beauty"
			info.notCheckable = true
			function info.func()
				UIDropDownMenu_SetText(DropDown_Button, "Beauty");
				UpgradeListDBVar.char.SavedOptions.SelectedBoss = "Beauty";
				UpgradeListDBVar.char.SavedOptions.SelectedInstance = "Blackrock Caverns";
				UpgradeListDBVar.char.SavedOptions.SelectedDifficulty = "Heroic";
				CloseDropDownMenus(1);
			end
			UIDropDownMenu_AddButton(info, level)
			
			info.text = "Ascendant Lord Obsidius"
			info.notCheckable = true
			function info.func()
				UIDropDownMenu_SetText(DropDown_Button, "Ascendant Lord Obsidius");
				UpgradeListDBVar.char.SavedOptions.SelectedBoss = "Ascendant Lord Obsidius";
				UpgradeListDBVar.char.SavedOptions.SelectedInstance = "Blackrock Caverns";
				UpgradeListDBVar.char.SavedOptions.SelectedDifficulty = "Heroic";
				CloseDropDownMenus(1);
			end
			UIDropDownMenu_AddButton(info, level)
			
			info.text = "(Trash Drop)"
			info.notCheckable = true
			function info.func()
				UIDropDownMenu_SetText(DropDown_Button, "(Trash Drop)");
				UpgradeListDBVar.char.SavedOptions.SelectedBoss = "(Trash Drop)";
				UpgradeListDBVar.char.SavedOptions.SelectedInstance = "Blackrock Caverns";
				UpgradeListDBVar.char.SavedOptions.SelectedDifficulty = "Heroic";
				CloseDropDownMenus(1);
			end
			UIDropDownMenu_AddButton(info, level)
			
		--Heroic Stonecore Bosses
		elseif (level == 4) and (UIDROPDOWNMENU_MENU_VALUE == "The Stonecore Heroic") then
			local info = UIDropDownMenu_CreateInfo()
			
			info.text = "Corborus"
			info.notCheckable = true
			function info.func()
				UIDropDownMenu_SetText(DropDown_Button, "Corborus");
				UpgradeListDBVar.char.SavedOptions.SelectedBoss = "Corborus";
				UpgradeListDBVar.char.SavedOptions.SelectedInstance = "The Stonecore";
				UpgradeListDBVar.char.SavedOptions.SelectedDifficulty = "Heroic";
				CloseDropDownMenus(1);
			end
			UIDropDownMenu_AddButton(info, level)
			
			info.text = "Slabhide"
			info.notCheckable = true
			function info.func()
				UIDropDownMenu_SetText(DropDown_Button, "Slabhide");
				UpgradeListDBVar.char.SavedOptions.SelectedBoss = "Slabhide";
				UpgradeListDBVar.char.SavedOptions.SelectedInstance = "The Stonecore";
				UpgradeListDBVar.char.SavedOptions.SelectedDifficulty = "Heroic";
				CloseDropDownMenus(1);
			end
			UIDropDownMenu_AddButton(info, level)
			
			info.text = "Ozruk"
			info.notCheckable = true
			function info.func()
				UIDropDownMenu_SetText(DropDown_Button, "Ozruk");
				UpgradeListDBVar.char.SavedOptions.SelectedBoss = "Ozruk";
				UpgradeListDBVar.char.SavedOptions.SelectedInstance = "The Stonecore";
				UpgradeListDBVar.char.SavedOptions.SelectedDifficulty = "Heroic";
				CloseDropDownMenus(1);
			end
			UIDropDownMenu_AddButton(info, level)
			
			info.text = "High Priestess Azil"
			info.notCheckable = true
			function info.func()
				UIDropDownMenu_SetText(DropDown_Button, "High Priestess Azil");
				UpgradeListDBVar.char.SavedOptions.SelectedBoss = "High Priestess Azil";
				UpgradeListDBVar.char.SavedOptions.SelectedInstance = "The Stonecore";
				UpgradeListDBVar.char.SavedOptions.SelectedDifficulty = "Heroic";
				CloseDropDownMenus(1);
			end
			UIDropDownMenu_AddButton(info, level)
			
			info.text = "(Trash Drop)"
			info.notCheckable = true
			function info.func()
				UIDropDownMenu_SetText(DropDown_Button, "(Trash Drop)");
				UpgradeListDBVar.char.SavedOptions.SelectedBoss = "(Trash Drop)";
				UpgradeListDBVar.char.SavedOptions.SelectedInstance = "The Stonecore";
				UpgradeListDBVar.char.SavedOptions.SelectedDifficulty = "Heroic";
				CloseDropDownMenus(1);
			end
			UIDropDownMenu_AddButton(info, level)

		--Heroic Vortex Pinnacle Bosses
		elseif (level == 4) and (UIDROPDOWNMENU_MENU_VALUE == "The Vortex Pinnacle Heroic") then
			local info = UIDropDownMenu_CreateInfo()
			
			info.text = "Grand Vizier Ertan"
			info.notCheckable = true
			function info.func()
				UIDropDownMenu_SetText(DropDown_Button, "Grand Vizier Ertan");
				UpgradeListDBVar.char.SavedOptions.SelectedBoss = "Grand Vizier Ertan";
				UpgradeListDBVar.char.SavedOptions.SelectedInstance = "The Vortex Pinnacle";
				UpgradeListDBVar.char.SavedOptions.SelectedDifficulty = "Heroic";
				CloseDropDownMenus(1);
			end
			UIDropDownMenu_AddButton(info, level)
			
			info.text = "Altairus"
			info.notCheckable = true
			function info.func()
				UIDropDownMenu_SetText(DropDown_Button, "Altairus");
				UpgradeListDBVar.char.SavedOptions.SelectedBoss = "Altairus";
				UpgradeListDBVar.char.SavedOptions.SelectedInstance = "The Vortex Pinnacle";
				UpgradeListDBVar.char.SavedOptions.SelectedDifficulty = "Heroic";
				CloseDropDownMenus(1);
			end
			UIDropDownMenu_AddButton(info, level)
			
			info.text = "Asaad"
			info.notCheckable = true
			function info.func()
				UIDropDownMenu_SetText(DropDown_Button, "Asaad");
				UpgradeListDBVar.char.SavedOptions.SelectedBoss = "Asaad";
				UpgradeListDBVar.char.SavedOptions.SelectedInstance = "The Vortex Pinnacle";
				UpgradeListDBVar.char.SavedOptions.SelectedDifficulty = "Heroic";
				CloseDropDownMenus(1);
			end
			UIDropDownMenu_AddButton(info, level)
			
			info.text = "(Trash Drop)"
			info.notCheckable = true
			function info.func()
				UIDropDownMenu_SetText(DropDown_Button, "(Trash Drop)");
				UpgradeListDBVar.char.SavedOptions.SelectedBoss = "(Trash Drop)";
				UpgradeListDBVar.char.SavedOptions.SelectedInstance = "The Vortex Pinnacle";
				UpgradeListDBVar.char.SavedOptions.SelectedDifficulty = "Heroic";
				CloseDropDownMenus(1);
			end
			UIDropDownMenu_AddButton(info, level)

		--Heroic Lost City of Tol'vir Bosses
		elseif (level == 4) and (UIDROPDOWNMENU_MENU_VALUE == "Lost City of Tol'vir Heroic") then
			local info = UIDropDownMenu_CreateInfo()
			
			info.text = "General Husam"
			info.notCheckable = true
			function info.func()
				UIDropDownMenu_SetText(DropDown_Button, "General Husam");
				UpgradeListDBVar.char.SavedOptions.SelectedBoss = "General Husam";
				UpgradeListDBVar.char.SavedOptions.SelectedInstance = "Lost City of Tol'vir";
				UpgradeListDBVar.char.SavedOptions.SelectedDifficulty = "Heroic";
				CloseDropDownMenus(1);
			end
			UIDropDownMenu_AddButton(info, level)
			
			info.text = "Augh and Lockmaw"
			info.notCheckable = true
			function info.func()
				UIDropDownMenu_SetText(DropDown_Button, "Augh and Lockmaw");
				UpgradeListDBVar.char.SavedOptions.SelectedBoss = "Augh and Lockmaw";
				UpgradeListDBVar.char.SavedOptions.SelectedInstance = "Lost City of Tol'vir";
				UpgradeListDBVar.char.SavedOptions.SelectedDifficulty = "Heroic";
				CloseDropDownMenus(1);
			end
			UIDropDownMenu_AddButton(info, level)
			
			info.text = "High Prophet Barim"
			info.notCheckable = true
			function info.func()
				UIDropDownMenu_SetText(DropDown_Button, "High Prophet Barim");
				UpgradeListDBVar.char.SavedOptions.SelectedBoss = "High Prophet Barim";
				UpgradeListDBVar.char.SavedOptions.SelectedInstance = "Lost City of Tol'vir";
				UpgradeListDBVar.char.SavedOptions.SelectedDifficulty = "Heroic";
				CloseDropDownMenus(1);
			end
			UIDropDownMenu_AddButton(info, level)
			
			info.text = "Siamat"
			info.notCheckable = true
			function info.func()
				UIDropDownMenu_SetText(DropDown_Button, "Siamat");
				UpgradeListDBVar.char.SavedOptions.SelectedBoss = "Siamat";
				UpgradeListDBVar.char.SavedOptions.SelectedInstance = "Lost City of Tol'vir";
				UpgradeListDBVar.char.SavedOptions.SelectedDifficulty = "Heroic";
				CloseDropDownMenus(1);
			end
			UIDropDownMenu_AddButton(info, level)
			
			info.text = "(Trash Drop)"
			info.notCheckable = true
			function info.func()
				UIDropDownMenu_SetText(DropDown_Button, "(Trash Drop)");
				UpgradeListDBVar.char.SavedOptions.SelectedBoss = "(Trash Drop)";
				UpgradeListDBVar.char.SavedOptions.SelectedInstance = "Lost City of Tol'vir";
				UpgradeListDBVar.char.SavedOptions.SelectedDifficulty = "Heroic";
				CloseDropDownMenus(1);
			end
			UIDropDownMenu_AddButton(info, level)
			
		--Heroic Grim Batol Bosses
		elseif (level == 4) and (UIDROPDOWNMENU_MENU_VALUE == "Grim Batol Heroic") then
			local info = UIDropDownMenu_CreateInfo()
			
			info.text = "General Umbriss"
			info.notCheckable = true
			function info.func()
				UIDropDownMenu_SetText(DropDown_Button, "General Umbriss");
				UpgradeListDBVar.char.SavedOptions.SelectedBoss = "General Umbriss";
				UpgradeListDBVar.char.SavedOptions.SelectedInstance = "Grim Batol";
				UpgradeListDBVar.char.SavedOptions.SelectedDifficulty = "Heroic";
				CloseDropDownMenus(1);
			end
			UIDropDownMenu_AddButton(info, level)
			
			info.text = "Forgemaster Throngus"
			info.notCheckable = true
			function info.func()
				UIDropDownMenu_SetText(DropDown_Button, "Forgemaster Throngus");
				UpgradeListDBVar.char.SavedOptions.SelectedBoss = "Forgemaster Throngus";
				UpgradeListDBVar.char.SavedOptions.SelectedInstance = "Grim Batol";
				UpgradeListDBVar.char.SavedOptions.SelectedDifficulty = "Heroic";
				CloseDropDownMenus(1);
			end
			UIDropDownMenu_AddButton(info, level)
			
			info.text = "Drahga Shadowburner"
			info.notCheckable = true
			function info.func()
				UIDropDownMenu_SetText(DropDown_Button, "Drahga Shadowburner");
				UpgradeListDBVar.char.SavedOptions.SelectedBoss = "Drahga Shadowburner";
				UpgradeListDBVar.char.SavedOptions.SelectedInstance = "Grim Batol";
				UpgradeListDBVar.char.SavedOptions.SelectedDifficulty = "Heroic";
				CloseDropDownMenus(1);
			end
			UIDropDownMenu_AddButton(info, level)
			
			info.text = "Erudax"
			info.notCheckable = true
			function info.func()
				UIDropDownMenu_SetText(DropDown_Button, "Erudax");
				UpgradeListDBVar.char.SavedOptions.SelectedBoss = "Erudax";
				UpgradeListDBVar.char.SavedOptions.SelectedInstance = "Grim Batol";
				UpgradeListDBVar.char.SavedOptions.SelectedDifficulty = "Heroic";
				CloseDropDownMenus(1);
			end
			UIDropDownMenu_AddButton(info, level)
			
			info.text = "(Trash Drop)"
			info.notCheckable = true
			function info.func()
				UIDropDownMenu_SetText(DropDown_Button, "(Trash Drop)");
				UpgradeListDBVar.char.SavedOptions.SelectedBoss = "(Trash Drop)";
				UpgradeListDBVar.char.SavedOptions.SelectedInstance = "Grim Batol";
				UpgradeListDBVar.char.SavedOptions.SelectedDifficulty = "Heroic";
				CloseDropDownMenus(1);
			end
			UIDropDownMenu_AddButton(info, level)
			
		--Heroic Halls of Origination Bosses
		elseif (level == 4) and (UIDROPDOWNMENU_MENU_VALUE == "Halls of Origination Heroic") then
			local info = UIDropDownMenu_CreateInfo()
			
			info.text = "Temple Guardian Anhuur"
			info.notCheckable = true
			function info.func()
				UIDropDownMenu_SetText(DropDown_Button, "Temple Guardian Anhuur");
				UpgradeListDBVar.char.SavedOptions.SelectedBoss = "Themple Guardian Anhuur";
				UpgradeListDBVar.char.SavedOptions.SelectedInstance = "Halls of Origination";
				UpgradeListDBVar.char.SavedOptions.SelectedDifficulty = "Heroic";
				CloseDropDownMenus(1);
			end
			UIDropDownMenu_AddButton(info, level)
			
			info.text = "Earthrager Ptah"
			info.notCheckable = true
			function info.func()
				UIDropDownMenu_SetText(DropDown_Button, "Earthrager Ptah");
				UpgradeListDBVar.char.SavedOptions.SelectedBoss = "Earthrager Ptah";
				UpgradeListDBVar.char.SavedOptions.SelectedInstance = "Halls of Origination";
				UpgradeListDBVar.char.SavedOptions.SelectedDifficulty = "Heroic";
				CloseDropDownMenus(1);
			end
			UIDropDownMenu_AddButton(info, level)
			
			info.text = "Anraphet"
			info.notCheckable = true
			function info.func()
				UIDropDownMenu_SetText(DropDown_Button, "Anraphet");
				UpgradeListDBVar.char.SavedOptions.SelectedBoss = "Anraphet";
				UpgradeListDBVar.char.SavedOptions.SelectedInstance = "Halls of Origination";
				UpgradeListDBVar.char.SavedOptions.SelectedDifficulty = "Heroic";
				CloseDropDownMenus(1);
			end
			UIDropDownMenu_AddButton(info, level)
			
			info.text = "Isiset"
			info.notCheckable = true
			function info.func()
				UIDropDownMenu_SetText(DropDown_Button, "Isiset");
				UpgradeListDBVar.char.SavedOptions.SelectedBoss = "Isiset";
				UpgradeListDBVar.char.SavedOptions.SelectedInstance = "Halls of Origination";
				UpgradeListDBVar.char.SavedOptions.SelectedDifficulty = "Heroic";
				CloseDropDownMenus(1);
			end
			UIDropDownMenu_AddButton(info, level)
			
			info.text = "Ammunae"
			info.notCheckable = true
			function info.func()
				UIDropDownMenu_SetText(DropDown_Button, "Ammunae");
				UpgradeListDBVar.char.SavedOptions.SelectedBoss = "Ammunae";
				UpgradeListDBVar.char.SavedOptions.SelectedInstance = "Halls of Origination";
				UpgradeListDBVar.char.SavedOptions.SelectedDifficulty = "Heroic";
				CloseDropDownMenus(1);
			end
			UIDropDownMenu_AddButton(info, level)
			
			info.text = "Setesh"
			info.notCheckable = true
			function info.func()
				UIDropDownMenu_SetText(DropDown_Button, "Setesh");
				UpgradeListDBVar.char.SavedOptions.SelectedBoss = "Setesh";
				UpgradeListDBVar.char.SavedOptions.SelectedInstance = "Halls of Origination";
				UpgradeListDBVar.char.SavedOptions.SelectedDifficulty = "Heroic";
				CloseDropDownMenus(1);
			end
			UIDropDownMenu_AddButton(info, level)
			
			info.text = "Rajh"
			info.notCheckable = true
			function info.func()
				UIDropDownMenu_SetText(DropDown_Button, "Rajh");
				UpgradeListDBVar.char.SavedOptions.SelectedBoss = "Rajh";
				UpgradeListDBVar.char.SavedOptions.SelectedInstance = "Halls of Origination";
				UpgradeListDBVar.char.SavedOptions.SelectedDifficulty = "Heroic";
				CloseDropDownMenus(1);
			end
			UIDropDownMenu_AddButton(info, level)
			
			info.text = "(Trash Drop)"
			info.notCheckable = true
			function info.func()
				UIDropDownMenu_SetText(DropDown_Button, "(Trash Drop)");
				UpgradeListDBVar.char.SavedOptions.SelectedBoss = "(Trash Drop)";
				UpgradeListDBVar.char.SavedOptions.SelectedInstance = "Trash Drop";
				UpgradeListDBVar.char.SavedOptions.SelectedDifficulty = "Heroic";
				CloseDropDownMenus(1);
			end
			UIDropDownMenu_AddButton(info, level)
			
		--Heroic Deadmines Bosses
		elseif (level == 4) and (UIDROPDOWNMENU_MENU_VALUE == "The Deadmines Heroic") then
			local info = UIDropDownMenu_CreateInfo()
			
			info.text = "Glubtok"
			info.notCheckable = true
			function info.func()
				UIDropDownMenu_SetText(DropDown_Button, "Glubtok");
				UpgradeListDBVar.char.SavedOptions.SelectedBoss = "Glubtok";
				UpgradeListDBVar.char.SavedOptions.SelectedInstance = "The Deadmines";
				UpgradeListDBVar.char.SavedOptions.SelectedDifficulty = "Heroic";
				CloseDropDownMenus(1);
			end
			UIDropDownMenu_AddButton(info, level)
			
			info.text = "Helix Gearbreaker"
			info.notCheckable = true
			function info.func()
				UIDropDownMenu_SetText(DropDown_Button, "Helix Gearbreaker");
				UpgradeListDBVar.char.SavedOptions.SelectedBoss = "Helix Gearbreaker";
				UpgradeListDBVar.char.SavedOptions.SelectedInstance = "The Deadmines";
				UpgradeListDBVar.char.SavedOptions.SelectedDifficulty = "Heroic";
				CloseDropDownMenus(1);
			end
			UIDropDownMenu_AddButton(info, level)
			
			info.text = "Foe Reaper 5000"
			info.notCheckable = true
			function info.func()
				UIDropDownMenu_SetText(DropDown_Button, "Foe Reaper 5000");
				UpgradeListDBVar.char.SavedOptions.SelectedBoss = "Foe Reaper 5000";
				UpgradeListDBVar.char.SavedOptions.SelectedInstance = "The Deadmines";
				UpgradeListDBVar.char.SavedOptions.SelectedDifficulty = "Heroic";
				CloseDropDownMenus(1);
			end
			UIDropDownMenu_AddButton(info, level)
			
			info.text = "Admiral Ripsnarl"
			info.notCheckable = true
			function info.func()
				UIDropDownMenu_SetText(DropDown_Button, "Admiral Ripsnarl");
				UpgradeListDBVar.char.SavedOptions.SelectedBoss = "Admiral Ripsnarl";
				UpgradeListDBVar.char.SavedOptions.SelectedInstance = "The Deadmines";
				UpgradeListDBVar.char.SavedOptions.SelectedDifficulty = "Heroic";
				CloseDropDownMenus(1);
			end
			UIDropDownMenu_AddButton(info, level)
			
			info.text = "\"Captain\" Cookie"
			info.notCheckable = true
			function info.func()
				UIDropDownMenu_SetText(DropDown_Button, "\"Captain\" Cookie");
				UpgradeListDBVar.char.SavedOptions.SelectedBoss = "\"Captain\" Cookie";
				UpgradeListDBVar.char.SavedOptions.SelectedInstance = "The Deadmines";
				UpgradeListDBVar.char.SavedOptions.SelectedDifficulty = "Heroic";
				CloseDropDownMenus(1);
			end
			UIDropDownMenu_AddButton(info, level)
			
			info.text = "Vanessa VanCleef"
			info.notCheckable = true
			function info.func()
				UIDropDownMenu_SetText(DropDown_Button, "Vanessa VanCleef");
				UpgradeListDBVar.char.SavedOptions.SelectedBoss = "Vanessa VanCleef";
				UpgradeListDBVar.char.SavedOptions.SelectedInstance = "The Deadmines";
				UpgradeListDBVar.char.SavedOptions.SelectedDifficulty = "Heroic";
				CloseDropDownMenus(1);
			end
			UIDropDownMenu_AddButton(info, level)
			
			info.text = "(Trash Drop)"
			info.notCheckable = true
			function info.func()
				UIDropDownMenu_SetText(DropDown_Button, "(Trash Drop)");
				UpgradeListDBVar.char.SavedOptions.SelectedBoss = "(Trash Drop)";
				UpgradeListDBVar.char.SavedOptions.SelectedInstance = "The Deadmines";
				UpgradeListDBVar.char.SavedOptions.SelectedDifficulty = "Heroic";
				CloseDropDownMenus(1);
			end
			UIDropDownMenu_AddButton(info, level)
			
		--Heroic Shadowfang Keep Bosses
		elseif (level == 4) and (UIDROPDOWNMENU_MENU_VALUE == "Shadowfang Keep Heroic") then
			local info = UIDropDownMenu_CreateInfo()
			
			info.text = "Baron Ashbury"
			info.notCheckable = true
			function info.func()
				UIDropDownMenu_SetText(DropDown_Button, "Baron Ashbury");
				UpgradeListDBVar.char.SavedOptions.SelectedBoss = "Baron Ashbury";
				UpgradeListDBVar.char.SavedOptions.SelectedInstance = "Shadowfang Keep";
				UpgradeListDBVar.char.SavedOptions.SelectedDifficulty = "Heroic";
				CloseDropDownMenus(1);
			end
			UIDropDownMenu_AddButton(info, level)
			
			info.text = "Baron Silverlaine"
			info.notCheckable = true
			function info.func()
				UIDropDownMenu_SetText(DropDown_Button, "Baron Silverlaine");
				UpgradeListDBVar.char.SavedOptions.SelectedBoss = "Baron Silverlaine";
				UpgradeListDBVar.char.SavedOptions.SelectedInstance = "Shadowfang Keep";
				UpgradeListDBVar.char.SavedOptions.SelectedDifficulty = "Heroic";
				CloseDropDownMenus(1);
			end
			UIDropDownMenu_AddButton(info, level)
			
			info.text = "Commander Springvale"
			info.notCheckable = true
			function info.func()
				UIDropDownMenu_SetText(DropDown_Button, "Commander Springvale");
				UpgradeListDBVar.char.SavedOptions.SelectedBoss = "Commander Springvale";
				UpgradeListDBVar.char.SavedOptions.SelectedInstance = "Shadowfang Keep";
				UpgradeListDBVar.char.SavedOptions.SelectedDifficulty = "Heroic";
				CloseDropDownMenus(1);
			end
			UIDropDownMenu_AddButton(info, level)
			
			info.text = "Lord Walden"
			info.notCheckable = true
			function info.func()
				UIDropDownMenu_SetText(DropDown_Button, "Lord Walden");
				UpgradeListDBVar.char.SavedOptions.SelectedBoss = "Lord Walden";
				UpgradeListDBVar.char.SavedOptions.SelectedInstance = "Shadowfang Keep";
				UpgradeListDBVar.char.SavedOptions.SelectedDifficulty = "Heroic";
				CloseDropDownMenus(1);
			end
			UIDropDownMenu_AddButton(info, level)
			
			info.text = "Lord Godfrey"
			info.notCheckable = true
			function info.func()
				UIDropDownMenu_SetText(DropDown_Button, "Lord Godfrey");
				UpgradeListDBVar.char.SavedOptions.SelectedBoss = "Lord Godfrey";
				UpgradeListDBVar.char.SavedOptions.SelectedInstance = "Shadowfang Keep";
				UpgradeListDBVar.char.SavedOptions.SelectedDifficulty = "Heroic";
				CloseDropDownMenus(1);
			end
			UIDropDownMenu_AddButton(info, level)
			
			info.text = "(Trash Drop)"
			info.notCheckable = true
			function info.func()
				UIDropDownMenu_SetText(DropDown_Button, "(Trash Drop)");
				UpgradeListDBVar.char.SavedOptions.SelectedBoss = "(Trash Drop)";
				UpgradeListDBVar.char.SavedOptions.SelectedInstance = "Shadowfang Keep";
				UpgradeListDBVar.char.SavedOptions.SelectedDifficulty = "Heroic";
				CloseDropDownMenus(1);
			end
			UIDropDownMenu_AddButton(info, level)
			
		--Normal Throne of Tides Bosses
		elseif (level == 4) and (UIDROPDOWNMENU_MENU_VALUE == "Throne of the Tides Normal") then
			local info = UIDropDownMenu_CreateInfo()
			
			info.text = "Lady Naz'jar"
			info.notCheckable = true
			function info.func()
				UIDropDownMenu_SetText(DropDown_Button, "Lady Naz'jar");
				UpgradeListDBVar.char.SavedOptions.SelectedBoss = "Lady Naz'jar";
				UpgradeListDBVar.char.SavedOptions.SelectedInstance = "Throne of the Tides";
				UpgradeListDBVar.char.SavedOptions.SelectedDifficulty = "Normal";
				CloseDropDownMenus(1);
			end
			UIDropDownMenu_AddButton(info, level)
			
			info.text = "Commander Ulthok"
			info.notCheckable = true
			function info.func()
				UIDropDownMenu_SetText(DropDown_Button, "Commander Ulthok");
				UpgradeListDBVar.char.SavedOptions.SelectedBoss = "Commander Ulthok";
				UpgradeListDBVar.char.SavedOptions.SelectedInstance = "Throne of the Tides";
				UpgradeListDBVar.char.SavedOptions.SelectedDifficulty = "Normal";
				CloseDropDownMenus(1);
			end
			UIDropDownMenu_AddButton(info, level)
			
			info.text = "Mindbender Ghur'sha"
			info.notCheckable = true
			function info.func()
				UIDropDownMenu_SetText(DropDown_Button, "Mindbender Ghur'sha");
				UpgradeListDBVar.char.SavedOptions.SelectedBoss = "Mindbender Ghur'sha";
				UpgradeListDBVar.char.SavedOptions.SelectedInstance = "Throne of the Tides";
				UpgradeListDBVar.char.SavedOptions.SelectedDifficulty = "Normal";
				CloseDropDownMenus(1);
			end
			UIDropDownMenu_AddButton(info, level)
			
			info.text = "Ozumat"
			info.notCheckable = true
			function info.func()
				UIDropDownMenu_SetText(DropDown_Button, "Ozumat");
				UpgradeListDBVar.char.SavedOptions.SelectedBoss = "Ozumat";
				UpgradeListDBVar.char.SavedOptions.SelectedInstance = "Throne of the Tides";
				UpgradeListDBVar.char.SavedOptions.SelectedDifficulty = "Normal";
				CloseDropDownMenus(1);
			end
			UIDropDownMenu_AddButton(info, level)
			
			info.text = "(Trash Drop)"
			info.notCheckable = true
			function info.func()
				UIDropDownMenu_SetText(DropDown_Button, "(Trash Drop)");
				UpgradeListDBVar.char.SavedOptions.SelectedBoss = "(Trash Drop)";
				UpgradeListDBVar.char.SavedOptions.SelectedInstance = "Throne of the Tides";
				UpgradeListDBVar.char.SavedOptions.SelectedDifficulty = "Normal";
				CloseDropDownMenus(1);
			end
			UIDropDownMenu_AddButton(info, level)
			
		--Normal Blackrock Caverns Bosses
		elseif (level == 4) and (UIDROPDOWNMENU_MENU_VALUE == "Blackrock Caverns Normal") then
			local info = UIDropDownMenu_CreateInfo()
			
			info.text = "Rom'ogg Bonecrusher"
			info.notCheckable = true
			function info.func()
				UIDropDownMenu_SetText(DropDown_Button, "Rom'ogg Bonecrusher");
				UpgradeListDBVar.char.SavedOptions.SelectedBoss = "Rom'ogg Bonecrusher";
				UpgradeListDBVar.char.SavedOptions.SelectedInstance = "Blackrock Caverns";
				UpgradeListDBVar.char.SavedOptions.SelectedDifficulty = "Normal";
				CloseDropDownMenus(1);
			end
			UIDropDownMenu_AddButton(info, level)
			
			info.text = "Corla, Herald of Twilight"
			info.notCheckable = true
			function info.func()
				UIDropDownMenu_SetText(DropDown_Button, "Corla, Herald of Twilight");
				UpgradeListDBVar.char.SavedOptions.SelectedBoss = "Corla, Herald of Twilight";
				UpgradeListDBVar.char.SavedOptions.SelectedInstance = "Blackrock Caverns";
				UpgradeListDBVar.char.SavedOptions.SelectedDifficulty = "Normal";
				CloseDropDownMenus(1);
			end
			UIDropDownMenu_AddButton(info, level)
			
			info.text = "Karsh Steelbender"
			info.notCheckable = true
			function info.func()
				UIDropDownMenu_SetText(DropDown_Button, "Karsh Steelbender");
				UpgradeListDBVar.char.SavedOptions.SelectedBoss = "Karsh Steelbender";
				UpgradeListDBVar.char.SavedOptions.SelectedInstance = "Blackrock Caverns";
				UpgradeListDBVar.char.SavedOptions.SelectedDifficulty = "Normal";
				CloseDropDownMenus(1);
			end
			UIDropDownMenu_AddButton(info, level)
			
			info.text = "Beauty"
			info.notCheckable = true
			function info.func()
				UIDropDownMenu_SetText(DropDown_Button, "Beauty");
				UpgradeListDBVar.char.SavedOptions.SelectedBoss = "Beauty";
				UpgradeListDBVar.char.SavedOptions.SelectedInstance = "Blackrock Caverns";
				UpgradeListDBVar.char.SavedOptions.SelectedDifficulty = "Normal";
				CloseDropDownMenus(1);
			end
			UIDropDownMenu_AddButton(info, level)
			
			info.text = "Ascendant Lord Obsidius"
			info.notCheckable = true
			function info.func()
				UIDropDownMenu_SetText(DropDown_Button, "Ascendant Lord Obsidius");
				UpgradeListDBVar.char.SavedOptions.SelectedBoss = "Ascendant Lord Obsidius";
				UpgradeListDBVar.char.SavedOptions.SelectedInstance = "Blackrock Caverns";
				UpgradeListDBVar.char.SavedOptions.SelectedDifficulty = "Normal";
				CloseDropDownMenus(1);
			end
			UIDropDownMenu_AddButton(info, level)
			
			info.text = "(Trash Drop)"
			info.notCheckable = true
			function info.func()
				UIDropDownMenu_SetText(DropDown_Button, "(Trash Drop)");
				UpgradeListDBVar.char.SavedOptions.SelectedBoss = "(Trash Drop)";
				UpgradeListDBVar.char.SavedOptions.SelectedInstance = "Blackrock Caverns";
				UpgradeListDBVar.char.SavedOptions.SelectedDifficulty = "Normal";
				CloseDropDownMenus(1);
			end
			UIDropDownMenu_AddButton(info, level)
			
		--Normal Stonecore Bosses
		elseif (level == 4) and (UIDROPDOWNMENU_MENU_VALUE == "The Stonecore Normal") then
			local info = UIDropDownMenu_CreateInfo()
			
			info.text = "Corborus"
			info.notCheckable = true
			function info.func()
				UIDropDownMenu_SetText(DropDown_Button, "Corborus");
				UpgradeListDBVar.char.SavedOptions.SelectedBoss = "Corborus";
				UpgradeListDBVar.char.SavedOptions.SelectedInstance = "The Stonecore";
				UpgradeListDBVar.char.SavedOptions.SelectedDifficulty = "Normal";
				CloseDropDownMenus(1);
			end
			UIDropDownMenu_AddButton(info, level)
			
			info.text = "Slabhide"
			info.notCheckable = true
			function info.func()
				UIDropDownMenu_SetText(DropDown_Button, "Slabhide");
				UpgradeListDBVar.char.SavedOptions.SelectedBoss = "Slabhide";
				UpgradeListDBVar.char.SavedOptions.SelectedInstance = "The Stonecore";
				UpgradeListDBVar.char.SavedOptions.SelectedDifficulty = "Normal";
				CloseDropDownMenus(1);
			end
			UIDropDownMenu_AddButton(info, level)
			
			info.text = "Ozruk"
			info.notCheckable = true
			function info.func()
				UIDropDownMenu_SetText(DropDown_Button, "Ozruk");
				UpgradeListDBVar.char.SavedOptions.SelectedBoss = "Ozruk";
				UpgradeListDBVar.char.SavedOptions.SelectedInstance = "The Stonecore";
				UpgradeListDBVar.char.SavedOptions.SelectedDifficulty = "Normal";
				CloseDropDownMenus(1);
			end
			UIDropDownMenu_AddButton(info, level)
			
			info.text = "High Priestess Azil"
			info.notCheckable = true
			function info.func()
				UIDropDownMenu_SetText(DropDown_Button, "High Priestess Azil");
				UpgradeListDBVar.char.SavedOptions.SelectedBoss = "High Priestess Azil";
				UpgradeListDBVar.char.SavedOptions.SelectedInstance = "The Stonecore";
				UpgradeListDBVar.char.SavedOptions.SelectedDifficulty = "Normal";
				CloseDropDownMenus(1);
			end
			UIDropDownMenu_AddButton(info, level)
			
			info.text = "(Trash Drop)"
			info.notCheckable = true
			function info.func()
				UIDropDownMenu_SetText(DropDown_Button, "(Trash Drop)");
				UpgradeListDBVar.char.SavedOptions.SelectedBoss = "(Trash Drop)";
				UpgradeListDBVar.char.SavedOptions.SelectedInstance = "The Stonecore";
				UpgradeListDBVar.char.SavedOptions.SelectedDifficulty = "Normal";
				CloseDropDownMenus(1);
			end
			UIDropDownMenu_AddButton(info, level)

		--Normal Vortex Pinnacle Bosses
		elseif (level == 4) and (UIDROPDOWNMENU_MENU_VALUE == "The Vortex Pinnacle Normal") then
			local info = UIDropDownMenu_CreateInfo()
			
			info.text = "Grand Vizier Ertan"
			info.notCheckable = true
			function info.func()
				UIDropDownMenu_SetText(DropDown_Button, "Grand Vizier Ertan");
				UpgradeListDBVar.char.SavedOptions.SelectedBoss = "Grand Vizier Ertan";
				UpgradeListDBVar.char.SavedOptions.SelectedInstance = "The Vortex Pinnacle";
				UpgradeListDBVar.char.SavedOptions.SelectedDifficulty = "Normal";
				CloseDropDownMenus(1);
			end
			UIDropDownMenu_AddButton(info, level)
			
			info.text = "Altairus"
			info.notCheckable = true
			function info.func()
				UIDropDownMenu_SetText(DropDown_Button, "Altairus");
				UpgradeListDBVar.char.SavedOptions.SelectedBoss = "Altairus";
				UpgradeListDBVar.char.SavedOptions.SelectedInstance = "The Vortex Pinnacle";
				UpgradeListDBVar.char.SavedOptions.SelectedDifficulty = "Normal";
				CloseDropDownMenus(1);
			end
			UIDropDownMenu_AddButton(info, level)
			
			info.text = "Asaad"
			info.notCheckable = true
			function info.func()
				UIDropDownMenu_SetText(DropDown_Button, "Asaad");
				UpgradeListDBVar.char.SavedOptions.SelectedBoss = "Asaad";
				UpgradeListDBVar.char.SavedOptions.SelectedInstance = "The Vortex Pinnacle";
				UpgradeListDBVar.char.SavedOptions.SelectedDifficulty = "Normal";
				CloseDropDownMenus(1);
			end
			UIDropDownMenu_AddButton(info, level)
			
			info.text = "(Trash Drop)"
			info.notCheckable = true
			function info.func()
				UIDropDownMenu_SetText(DropDown_Button, "(Trash Drop)");
				UpgradeListDBVar.char.SavedOptions.SelectedBoss = "(Trash Drop)";
				UpgradeListDBVar.char.SavedOptions.SelectedInstance = "The Vortex Pinnacle";
				UpgradeListDBVar.char.SavedOptions.SelectedDifficulty = "Normal";
				CloseDropDownMenus(1);
			end
			UIDropDownMenu_AddButton(info, level)

		--Normal Lost City of Tol'vir Bosses
		elseif (level == 4) and (UIDROPDOWNMENU_MENU_VALUE == "Lost City of Tol'vir Normal") then
			local info = UIDropDownMenu_CreateInfo()
			
			info.text = "General Husam"
			info.notCheckable = true
			function info.func()
				UIDropDownMenu_SetText(DropDown_Button, "General Husam");
				UpgradeListDBVar.char.SavedOptions.SelectedBoss = "General Husam";
				UpgradeListDBVar.char.SavedOptions.SelectedInstance = "Lost City of Tol'vir";
				UpgradeListDBVar.char.SavedOptions.SelectedDifficulty = "Normal";
				CloseDropDownMenus(1);
			end
			UIDropDownMenu_AddButton(info, level)
			
			info.text = "Augh and Lockmaw"
			info.notCheckable = true
			function info.func()
				UIDropDownMenu_SetText(DropDown_Button, "Augh and Lockmaw");
				UpgradeListDBVar.char.SavedOptions.SelectedBoss = "Augh and Lockmaw";
				UpgradeListDBVar.char.SavedOptions.SelectedInstance = "Lost City of Tol'vir";
				UpgradeListDBVar.char.SavedOptions.SelectedDifficulty = "Normal";
				CloseDropDownMenus(1);
			end
			UIDropDownMenu_AddButton(info, level)
			
			info.text = "High Prophet Barim"
			info.notCheckable = true
			function info.func()
				UIDropDownMenu_SetText(DropDown_Button, "High Prophet Barim");
				UpgradeListDBVar.char.SavedOptions.SelectedBoss = "High Prophet Barim";
				UpgradeListDBVar.char.SavedOptions.SelectedInstance = "Lost City of Tol'vir";
				UpgradeListDBVar.char.SavedOptions.SelectedDifficulty = "Normal";
				CloseDropDownMenus(1);
			end
			UIDropDownMenu_AddButton(info, level)
			
			info.text = "Siamat"
			info.notCheckable = true
			function info.func()
				UIDropDownMenu_SetText(DropDown_Button, "Siamat");
				UpgradeListDBVar.char.SavedOptions.SelectedBoss = "Siamat";
				UpgradeListDBVar.char.SavedOptions.SelectedInstance = "Lost City of Tol'vir";
				UpgradeListDBVar.char.SavedOptions.SelectedDifficulty = "Normal";
				CloseDropDownMenus(1);
			end
			UIDropDownMenu_AddButton(info, level)
			
			info.text = "(Trash Drop)"
			info.notCheckable = true
			function info.func()
				UIDropDownMenu_SetText(DropDown_Button, "(Trash Drop)");
				UpgradeListDBVar.char.SavedOptions.SelectedBoss = "(Trash Drop)";
				UpgradeListDBVar.char.SavedOptions.SelectedInstance = "Lost City of Tol'vir";
				UpgradeListDBVar.char.SavedOptions.SelectedDifficulty = "Normal";
				CloseDropDownMenus(1);
			end
			UIDropDownMenu_AddButton(info, level)
			
		--Normal Grim Batol Bosses
		elseif (level == 4) and (UIDROPDOWNMENU_MENU_VALUE == "Grim Batol Normal") then
			local info = UIDropDownMenu_CreateInfo()
			
			info.text = "General Umbriss"
			info.notCheckable = true
			function info.func()
				UIDropDownMenu_SetText(DropDown_Button, "General Umbriss");
				UpgradeListDBVar.char.SavedOptions.SelectedBoss = "General Umbriss";
				UpgradeListDBVar.char.SavedOptions.SelectedInstance = "Grim Batol";
				UpgradeListDBVar.char.SavedOptions.SelectedDifficulty = "Normal";
				CloseDropDownMenus(1);
			end
			UIDropDownMenu_AddButton(info, level)
			
			info.text = "Forgemaster Throngus"
			info.notCheckable = true
			function info.func()
				UIDropDownMenu_SetText(DropDown_Button, "Forgemaster Throngus");
				UpgradeListDBVar.char.SavedOptions.SelectedBoss = "Forgemaster Throngus";
				UpgradeListDBVar.char.SavedOptions.SelectedInstance = "Grim Batol";
				UpgradeListDBVar.char.SavedOptions.SelectedDifficulty = "Normal";
				CloseDropDownMenus(1);
			end
			UIDropDownMenu_AddButton(info, level)
			
			info.text = "Drahga Shadowburner"
			info.notCheckable = true
			function info.func()
				UIDropDownMenu_SetText(DropDown_Button, "Drahga Shadowburner");
				UpgradeListDBVar.char.SavedOptions.SelectedBoss = "Drahga Shadowburner";
				UpgradeListDBVar.char.SavedOptions.SelectedInstance = "Grim Batol";
				UpgradeListDBVar.char.SavedOptions.SelectedDifficulty = "Normal";
				CloseDropDownMenus(1);
			end
			UIDropDownMenu_AddButton(info, level)
			
			info.text = "Erudax"
			info.notCheckable = true
			function info.func()
				UIDropDownMenu_SetText(DropDown_Button, "Erudax");
				UpgradeListDBVar.char.SavedOptions.SelectedBoss = "Erudax";
				UpgradeListDBVar.char.SavedOptions.SelectedInstance = "Grim Batol";
				UpgradeListDBVar.char.SavedOptions.SelectedDifficulty = "Normal";
				CloseDropDownMenus(1);
			end
			UIDropDownMenu_AddButton(info, level)
			
			info.text = "(Trash Drop)"
			info.notCheckable = true
			function info.func()
				UIDropDownMenu_SetText(DropDown_Button, "(Trash Drop)");
				UpgradeListDBVar.char.SavedOptions.SelectedBoss = "(Trash Drop)";
				UpgradeListDBVar.char.SavedOptions.SelectedInstance = "Grim Batol";
				UpgradeListDBVar.char.SavedOptions.SelectedDifficulty = "Normal";
				CloseDropDownMenus(1);
			end
			UIDropDownMenu_AddButton(info, level)
			
		--Normal Halls of Origination Bosses
		elseif (level == 4) and (UIDROPDOWNMENU_MENU_VALUE == "Halls of Origination Normal") then
			local info = UIDropDownMenu_CreateInfo()
			
			info.text = "Temple Guardian Anhuur"
			info.notCheckable = true
			function info.func()
				UIDropDownMenu_SetText(DropDown_Button, "Temple Guardian Anhuur");
				UpgradeListDBVar.char.SavedOptions.SelectedBoss = "Themple Guardian Anhuur";
				UpgradeListDBVar.char.SavedOptions.SelectedInstance = "Halls of Origination";
				UpgradeListDBVar.char.SavedOptions.SelectedDifficulty = "Normal";
				CloseDropDownMenus(1);
			end
			UIDropDownMenu_AddButton(info, level)
			
			info.text = "Earthrager Ptah"
			info.notCheckable = true
			function info.func()
				UIDropDownMenu_SetText(DropDown_Button, "Earthrager Ptah");
				UpgradeListDBVar.char.SavedOptions.SelectedBoss = "Earthrager Ptah";
				UpgradeListDBVar.char.SavedOptions.SelectedInstance = "Halls of Origination";
				UpgradeListDBVar.char.SavedOptions.SelectedDifficulty = "Normal";
				CloseDropDownMenus(1);
			end
			UIDropDownMenu_AddButton(info, level)
			
			info.text = "Anraphet"
			info.notCheckable = true
			function info.func()
				UIDropDownMenu_SetText(DropDown_Button, "Anraphet");
				UpgradeListDBVar.char.SavedOptions.SelectedBoss = "Anraphet";
				UpgradeListDBVar.char.SavedOptions.SelectedInstance = "Halls of Origination";
				UpgradeListDBVar.char.SavedOptions.SelectedDifficulty = "Normal";
				CloseDropDownMenus(1);
			end
			UIDropDownMenu_AddButton(info, level)
			
			info.text = "Isiset"
			info.notCheckable = true
			function info.func()
				UIDropDownMenu_SetText(DropDown_Button, "Isiset");
				UpgradeListDBVar.char.SavedOptions.SelectedBoss = "Isiset";
				UpgradeListDBVar.char.SavedOptions.SelectedInstance = "Halls of Origination";
				UpgradeListDBVar.char.SavedOptions.SelectedDifficulty = "Normal";
				CloseDropDownMenus(1);
			end
			UIDropDownMenu_AddButton(info, level)
			
			info.text = "Ammunae"
			info.notCheckable = true
			function info.func()
				UIDropDownMenu_SetText(DropDown_Button, "Ammunae");
				UpgradeListDBVar.char.SavedOptions.SelectedBoss = "Ammunae";
				UpgradeListDBVar.char.SavedOptions.SelectedInstance = "Halls of Origination";
				UpgradeListDBVar.char.SavedOptions.SelectedDifficulty = "Normal";
				CloseDropDownMenus(1);
			end
			UIDropDownMenu_AddButton(info, level)
			
			info.text = "Setesh"
			info.notCheckable = true
			function info.func()
				UIDropDownMenu_SetText(DropDown_Button, "Setesh");
				UpgradeListDBVar.char.SavedOptions.SelectedBoss = "Setesh";
				UpgradeListDBVar.char.SavedOptions.SelectedInstance = "Halls of Origination";
				UpgradeListDBVar.char.SavedOptions.SelectedDifficulty = "Normal";
				CloseDropDownMenus(1);
			end
			UIDropDownMenu_AddButton(info, level)
			
			info.text = "Rajh"
			info.notCheckable = true
			function info.func()
				UIDropDownMenu_SetText(DropDown_Button, "Rajh");
				UpgradeListDBVar.char.SavedOptions.SelectedBoss = "Rajh";
				UpgradeListDBVar.char.SavedOptions.SelectedInstance = "Halls of Origination";
				UpgradeListDBVar.char.SavedOptions.SelectedDifficulty = "Normal";
				CloseDropDownMenus(1);
			end
			UIDropDownMenu_AddButton(info, level)
			
			info.text = "(Trash Drop)"
			info.notCheckable = true
			function info.func()
				UIDropDownMenu_SetText(DropDown_Button, "(Trash Drop)");
				UpgradeListDBVar.char.SavedOptions.SelectedBoss = "(Trash Drop)";
				UpgradeListDBVar.char.SavedOptions.SelectedInstance = "Halls of Origination";
				UpgradeListDBVar.char.SavedOptions.SelectedDifficulty = "Normal";
				CloseDropDownMenus(1);
			end
			UIDropDownMenu_AddButton(info, level)
		end
	end

	
	function DropDown_DropDownOnLoad(self)
		UIDropDownMenu_Initialize(self, DropDown_InitializeDropDown)
	end

	function DropDown_ButtonOnClick(self, button, down)
		local name = self:GetName()
		ToggleDropDownMenu(1, nil, DropDown_DropDown, name, 0, 0)
	end
	
	UIDropDownMenu_Initialize(DropDown_Button, DropDown_InitializeDropDown)
	UIDropDownMenu_SetWidth(DropDown_Button, 175);
	UIDropDownMenu_SetButtonWidth(DropDown_Button, 175)
	UIDropDownMenu_SetSelectedID(DropDown_Button, 0)
	UIDropDownMenu_JustifyText(DropDown_Button, "CENTER")
	UIDropDownMenu_SetText(DropDown_Button, "Location:")

	local DropDownHeading = CreateFrame('Frame', "DropDownHeading", OptionsFrame);
	NoteFont = DropDownHeading:CreateFontString("DropDownHeading", "ARTWORK", "GameFontNormalSmallLeft");
	NoteFont:SetText("Select Item Location:");
	NoteFont:SetPoint("BOTTOM", DropDown_Button, "TOP");
	NoteFont:SetWidth(NoteFont:GetStringWidth() + 5);
	NoteFont:SetHeight(NoteFont:GetStringHeight());	
	
	--Creation of the Note Entry Box
	local NoteEntryBox = CreateFrame('EditBox', "NoteEntryBox", OptionsFrame, "InputBoxTemplate");
	NoteEntryBox:SetPoint("TOP", DropDown_Button, "BOTTOM", 0, -20);
	NoteEntryBox:SetAutoFocus(false);
	NoteEntryBox:SetWidth(250);
    NoteEntryBox:SetHeight(24);
	NoteEntryBox:SetMaxLetters(28);
	
	local NoteEntryBoxHeading = CreateFrame('Frame', "NoteEntryBoxHeading", OptionsFrame);
	NoteFont = NoteEntryBoxHeading:CreateFontString("NoteHeading", "ARTWORK", "GameFontNormalSmallLeft");
	NoteFont:SetText("Enter an optional note:");
	NoteFont:SetPoint("BOTTOM", NoteEntryBox, "TOP");
	NoteFont:SetWidth(NoteFont:GetStringWidth() + 5);
	NoteFont:SetHeight(NoteFont:GetStringHeight());	
	
	--Primary Spec Selector Radio Button
	local PrimarySpecRadioButton = CreateFrame('CheckButton', "PrimarySpecRadioButton", OptionsFrame, "UIRadioButtonTemplate");
	PrimarySpecRadioButton:SetHeight(20);
	PrimarySpecRadioButton:SetWidth(20);
	PrimarySpecRadioButton:SetChecked(true);
	PrimarySpecRadioButton:SetPoint("TOP", NoteEntryBox, "BOTTOM", -95, -25);
	_G[PrimarySpecRadioButton:GetName() .. "Text"]:SetText("Primary Spec");
	PrimarySpecRadioButton:SetScript("OnClick", function (self, button, down)
		if GetNumTalentGroups("player") == 1 then
			SecondarySpecRadioButton:Disable();
			PrimarySpecRadioButton:SetChecked(true);
		else
			SecondarySpecRadioButton:SetChecked(false);
		end
	PrimarySpecRadioButton:SetChecked(true);
	end);
	
	--Secondary Spec Selector Radio Button
	local SecondarySpecRadioButton = CreateFrame('CheckButton', "SecondarySpecRadioButton", OptionsFrame, "UIRadioButtonTemplate");
	SecondarySpecRadioButton:SetHeight(20);
	SecondarySpecRadioButton:SetWidth(20);
	SecondarySpecRadioButton:SetChecked(false);
	SecondarySpecRadioButton:SetPoint("TOP", NoteEntryBox, "BOTTOM", 20, -25);
	_G[SecondarySpecRadioButton:GetName() .. "Text"]:SetText("Secondary Spec");
	if GetNumTalentGroups("player") == 1 then
		_G[SecondarySpecRadioButton:GetName() .. "Text"]:SetTextColor(0.5, 0.5, 0.5);
		SecondarySpecRadioButton:Disable();
	end
	SecondarySpecRadioButton:SetScript("OnClick", function (self, button, down)
		SecondarySpecRadioButton:SetChecked(true);
		PrimarySpecRadioButton:SetChecked(false);
	end);
	
	local SpecEntryBoxHeading = CreateFrame('Frame', "SpecEntryBoxHeading", OptionsFrame);
	SpecFont = SpecEntryBoxHeading:CreateFontString("SpecHeading", "ARTWORK", "GameFontNormalSmallLeft");
	SpecFont:SetText("Select which spec to which you would like to add this item:");
	SpecFont:SetPoint("BOTTOM", NoteEntryBox, "TOP", 0, -47);
	SpecFont:SetWidth(SpecFont:GetStringWidth() + 5);
	SpecFont:SetHeight(SpecFont:GetStringHeight());	
	
	--AddItemLocation
	local priorityfield = CreateFrame('EditBox', "priorityfield", OptionsFrame, "InputBoxTemplate");
	priorityfield:SetPoint("TOP", ItemEntryBox, "BOTTOM", 0, -180);
	priorityfield:SetAutoFocus(false);
	priorityfield:SetWidth(25);
	priorityfield:SetHeight(24);
	
	local PriorityBoxHeading = CreateFrame('Frame', "PriorityBoxHeading", OptionsFrame);
	PriorityFont = PriorityBoxHeading:CreateFontString("SpecHeading", "ARTWORK", "GameFontNormalSmallLeft");
	PriorityFont:SetText("Enter the priority number for this item OR \nleave it blank to add the item to bottom of the list:");
	PriorityFont:SetJustifyH("CENTER");
	PriorityFont:SetPoint("BOTTOM", priorityfield, "TOP", 0, 5);
	PriorityFont:SetWidth(PriorityFont:GetStringWidth() + 5);
	PriorityFont:SetHeight(PriorityFont:GetStringHeight());	
	
	
	--"Add" button
	local AddButton = CreateFrame('Button', "AddButton", OptionsFrame, "UIPanelButtonTemplate");
	AddButton:SetPoint("TOP", priorityfield, "BOTTOM", 0, -5);
	AddButton:SetWidth(100);
    AddButton:SetHeight(24);
	AddButton:SetText("Add Item");
	AddButton:SetScript("OnClick", function (self, button, down)
		local itemName, itemLink, itemRarity, itemLevel, itemMinLevel, itemType, itemSubType, itemStackCount, itemEquipLoc, itemTexture, itemSellPrice = GetItemInfo(ItemEntryBox:GetText());
		UpgradeList_wait(.5, AddItem, ItemEntryBox, PrimarySpecRadioButton, SecondarySpecRadioButton, UpgradeListMainFrame, priorityfield, statusbarfont, NoteEntryBox);
	end);
	
	--Moving heading text
	MovingHeading = CreateFrame('Frame', "MovingHeading", OptionsFrame);
	MovingHeadingFont = MovingHeading:CreateFontString("MovingHeading", "ARTWORK", "GameFontNormalSmallLeft");
	MovingHeadingFont:SetText("In the currently selected tab, move item #:");
	MovingHeadingFont:SetPoint("BOTTOM", ItemEntryBox, "TOP", -275, 0);
	MovingHeadingFont:SetWidth(MovingHeadingFont:GetStringWidth() + 5);
	MovingHeadingFont:SetHeight(MovingHeadingFont:GetStringHeight());
	
	--"From" field for moving items
	local fromfield = CreateFrame('EditBox', "fromfield", OptionsFrame, "InputBoxTemplate");
	fromfield:SetPoint("TOP", MovingHeadingFont, "BOTTOM", -30, 0);
	fromfield:SetAutoFocus(false);
	fromfield:SetWidth(25);
	fromfield:SetHeight(24);
	
	--"To" field for moving items
	local tofield = CreateFrame('EditBox', "tofield", OptionsFrame, "InputBoxTemplate");
	tofield:SetPoint("LEFT", fromfield, "RIGHT", 20, 0);
	tofield:SetAutoFocus(false);
	tofield:SetWidth(25);
	tofield:SetHeight(24);
	
	--"To" between the To and From fields
	local to = CreateFrame('Frame', "To", OptionsFrame);
	toheadingfont = to:CreateFontString("to", "ARTWORK", "GameFontNormalSmallLeft");
	toheadingfont:SetText("to");
	toheadingfont:SetPoint("LEFT", fromfield, "RIGHT", 2, 0);
	
	--"Move Item" button
	local MoveButton = CreateFrame('Button', "MoveButton", OptionsFrame, "UIPanelButtonTemplate");
	MoveButton:SetPoint("TOP", toheadingfont, "BOTTOM", 0, -10);
	MoveButton:SetWidth(100);
    MoveButton:SetHeight(24);
	MoveButton:SetText("Move Item");
	MoveButton:SetScript("OnClick", function (self, button, down)
		MoveItem(fromfield, tofield, UpgradeListMainFrame);
	end);
	
	--"Delete item" heading
	DeletingHeading = CreateFrame('Frame', "DeletingHeading", OptionsFrame);
	DeletingHeadingFont = DeletingHeading:CreateFontString("DeletingHeading", "ARTWORK", "GameFontNormalSmallLeft");
	DeletingHeadingFont:SetText("In the currently selected tab, delete item #:");
	DeletingHeadingFont:SetPoint("BOTTOM", ItemEntryBox, "TOP", 275, 0);
	DeletingHeadingFont:SetWidth(DeletingHeadingFont:GetStringWidth() + 5);
	DeletingHeadingFont:SetHeight(DeletingHeadingFont:GetStringHeight());
	
	--"Delete Item" button
	local DeleteButton = CreateFrame('Button', "DeleteButton", OptionsFrame, "UIPanelButtonTemplate");
	DeleteButton:SetPoint("TOP", DeletingHeadingFont, "BOTTOM", 0, -25);
	DeleteButton:SetWidth(100);
    DeleteButton:SetHeight(24);
	DeleteButton:SetText("Delete Item");
	DeleteButton:SetScript("OnClick", function (self, button, down)
		DeleteItem(deletefield, UpgradeListMainFrame, statusbarfont);
	end);
	
	--"Delete Item" field
	local deletefield = CreateFrame('EditBox', "deletefield", OptionsFrame, "InputBoxTemplate");
	deletefield:SetPoint("TOP", DeletingHeadingFont, "BOTTOM", 0, 0);
	deletefield:SetAutoFocus(false);
	deletefield:SetWidth(25);
	deletefield:SetHeight(24);
	
	--Status Bar
	local PaneBackdrop  = {
		bgFile = "Interface\\ChatFrame\\ChatFrameBackground",
		edgeFile = "Interface\\Tooltips\\UI-Tooltip-Border",
		tile = true, tileSize = 16, edgeSize = 16,
		insets = { left = 3, right = 3, top = 5, bottom = 3 }
	}
	
	local statusbar = CreateFrame("Frame", "Status Bar", OptionsFrame)
	statusbar:SetPoint("BOTTOMLEFT", OptionsFrame, "BOTTOMLEFT", 15, 15)
	statusbar:SetPoint("BOTTOMRIGHT", OptionsFrame, "BOTTOMRIGHT", -15, 15)
	statusbar:SetHeight(24)
	statusbar:SetBackdrop(PaneBackdrop)
	statusbar:SetBackdropColor(0.1,0.1,0.1)
	statusbar:SetBackdropBorderColor(0.4,0.4,0.4)
	
	statusbarfont = statusbar:CreateFontString("statusbar", "ARTWORK", "GameFontWhite");
	statusbarfont:SetPoint("LEFT", statusbar, "LEFT", 7, 0);
	statusbarfont:SetHeight(22);
	statusbarfont:SetText("UpgradeList v " .. UPGRADELIST_VERSION);
	
	--Frame for entering the number of points needed for certain items
	local PointInput = CreateFrame("Frame", "PointInput", UIParent);
	PointInput:SetFrameStrata("FULLSCREEN");
	PointInput:SetWidth(250);
	PointInput:SetHeight(200);
	
	PointInput:SetBackdrop({bgFile = "Interface/DialogFrame/UI-DialogBox-Background-Dark", 
	edgeFile = "Interface/DialogFrame/UI-DialogBox-Border",
	tile = true, tileSize = 32, edgeSize = 32, 
	insets = { left = 11, right = 11, top = 10, bottom = 10 }});

	PointInput:SetBackdropColor(0,0,0,1);
	PointInput:SetPoint("CENTER", UIParent, "CENTER");
	
	PointInput:Hide();
	
	local PointInputHeading = CreateFrame('Frame', "PointInputHeading", PointInput);
	PointInputFont = PointInputHeading:CreateFontString("PointInputHeading", "ARTWORK", "GameFontNormal");
	PointInputFont:SetText("Enter the number of	points needed for this item:");
	PointInputFont:SetJustifyH("CENTER");
	PointInputFont:SetPoint("TOP", PointInput, "TOP", 0, -15);
	PointInputFont:SetWidth(230);
	PointInputFont:SetHeight(PointInputFont:GetStringHeight());
	
	local PointInputBox = CreateFrame("Editbox", "PointInputBox", PointInput, "InputBoxTemplate");
	PointInputBox:SetPoint("CENTER", PointInput, "CENTER", 0, 0);
	PointInputBox:SetAutoFocus(true);
	PointInputBox:SetWidth(175);
	PointInputBox:SetHeight(27);
	PointInputBox:SetNumeric(1);
	PointInputBox:SetMaxLetters(5);
	
	local PointInputOK = CreateFrame('Button', "PointInputOK", PointInput, "UIPanelButtonTemplate");
	PointInputOK:SetPoint("BOTTOM", PointInput, "BOTTOM", -50, 20);
	PointInputOK:SetWidth(100);
	PointInputOK:SetHeight(24);
	PointInputOK:SetText("Ok");
	PointInputOK:SetScript("OnClick", function (self, button, down)
		local pointnum = tonumber(PointInputBox:GetText());
		if pointnum == nil then
			statusbarfont:SetTextColor(1, 0, 0);
			statusbarfont:SetText("No number entered.");
		elseif pointnum >= 0 then
			pointnum = math.floor(pointnum);
			UIDropDownMenu_SetText(DropDown_Button, UIDropDownMenu_GetSelectedName(DropDown_Button));
			PointInput:Hide();
			PointInputBox:SetText("");
			UpgradeListDBVar.char.SavedOptions.SelectedBoss = pointnum;
			UpgradeListDBVar.char.SavedOptions.SelectedInstance = UIDropDownMenu_GetSelectedName(DropDown_Button);
			UpgradeListMainFrame:EnableMouse(true)
			CloseButton:EnableMouse(true)
			ToggleButton:EnableMouse(true)
			UpgradeListDBVar.char.SavedOptions.PrimaryCheck:EnableMouse(true)
			UpgradeListDBVar.char.SavedOptions.SecondaryCheck:EnableMouse(true)
			OptionsFrame:EnableMouse(true)
			ItemEntryBox:EnableMouse(true)
			DropDown_Button:EnableMouse(true)
			NoteEntryBox:EnableMouse(true)
			PrimarySpecRadioButton:EnableMouse(true)
			SecondarySpecRadioButton:EnableMouse(true)
			priorityfield:EnableMouse(true)
			AddButton:EnableMouse(true)
			tofield:EnableMouse(true)
			fromfield:EnableMouse(true)
			MoveButton:EnableMouse(true)
			DeleteButton:EnableMouse(true)
			deletefield:EnableMouse(true)
		else
			statusbarfont:SetTextColor(1, 0, 0);
			statusbarfont:SetText("Invalid number.");
		end
	end);
	
	local PointInputCancel = CreateFrame('Button', "PointInputCancel", PointInput, "UIPanelButtonTemplate");
	PointInputCancel:SetPoint("LEFT", PointInputOK, "RIGHT", 0, 0);
	PointInputCancel:SetWidth(100);
	PointInputCancel:SetHeight(24);
	PointInputCancel:SetText("Cancel");
	PointInputCancel:SetScript("OnClick", function (self, button, down)
		UIDropDownMenu_SetText(DropDown_Button, "Location:");
		PointInput:Hide();
		UpgradeListMainFrame:EnableMouse(true)
		CloseButton:EnableMouse(true)
		ToggleButton:EnableMouse(true)
		UpgradeListDBVar.char.SavedOptions.PrimaryCheck:EnableMouse(true)
		UpgradeListDBVar.char.SavedOptions.SecondaryCheck:EnableMouse(true)
		OptionsFrame:EnableMouse(true)
		ItemEntryBox:EnableMouse(true)
		DropDown_Button:EnableMouse(true)
		NoteEntryBox:EnableMouse(true)
		PrimarySpecRadioButton:EnableMouse(true)
		SecondarySpecRadioButton:EnableMouse(true)
		priorityfield:EnableMouse(true)
		AddButton:EnableMouse(true)
		tofield:EnableMouse(true)
		fromfield:EnableMouse(true)
		MoveButton:EnableMouse(true)
		DeleteButton:EnableMouse(true)
		deletefield:EnableMouse(true)
		PointInputBox:SetText("");
	end);
	
	--Frame for selecting whether a weapon is main hand or off hand.
	local WeaponInput = CreateFrame("Frame", "WeaponInput", UIParent);
	WeaponInput:SetFrameStrata("FULLSCREEN");
	WeaponInput:SetWidth(250);
	WeaponInput:SetHeight(200);
	
	WeaponInput:SetBackdrop({bgFile = "Interface/DialogFrame/UI-DialogBox-Background-Dark", 
		edgeFile = "Interface/DialogFrame/UI-DialogBox-Border",
		tile = true, tileSize = 32, edgeSize = 32, 
		insets = { left = 11, right = 11, top = 10, bottom = 10 }});

	WeaponInput:SetBackdropColor(0,0,0,1);
	WeaponInput:SetPoint("CENTER", UIParent, "CENTER");
	
	WeaponInput:Hide();
	
	local WeaponInputHeading = CreateFrame('Frame', "WeaponInputHeading", WeaponInput);
	WeaponInputFont = WeaponInputHeading:CreateFontString("WeaponInputHeading", "ARTWORK", "GameFontNormal");
	WeaponInputFont:SetText("Select which list to add this item:");
	WeaponInputFont:SetJustifyH("CENTER");
	WeaponInputFont:SetPoint("TOP", WeaponInput, "TOP", 0, -15);
	WeaponInputFont:SetWidth(230);
	WeaponInputFont:SetHeight(WeaponInputFont:GetStringHeight());
	
	--Main Hand weapon checkbox
	local MainHandCheck = CreateFrame('CheckButton', "MainHandCheck", WeaponInput, "UICheckButtonTemplate");
	MainHandCheck:SetPoint("CENTER", WeaponInput, "CENTER", -30, 25);
	MainHandCheck:SetChecked(true);
	_G[MainHandCheck:GetName() .. "Text"]:SetText("Main Hand");
	MainHandCheck:SetScript("OnClick", function (self, button, down)
		OffHandCheck:SetChecked(false);
		MainHandCheck:SetChecked(true);
	end);
	
	--Off Hand weapon checkbox
	local OffHandCheck = CreateFrame('CheckButton', "OffHandCheck", WeaponInput, "UICheckButtonTemplate");
	OffHandCheck:SetPoint("TOP", MainHandCheck, "BOTTOM", 0, 0);
	OffHandCheck:SetChecked(false);
	_G[OffHandCheck:GetName() .. "Text"]:SetText("Off Hand");
	OffHandCheck:SetScript("OnClick", function (self, button, down)
		OffHandCheck:SetChecked(true);
		MainHandCheck:SetChecked(false);
	end);
	
	local WeaponInputOK = CreateFrame('Button', "WeaponInputOK", WeaponInput, "UIPanelButtonTemplate");
	WeaponInputOK:SetPoint("BOTTOM", WeaponInput, "BOTTOM", -50, 20);
	WeaponInputOK:SetWidth(100);
	WeaponInputOK:SetHeight(24);
	WeaponInputOK:SetText("Ok");
	WeaponInputOK:SetScript("OnClick", function (self, button, down)
		local itemName, itemLink, itemRarity, itemLevel, itemMinLevel, itemType, itemSubType, itemStackCount, itemEquipLoc, itemTexture, itemSellPrice = GetItemInfo(ItemEntryBox:GetText());
		local priorityfieldnum = tonumber(priorityfield:GetText());
		if priorityfieldnum ~= nil then
			priorityfieldnum = math.floor(priorityfieldnum);
		end
		if PrimarySpecRadioButton:GetChecked() then --Adding to Primary Spec List
			if MainHandCheck:GetChecked() then --If the user selects the Main Hand checkbox
				if priorityfield:GetText() == "" or priorityfieldnum > UpgradeListDBVar.char.PrimarySpecList.Main.Count then --Priority # entered was blank or bigger than the list of items
					UpgradeListDBVar.char.PrimarySpecList.Main.Row[UpgradeListDBVar.char.PrimarySpecList.Main.Count] = { UpgradeListDBVar.char.PrimarySpecList.Main.Count, itemLevel, itemLink, UpgradeListDBVar.char.SavedOptions.SelectedDifficulty, UpgradeListDBVar.char.SavedOptions.SelectedInstance, UpgradeListDBVar.char.SavedOptions.SelectedBoss, NoteEntryBox:GetText(), ItemEntryBox:GetText() };
				elseif priorityfieldnum <= UpgradeListDBVar.char.PrimarySpecList.Main.Count and priorityfieldnum > 0 then --If the priority number is equal to or less than the list length and not zero
					table.insert(UpgradeListDBVar.char.PrimarySpecList.Main.Row, priorityfieldnum, { priorityfieldnum, itemLevel, itemLink, UpgradeListDBVar.char.SavedOptions.SelectedDifficulty, UpgradeListDBVar.char.SavedOptions.SelectedInstance, UpgradeListDBVar.char.SavedOptions.SelectedBoss, NoteEntryBox:GetText(), ItemEntryBox:GetText() });
					for i = UpgradeListDBVar.char.PrimarySpecList.Main.Count, priorityfieldnum, -1 do
						UpgradeListDBVar.char.PrimarySpecList.Main.Row[i][1] = i;
					end
				end
				UpgradeListDBVar.char.PrimarySpecList.Main.Count = UpgradeListDBVar.char.PrimarySpecList.Main.Count + 1;
				statusbarfont:SetTextColor(0, 1, 0);
				statusbarfont:SetText("Successfully added " .. itemLink .. " to your Primary Spec's Main tab.");
				if (PanelTemplates_GetSelectedTab(UpgradeListMainFrame) == 13) and (UpgradeListDBVar.char.SavedOptions.PrimaryCheck:GetChecked() == 1) then --If you're viewing the tab you're adding to
					UpgradeList:RefreshWindow()
				end
				UpgradeListDBVar.char.SavedOptions.SelectedInstance = nil;
				UpgradeListDBVar.char.SavedOptions.SelectedBoss = nil;
				UpgradeListDBVar.char.SavedOptions.SelectedDifficulty = nil;
				ItemEntryBox:SetText("");
				ItemEntryBox:ClearFocus();
				NoteEntryBox:SetText("");
				NoteEntryBox:ClearFocus();
				priorityfield:SetText("");
				priorityfield:ClearFocus();
				UIDropDownMenu_SetText(DropDown_Button, "Location:");
			elseif OffHandCheck:GetChecked() then --If the user selects the Off Hand checkbox
				if priorityfield:GetText() == "" or priorityfieldnum > UpgradeListDBVar.char.PrimarySpecList.Off.Count then --Priority # entered was blank or bigger than the list of items
					UpgradeListDBVar.char.PrimarySpecList.Off.Row[UpgradeListDBVar.char.PrimarySpecList.Off.Count] = { UpgradeListDBVar.char.PrimarySpecList.Off.Count, itemLevel, itemLink, UpgradeListDBVar.char.SavedOptions.SelectedDifficulty, UpgradeListDBVar.char.SavedOptions.SelectedInstance, UpgradeListDBVar.char.SavedOptions.SelectedBoss, NoteEntryBox:GetText(), ItemEntryBox:GetText() };
				elseif priorityfieldnum <= UpgradeListDBVar.char.PrimarySpecList.Off.Count and priorityfieldnum > 0 then --If the priority number is equal to or less than the list length and not zero
					table.insert(UpgradeListDBVar.char.PrimarySpecList.Off.Row, priorityfieldnum, { priorityfieldnum, itemLevel, itemLink, UpgradeListDBVar.char.SavedOptions.SelectedDifficulty, UpgradeListDBVar.char.SavedOptions.SelectedInstance, UpgradeListDBVar.char.SavedOptions.SelectedBoss, NoteEntryBox:GetText(), ItemEntryBox:GetText() });
					for i = UpgradeListDBVar.char.PrimarySpecList.Off.Count, priorityfieldnum, -1 do
						UpgradeListDBVar.char.PrimarySpecList.Off.Row[i][1] = i;
					end
				end
				UpgradeListDBVar.char.PrimarySpecList.Off.Count = UpgradeListDBVar.char.PrimarySpecList.Off.Count + 1;
				statusbarfont:SetTextColor(0, 1, 0);
				statusbarfont:SetText("Successfully added " .. itemLink .. " to your Primary Spec's Off tab.");
				if (PanelTemplates_GetSelectedTab(UpgradeListMainFrame) == 14) and (UpgradeListDBVar.char.SavedOptions.PrimaryCheck:GetChecked() == 1) then --If you're viewing the tab you're adding to
					UpgradeList:RefreshWindow()
				end
				UpgradeListDBVar.char.SavedOptions.SelectedInstance = nil;
				UpgradeListDBVar.char.SavedOptions.SelectedBoss = nil;
				UpgradeListDBVar.char.SavedOptions.SelectedDifficulty = nil;
				ItemEntryBox:SetText("");
				ItemEntryBox:ClearFocus();
				NoteEntryBox:SetText("");
				NoteEntryBox:ClearFocus();
				priorityfield:SetText("");
				priorityfield:ClearFocus();
				UIDropDownMenu_SetText(DropDown_Button, "Location:");
			else
				--Can't tell if the user selected main hand or off hand checkbox
			end
		else --Adding to Secondary Spec List
			if MainHandCheck:GetChecked() then --If the user selects the Main Hand checkbox
				if priorityfield:GetText() == "" or priorityfieldnum > UpgradeListDBVar.char.SecondarySpecList.Main.Count then --Priority # entered was blank or bigger than the list of items
					UpgradeListDBVar.char.SecondarySpecList.Main.Row[UpgradeListDBVar.char.SecondarySpecList.Main.Count] = { UpgradeListDBVar.char.SecondarySpecList.Main.Count, itemLevel, itemLink, UpgradeListDBVar.char.SavedOptions.SelectedDifficulty, UpgradeListDBVar.char.SavedOptions.SelectedInstance, UpgradeListDBVar.char.SavedOptions.SelectedBoss, NoteEntryBox:GetText(), ItemEntryBox:GetText() };
				elseif priorityfieldnum <= UpgradeListDBVar.char.SecondarySpecList.Main.Count and priorityfieldnum > 0 then --If the priority number is equal to or less than the list length and not zero
					table.insert(UpgradeListDBVar.char.SecondarySpecList.Main.Row, priorityfieldnum, { priorityfieldnum, itemLevel, itemLink, UpgradeListDBVar.char.SavedOptions.SelectedDifficulty, UpgradeListDBVar.char.SavedOptions.SelectedInstance, UpgradeListDBVar.char.SavedOptions.SelectedBoss, NoteEntryBox:GetText(), ItemEntryBox:GetText() });
					for i = UpgradeListDBVar.char.SecondarySpecList.Main.Count, priorityfieldnum, -1 do
						UpgradeListDBVar.char.SecondarySpecList.Main.Row[i][1] = i;
					end
				end
				UpgradeListDBVar.char.SecondarySpecList.Main.Count = UpgradeListDBVar.char.SecondarySpecList.Main.Count + 1;
				statusbarfont:SetTextColor(0, 1, 0);
				statusbarfont:SetText("Successfully added " .. itemLink .. " to your Secondary Spec's Main tab.");
				if (PanelTemplates_GetSelectedTab(UpgradeListMainFrame) == 13) and (UpgradeListDBVar.char.SavedOptions.SecondaryCheck:GetChecked() == 1) then --If you're viewing the tab you're adding to
					UpgradeList:RefreshWindow()
				end
				UpgradeListDBVar.char.SavedOptions.SelectedInstance = nil;
				UpgradeListDBVar.char.SavedOptions.SelectedBoss = nil;
				UpgradeListDBVar.char.SavedOptions.SelectedDifficulty = nil;
				ItemEntryBox:SetText("");
				ItemEntryBox:ClearFocus();
				NoteEntryBox:SetText("");
				NoteEntryBox:ClearFocus();
				priorityfield:SetText("");
				priorityfield:ClearFocus();
				UIDropDownMenu_SetText(DropDown_Button, "Location:");
			elseif OffHandCheck:GetChecked() then --If the user selects the Off Hand checkbox
				if priorityfield:GetText() == "" or priorityfieldnum > UpgradeListDBVar.char.SecondarySpecList.Off.Count then --Priority # entered was blank or bigger than the list of items
					UpgradeListDBVar.char.SecondarySpecList.Off.Row[UpgradeListDBVar.char.SecondarySpecList.Off.Count] = { UpgradeListDBVar.char.SecondarySpecList.Off.Count, itemLevel, itemLink, UpgradeListDBVar.char.SavedOptions.SelectedDifficulty, UpgradeListDBVar.char.SavedOptions.SelectedInstance, UpgradeListDBVar.char.SavedOptions.SelectedBoss, NoteEntryBox:GetText(), ItemEntryBox:GetText() };
				elseif priorityfieldnum <= UpgradeListDBVar.char.SecondarySpecList.Off.Count and priorityfieldnum > 0 then --If the priority number is equal to or less than the list length and not zero
					table.insert(UpgradeListDBVar.char.SecondarySpecList.Off.Row, priorityfieldnum, { priorityfieldnum, itemLevel, itemLink, UpgradeListDBVar.char.SavedOptions.SelectedDifficulty, UpgradeListDBVar.char.SavedOptions.SelectedInstance, UpgradeListDBVar.char.SavedOptions.SelectedBoss, NoteEntryBox:GetText(), ItemEntryBox:GetText() });
					for i = UpgradeListDBVar.char.SecondarySpecList.Off.Count, priorityfieldnum, -1 do
						UpgradeListDBVar.char.SecondarySpecList.Off.Row[i][1] = i;
					end
				end
				UpgradeListDBVar.char.SecondarySpecList.Off.Count = UpgradeListDBVar.char.SecondarySpecList.Off.Count + 1;
				statusbarfont:SetTextColor(0, 1, 0);
				statusbarfont:SetText("Successfully added " .. itemLink .. " to your Secondary Spec's Off tab.");
				if (PanelTemplates_GetSelectedTab(UpgradeListMainFrame) == 14) and (UpgradeListDBVar.char.SavedOptions.SecondaryCheck:GetChecked() == 1) then --If you're viewing the tab you're adding to
					UpgradeList:RefreshWindow()
				end
				UpgradeListDBVar.char.SavedOptions.SelectedInstance = nil;
				UpgradeListDBVar.char.SavedOptions.SelectedBoss = nil;
				UpgradeListDBVar.char.SavedOptions.SelectedDifficulty = nil;
				ItemEntryBox:SetText("");
				ItemEntryBox:ClearFocus();
				NoteEntryBox:SetText("");
				NoteEntryBox:ClearFocus();
				priorityfield:SetText("");
				priorityfield:ClearFocus();
				UIDropDownMenu_SetText(DropDown_Button, "Location:");
			else
				statusbarfont:SetTextColor(0, 1, 0);
				statusbarfont:SetText("ERROR: Unable to determine if you selected Main Hand or Off Hand for this weapon");
			end
		end
		WeaponInput:Hide();
		OffHandCheck:SetChecked(false);
		MainHandCheck:SetChecked(true);
		UpgradeListMainFrame:EnableMouse(true)
		CloseButton:EnableMouse(true)
		ToggleButton:EnableMouse(true)
		UpgradeListDBVar.char.SavedOptions.PrimaryCheck:EnableMouse(true)
		UpgradeListDBVar.char.SavedOptions.SecondaryCheck:EnableMouse(true)
		OptionsFrame:EnableMouse(true)
		ItemEntryBox:EnableMouse(true)
		DropDown_Button:EnableMouse(true)
		NoteEntryBox:EnableMouse(true)
		PrimarySpecRadioButton:EnableMouse(true)
		SecondarySpecRadioButton:EnableMouse(true)
		priorityfield:EnableMouse(true)
		AddButton:EnableMouse(true)
		tofield:EnableMouse(true)
		fromfield:EnableMouse(true)
		MoveButton:EnableMouse(true)
		DeleteButton:EnableMouse(true)
		deletefield:EnableMouse(true)
	end);
	
	local WeaponInputCancel = CreateFrame('Button', "WeaponInputCancel", WeaponInput, "UIPanelButtonTemplate");
	WeaponInputCancel:SetPoint("LEFT", WeaponInputOK, "RIGHT", 0, 0);
	WeaponInputCancel:SetWidth(100);
	WeaponInputCancel:SetHeight(24);
	WeaponInputCancel:SetText("Cancel");
	WeaponInputCancel:SetScript("OnClick", function (self, button, down)
		WeaponInput:Hide();
		OffHandCheck:SetChecked(false);
		MainHandCheck:SetChecked(true);
		UpgradeListMainFrame:EnableMouse(true)
		CloseButton:EnableMouse(true)
		ToggleButton:EnableMouse(true)
		UpgradeListDBVar.char.SavedOptions.PrimaryCheck:EnableMouse(true)
		UpgradeListDBVar.char.SavedOptions.SecondaryCheck:EnableMouse(true)
		OptionsFrame:EnableMouse(true)
		ItemEntryBox:EnableMouse(true)
		DropDown_Button:EnableMouse(true)
		NoteEntryBox:EnableMouse(true)
		PrimarySpecRadioButton:EnableMouse(true)
		SecondarySpecRadioButton:EnableMouse(true)
		priorityfield:EnableMouse(true)
		AddButton:EnableMouse(true)
		tofield:EnableMouse(true)
		fromfield:EnableMouse(true)
		MoveButton:EnableMouse(true)
		DeleteButton:EnableMouse(true)
		deletefield:EnableMouse(true)
	end);
	
	--Frame for asking whether an acquired upgrade is for Main Spec or Off Spec
	local SpecInput = CreateFrame("Frame", "SpecInput", UIParent);
	SpecInput:SetFrameStrata("FULLSCREEN");
	SpecInput:SetWidth(250);
	SpecInput:SetHeight(200);
	
	SpecInput:SetBackdrop({bgFile = "Interface/DialogFrame/UI-DialogBox-Background-Dark", 
		edgeFile = "Interface/DialogFrame/UI-DialogBox-Border",
		tile = true, tileSize = 32, edgeSize = 32, 
		insets = { left = 11, right = 11, top = 10, bottom = 10 }});

	SpecInput:SetBackdropColor(0,0,0,1);
	SpecInput:SetPoint("CENTER", UIParent, "CENTER");
	
	SpecInput:Hide();
	
	local SpecInputHeading = CreateFrame('Frame', "SpecInputHeading", SpecInput);
	SpecInputFont = SpecInputHeading:CreateFontString("SpecInputHeading", "ARTWORK", "GameFontNormal");
	SpecInputFont:SetText("Is your newly acquired item for your Main Spec or your Off Spec?");
	SpecInputFont:SetJustifyH("CENTER");
	SpecInputFont:SetPoint("TOP", SpecInput, "TOP", 0, -15);
	SpecInputFont:SetWidth(230);
	SpecInputFont:SetHeight(SpecInputFont:GetStringHeight());
	
	--Main Spec selected
	local MainSpecCheck = CreateFrame('CheckButton', "MainSpecCheck", SpecInput, "UICheckButtonTemplate");
	MainSpecCheck:SetPoint("CENTER", SpecInput, "CENTER", -30, 25);
	MainSpecCheck:SetChecked(true);
	_G[MainSpecCheck:GetName() .. "Text"]:SetText("Main Spec");
	MainSpecCheck:SetScript("OnClick", function (self, button, down)
		OffSpecCheck:SetChecked(false);
		MainSpecCheck:SetChecked(true);
	end);
	
	--Off Spec selected
	local OffSpecCheck = CreateFrame('CheckButton', "OffSpecCheck", SpecInput, "UICheckButtonTemplate");
	OffSpecCheck:SetPoint("TOP", MainHandCheck, "BOTTOM", 0, 0);
	OffSpecCheck:SetChecked(false);
	_G[OffSpecCheck:GetName() .. "Text"]:SetText("Off Spec");
	OffSpecCheck:SetScript("OnClick", function (self, button, down)
		OffSpecCheck:SetChecked(true);
		MainSpecCheck:SetChecked(false);
	end);
	
	local SpecInputOK = CreateFrame('Button', "SpecInputOK", SpecInput, "UIPanelButtonTemplate");
	SpecInputOK:SetPoint("BOTTOM", SpecInput, "BOTTOM", -50, 20);
	SpecInputOK:SetWidth(100);
	SpecInputOK:SetHeight(24);
	SpecInputOK:SetText("Ok");
		
	local SpecInputCancel = CreateFrame('Button', "SpecInputCancel", SpecInput, "UIPanelButtonTemplate");
	SpecInputCancel:SetPoint("LEFT", SpecInputOK, "RIGHT", 0, 0);
	SpecInputCancel:SetWidth(100);
	SpecInputCancel:SetHeight(24);
	SpecInputCancel:SetText("Cancel");
	SpecInputCancel:SetScript("OnClick", function (self, button, down)
		SpecInput:Hide();
		OffSpecCheck:SetChecked(false);
		MainSpecCheck:SetChecked(true);
		UpgradeListMainFrame:EnableMouse(true)
		CloseButton:EnableMouse(true)
		ToggleButton:EnableMouse(true)
		UpgradeListDBVar.char.SavedOptions.PrimaryCheck:EnableMouse(true)
		UpgradeListDBVar.char.SavedOptions.SecondaryCheck:EnableMouse(true)
		OptionsFrame:EnableMouse(true)
		ItemEntryBox:EnableMouse(true)
		DropDown_Button:EnableMouse(true)
		NoteEntryBox:EnableMouse(true)
		PrimarySpecRadioButton:EnableMouse(true)
		SecondarySpecRadioButton:EnableMouse(true)
		priorityfield:EnableMouse(true)
		AddButton:EnableMouse(true)
		tofield:EnableMouse(true)
		fromfield:EnableMouse(true)
		MoveButton:EnableMouse(true)
		DeleteButton:EnableMouse(true)
		deletefield:EnableMouse(true)
	end);
	
	--Frame for asking whether an acquired upgrade is for Main Hand or Off Hand
	local MainHandorOffHand = CreateFrame("Frame", "MainHandorOffHand", UIParent);
	MainHandorOffHand:SetFrameStrata("FULLSCREEN");
	MainHandorOffHand:SetWidth(250);
	MainHandorOffHand:SetHeight(200);
	
	MainHandorOffHand:SetBackdrop({bgFile = "Interface/DialogFrame/UI-DialogBox-Background-Dark", 
		edgeFile = "Interface/DialogFrame/UI-DialogBox-Border",
		tile = true, tileSize = 32, edgeSize = 32, 
		insets = { left = 11, right = 11, top = 10, bottom = 10 }});

	MainHandorOffHand:SetBackdropColor(0,0,0,1);
	MainHandorOffHand:SetPoint("CENTER", UIParent, "CENTER");
	
	MainHandorOffHand:Hide();
	
	local MainHandorOffHandHeading = CreateFrame('Frame', "MainHandorOffHandHeading", MainHandorOffHand);
	MainHandorOffHandFont = MainHandorOffHandHeading:CreateFontString("MainHandorOffHandHeading", "ARTWORK", "GameFontNormal");
	MainHandorOffHandFont:SetText("Is your newly acquired item for your Main Hand or your Off Hand?");
	MainHandorOffHandFont:SetJustifyH("CENTER");
	MainHandorOffHandFont:SetPoint("TOP", MainHandorOffHand, "TOP", 0, -15);
	MainHandorOffHandFont:SetWidth(230);
	MainHandorOffHandFont:SetHeight(MainHandorOffHandFont:GetStringHeight());
	
	--Main Hand weapon check
	local WeaponInMain = CreateFrame('CheckButton', "WeaponInMain", MainHandorOffHand, "UICheckButtonTemplate");
	WeaponInMain:SetPoint("CENTER", MainHandorOffHand, "CENTER", -30, 25);
	WeaponInMain:SetChecked(true);
	_G[WeaponInMain:GetName() .. "Text"]:SetText("Main Hand");
	WeaponInMain:SetScript("OnClick", function (self, button, down)
		WeaponInOff:SetChecked(false);
		WeaponInMain:SetChecked(true);
	end);
	
	--Off Hand weapon check
	local WeaponInOff = CreateFrame('CheckButton', "WeaponInOff", MainHandorOffHand, "UICheckButtonTemplate");
	WeaponInOff:SetPoint("TOP", MainHandCheck, "BOTTOM", 0, 0);
	WeaponInOff:SetChecked(false);
	_G[WeaponInOff:GetName() .. "Text"]:SetText("Off Hand");
	WeaponInOff:SetScript("OnClick", function (self, button, down)
		WeaponInOff:SetChecked(true);
		WeaponInMain:SetChecked(false);
	end);
	
	local MainHandorOffHandOK = CreateFrame('Button', "MainHandorOffHandOK", MainHandorOffHand, "UIPanelButtonTemplate");
	MainHandorOffHandOK:SetPoint("BOTTOM", MainHandorOffHand, "BOTTOM", -50, 20);
	MainHandorOffHandOK:SetWidth(100);
	MainHandorOffHandOK:SetHeight(24);
	MainHandorOffHandOK:SetText("Ok");
	
	local MainHandorOffHandCancel = CreateFrame('Button', "MainHandorOffHandCancel", MainHandorOffHand, "UIPanelButtonTemplate");
	MainHandorOffHandCancel:SetPoint("LEFT", MainHandorOffHandOK, "RIGHT", 0, 0);
	MainHandorOffHandCancel:SetWidth(100);
	MainHandorOffHandCancel:SetHeight(24);
	MainHandorOffHandCancel:SetText("Cancel");
	MainHandorOffHandCancel:SetScript("OnClick", function (self, button, down)
		MainHandorOffHand:Hide();
		WeaponInOff:SetChecked(false);
		WeaponInMain:SetChecked(true);
		UpgradeListMainFrame:EnableMouse(true)
		CloseButton:EnableMouse(true)
		ToggleButton:EnableMouse(true)
		UpgradeListDBVar.char.SavedOptions.PrimaryCheck:EnableMouse(true)
		UpgradeListDBVar.char.SavedOptions.SecondaryCheck:EnableMouse(true)
		OptionsFrame:EnableMouse(true)
		ItemEntryBox:EnableMouse(true)
		DropDown_Button:EnableMouse(true)
		NoteEntryBox:EnableMouse(true)
		PrimarySpecRadioButton:EnableMouse(true)
		SecondarySpecRadioButton:EnableMouse(true)
		priorityfield:EnableMouse(true)
		AddButton:EnableMouse(true)
		tofield:EnableMouse(true)
		fromfield:EnableMouse(true)
		MoveButton:EnableMouse(true)
		DeleteButton:EnableMouse(true)
		deletefield:EnableMouse(true)
	end);
	
	--Frame for entering a new note
	local EditNote = CreateFrame("Frame", "EditNote", UIParent);
	EditNote:SetFrameStrata("FULLSCREEN");
	EditNote:SetWidth(360);
	EditNote:SetHeight(150);
	
	EditNote:SetBackdrop({bgFile = "Interface/DialogFrame/UI-DialogBox-Background-Dark", 
	edgeFile = "Interface/DialogFrame/UI-DialogBox-Border",
	tile = true, tileSize = 32, edgeSize = 32, 
	insets = { left = 11, right = 11, top = 10, bottom = 10 }});

	EditNote:SetBackdropColor(0,0,0,1);
	EditNote:SetPoint("CENTER", UIParent, "CENTER");
	
	EditNote:Hide();
	
	local EditNoteHeading = CreateFrame('Frame', "EditNoteHeading", EditNote);
	EditNoteFont = EditNoteHeading:CreateFontString("EditNoteHeading", "ARTWORK", "GameFontNormal");
	EditNoteFont:SetText("Enter your new note:");
	EditNoteFont:SetJustifyH("CENTER");
	EditNoteFont:SetPoint("TOP", EditNote, "TOP", 0, -15);
	EditNoteFont:SetWidth(230);
	EditNoteFont:SetHeight(EditNoteFont:GetStringHeight());
	
	local EditNoteBox = CreateFrame("Editbox", "EditNoteBox", EditNote, "InputBoxTemplate");
	EditNoteBox:SetPoint("CENTER", EditNote, "CENTER", 0, 0);
	EditNoteBox:SetAutoFocus(true);
	EditNoteBox:SetWidth(285);
	EditNoteBox:SetHeight(27);
	EditNoteBox:SetMaxLetters(28);
	
	local EditNoteOK = CreateFrame('Button', "EditNoteOK", EditNote, "UIPanelButtonTemplate");
	EditNoteOK:SetPoint("BOTTOM", EditNote, "BOTTOM", -50, 20);
	EditNoteOK:SetWidth(100);
	EditNoteOK:SetHeight(24);
	EditNoteOK:SetText("Ok");
	
	local EditNoteCancel = CreateFrame('Button', "EditNoteCancel", EditNote, "UIPanelButtonTemplate");
	EditNoteCancel:SetPoint("LEFT", EditNoteOK, "RIGHT", 0, 0);
	EditNoteCancel:SetWidth(100);
	EditNoteCancel:SetHeight(24);
	EditNoteCancel:SetText("Cancel");
	EditNoteCancel:SetScript("OnClick", function (self, button, down)
		EditNote:Hide();
		UpgradeListMainFrame:EnableMouse(true)
		CloseButton:EnableMouse(true)
		ToggleButton:EnableMouse(true)
		UpgradeListDBVar.char.SavedOptions.PrimaryCheck:EnableMouse(true)
		UpgradeListDBVar.char.SavedOptions.SecondaryCheck:EnableMouse(true)
		OptionsFrame:EnableMouse(true)
		ItemEntryBox:EnableMouse(true)
		DropDown_Button:EnableMouse(true)
		NoteEntryBox:EnableMouse(true)
		PrimarySpecRadioButton:EnableMouse(true)
		SecondarySpecRadioButton:EnableMouse(true)
		priorityfield:EnableMouse(true)
		AddButton:EnableMouse(true)
		tofield:EnableMouse(true)
		fromfield:EnableMouse(true)
		MoveButton:EnableMouse(true)
		DeleteButton:EnableMouse(true)
		deletefield:EnableMouse(true)
		EditNoteBox:SetText("");
	end);
	
	UpgradeListMainFrame:Hide();
	
end